/* Device.c generated by valac 0.52.4, the Vala compiler
 * generated from Device.vala, do not modify */

/*
 * Device.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */
/* Functions and classes for handling disk partitions */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;
typedef struct _DevicePrivate DevicePrivate;

#define TYPE_MOUNT_ENTRY (mount_entry_get_type ())
#define MOUNT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOUNT_ENTRY, MountEntry))
#define MOUNT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOUNT_ENTRY, MountEntryClass))
#define IS_MOUNT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOUNT_ENTRY))
#define IS_MOUNT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOUNT_ENTRY))
#define MOUNT_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOUNT_ENTRY, MountEntryClass))

typedef struct _MountEntry MountEntry;
typedef struct _MountEntryClass MountEntryClass;
enum  {
	DEVICE_0_PROPERTY,
	DEVICE_FREE_BYTES_PROPERTY,
	DEVICE_SIZE_PROPERTY,
	DEVICE_USED_PROPERTY,
	DEVICE_FREE_PROPERTY,
	DEVICE_IS_MOUNTED_PROPERTY,
	DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY,
	DEVICE_FULL_NAME_WITH_PARENT_PROPERTY,
	DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY,
	DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY,
	DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY,
	DEVICE_NUM_PROPERTIES
};
static GParamSpec* device_properties[DEVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _MountEntryPrivate MountEntryPrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_TIMEOUT_COUNTER (timeout_counter_get_type ())
#define TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounter))
#define TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))
#define IS_TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMEOUT_COUNTER))
#define IS_TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMEOUT_COUNTER))
#define TIMEOUT_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))

typedef struct _TimeoutCounter TimeoutCounter;
typedef struct _TimeoutCounterClass TimeoutCounterClass;

struct _Device {
	GObject parent_instance;
	DevicePrivate * priv;
	gchar* device;
	gchar* name;
	gchar* kname;
	gchar* pkname;
	gchar* pkname_toplevel;
	gchar* mapped_name;
	gchar* uuid;
	gchar* label;
	gchar* partuuid;
	gchar* partlabel;
	gint major;
	gint minor;
	gchar* device_mapper;
	gchar* device_by_uuid;
	gchar* device_by_label;
	gchar* device_by_partuuid;
	gchar* device_by_partlabel;
	gchar* type;
	gchar* fstype;
	gint order;
	gchar* vendor;
	gchar* model;
	gchar* serial;
	gchar* revision;
	gboolean removable;
	gboolean read_only;
	guint64 size_bytes;
	guint64 used_bytes;
	guint64 available_bytes;
	gchar* used_percent;
	gchar* dist_info;
	GeeArrayList* mount_points;
	GeeArrayList* symlinks;
	Device* parent;
	GeeArrayList* children;
};

struct _DeviceClass {
	GObjectClass parent_class;
};

struct _MountEntry {
	GObject parent_instance;
	MountEntryPrivate * priv;
	Device* device;
	gchar* mount_point;
	gchar* mount_options;
};

struct _MountEntryClass {
	GObjectClass parent_class;
};

static gpointer device_parent_class = NULL;
extern gdouble device_KB;
gdouble device_KB = (gdouble) 1000;
extern gdouble device_MB;
gdouble device_MB = 0.0;
extern gdouble device_GB;
gdouble device_GB = 0.0;
extern gdouble device_KiB;
gdouble device_KiB = (gdouble) 1024;
extern gdouble device_MiB;
gdouble device_MiB = 0.0;
extern gdouble device_GiB;
gdouble device_GiB = 0.0;
static gchar* device_lsblk_version;
static gchar* device_lsblk_version = NULL;
static gboolean device_lsblk_is_ancient;
static gboolean device_lsblk_is_ancient = FALSE;
static GeeArrayList* device_device_list;
static GeeArrayList* device_device_list = NULL;
extern gboolean tee_jee_logging_LOG_DEBUG;

GType device_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Device, g_object_unref)
GType mount_entry_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MountEntry, g_object_unref)
Device* device_new (void);
Device* device_construct (GType object_type);
void device_test_lsblk_version (void);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
gboolean device_is_mounted_at_path (Device* self,
                                    const gchar* subvolname,
                                    const gchar* mount_path);
gboolean device_has_linux_filesystem (Device* self);
gboolean device_is_encrypted_partition (Device* self);
gboolean device_is_on_encrypted_partition (Device* self);
gboolean device_is_lvm_partition (Device* self);
gboolean device_has_children (Device* self);
Device* device_first_linux_child (Device* self);
gboolean device_has_parent (Device* self);
GeeArrayList* device_get_filesystems (gboolean get_space,
                                      gboolean get_mounts);
GeeArrayList* device_get_block_devices_using_lsblk (const gchar* dev_name);
GeeArrayList* device_get_disk_space_using_df (const gchar* dev_name_or_mount_point);
Device* device_find_device_in_list (GeeArrayList* list,
                                    const gchar* _dev_alias);
GeeArrayList* device_get_mounted_filesystems_using_mtab (void);
void tee_jee_logging_log_debug (const gchar* message);
static void device_find_child_devices (GeeArrayList* list,
                                Device* parent);
static void device_find_toplevel_parent (GeeArrayList* list,
                                  Device* dev);
static void device_find_child_devices_using_dmsetup (GeeArrayList* list);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
MountEntry* mount_entry_new (Device* device,
                             const gchar* mount_point,
                             const gchar* mount_options);
MountEntry* mount_entry_construct (GType object_type,
                                   Device* device,
                                   const gchar* mount_point,
                                   const gchar* mount_options);
gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
GeeArrayList* device_get_block_devices_using_blkid (const gchar* dev_name);
gint tee_jee_process_helper_exec_script_sync (const gchar* script,
                                              gchar* * std_out,
                                              gchar* * std_err,
                                              gboolean supress_errors,
                                              gboolean run_as_admin,
                                              gboolean cleanup_tmp,
                                              gboolean print_to_terminal);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gchar* device_resolve_device_name (const gchar* dev_alias);
gchar* device_get_device_uuid (const gchar* device);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
Device* device_get_device_by_uuid (const gchar* uuid);
Device* device_get_device_by_name (const gchar* file_name);
Device* device_get_device_by_path (const gchar* path_to_check);
GeeArrayList* device_get_device_mount_points (const gchar* dev_name_or_uuid);
gboolean device_device_is_mounted (const gchar* dev_name_or_uuid);
gboolean device_mount_point_in_use (const gchar* mount_point);
gboolean tee_jee_file_system_file_is_symlink (const gchar* file_path);
gchar* tee_jee_file_system_file_get_symlink_target (const gchar* file_path);
void device_copy_fields_from (Device* self,
                              Device* dev2);
Device* device_query_changes (Device* self);
void device_query_disk_space (Device* self);
gboolean device_automount_udisks (const gchar* dev_name_or_uuid,
                                  GtkWindow* parent_window);
void tee_jee_gtk_helper_gtk_messagebox (const gchar* title,
                                        const gchar* message,
                                        GtkWindow* parent_win,
                                        gboolean is_error);
gboolean device_automount_udisks_iso (const gchar* iso_file_path,
                                      gchar* * loop_device,
                                      GtkWindow* parent_window);
void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
gboolean device_unmount_udisks (const gchar* dev_name_or_uuid,
                                GtkWindow* parent_window);
Device* device_luks_unlock (Device* luks_device,
                            const gchar* mapped_name,
                            const gchar* passphrase,
                            GtkWindow* parent_window,
                            gchar* * message,
                            gchar* * details);
GType timeout_counter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (TimeoutCounter, g_object_unref)
TimeoutCounter* timeout_counter_new (void);
TimeoutCounter* timeout_counter_construct (GType object_type);
void timeout_counter_kill_process_on_timeout (TimeoutCounter* self,
                                              const gchar* process_to_kill,
                                              gint seconds_to_wait,
                                              gboolean exit_app);
void timeout_counter_stop (TimeoutCounter* self);
gchar* tee_jee_gtk_helper_gtk_inputbox (const gchar* title,
                                        const gchar* message,
                                        GtkWindow* parent_win,
                                        gboolean mask_password);
gboolean device_luks_lock (const gchar* kname,
                           GtkWindow* parent_window);
gboolean device_mount (const gchar* dev_name_or_uuid,
                       const gchar* mount_point,
                       const gchar* mount_options,
                       gboolean silent);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
gboolean device_unmount (const gchar* mount_point);
gchar* device_get_device_name_with_parent (Device* self);
gchar* device_automount (const gchar* dev_name_or_uuid,
                         const gchar* mount_options,
                         const gchar* mount_prefix);
gchar* device_description (Device* self);
gchar* device_description_formatted (Device* self);
gchar* tee_jee_file_system_format_file_size (guint64 size,
                                             gboolean binary_units,
                                             const gchar* unit,
                                             gboolean show_units,
                                             gint decimals);
gchar* device_get_short_name_with_parent (Device* self);
gchar* device_description_simple (Device* self);
gchar* device_description_simple_formatted (Device* self);
gchar* device_description_full_free (Device* self);
guint64 device_get_free_bytes (Device* self);
gchar* device_description_free (Device* self);
gchar* device_description_full (Device* self);
gchar* device_get_used (Device* self);
gchar* device_get_size (Device* self);
gchar* device_description_usage (Device* self);
gchar* device_tooltip_text (Device* self);
static gchar* device_display_name (Device* self,
                            gboolean short_name,
                            gboolean show_label,
                            gboolean show_parent,
                            gboolean show_alias);
void device_test_all (void);
void device_print_device_list (GeeArrayList* list);
void device_print_device_mounts (GeeArrayList* list);
void device_print_device_disk_space (GeeArrayList* list);
gchar* device_get_free (Device* self);
gboolean device_get_is_mounted (Device* self);
gchar* device_get_full_name_with_alias (Device* self);
gchar* device_get_full_name_with_parent (Device* self);
gchar* device_get_short_name_with_alias (Device* self);
static void device_finalize (GObject * obj);
static GType device_get_type_once (void);
static void _vala_device_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

Device*
device_construct (GType object_type)
{
	Device * self = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
#line 94 "Utility/Device.vala"
	self = (Device*) g_object_new (object_type, NULL);
#line 95 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_MOUNT_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 95 "Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 95 "Utility/Device.vala"
	self->mount_points = _tmp0_;
#line 96 "Utility/Device.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 96 "Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 96 "Utility/Device.vala"
	self->symlinks = _tmp1_;
#line 97 "Utility/Device.vala"
	_tmp2_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 97 "Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 97 "Utility/Device.vala"
	self->children = _tmp2_;
#line 99 "Utility/Device.vala"
	device_test_lsblk_version ();
#line 94 "Utility/Device.vala"
	return self;
#line 361 "Device.c"
}

Device*
device_new (void)
{
#line 94 "Utility/Device.vala"
	return device_construct (TYPE_DEVICE);
#line 369 "Device.c"
}

void
device_test_lsblk_version (void)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_;
#line 104 "Utility/Device.vala"
	_tmp1_ = device_lsblk_version;
#line 104 "Utility/Device.vala"
	if (_tmp1_ != NULL) {
#line 387 "Device.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 104 "Utility/Device.vala"
		_tmp2_ = device_lsblk_version;
#line 104 "Utility/Device.vala"
		_tmp3_ = strlen (_tmp2_);
#line 104 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 104 "Utility/Device.vala"
		_tmp0_ = _tmp4_ > 0;
#line 399 "Device.c"
	} else {
#line 104 "Utility/Device.vala"
		_tmp0_ = FALSE;
#line 403 "Device.c"
	}
#line 104 "Utility/Device.vala"
	if (_tmp0_) {
#line 105 "Utility/Device.vala"
		return;
#line 409 "Device.c"
	}
#line 109 "Utility/Device.vala"
	_tmp7_ = tee_jee_process_helper_exec_sync ("lsblk --bytes --pairs --output HOTPLUG,PKNAME,VENDOR,SERIAL,REV", &_tmp5_, &_tmp6_);
#line 109 "Utility/Device.vala"
	_g_free0 (std_out);
#line 109 "Utility/Device.vala"
	std_out = _tmp5_;
#line 109 "Utility/Device.vala"
	_g_free0 (std_err);
#line 109 "Utility/Device.vala"
	std_err = _tmp6_;
#line 109 "Utility/Device.vala"
	status = _tmp7_;
#line 110 "Utility/Device.vala"
	if (status == 0) {
#line 425 "Device.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 111 "Utility/Device.vala"
		_tmp8_ = std_out;
#line 111 "Utility/Device.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 111 "Utility/Device.vala"
		_g_free0 (device_lsblk_version);
#line 111 "Utility/Device.vala"
		device_lsblk_version = _tmp9_;
#line 112 "Utility/Device.vala"
		device_lsblk_is_ancient = FALSE;
#line 438 "Device.c"
	} else {
		gchar* _tmp10_;
#line 115 "Utility/Device.vala"
		_tmp10_ = g_strdup ("ancient");
#line 115 "Utility/Device.vala"
		_g_free0 (device_lsblk_version);
#line 115 "Utility/Device.vala"
		device_lsblk_version = _tmp10_;
#line 116 "Utility/Device.vala"
		device_lsblk_is_ancient = TRUE;
#line 449 "Device.c"
	}
#line 102 "Utility/Device.vala"
	_g_free0 (std_err);
#line 102 "Utility/Device.vala"
	_g_free0 (std_out);
#line 455 "Device.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 474 "Device.c"
}

gboolean
device_is_mounted_at_path (Device* self,
                           const gchar* subvolname,
                           const gchar* mount_path)
{
	gboolean result = FALSE;
#line 158 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "Utility/Device.vala"
	g_return_val_if_fail (subvolname != NULL, FALSE);
#line 158 "Utility/Device.vala"
	g_return_val_if_fail (mount_path != NULL, FALSE);
#line 489 "Device.c"
	{
		GeeArrayList* _mnt_list = NULL;
		GeeArrayList* _tmp0_;
		gint _mnt_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _mnt_index = 0;
#line 160 "Utility/Device.vala"
		_tmp0_ = self->mount_points;
#line 160 "Utility/Device.vala"
		_mnt_list = _tmp0_;
#line 160 "Utility/Device.vala"
		_tmp1_ = _mnt_list;
#line 160 "Utility/Device.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 160 "Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 160 "Utility/Device.vala"
		_mnt_size = _tmp3_;
#line 160 "Utility/Device.vala"
		_mnt_index = -1;
#line 160 "Utility/Device.vala"
		while (TRUE) {
#line 514 "Device.c"
			gint _tmp4_;
			gint _tmp5_;
			MountEntry* mnt = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			MountEntry* _tmp8_;
			const gchar* _tmp9_;
#line 160 "Utility/Device.vala"
			_mnt_index = _mnt_index + 1;
#line 160 "Utility/Device.vala"
			_tmp4_ = _mnt_index;
#line 160 "Utility/Device.vala"
			_tmp5_ = _mnt_size;
#line 160 "Utility/Device.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 160 "Utility/Device.vala"
				break;
#line 532 "Device.c"
			}
#line 160 "Utility/Device.vala"
			_tmp6_ = _mnt_list;
#line 160 "Utility/Device.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _mnt_index);
#line 160 "Utility/Device.vala"
			mnt = (MountEntry*) _tmp7_;
#line 161 "Utility/Device.vala"
			_tmp8_ = mnt;
#line 161 "Utility/Device.vala"
			_tmp9_ = _tmp8_->mount_point;
#line 161 "Utility/Device.vala"
			if (g_strcmp0 (_tmp9_, mount_path) == 0) {
#line 546 "Device.c"
				gint _tmp10_;
				gint _tmp11_;
#line 162 "Utility/Device.vala"
				_tmp10_ = strlen (subvolname);
#line 162 "Utility/Device.vala"
				_tmp11_ = _tmp10_;
#line 162 "Utility/Device.vala"
				if (_tmp11_ == 0) {
#line 163 "Utility/Device.vala"
					result = TRUE;
#line 163 "Utility/Device.vala"
					_g_object_unref0 (mnt);
#line 163 "Utility/Device.vala"
					return result;
#line 561 "Device.c"
				} else {
					gboolean _tmp12_ = FALSE;
					MountEntry* _tmp13_;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gboolean _tmp17_;
#line 165 "Utility/Device.vala"
					_tmp13_ = mnt;
#line 165 "Utility/Device.vala"
					_tmp14_ = _tmp13_->mount_options;
#line 165 "Utility/Device.vala"
					_tmp15_ = g_strdup_printf ("subvol=%s", subvolname);
#line 165 "Utility/Device.vala"
					_tmp16_ = _tmp15_;
#line 165 "Utility/Device.vala"
					_tmp17_ = string_contains (_tmp14_, _tmp16_);
#line 165 "Utility/Device.vala"
					_g_free0 (_tmp16_);
#line 165 "Utility/Device.vala"
					if (_tmp17_) {
#line 165 "Utility/Device.vala"
						_tmp12_ = TRUE;
#line 585 "Device.c"
					} else {
						MountEntry* _tmp18_;
						const gchar* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
#line 166 "Utility/Device.vala"
						_tmp18_ = mnt;
#line 166 "Utility/Device.vala"
						_tmp19_ = _tmp18_->mount_options;
#line 166 "Utility/Device.vala"
						_tmp20_ = g_strdup_printf ("subvol=/%s", subvolname);
#line 166 "Utility/Device.vala"
						_tmp21_ = _tmp20_;
#line 166 "Utility/Device.vala"
						_tmp12_ = string_contains (_tmp19_, _tmp21_);
#line 166 "Utility/Device.vala"
						_g_free0 (_tmp21_);
#line 603 "Device.c"
					}
#line 165 "Utility/Device.vala"
					if (_tmp12_) {
#line 168 "Utility/Device.vala"
						result = TRUE;
#line 168 "Utility/Device.vala"
						_g_object_unref0 (mnt);
#line 168 "Utility/Device.vala"
						return result;
#line 613 "Device.c"
					}
				}
			}
#line 160 "Utility/Device.vala"
			_g_object_unref0 (mnt);
#line 619 "Device.c"
		}
	}
#line 173 "Utility/Device.vala"
	result = FALSE;
#line 173 "Utility/Device.vala"
	return result;
#line 626 "Device.c"
}

gboolean
device_has_linux_filesystem (Device* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label0 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label1 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label2 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label3 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label4 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label5 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label6 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label7 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label8 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label9 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label10 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label11 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label12 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label13 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label14 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label15 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label16 = 0;
#line 669 "Device.c"
	gboolean result = FALSE;
#line 176 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 177 "Utility/Device.vala"
	_tmp0_ = self->fstype;
#line 177 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 177 "Utility/Device.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 177 "Utility/Device.vala"
	if (((((((((((((((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("ext2")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("ext3"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("ext4"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("f2fs"))))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("reiserfs"))))) || (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("reiser4"))))) || (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("xfs"))))) || (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("jfs"))))) || (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("zfs"))))) || (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("zfs_member"))))) || (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("btrfs"))))) || (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("lvm"))))) || (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("lvm2"))))) || (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("lvm2_member"))))) || (_tmp3_ == ((0 != _tmp2_label14) ? _tmp2_label14 : (_tmp2_label14 = g_quark_from_static_string ("luks"))))) || (_tmp3_ == ((0 != _tmp2_label15) ? _tmp2_label15 : (_tmp2_label15 = g_quark_from_static_string ("crypt"))))) || (_tmp3_ == ((0 != _tmp2_label16) ? _tmp2_label16 : (_tmp2_label16 = g_quark_from_static_string ("crypto_luks"))))) {
#line 177 "Utility/Device.vala"
		switch (0) {
#line 683 "Device.c"
			default:
			{
#line 195 "Utility/Device.vala"
				result = TRUE;
#line 195 "Utility/Device.vala"
				return result;
#line 690 "Device.c"
			}
		}
	} else {
#line 177 "Utility/Device.vala"
		switch (0) {
#line 696 "Device.c"
			default:
			{
#line 197 "Utility/Device.vala"
				result = FALSE;
#line 197 "Utility/Device.vala"
				return result;
#line 703 "Device.c"
			}
		}
	}
}

gboolean
device_is_encrypted_partition (Device* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean result = FALSE;
#line 201 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 202 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 202 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "part") == 0) {
#line 721 "Device.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 202 "Utility/Device.vala"
		_tmp2_ = self->fstype;
#line 202 "Utility/Device.vala"
		_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 202 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 202 "Utility/Device.vala"
		_tmp0_ = string_contains (_tmp4_, "luks");
#line 202 "Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 735 "Device.c"
	} else {
#line 202 "Utility/Device.vala"
		_tmp0_ = FALSE;
#line 739 "Device.c"
	}
#line 202 "Utility/Device.vala"
	result = _tmp0_;
#line 202 "Utility/Device.vala"
	return result;
#line 745 "Device.c"
}

gboolean
device_is_on_encrypted_partition (Device* self)
{
	const gchar* _tmp0_;
	gboolean result = FALSE;
#line 205 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 206 "Utility/Device.vala"
	_tmp0_ = self->type;
#line 206 "Utility/Device.vala"
	result = g_strcmp0 (_tmp0_, "crypt") == 0;
#line 206 "Utility/Device.vala"
	return result;
#line 761 "Device.c"
}

gboolean
device_is_lvm_partition (Device* self)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gboolean result = FALSE;
#line 209 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 210 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 210 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "part") == 0) {
#line 776 "Device.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 210 "Utility/Device.vala"
		_tmp2_ = self->fstype;
#line 210 "Utility/Device.vala"
		_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 210 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 210 "Utility/Device.vala"
		_tmp0_ = string_contains (_tmp4_, "lvm2_member");
#line 210 "Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 790 "Device.c"
	} else {
#line 210 "Utility/Device.vala"
		_tmp0_ = FALSE;
#line 794 "Device.c"
	}
#line 210 "Utility/Device.vala"
	result = _tmp0_;
#line 210 "Utility/Device.vala"
	return result;
#line 800 "Device.c"
}

gboolean
device_has_children (Device* self)
{
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result = FALSE;
#line 213 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 214 "Utility/Device.vala"
	_tmp0_ = self->children;
#line 214 "Utility/Device.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 214 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 214 "Utility/Device.vala"
	result = _tmp2_ > 0;
#line 214 "Utility/Device.vala"
	return result;
#line 822 "Device.c"
}

Device*
device_first_linux_child (Device* self)
{
	Device* result = NULL;
#line 217 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 831 "Device.c"
	{
		GeeArrayList* _child_list = NULL;
		GeeArrayList* _tmp0_;
		gint _child_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _child_index = 0;
#line 219 "Utility/Device.vala"
		_tmp0_ = self->children;
#line 219 "Utility/Device.vala"
		_child_list = _tmp0_;
#line 219 "Utility/Device.vala"
		_tmp1_ = _child_list;
#line 219 "Utility/Device.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 219 "Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 219 "Utility/Device.vala"
		_child_size = _tmp3_;
#line 219 "Utility/Device.vala"
		_child_index = -1;
#line 219 "Utility/Device.vala"
		while (TRUE) {
#line 856 "Device.c"
			gint _tmp4_;
			gint _tmp5_;
			Device* child = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			Device* _tmp8_;
#line 219 "Utility/Device.vala"
			_child_index = _child_index + 1;
#line 219 "Utility/Device.vala"
			_tmp4_ = _child_index;
#line 219 "Utility/Device.vala"
			_tmp5_ = _child_size;
#line 219 "Utility/Device.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 219 "Utility/Device.vala"
				break;
#line 873 "Device.c"
			}
#line 219 "Utility/Device.vala"
			_tmp6_ = _child_list;
#line 219 "Utility/Device.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _child_index);
#line 219 "Utility/Device.vala"
			child = (Device*) _tmp7_;
#line 220 "Utility/Device.vala"
			_tmp8_ = child;
#line 220 "Utility/Device.vala"
			if (device_has_linux_filesystem (_tmp8_)) {
#line 221 "Utility/Device.vala"
				result = child;
#line 221 "Utility/Device.vala"
				return result;
#line 889 "Device.c"
			}
#line 219 "Utility/Device.vala"
			_g_object_unref0 (child);
#line 893 "Device.c"
		}
	}
#line 225 "Utility/Device.vala"
	result = NULL;
#line 225 "Utility/Device.vala"
	return result;
#line 900 "Device.c"
}

gboolean
device_has_parent (Device* self)
{
	Device* _tmp0_;
	gboolean result = FALSE;
#line 228 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 229 "Utility/Device.vala"
	_tmp0_ = self->parent;
#line 229 "Utility/Device.vala"
	result = _tmp0_ != NULL;
#line 229 "Utility/Device.vala"
	return result;
#line 916 "Device.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 261 "Utility/Device.vala"
	return self ? g_object_ref (self) : NULL;
#line 924 "Device.c"
}

GeeArrayList*
device_get_filesystems (gboolean get_space,
                        gboolean get_mounts)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	GeeArrayList* result = NULL;
#line 239 "Utility/Device.vala"
	_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 239 "Utility/Device.vala"
	list = _tmp0_;
#line 241 "Utility/Device.vala"
	if (get_space) {
#line 945 "Device.c"
		GeeArrayList* list_df = NULL;
		GeeArrayList* _tmp1_;
#line 243 "Utility/Device.vala"
		_tmp1_ = device_get_disk_space_using_df ("");
#line 243 "Utility/Device.vala"
		list_df = _tmp1_;
#line 952 "Device.c"
		{
			GeeArrayList* _dev_df_list = NULL;
			GeeArrayList* _tmp2_;
			gint _dev_df_size = 0;
			GeeArrayList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			gint _dev_df_index = 0;
#line 244 "Utility/Device.vala"
			_tmp2_ = list_df;
#line 244 "Utility/Device.vala"
			_dev_df_list = _tmp2_;
#line 244 "Utility/Device.vala"
			_tmp3_ = _dev_df_list;
#line 244 "Utility/Device.vala"
			_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 244 "Utility/Device.vala"
			_tmp5_ = _tmp4_;
#line 244 "Utility/Device.vala"
			_dev_df_size = _tmp5_;
#line 244 "Utility/Device.vala"
			_dev_df_index = -1;
#line 244 "Utility/Device.vala"
			while (TRUE) {
#line 977 "Device.c"
				gint _tmp6_;
				gint _tmp7_;
				Device* dev_df = NULL;
				GeeArrayList* _tmp8_;
				gpointer _tmp9_;
				Device* dev = NULL;
				GeeArrayList* _tmp10_;
				Device* _tmp11_;
				const gchar* _tmp12_;
				Device* _tmp13_;
				Device* _tmp14_;
#line 244 "Utility/Device.vala"
				_dev_df_index = _dev_df_index + 1;
#line 244 "Utility/Device.vala"
				_tmp6_ = _dev_df_index;
#line 244 "Utility/Device.vala"
				_tmp7_ = _dev_df_size;
#line 244 "Utility/Device.vala"
				if (!(_tmp6_ < _tmp7_)) {
#line 244 "Utility/Device.vala"
					break;
#line 999 "Device.c"
				}
#line 244 "Utility/Device.vala"
				_tmp8_ = _dev_df_list;
#line 244 "Utility/Device.vala"
				_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _dev_df_index);
#line 244 "Utility/Device.vala"
				dev_df = (Device*) _tmp9_;
#line 245 "Utility/Device.vala"
				_tmp10_ = list;
#line 245 "Utility/Device.vala"
				_tmp11_ = dev_df;
#line 245 "Utility/Device.vala"
				_tmp12_ = _tmp11_->uuid;
#line 245 "Utility/Device.vala"
				_tmp13_ = device_find_device_in_list (_tmp10_, _tmp12_);
#line 245 "Utility/Device.vala"
				dev = _tmp13_;
#line 246 "Utility/Device.vala"
				_tmp14_ = dev;
#line 246 "Utility/Device.vala"
				if (_tmp14_ != NULL) {
#line 1021 "Device.c"
					Device* _tmp15_;
					Device* _tmp16_;
					Device* _tmp17_;
					Device* _tmp18_;
					Device* _tmp19_;
					Device* _tmp20_;
					Device* _tmp21_;
					Device* _tmp22_;
					const gchar* _tmp23_;
					gchar* _tmp24_;
#line 247 "Utility/Device.vala"
					_tmp15_ = dev;
#line 247 "Utility/Device.vala"
					_tmp16_ = dev_df;
#line 247 "Utility/Device.vala"
					_tmp15_->size_bytes = _tmp16_->size_bytes;
#line 248 "Utility/Device.vala"
					_tmp17_ = dev;
#line 248 "Utility/Device.vala"
					_tmp18_ = dev_df;
#line 248 "Utility/Device.vala"
					_tmp17_->used_bytes = _tmp18_->used_bytes;
#line 249 "Utility/Device.vala"
					_tmp19_ = dev;
#line 249 "Utility/Device.vala"
					_tmp20_ = dev_df;
#line 249 "Utility/Device.vala"
					_tmp19_->available_bytes = _tmp20_->available_bytes;
#line 250 "Utility/Device.vala"
					_tmp21_ = dev;
#line 250 "Utility/Device.vala"
					_tmp22_ = dev_df;
#line 250 "Utility/Device.vala"
					_tmp23_ = _tmp22_->used_percent;
#line 250 "Utility/Device.vala"
					_tmp24_ = g_strdup (_tmp23_);
#line 250 "Utility/Device.vala"
					_g_free0 (_tmp21_->used_percent);
#line 250 "Utility/Device.vala"
					_tmp21_->used_percent = _tmp24_;
#line 1062 "Device.c"
				}
#line 244 "Utility/Device.vala"
				_g_object_unref0 (dev);
#line 244 "Utility/Device.vala"
				_g_object_unref0 (dev_df);
#line 1068 "Device.c"
			}
		}
#line 241 "Utility/Device.vala"
		_g_object_unref0 (list_df);
#line 1073 "Device.c"
	}
#line 255 "Utility/Device.vala"
	if (get_mounts) {
#line 1077 "Device.c"
		GeeArrayList* list_mtab = NULL;
		GeeArrayList* _tmp25_;
#line 257 "Utility/Device.vala"
		_tmp25_ = device_get_mounted_filesystems_using_mtab ();
#line 257 "Utility/Device.vala"
		list_mtab = _tmp25_;
#line 1084 "Device.c"
		{
			GeeArrayList* _dev_mtab_list = NULL;
			GeeArrayList* _tmp26_;
			gint _dev_mtab_size = 0;
			GeeArrayList* _tmp27_;
			gint _tmp28_;
			gint _tmp29_;
			gint _dev_mtab_index = 0;
#line 258 "Utility/Device.vala"
			_tmp26_ = list_mtab;
#line 258 "Utility/Device.vala"
			_dev_mtab_list = _tmp26_;
#line 258 "Utility/Device.vala"
			_tmp27_ = _dev_mtab_list;
#line 258 "Utility/Device.vala"
			_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
#line 258 "Utility/Device.vala"
			_tmp29_ = _tmp28_;
#line 258 "Utility/Device.vala"
			_dev_mtab_size = _tmp29_;
#line 258 "Utility/Device.vala"
			_dev_mtab_index = -1;
#line 258 "Utility/Device.vala"
			while (TRUE) {
#line 1109 "Device.c"
				gint _tmp30_;
				gint _tmp31_;
				Device* dev_mtab = NULL;
				GeeArrayList* _tmp32_;
				gpointer _tmp33_;
				Device* dev = NULL;
				GeeArrayList* _tmp34_;
				Device* _tmp35_;
				const gchar* _tmp36_;
				Device* _tmp37_;
				Device* _tmp38_;
#line 258 "Utility/Device.vala"
				_dev_mtab_index = _dev_mtab_index + 1;
#line 258 "Utility/Device.vala"
				_tmp30_ = _dev_mtab_index;
#line 258 "Utility/Device.vala"
				_tmp31_ = _dev_mtab_size;
#line 258 "Utility/Device.vala"
				if (!(_tmp30_ < _tmp31_)) {
#line 258 "Utility/Device.vala"
					break;
#line 1131 "Device.c"
				}
#line 258 "Utility/Device.vala"
				_tmp32_ = _dev_mtab_list;
#line 258 "Utility/Device.vala"
				_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, _dev_mtab_index);
#line 258 "Utility/Device.vala"
				dev_mtab = (Device*) _tmp33_;
#line 259 "Utility/Device.vala"
				_tmp34_ = list;
#line 259 "Utility/Device.vala"
				_tmp35_ = dev_mtab;
#line 259 "Utility/Device.vala"
				_tmp36_ = _tmp35_->uuid;
#line 259 "Utility/Device.vala"
				_tmp37_ = device_find_device_in_list (_tmp34_, _tmp36_);
#line 259 "Utility/Device.vala"
				dev = _tmp37_;
#line 260 "Utility/Device.vala"
				_tmp38_ = dev;
#line 260 "Utility/Device.vala"
				if (_tmp38_ != NULL) {
#line 1153 "Device.c"
					Device* _tmp39_;
					Device* _tmp40_;
					GeeArrayList* _tmp41_;
					GeeArrayList* _tmp42_;
#line 261 "Utility/Device.vala"
					_tmp39_ = dev;
#line 261 "Utility/Device.vala"
					_tmp40_ = dev_mtab;
#line 261 "Utility/Device.vala"
					_tmp41_ = _tmp40_->mount_points;
#line 261 "Utility/Device.vala"
					_tmp42_ = _g_object_ref0 (_tmp41_);
#line 261 "Utility/Device.vala"
					_g_object_unref0 (_tmp39_->mount_points);
#line 261 "Utility/Device.vala"
					_tmp39_->mount_points = _tmp42_;
#line 1170 "Device.c"
				}
#line 258 "Utility/Device.vala"
				_g_object_unref0 (dev);
#line 258 "Utility/Device.vala"
				_g_object_unref0 (dev_mtab);
#line 1176 "Device.c"
			}
		}
#line 255 "Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 1181 "Device.c"
	}
#line 270 "Utility/Device.vala"
	_tmp43_ = list;
#line 270 "Utility/Device.vala"
	_tmp44_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp43_);
#line 270 "Utility/Device.vala"
	_tmp45_ = _tmp44_;
#line 270 "Utility/Device.vala"
	_tmp46_ = g_strdup_printf ("Device: get_filesystems(): %d", _tmp45_);
#line 270 "Utility/Device.vala"
	_tmp47_ = _tmp46_;
#line 270 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp47_);
#line 270 "Utility/Device.vala"
	_g_free0 (_tmp47_);
#line 272 "Utility/Device.vala"
	result = list;
#line 272 "Utility/Device.vala"
	return result;
#line 1201 "Device.c"
}

static void
device_find_child_devices (GeeArrayList* list,
                           Device* parent)
{
	gboolean _tmp0_ = FALSE;
#line 275 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 275 "Utility/Device.vala"
	g_return_if_fail (parent != NULL);
#line 276 "Utility/Device.vala"
	if (device_lsblk_is_ancient) {
#line 1215 "Device.c"
		const gchar* _tmp1_;
#line 276 "Utility/Device.vala"
		_tmp1_ = parent->type;
#line 276 "Utility/Device.vala"
		_tmp0_ = g_strcmp0 (_tmp1_, "disk") == 0;
#line 1221 "Device.c"
	} else {
#line 276 "Utility/Device.vala"
		_tmp0_ = FALSE;
#line 1225 "Device.c"
	}
#line 276 "Utility/Device.vala"
	if (_tmp0_) {
#line 1229 "Device.c"
		{
			GeeArrayList* _part_list = NULL;
			gint _part_size = 0;
			GeeArrayList* _tmp2_;
			gint _tmp3_;
			gint _tmp4_;
			gint _part_index = 0;
#line 277 "Utility/Device.vala"
			_part_list = list;
#line 277 "Utility/Device.vala"
			_tmp2_ = _part_list;
#line 277 "Utility/Device.vala"
			_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 277 "Utility/Device.vala"
			_tmp4_ = _tmp3_;
#line 277 "Utility/Device.vala"
			_part_size = _tmp4_;
#line 277 "Utility/Device.vala"
			_part_index = -1;
#line 277 "Utility/Device.vala"
			while (TRUE) {
#line 1251 "Device.c"
				gint _tmp5_;
				gint _tmp6_;
				Device* part = NULL;
				GeeArrayList* _tmp7_;
				gpointer _tmp8_;
				gboolean _tmp9_ = FALSE;
				Device* _tmp10_;
				const gchar* _tmp11_;
				const gchar* _tmp12_;
#line 277 "Utility/Device.vala"
				_part_index = _part_index + 1;
#line 277 "Utility/Device.vala"
				_tmp5_ = _part_index;
#line 277 "Utility/Device.vala"
				_tmp6_ = _part_size;
#line 277 "Utility/Device.vala"
				if (!(_tmp5_ < _tmp6_)) {
#line 277 "Utility/Device.vala"
					break;
#line 1271 "Device.c"
				}
#line 277 "Utility/Device.vala"
				_tmp7_ = _part_list;
#line 277 "Utility/Device.vala"
				_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _part_index);
#line 277 "Utility/Device.vala"
				part = (Device*) _tmp8_;
#line 278 "Utility/Device.vala"
				_tmp10_ = part;
#line 278 "Utility/Device.vala"
				_tmp11_ = _tmp10_->kname;
#line 278 "Utility/Device.vala"
				_tmp12_ = parent->kname;
#line 278 "Utility/Device.vala"
				if (g_strcmp0 (_tmp11_, _tmp12_) != 0) {
#line 1287 "Device.c"
					Device* _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
#line 278 "Utility/Device.vala"
					_tmp13_ = part;
#line 278 "Utility/Device.vala"
					_tmp14_ = _tmp13_->kname;
#line 278 "Utility/Device.vala"
					_tmp15_ = parent->kname;
#line 278 "Utility/Device.vala"
					_tmp9_ = g_str_has_prefix (_tmp14_, _tmp15_);
#line 1299 "Device.c"
				} else {
#line 278 "Utility/Device.vala"
					_tmp9_ = FALSE;
#line 1303 "Device.c"
				}
#line 278 "Utility/Device.vala"
				if (_tmp9_) {
#line 1307 "Device.c"
					GeeArrayList* _tmp16_;
					Device* _tmp17_;
					Device* _tmp18_;
					Device* _tmp19_;
					Device* _tmp20_;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					const gchar* _tmp23_;
					Device* _tmp24_;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					gchar* _tmp27_;
#line 279 "Utility/Device.vala"
					_tmp16_ = parent->children;
#line 279 "Utility/Device.vala"
					_tmp17_ = part;
#line 279 "Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 280 "Utility/Device.vala"
					_tmp18_ = part;
#line 280 "Utility/Device.vala"
					_tmp19_ = _g_object_ref0 (parent);
#line 280 "Utility/Device.vala"
					_g_object_unref0 (_tmp18_->parent);
#line 280 "Utility/Device.vala"
					_tmp18_->parent = _tmp19_;
#line 281 "Utility/Device.vala"
					_tmp20_ = part;
#line 281 "Utility/Device.vala"
					_tmp21_ = parent->kname;
#line 281 "Utility/Device.vala"
					_tmp22_ = g_strdup (_tmp21_);
#line 281 "Utility/Device.vala"
					_g_free0 (_tmp20_->pkname);
#line 281 "Utility/Device.vala"
					_tmp20_->pkname = _tmp22_;
#line 282 "Utility/Device.vala"
					_tmp23_ = parent->kname;
#line 282 "Utility/Device.vala"
					_tmp24_ = part;
#line 282 "Utility/Device.vala"
					_tmp25_ = _tmp24_->kname;
#line 282 "Utility/Device.vala"
					_tmp26_ = g_strdup_printf ("%s -> %s", _tmp23_, _tmp25_);
#line 282 "Utility/Device.vala"
					_tmp27_ = _tmp26_;
#line 282 "Utility/Device.vala"
					tee_jee_logging_log_debug (_tmp27_);
#line 282 "Utility/Device.vala"
					_g_free0 (_tmp27_);
#line 1358 "Device.c"
				}
#line 277 "Utility/Device.vala"
				_g_object_unref0 (part);
#line 1362 "Device.c"
			}
		}
	} else {
		{
			GeeArrayList* _part_list = NULL;
			gint _part_size = 0;
			GeeArrayList* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gint _part_index = 0;
#line 287 "Utility/Device.vala"
			_part_list = list;
#line 287 "Utility/Device.vala"
			_tmp28_ = _part_list;
#line 287 "Utility/Device.vala"
			_tmp29_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp28_);
#line 287 "Utility/Device.vala"
			_tmp30_ = _tmp29_;
#line 287 "Utility/Device.vala"
			_part_size = _tmp30_;
#line 287 "Utility/Device.vala"
			_part_index = -1;
#line 287 "Utility/Device.vala"
			while (TRUE) {
#line 1387 "Device.c"
				gint _tmp31_;
				gint _tmp32_;
				Device* part = NULL;
				GeeArrayList* _tmp33_;
				gpointer _tmp34_;
				Device* _tmp35_;
				const gchar* _tmp36_;
				const gchar* _tmp37_;
#line 287 "Utility/Device.vala"
				_part_index = _part_index + 1;
#line 287 "Utility/Device.vala"
				_tmp31_ = _part_index;
#line 287 "Utility/Device.vala"
				_tmp32_ = _part_size;
#line 287 "Utility/Device.vala"
				if (!(_tmp31_ < _tmp32_)) {
#line 287 "Utility/Device.vala"
					break;
#line 1406 "Device.c"
				}
#line 287 "Utility/Device.vala"
				_tmp33_ = _part_list;
#line 287 "Utility/Device.vala"
				_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) _tmp33_, _part_index);
#line 287 "Utility/Device.vala"
				part = (Device*) _tmp34_;
#line 288 "Utility/Device.vala"
				_tmp35_ = part;
#line 288 "Utility/Device.vala"
				_tmp36_ = _tmp35_->pkname;
#line 288 "Utility/Device.vala"
				_tmp37_ = parent->kname;
#line 288 "Utility/Device.vala"
				if (g_strcmp0 (_tmp36_, _tmp37_) == 0) {
#line 1422 "Device.c"
					GeeArrayList* _tmp38_;
					Device* _tmp39_;
					Device* _tmp40_;
					Device* _tmp41_;
#line 289 "Utility/Device.vala"
					_tmp38_ = parent->children;
#line 289 "Utility/Device.vala"
					_tmp39_ = part;
#line 289 "Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, _tmp39_);
#line 290 "Utility/Device.vala"
					_tmp40_ = part;
#line 290 "Utility/Device.vala"
					_tmp41_ = _g_object_ref0 (parent);
#line 290 "Utility/Device.vala"
					_g_object_unref0 (_tmp40_->parent);
#line 290 "Utility/Device.vala"
					_tmp40_->parent = _tmp41_;
#line 1441 "Device.c"
				}
#line 287 "Utility/Device.vala"
				_g_object_unref0 (part);
#line 1445 "Device.c"
			}
		}
	}
}

static void
device_find_toplevel_parent (GeeArrayList* list,
                             Device* dev)
{
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* top_kname = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
#line 296 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 296 "Utility/Device.vala"
	g_return_if_fail (dev != NULL);
#line 298 "Utility/Device.vala"
	_tmp0_ = dev->pkname;
#line 298 "Utility/Device.vala"
	_tmp1_ = strlen (_tmp0_);
#line 298 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 298 "Utility/Device.vala"
	if (_tmp2_ == 0) {
#line 298 "Utility/Device.vala"
		return;
#line 1477 "Device.c"
	}
#line 300 "Utility/Device.vala"
	_tmp3_ = dev->pkname;
#line 300 "Utility/Device.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 300 "Utility/Device.vala"
	top_kname = _tmp4_;
#line 1485 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		gint _part_size = 0;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _part_index = 0;
#line 302 "Utility/Device.vala"
		_part_list = list;
#line 302 "Utility/Device.vala"
		_tmp5_ = _part_list;
#line 302 "Utility/Device.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 302 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 302 "Utility/Device.vala"
		_part_size = _tmp7_;
#line 302 "Utility/Device.vala"
		_part_index = -1;
#line 302 "Utility/Device.vala"
		while (TRUE) {
#line 1507 "Device.c"
			gint _tmp8_;
			gint _tmp9_;
			Device* part = NULL;
			GeeArrayList* _tmp10_;
			gpointer _tmp11_;
			Device* _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
#line 302 "Utility/Device.vala"
			_part_index = _part_index + 1;
#line 302 "Utility/Device.vala"
			_tmp8_ = _part_index;
#line 302 "Utility/Device.vala"
			_tmp9_ = _part_size;
#line 302 "Utility/Device.vala"
			if (!(_tmp8_ < _tmp9_)) {
#line 302 "Utility/Device.vala"
				break;
#line 1526 "Device.c"
			}
#line 302 "Utility/Device.vala"
			_tmp10_ = _part_list;
#line 302 "Utility/Device.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp10_, _part_index);
#line 302 "Utility/Device.vala"
			part = (Device*) _tmp11_;
#line 303 "Utility/Device.vala"
			_tmp12_ = part;
#line 303 "Utility/Device.vala"
			_tmp13_ = _tmp12_->kname;
#line 303 "Utility/Device.vala"
			_tmp14_ = top_kname;
#line 303 "Utility/Device.vala"
			if (g_strcmp0 (_tmp13_, _tmp14_) == 0) {
#line 1542 "Device.c"
				Device* _tmp15_;
				const gchar* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
#line 304 "Utility/Device.vala"
				_tmp15_ = part;
#line 304 "Utility/Device.vala"
				_tmp16_ = _tmp15_->pkname;
#line 304 "Utility/Device.vala"
				_tmp17_ = strlen (_tmp16_);
#line 304 "Utility/Device.vala"
				_tmp18_ = _tmp17_;
#line 304 "Utility/Device.vala"
				if (_tmp18_ > 0) {
#line 1557 "Device.c"
					Device* _tmp19_;
					const gchar* _tmp20_;
					gchar* _tmp21_;
#line 305 "Utility/Device.vala"
					_tmp19_ = part;
#line 305 "Utility/Device.vala"
					_tmp20_ = _tmp19_->pkname;
#line 305 "Utility/Device.vala"
					_tmp21_ = g_strdup (_tmp20_);
#line 305 "Utility/Device.vala"
					_g_free0 (top_kname);
#line 305 "Utility/Device.vala"
					top_kname = _tmp21_;
#line 1571 "Device.c"
				}
			}
#line 302 "Utility/Device.vala"
			_g_object_unref0 (part);
#line 1576 "Device.c"
		}
	}
#line 310 "Utility/Device.vala"
	_tmp22_ = top_kname;
#line 310 "Utility/Device.vala"
	_tmp23_ = g_strdup (_tmp22_);
#line 310 "Utility/Device.vala"
	_g_free0 (dev->pkname_toplevel);
#line 310 "Utility/Device.vala"
	dev->pkname_toplevel = _tmp23_;
#line 296 "Utility/Device.vala"
	_g_free0 (top_kname);
#line 1589 "Device.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 1610 "Device.c"
}

static void
device_find_child_devices_using_dmsetup (GeeArrayList* list)
{
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	GError* _inner_error0_ = NULL;
#line 315 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 318 "Utility/Device.vala"
	tee_jee_process_helper_exec_sync ("dmsetup deps -o blkdevname", &_tmp0_, &_tmp1_);
#line 318 "Utility/Device.vala"
	_g_free0 (std_out);
#line 318 "Utility/Device.vala"
	std_out = _tmp0_;
#line 318 "Utility/Device.vala"
	_g_free0 (std_err);
#line 318 "Utility/Device.vala"
	std_err = _tmp1_;
#line 329 "Utility/Device.vala"
	_tmp2_ = std_out;
#line 329 "Utility/Device.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 1642 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 329 "Utility/Device.vala"
		line_collection = _tmp4_;
#line 329 "Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp3_);
#line 329 "Utility/Device.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1654 "Device.c"
			gchar* _tmp5_;
			gchar* line = NULL;
#line 329 "Utility/Device.vala"
			_tmp5_ = g_strdup (line_collection[line_it]);
#line 329 "Utility/Device.vala"
			line = _tmp5_;
#line 1661 "Device.c"
			{
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				gboolean _tmp11_;
#line 330 "Utility/Device.vala"
				_tmp6_ = line;
#line 330 "Utility/Device.vala"
				_tmp7_ = string_strip (_tmp6_);
#line 330 "Utility/Device.vala"
				_tmp8_ = _tmp7_;
#line 330 "Utility/Device.vala"
				_tmp9_ = strlen (_tmp8_);
#line 330 "Utility/Device.vala"
				_tmp10_ = _tmp9_;
#line 330 "Utility/Device.vala"
				_tmp11_ = _tmp10_ == 0;
#line 330 "Utility/Device.vala"
				_g_free0 (_tmp8_);
#line 330 "Utility/Device.vala"
				if (_tmp11_) {
#line 330 "Utility/Device.vala"
					_g_free0 (line);
#line 330 "Utility/Device.vala"
					continue;
#line 1689 "Device.c"
				}
				{
					GRegex* _tmp12_ = NULL;
					GRegex* _tmp13_;
					GRegex* _tmp14_;
					GRegex* _tmp15_;
					const gchar* _tmp16_;
					GMatchInfo* _tmp17_ = NULL;
					gboolean _tmp18_;
#line 334 "Utility/Device.vala"
					_tmp13_ = g_regex_new ("([^:]*)\\:.*\\((.*)\\)", 0, 0, &_inner_error0_);
#line 334 "Utility/Device.vala"
					_tmp12_ = _tmp13_;
#line 334 "Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1705 "Device.c"
						goto __catch0_g_error;
					}
#line 334 "Utility/Device.vala"
					_tmp14_ = _tmp12_;
#line 334 "Utility/Device.vala"
					_tmp12_ = NULL;
#line 334 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 334 "Utility/Device.vala"
					rex = _tmp14_;
#line 336 "Utility/Device.vala"
					_tmp15_ = rex;
#line 336 "Utility/Device.vala"
					_tmp16_ = line;
#line 336 "Utility/Device.vala"
					_tmp18_ = g_regex_match (_tmp15_, _tmp16_, 0, &_tmp17_);
#line 336 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 336 "Utility/Device.vala"
					match = _tmp17_;
#line 336 "Utility/Device.vala"
					if (_tmp18_) {
#line 1728 "Device.c"
						gchar* child_name = NULL;
						GMatchInfo* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* parent_kname = NULL;
						GMatchInfo* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						Device* parent = NULL;
						Device* child = NULL;
						gboolean _tmp53_ = FALSE;
						Device* _tmp54_;
#line 338 "Utility/Device.vala"
						_tmp19_ = match;
#line 338 "Utility/Device.vala"
						_tmp20_ = g_match_info_fetch (_tmp19_, 1);
#line 338 "Utility/Device.vala"
						_tmp21_ = _tmp20_;
#line 338 "Utility/Device.vala"
						_tmp22_ = string_strip (_tmp21_);
#line 338 "Utility/Device.vala"
						_tmp23_ = _tmp22_;
#line 338 "Utility/Device.vala"
						_g_free0 (_tmp21_);
#line 338 "Utility/Device.vala"
						child_name = _tmp23_;
#line 339 "Utility/Device.vala"
						_tmp24_ = match;
#line 339 "Utility/Device.vala"
						_tmp25_ = g_match_info_fetch (_tmp24_, 2);
#line 339 "Utility/Device.vala"
						_tmp26_ = _tmp25_;
#line 339 "Utility/Device.vala"
						_tmp27_ = string_strip (_tmp26_);
#line 339 "Utility/Device.vala"
						_tmp28_ = _tmp27_;
#line 339 "Utility/Device.vala"
						_g_free0 (_tmp26_);
#line 339 "Utility/Device.vala"
						parent_kname = _tmp28_;
#line 341 "Utility/Device.vala"
						parent = NULL;
#line 1775 "Device.c"
						{
							GeeArrayList* _dev_list = NULL;
							gint _dev_size = 0;
							GeeArrayList* _tmp29_;
							gint _tmp30_;
							gint _tmp31_;
							gint _dev_index = 0;
#line 342 "Utility/Device.vala"
							_dev_list = list;
#line 342 "Utility/Device.vala"
							_tmp29_ = _dev_list;
#line 342 "Utility/Device.vala"
							_tmp30_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp29_);
#line 342 "Utility/Device.vala"
							_tmp31_ = _tmp30_;
#line 342 "Utility/Device.vala"
							_dev_size = _tmp31_;
#line 342 "Utility/Device.vala"
							_dev_index = -1;
#line 342 "Utility/Device.vala"
							while (TRUE) {
#line 1797 "Device.c"
								gint _tmp32_;
								gint _tmp33_;
								Device* dev = NULL;
								GeeArrayList* _tmp34_;
								gpointer _tmp35_;
								Device* _tmp36_;
								const gchar* _tmp37_;
								const gchar* _tmp38_;
#line 342 "Utility/Device.vala"
								_dev_index = _dev_index + 1;
#line 342 "Utility/Device.vala"
								_tmp32_ = _dev_index;
#line 342 "Utility/Device.vala"
								_tmp33_ = _dev_size;
#line 342 "Utility/Device.vala"
								if (!(_tmp32_ < _tmp33_)) {
#line 342 "Utility/Device.vala"
									break;
#line 1816 "Device.c"
								}
#line 342 "Utility/Device.vala"
								_tmp34_ = _dev_list;
#line 342 "Utility/Device.vala"
								_tmp35_ = gee_abstract_list_get ((GeeAbstractList*) _tmp34_, _dev_index);
#line 342 "Utility/Device.vala"
								dev = (Device*) _tmp35_;
#line 343 "Utility/Device.vala"
								_tmp36_ = dev;
#line 343 "Utility/Device.vala"
								_tmp37_ = _tmp36_->kname;
#line 343 "Utility/Device.vala"
								_tmp38_ = parent_kname;
#line 343 "Utility/Device.vala"
								if (g_strcmp0 (_tmp37_, _tmp38_) == 0) {
#line 1832 "Device.c"
									Device* _tmp39_;
									Device* _tmp40_;
#line 344 "Utility/Device.vala"
									_tmp39_ = dev;
#line 344 "Utility/Device.vala"
									_tmp40_ = _g_object_ref0 (_tmp39_);
#line 344 "Utility/Device.vala"
									_g_object_unref0 (parent);
#line 344 "Utility/Device.vala"
									parent = _tmp40_;
#line 345 "Utility/Device.vala"
									_g_object_unref0 (dev);
#line 345 "Utility/Device.vala"
									break;
#line 1847 "Device.c"
								}
#line 342 "Utility/Device.vala"
								_g_object_unref0 (dev);
#line 1851 "Device.c"
							}
						}
#line 349 "Utility/Device.vala"
						child = NULL;
#line 1856 "Device.c"
						{
							GeeArrayList* _dev_list = NULL;
							gint _dev_size = 0;
							GeeArrayList* _tmp41_;
							gint _tmp42_;
							gint _tmp43_;
							gint _dev_index = 0;
#line 350 "Utility/Device.vala"
							_dev_list = list;
#line 350 "Utility/Device.vala"
							_tmp41_ = _dev_list;
#line 350 "Utility/Device.vala"
							_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
#line 350 "Utility/Device.vala"
							_tmp43_ = _tmp42_;
#line 350 "Utility/Device.vala"
							_dev_size = _tmp43_;
#line 350 "Utility/Device.vala"
							_dev_index = -1;
#line 350 "Utility/Device.vala"
							while (TRUE) {
#line 1878 "Device.c"
								gint _tmp44_;
								gint _tmp45_;
								Device* dev = NULL;
								GeeArrayList* _tmp46_;
								gpointer _tmp47_;
								Device* _tmp48_;
								const gchar* _tmp49_;
								const gchar* _tmp50_;
#line 350 "Utility/Device.vala"
								_dev_index = _dev_index + 1;
#line 350 "Utility/Device.vala"
								_tmp44_ = _dev_index;
#line 350 "Utility/Device.vala"
								_tmp45_ = _dev_size;
#line 350 "Utility/Device.vala"
								if (!(_tmp44_ < _tmp45_)) {
#line 350 "Utility/Device.vala"
									break;
#line 1897 "Device.c"
								}
#line 350 "Utility/Device.vala"
								_tmp46_ = _dev_list;
#line 350 "Utility/Device.vala"
								_tmp47_ = gee_abstract_list_get ((GeeAbstractList*) _tmp46_, _dev_index);
#line 350 "Utility/Device.vala"
								dev = (Device*) _tmp47_;
#line 351 "Utility/Device.vala"
								_tmp48_ = dev;
#line 351 "Utility/Device.vala"
								_tmp49_ = _tmp48_->mapped_name;
#line 351 "Utility/Device.vala"
								_tmp50_ = child_name;
#line 351 "Utility/Device.vala"
								if (g_strcmp0 (_tmp49_, _tmp50_) == 0) {
#line 1913 "Device.c"
									Device* _tmp51_;
									Device* _tmp52_;
#line 352 "Utility/Device.vala"
									_tmp51_ = dev;
#line 352 "Utility/Device.vala"
									_tmp52_ = _g_object_ref0 (_tmp51_);
#line 352 "Utility/Device.vala"
									_g_object_unref0 (child);
#line 352 "Utility/Device.vala"
									child = _tmp52_;
#line 353 "Utility/Device.vala"
									_g_object_unref0 (dev);
#line 353 "Utility/Device.vala"
									break;
#line 1928 "Device.c"
								}
#line 350 "Utility/Device.vala"
								_g_object_unref0 (dev);
#line 1932 "Device.c"
							}
						}
#line 357 "Utility/Device.vala"
						_tmp54_ = parent;
#line 357 "Utility/Device.vala"
						if (_tmp54_ != NULL) {
#line 1939 "Device.c"
							Device* _tmp55_;
#line 357 "Utility/Device.vala"
							_tmp55_ = child;
#line 357 "Utility/Device.vala"
							_tmp53_ = _tmp55_ != NULL;
#line 1945 "Device.c"
						} else {
#line 357 "Utility/Device.vala"
							_tmp53_ = FALSE;
#line 1949 "Device.c"
						}
#line 357 "Utility/Device.vala"
						if (_tmp53_) {
#line 1953 "Device.c"
							Device* _tmp56_;
							Device* _tmp57_;
							const gchar* _tmp58_;
							gchar* _tmp59_;
#line 358 "Utility/Device.vala"
							_tmp56_ = child;
#line 358 "Utility/Device.vala"
							_tmp57_ = parent;
#line 358 "Utility/Device.vala"
							_tmp58_ = _tmp57_->kname;
#line 358 "Utility/Device.vala"
							_tmp59_ = g_strdup (_tmp58_);
#line 358 "Utility/Device.vala"
							_g_free0 (_tmp56_->pkname);
#line 358 "Utility/Device.vala"
							_tmp56_->pkname = _tmp59_;
#line 1970 "Device.c"
						}
#line 336 "Utility/Device.vala"
						_g_object_unref0 (child);
#line 336 "Utility/Device.vala"
						_g_object_unref0 (parent);
#line 336 "Utility/Device.vala"
						_g_free0 (parent_kname);
#line 336 "Utility/Device.vala"
						_g_free0 (child_name);
#line 1980 "Device.c"
					} else {
						const gchar* _tmp60_;
						gchar* _tmp61_;
						gchar* _tmp62_;
#line 364 "Utility/Device.vala"
						_tmp60_ = line;
#line 364 "Utility/Device.vala"
						_tmp61_ = g_strdup_printf ("no-match: %s", _tmp60_);
#line 364 "Utility/Device.vala"
						_tmp62_ = _tmp61_;
#line 364 "Utility/Device.vala"
						tee_jee_logging_log_debug (_tmp62_);
#line 364 "Utility/Device.vala"
						_g_free0 (_tmp62_);
#line 1995 "Device.c"
					}
#line 332 "Utility/Device.vala"
					_g_regex_unref0 (_tmp12_);
#line 1999 "Device.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp63_;
					const gchar* _tmp64_;
#line 332 "Utility/Device.vala"
					e = _inner_error0_;
#line 332 "Utility/Device.vala"
					_inner_error0_ = NULL;
#line 368 "Utility/Device.vala"
					_tmp63_ = e;
#line 368 "Utility/Device.vala"
					_tmp64_ = _tmp63_->message;
#line 368 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp64_, FALSE, FALSE);
#line 332 "Utility/Device.vala"
					_g_error_free0 (e);
#line 2019 "Device.c"
				}
				__finally0:
#line 332 "Utility/Device.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 332 "Utility/Device.vala"
					_g_free0 (line);
#line 332 "Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 332 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 332 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 332 "Utility/Device.vala"
					_g_free0 (std_err);
#line 332 "Utility/Device.vala"
					_g_free0 (std_out);
#line 332 "Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 332 "Utility/Device.vala"
					g_clear_error (&_inner_error0_);
#line 332 "Utility/Device.vala"
					return;
#line 2042 "Device.c"
				}
#line 329 "Utility/Device.vala"
				_g_free0 (line);
#line 2046 "Device.c"
			}
		}
#line 329 "Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2051 "Device.c"
	}
#line 315 "Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 315 "Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 315 "Utility/Device.vala"
	_g_free0 (std_err);
#line 315 "Utility/Device.vala"
	_g_free0 (std_out);
#line 2061 "Device.c"
}

static gint64
int64_parse (const gchar* str,
             guint _base)
{
	gint64 result = 0LL;
#line 770 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 771 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, _base);
#line 771 "glib-2.0.vapi"
	return result;
#line 2075 "Device.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2097 "Device.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2101 "Device.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2107 "Device.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2111 "Device.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2115 "Device.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 2123 "Device.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2151 "Device.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 2160 "Device.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2174 "Device.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 2183 "Device.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 2197 "Device.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2206 "Device.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 2215 "Device.c"
}

GeeArrayList*
device_get_block_devices_using_lsblk (const gchar* dev_name)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	gint _tmp3_;
	gint _tmp4_;
	const gchar* _tmp9_;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gint _tmp12_;
	gint index = 0;
	const gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	GeeArrayList* _tmp284_;
	GeeArrayList* _tmp285_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result = NULL;
#line 374 "Utility/Device.vala"
	g_return_val_if_fail (dev_name != NULL, NULL);
#line 381 "Utility/Device.vala"
	device_test_lsblk_version ();
#line 383 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 383 "Utility/Device.vala"
	list = _tmp0_;
#line 392 "Utility/Device.vala"
	if (device_lsblk_is_ancient) {
#line 2253 "Device.c"
		gchar* _tmp1_;
#line 393 "Utility/Device.vala"
		_tmp1_ = g_strdup ("lsblk --bytes --pairs --output NAME,KNAME,LABEL,UUID,TYPE,FSTYPE,SIZE," \
"MOUNTPOINT,MODEL,RO,RM,MAJ:MIN");
#line 393 "Utility/Device.vala"
		_g_free0 (cmd);
#line 393 "Utility/Device.vala"
		cmd = _tmp1_;
#line 2261 "Device.c"
	} else {
		gchar* _tmp2_;
#line 396 "Utility/Device.vala"
		_tmp2_ = g_strdup ("lsblk --bytes --pairs --output NAME,KNAME,LABEL,UUID,TYPE,FSTYPE,SIZE," \
"MOUNTPOINT,MODEL,RO,HOTPLUG,MAJ:MIN,PARTLABEL,PARTUUID,PKNAME,VENDOR,S" \
"ERIAL,REV");
#line 396 "Utility/Device.vala"
		_g_free0 (cmd);
#line 396 "Utility/Device.vala"
		cmd = _tmp2_;
#line 2270 "Device.c"
	}
#line 399 "Utility/Device.vala"
	_tmp3_ = strlen (dev_name);
#line 399 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 399 "Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 2278 "Device.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 400 "Utility/Device.vala"
		_tmp5_ = cmd;
#line 400 "Utility/Device.vala"
		_tmp6_ = g_strdup_printf (" %s", dev_name);
#line 400 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 400 "Utility/Device.vala"
		_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 400 "Utility/Device.vala"
		_g_free0 (cmd);
#line 400 "Utility/Device.vala"
		cmd = _tmp8_;
#line 400 "Utility/Device.vala"
		_g_free0 (_tmp7_);
#line 2297 "Device.c"
	}
#line 403 "Utility/Device.vala"
	_tmp9_ = cmd;
#line 403 "Utility/Device.vala"
	_tmp12_ = tee_jee_process_helper_exec_sync (_tmp9_, &_tmp10_, &_tmp11_);
#line 403 "Utility/Device.vala"
	_g_free0 (std_out);
#line 403 "Utility/Device.vala"
	std_out = _tmp10_;
#line 403 "Utility/Device.vala"
	_g_free0 (std_err);
#line 403 "Utility/Device.vala"
	std_err = _tmp11_;
#line 403 "Utility/Device.vala"
	ret_val = _tmp12_;
#line 424 "Utility/Device.vala"
	index = -1;
#line 426 "Utility/Device.vala"
	_tmp13_ = std_out;
#line 426 "Utility/Device.vala"
	_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, "\n", 0);
#line 2319 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 426 "Utility/Device.vala"
		line_collection = _tmp15_;
#line 426 "Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp14_);
#line 426 "Utility/Device.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 2331 "Device.c"
			gchar* _tmp16_;
			gchar* line = NULL;
#line 426 "Utility/Device.vala"
			_tmp16_ = g_strdup (line_collection[line_it]);
#line 426 "Utility/Device.vala"
			line = _tmp16_;
#line 2338 "Device.c"
			{
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gboolean _tmp22_;
#line 427 "Utility/Device.vala"
				_tmp17_ = line;
#line 427 "Utility/Device.vala"
				_tmp18_ = string_strip (_tmp17_);
#line 427 "Utility/Device.vala"
				_tmp19_ = _tmp18_;
#line 427 "Utility/Device.vala"
				_tmp20_ = strlen (_tmp19_);
#line 427 "Utility/Device.vala"
				_tmp21_ = _tmp20_;
#line 427 "Utility/Device.vala"
				_tmp22_ = _tmp21_ == 0;
#line 427 "Utility/Device.vala"
				_g_free0 (_tmp19_);
#line 427 "Utility/Device.vala"
				if (_tmp22_) {
#line 427 "Utility/Device.vala"
					_g_free0 (line);
#line 427 "Utility/Device.vala"
					continue;
#line 2366 "Device.c"
				}
				{
					GRegex* _tmp29_;
					const gchar* _tmp30_;
					GMatchInfo* _tmp31_ = NULL;
					gboolean _tmp32_;
#line 430 "Utility/Device.vala"
					if (device_lsblk_is_ancient) {
#line 2375 "Device.c"
						GRegex* _tmp23_ = NULL;
						GRegex* _tmp24_;
						GRegex* _tmp25_;
#line 431 "Utility/Device.vala"
						_tmp24_ = g_regex_new ("NAME=\"(.*)\" KNAME=\"(.*)\" LABEL=\"(.*)\" UUID=\"(.*)\" TYPE=\"(.*)\"" \
" FSTYPE=\"(.*)\" SIZE=\"(.*)\" MOUNTPOINT=\"(.*)\" MODEL=\"(.*)\" RO=\"" \
"([0-9]+)\" RM=\"([0-9]+)\" MAJ:MIN=\"([0-9:]+)\"", 0, 0, &_inner_error0_);
#line 431 "Utility/Device.vala"
						_tmp23_ = _tmp24_;
#line 431 "Utility/Device.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2385 "Device.c"
							goto __catch0_g_error;
						}
#line 431 "Utility/Device.vala"
						_tmp25_ = _tmp23_;
#line 431 "Utility/Device.vala"
						_tmp23_ = NULL;
#line 431 "Utility/Device.vala"
						_g_regex_unref0 (rex);
#line 431 "Utility/Device.vala"
						rex = _tmp25_;
#line 430 "Utility/Device.vala"
						_g_regex_unref0 (_tmp23_);
#line 2398 "Device.c"
					} else {
						GRegex* _tmp26_ = NULL;
						GRegex* _tmp27_;
						GRegex* _tmp28_;
#line 434 "Utility/Device.vala"
						_tmp27_ = g_regex_new ("NAME=\"(.*)\" KNAME=\"(.*)\" LABEL=\"(.*)\" UUID=\"(.*)\" TYPE=\"(.*)\"" \
" FSTYPE=\"(.*)\" SIZE=\"(.*)\" MOUNTPOINT=\"(.*)\" MODEL=\"(.*)\" RO=\"" \
"([0-9]+)\" HOTPLUG=\"([0-9]+)\" MAJ:MIN=\"([0-9:]+)\" PARTLABEL=\"(.*)" \
"\" PARTUUID=\"(.*)\" PKNAME=\"(.*)\" VENDOR=\"(.*)\" SERIAL=\"(.*)\" R" \
"EV=\"(.*)\"", 0, 0, &_inner_error0_);
#line 434 "Utility/Device.vala"
						_tmp26_ = _tmp27_;
#line 434 "Utility/Device.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2409 "Device.c"
							goto __catch0_g_error;
						}
#line 434 "Utility/Device.vala"
						_tmp28_ = _tmp26_;
#line 434 "Utility/Device.vala"
						_tmp26_ = NULL;
#line 434 "Utility/Device.vala"
						_g_regex_unref0 (rex);
#line 434 "Utility/Device.vala"
						rex = _tmp28_;
#line 430 "Utility/Device.vala"
						_g_regex_unref0 (_tmp26_);
#line 2422 "Device.c"
					}
#line 437 "Utility/Device.vala"
					_tmp29_ = rex;
#line 437 "Utility/Device.vala"
					_tmp30_ = line;
#line 437 "Utility/Device.vala"
					_tmp32_ = g_regex_match (_tmp29_, _tmp30_, 0, &_tmp31_);
#line 437 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 437 "Utility/Device.vala"
					match = _tmp31_;
#line 437 "Utility/Device.vala"
					if (_tmp32_) {
#line 2436 "Device.c"
						Device* pi = NULL;
						Device* _tmp33_;
						gint pos = 0;
						Device* _tmp34_;
						GMatchInfo* _tmp35_;
						gint _tmp36_;
						gchar* _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
						Device* _tmp40_;
						GMatchInfo* _tmp41_;
						gint _tmp42_;
						gchar* _tmp43_;
						gchar* _tmp44_;
						gchar* _tmp45_;
						Device* _tmp46_;
						GMatchInfo* _tmp47_;
						gint _tmp48_;
						gchar* _tmp49_;
						Device* _tmp50_;
						GMatchInfo* _tmp51_;
						gint _tmp52_;
						gchar* _tmp53_;
						gchar* _tmp54_;
						gchar* _tmp55_;
						Device* _tmp56_;
						GMatchInfo* _tmp57_;
						gint _tmp58_;
						gchar* _tmp59_;
						gchar* _tmp60_;
						gchar* _tmp61_;
						gchar* _tmp62_;
						gchar* _tmp63_;
						Device* _tmp64_;
						GMatchInfo* _tmp65_;
						gint _tmp66_;
						gchar* _tmp67_;
						gchar* _tmp68_;
						gchar* _tmp69_;
						gchar* _tmp70_;
						gchar* _tmp71_;
						const gchar* _tmp72_ = NULL;
						Device* _tmp73_;
						const gchar* _tmp74_;
						Device* _tmp77_;
						gchar* _tmp78_;
						const gchar* _tmp79_ = NULL;
						Device* _tmp80_;
						const gchar* _tmp81_;
						Device* _tmp84_;
						gchar* _tmp85_;
						Device* _tmp86_;
						GMatchInfo* _tmp87_;
						gint _tmp88_;
						gchar* _tmp89_;
						gchar* _tmp90_;
						gchar* _tmp91_;
						gchar* _tmp92_;
						gchar* mp = NULL;
						GMatchInfo* _tmp93_;
						gint _tmp94_;
						gchar* _tmp95_;
						gchar* _tmp96_;
						gchar* _tmp97_;
						gchar* _tmp98_;
						const gchar* _tmp99_;
						gint _tmp100_;
						gint _tmp101_;
						Device* _tmp108_;
						GMatchInfo* _tmp109_;
						gint _tmp110_;
						gchar* _tmp111_;
						gchar* _tmp112_;
						gchar* _tmp113_;
						Device* _tmp114_;
						GMatchInfo* _tmp115_;
						gint _tmp116_;
						gchar* _tmp117_;
						gchar* _tmp118_;
						gchar* _tmp119_;
						gchar* _tmp120_;
						Device* _tmp121_;
						GMatchInfo* _tmp122_;
						gint _tmp123_;
						gchar* _tmp124_;
						gchar* _tmp125_;
						gchar* _tmp126_;
						gchar* _tmp127_;
						gchar* txt = NULL;
						GMatchInfo* _tmp128_;
						gint _tmp129_;
						gchar* _tmp130_;
						gchar* _tmp131_;
						gchar* _tmp132_;
						gchar* _tmp133_;
						const gchar* _tmp134_;
						Device* _tmp181_;
						gint _tmp182_;
						Device* _tmp183_;
						Device* _tmp184_;
						const gchar* _tmp185_;
						gchar* _tmp186_;
						Device* _tmp187_;
						const gchar* _tmp188_;
						gint _tmp189_;
						gint _tmp190_;
						Device* _tmp195_;
						const gchar* _tmp196_;
						gint _tmp197_;
						gint _tmp198_;
						Device* _tmp203_;
						const gchar* _tmp204_;
						gint _tmp205_;
						gint _tmp206_;
						Device* _tmp211_;
						const gchar* _tmp212_;
						gint _tmp213_;
						gint _tmp214_;
						GeeArrayList* _tmp219_;
						Device* _tmp220_;
#line 439 "Utility/Device.vala"
						_tmp33_ = device_new ();
#line 439 "Utility/Device.vala"
						pi = _tmp33_;
#line 441 "Utility/Device.vala"
						pos = 0;
#line 443 "Utility/Device.vala"
						_tmp34_ = pi;
#line 443 "Utility/Device.vala"
						_tmp35_ = match;
#line 443 "Utility/Device.vala"
						pos = pos + 1;
#line 443 "Utility/Device.vala"
						_tmp36_ = pos;
#line 443 "Utility/Device.vala"
						_tmp37_ = g_match_info_fetch (_tmp35_, _tmp36_);
#line 443 "Utility/Device.vala"
						_tmp38_ = _tmp37_;
#line 443 "Utility/Device.vala"
						_tmp39_ = string_strip (_tmp38_);
#line 443 "Utility/Device.vala"
						_g_free0 (_tmp34_->name);
#line 443 "Utility/Device.vala"
						_tmp34_->name = _tmp39_;
#line 443 "Utility/Device.vala"
						_g_free0 (_tmp38_);
#line 444 "Utility/Device.vala"
						_tmp40_ = pi;
#line 444 "Utility/Device.vala"
						_tmp41_ = match;
#line 444 "Utility/Device.vala"
						pos = pos + 1;
#line 444 "Utility/Device.vala"
						_tmp42_ = pos;
#line 444 "Utility/Device.vala"
						_tmp43_ = g_match_info_fetch (_tmp41_, _tmp42_);
#line 444 "Utility/Device.vala"
						_tmp44_ = _tmp43_;
#line 444 "Utility/Device.vala"
						_tmp45_ = string_strip (_tmp44_);
#line 444 "Utility/Device.vala"
						_g_free0 (_tmp40_->kname);
#line 444 "Utility/Device.vala"
						_tmp40_->kname = _tmp45_;
#line 444 "Utility/Device.vala"
						_g_free0 (_tmp44_);
#line 446 "Utility/Device.vala"
						_tmp46_ = pi;
#line 446 "Utility/Device.vala"
						_tmp47_ = match;
#line 446 "Utility/Device.vala"
						pos = pos + 1;
#line 446 "Utility/Device.vala"
						_tmp48_ = pos;
#line 446 "Utility/Device.vala"
						_tmp49_ = g_match_info_fetch (_tmp47_, _tmp48_);
#line 446 "Utility/Device.vala"
						_g_free0 (_tmp46_->label);
#line 446 "Utility/Device.vala"
						_tmp46_->label = _tmp49_;
#line 447 "Utility/Device.vala"
						_tmp50_ = pi;
#line 447 "Utility/Device.vala"
						_tmp51_ = match;
#line 447 "Utility/Device.vala"
						pos = pos + 1;
#line 447 "Utility/Device.vala"
						_tmp52_ = pos;
#line 447 "Utility/Device.vala"
						_tmp53_ = g_match_info_fetch (_tmp51_, _tmp52_);
#line 447 "Utility/Device.vala"
						_tmp54_ = _tmp53_;
#line 447 "Utility/Device.vala"
						_tmp55_ = string_strip (_tmp54_);
#line 447 "Utility/Device.vala"
						_g_free0 (_tmp50_->uuid);
#line 447 "Utility/Device.vala"
						_tmp50_->uuid = _tmp55_;
#line 447 "Utility/Device.vala"
						_g_free0 (_tmp54_);
#line 449 "Utility/Device.vala"
						_tmp56_ = pi;
#line 449 "Utility/Device.vala"
						_tmp57_ = match;
#line 449 "Utility/Device.vala"
						pos = pos + 1;
#line 449 "Utility/Device.vala"
						_tmp58_ = pos;
#line 449 "Utility/Device.vala"
						_tmp59_ = g_match_info_fetch (_tmp57_, _tmp58_);
#line 449 "Utility/Device.vala"
						_tmp60_ = _tmp59_;
#line 449 "Utility/Device.vala"
						_tmp61_ = string_strip (_tmp60_);
#line 449 "Utility/Device.vala"
						_tmp62_ = _tmp61_;
#line 449 "Utility/Device.vala"
						_tmp63_ = g_utf8_strdown (_tmp62_, (gssize) -1);
#line 449 "Utility/Device.vala"
						_g_free0 (_tmp56_->type);
#line 449 "Utility/Device.vala"
						_tmp56_->type = _tmp63_;
#line 449 "Utility/Device.vala"
						_g_free0 (_tmp62_);
#line 449 "Utility/Device.vala"
						_g_free0 (_tmp60_);
#line 451 "Utility/Device.vala"
						_tmp64_ = pi;
#line 451 "Utility/Device.vala"
						_tmp65_ = match;
#line 451 "Utility/Device.vala"
						pos = pos + 1;
#line 451 "Utility/Device.vala"
						_tmp66_ = pos;
#line 451 "Utility/Device.vala"
						_tmp67_ = g_match_info_fetch (_tmp65_, _tmp66_);
#line 451 "Utility/Device.vala"
						_tmp68_ = _tmp67_;
#line 451 "Utility/Device.vala"
						_tmp69_ = string_strip (_tmp68_);
#line 451 "Utility/Device.vala"
						_tmp70_ = _tmp69_;
#line 451 "Utility/Device.vala"
						_tmp71_ = g_utf8_strdown (_tmp70_, (gssize) -1);
#line 451 "Utility/Device.vala"
						_g_free0 (_tmp64_->fstype);
#line 451 "Utility/Device.vala"
						_tmp64_->fstype = _tmp71_;
#line 451 "Utility/Device.vala"
						_g_free0 (_tmp70_);
#line 451 "Utility/Device.vala"
						_g_free0 (_tmp68_);
#line 452 "Utility/Device.vala"
						_tmp73_ = pi;
#line 452 "Utility/Device.vala"
						_tmp74_ = _tmp73_->fstype;
#line 452 "Utility/Device.vala"
						if (g_strcmp0 (_tmp74_, "crypto_luks") == 0) {
#line 452 "Utility/Device.vala"
							_tmp72_ = "luks";
#line 2697 "Device.c"
						} else {
							Device* _tmp75_;
							const gchar* _tmp76_;
#line 452 "Utility/Device.vala"
							_tmp75_ = pi;
#line 452 "Utility/Device.vala"
							_tmp76_ = _tmp75_->fstype;
#line 452 "Utility/Device.vala"
							_tmp72_ = _tmp76_;
#line 2707 "Device.c"
						}
#line 452 "Utility/Device.vala"
						_tmp77_ = pi;
#line 452 "Utility/Device.vala"
						_tmp78_ = g_strdup (_tmp72_);
#line 452 "Utility/Device.vala"
						_g_free0 (_tmp77_->fstype);
#line 452 "Utility/Device.vala"
						_tmp77_->fstype = _tmp78_;
#line 453 "Utility/Device.vala"
						_tmp80_ = pi;
#line 453 "Utility/Device.vala"
						_tmp81_ = _tmp80_->fstype;
#line 453 "Utility/Device.vala"
						if (g_strcmp0 (_tmp81_, "lvm2_member") == 0) {
#line 453 "Utility/Device.vala"
							_tmp79_ = "lvm2";
#line 2725 "Device.c"
						} else {
							Device* _tmp82_;
							const gchar* _tmp83_;
#line 453 "Utility/Device.vala"
							_tmp82_ = pi;
#line 453 "Utility/Device.vala"
							_tmp83_ = _tmp82_->fstype;
#line 453 "Utility/Device.vala"
							_tmp79_ = _tmp83_;
#line 2735 "Device.c"
						}
#line 453 "Utility/Device.vala"
						_tmp84_ = pi;
#line 453 "Utility/Device.vala"
						_tmp85_ = g_strdup (_tmp79_);
#line 453 "Utility/Device.vala"
						_g_free0 (_tmp84_->fstype);
#line 453 "Utility/Device.vala"
						_tmp84_->fstype = _tmp85_;
#line 455 "Utility/Device.vala"
						_tmp86_ = pi;
#line 455 "Utility/Device.vala"
						_tmp87_ = match;
#line 455 "Utility/Device.vala"
						pos = pos + 1;
#line 455 "Utility/Device.vala"
						_tmp88_ = pos;
#line 455 "Utility/Device.vala"
						_tmp89_ = g_match_info_fetch (_tmp87_, _tmp88_);
#line 455 "Utility/Device.vala"
						_tmp90_ = _tmp89_;
#line 455 "Utility/Device.vala"
						_tmp91_ = string_strip (_tmp90_);
#line 455 "Utility/Device.vala"
						_tmp92_ = _tmp91_;
#line 455 "Utility/Device.vala"
						_tmp86_->size_bytes = (guint64) int64_parse (_tmp92_, (guint) 0);
#line 455 "Utility/Device.vala"
						_g_free0 (_tmp92_);
#line 455 "Utility/Device.vala"
						_g_free0 (_tmp90_);
#line 457 "Utility/Device.vala"
						_tmp93_ = match;
#line 457 "Utility/Device.vala"
						pos = pos + 1;
#line 457 "Utility/Device.vala"
						_tmp94_ = pos;
#line 457 "Utility/Device.vala"
						_tmp95_ = g_match_info_fetch (_tmp93_, _tmp94_);
#line 457 "Utility/Device.vala"
						_tmp96_ = _tmp95_;
#line 457 "Utility/Device.vala"
						_tmp97_ = string_strip (_tmp96_);
#line 457 "Utility/Device.vala"
						_tmp98_ = _tmp97_;
#line 457 "Utility/Device.vala"
						_g_free0 (_tmp96_);
#line 457 "Utility/Device.vala"
						mp = _tmp98_;
#line 458 "Utility/Device.vala"
						_tmp99_ = mp;
#line 458 "Utility/Device.vala"
						_tmp100_ = strlen (_tmp99_);
#line 458 "Utility/Device.vala"
						_tmp101_ = _tmp100_;
#line 458 "Utility/Device.vala"
						if (_tmp101_ > 0) {
#line 2793 "Device.c"
							Device* _tmp102_;
							GeeArrayList* _tmp103_;
							Device* _tmp104_;
							const gchar* _tmp105_;
							MountEntry* _tmp106_;
							MountEntry* _tmp107_;
#line 459 "Utility/Device.vala"
							_tmp102_ = pi;
#line 459 "Utility/Device.vala"
							_tmp103_ = _tmp102_->mount_points;
#line 459 "Utility/Device.vala"
							_tmp104_ = pi;
#line 459 "Utility/Device.vala"
							_tmp105_ = mp;
#line 459 "Utility/Device.vala"
							_tmp106_ = mount_entry_new (_tmp104_, _tmp105_, "");
#line 459 "Utility/Device.vala"
							_tmp107_ = _tmp106_;
#line 459 "Utility/Device.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp103_, _tmp107_);
#line 459 "Utility/Device.vala"
							_g_object_unref0 (_tmp107_);
#line 2816 "Device.c"
						}
#line 462 "Utility/Device.vala"
						_tmp108_ = pi;
#line 462 "Utility/Device.vala"
						_tmp109_ = match;
#line 462 "Utility/Device.vala"
						pos = pos + 1;
#line 462 "Utility/Device.vala"
						_tmp110_ = pos;
#line 462 "Utility/Device.vala"
						_tmp111_ = g_match_info_fetch (_tmp109_, _tmp110_);
#line 462 "Utility/Device.vala"
						_tmp112_ = _tmp111_;
#line 462 "Utility/Device.vala"
						_tmp113_ = string_strip (_tmp112_);
#line 462 "Utility/Device.vala"
						_g_free0 (_tmp108_->model);
#line 462 "Utility/Device.vala"
						_tmp108_->model = _tmp113_;
#line 462 "Utility/Device.vala"
						_g_free0 (_tmp112_);
#line 464 "Utility/Device.vala"
						_tmp114_ = pi;
#line 464 "Utility/Device.vala"
						_tmp115_ = match;
#line 464 "Utility/Device.vala"
						pos = pos + 1;
#line 464 "Utility/Device.vala"
						_tmp116_ = pos;
#line 464 "Utility/Device.vala"
						_tmp117_ = g_match_info_fetch (_tmp115_, _tmp116_);
#line 464 "Utility/Device.vala"
						_tmp118_ = _tmp117_;
#line 464 "Utility/Device.vala"
						_tmp119_ = string_strip (_tmp118_);
#line 464 "Utility/Device.vala"
						_tmp120_ = _tmp119_;
#line 464 "Utility/Device.vala"
						_tmp114_->read_only = g_strcmp0 (_tmp120_, "1") == 0;
#line 464 "Utility/Device.vala"
						_g_free0 (_tmp120_);
#line 464 "Utility/Device.vala"
						_g_free0 (_tmp118_);
#line 466 "Utility/Device.vala"
						_tmp121_ = pi;
#line 466 "Utility/Device.vala"
						_tmp122_ = match;
#line 466 "Utility/Device.vala"
						pos = pos + 1;
#line 466 "Utility/Device.vala"
						_tmp123_ = pos;
#line 466 "Utility/Device.vala"
						_tmp124_ = g_match_info_fetch (_tmp122_, _tmp123_);
#line 466 "Utility/Device.vala"
						_tmp125_ = _tmp124_;
#line 466 "Utility/Device.vala"
						_tmp126_ = string_strip (_tmp125_);
#line 466 "Utility/Device.vala"
						_tmp127_ = _tmp126_;
#line 466 "Utility/Device.vala"
						_tmp121_->removable = g_strcmp0 (_tmp127_, "1") == 0;
#line 466 "Utility/Device.vala"
						_g_free0 (_tmp127_);
#line 466 "Utility/Device.vala"
						_g_free0 (_tmp125_);
#line 468 "Utility/Device.vala"
						_tmp128_ = match;
#line 468 "Utility/Device.vala"
						pos = pos + 1;
#line 468 "Utility/Device.vala"
						_tmp129_ = pos;
#line 468 "Utility/Device.vala"
						_tmp130_ = g_match_info_fetch (_tmp128_, _tmp129_);
#line 468 "Utility/Device.vala"
						_tmp131_ = _tmp130_;
#line 468 "Utility/Device.vala"
						_tmp132_ = string_strip (_tmp131_);
#line 468 "Utility/Device.vala"
						_tmp133_ = _tmp132_;
#line 468 "Utility/Device.vala"
						_g_free0 (_tmp131_);
#line 468 "Utility/Device.vala"
						txt = _tmp133_;
#line 469 "Utility/Device.vala"
						_tmp134_ = txt;
#line 469 "Utility/Device.vala"
						if (string_contains (_tmp134_, ":")) {
#line 2904 "Device.c"
							Device* _tmp135_;
							const gchar* _tmp136_;
							gchar** _tmp137_;
							gchar** _tmp138_;
							gchar** _tmp139_;
							gint _tmp139__length1;
							const gchar* _tmp140_;
							Device* _tmp141_;
							const gchar* _tmp142_;
							gchar** _tmp143_;
							gchar** _tmp144_;
							gchar** _tmp145_;
							gint _tmp145__length1;
							const gchar* _tmp146_;
#line 470 "Utility/Device.vala"
							_tmp135_ = pi;
#line 470 "Utility/Device.vala"
							_tmp136_ = txt;
#line 470 "Utility/Device.vala"
							_tmp138_ = _tmp137_ = g_strsplit (_tmp136_, ":", 0);
#line 470 "Utility/Device.vala"
							_tmp139_ = _tmp138_;
#line 470 "Utility/Device.vala"
							_tmp139__length1 = _vala_array_length (_tmp137_);
#line 470 "Utility/Device.vala"
							_tmp140_ = _tmp139_[0];
#line 470 "Utility/Device.vala"
							_tmp135_->major = atoi (_tmp140_);
#line 470 "Utility/Device.vala"
							_tmp139_ = (_vala_array_free (_tmp139_, _tmp139__length1, (GDestroyNotify) g_free), NULL);
#line 471 "Utility/Device.vala"
							_tmp141_ = pi;
#line 471 "Utility/Device.vala"
							_tmp142_ = txt;
#line 471 "Utility/Device.vala"
							_tmp144_ = _tmp143_ = g_strsplit (_tmp142_, ":", 0);
#line 471 "Utility/Device.vala"
							_tmp145_ = _tmp144_;
#line 471 "Utility/Device.vala"
							_tmp145__length1 = _vala_array_length (_tmp143_);
#line 471 "Utility/Device.vala"
							_tmp146_ = _tmp145_[1];
#line 471 "Utility/Device.vala"
							_tmp141_->minor = atoi (_tmp146_);
#line 471 "Utility/Device.vala"
							_tmp145_ = (_vala_array_free (_tmp145_, _tmp145__length1, (GDestroyNotify) g_free), NULL);
#line 2951 "Device.c"
						}
#line 474 "Utility/Device.vala"
						if (!device_lsblk_is_ancient) {
#line 2955 "Device.c"
							Device* _tmp147_;
							GMatchInfo* _tmp148_;
							gint _tmp149_;
							gchar* _tmp150_;
							Device* _tmp151_;
							GMatchInfo* _tmp152_;
							gint _tmp153_;
							gchar* _tmp154_;
							gchar* _tmp155_;
							gchar* _tmp156_;
							Device* _tmp157_;
							GMatchInfo* _tmp158_;
							gint _tmp159_;
							gchar* _tmp160_;
							gchar* _tmp161_;
							gchar* _tmp162_;
							Device* _tmp163_;
							GMatchInfo* _tmp164_;
							gint _tmp165_;
							gchar* _tmp166_;
							gchar* _tmp167_;
							gchar* _tmp168_;
							Device* _tmp169_;
							GMatchInfo* _tmp170_;
							gint _tmp171_;
							gchar* _tmp172_;
							gchar* _tmp173_;
							gchar* _tmp174_;
							Device* _tmp175_;
							GMatchInfo* _tmp176_;
							gint _tmp177_;
							gchar* _tmp178_;
							gchar* _tmp179_;
							gchar* _tmp180_;
#line 476 "Utility/Device.vala"
							_tmp147_ = pi;
#line 476 "Utility/Device.vala"
							_tmp148_ = match;
#line 476 "Utility/Device.vala"
							pos = pos + 1;
#line 476 "Utility/Device.vala"
							_tmp149_ = pos;
#line 476 "Utility/Device.vala"
							_tmp150_ = g_match_info_fetch (_tmp148_, _tmp149_);
#line 476 "Utility/Device.vala"
							_g_free0 (_tmp147_->partlabel);
#line 476 "Utility/Device.vala"
							_tmp147_->partlabel = _tmp150_;
#line 477 "Utility/Device.vala"
							_tmp151_ = pi;
#line 477 "Utility/Device.vala"
							_tmp152_ = match;
#line 477 "Utility/Device.vala"
							pos = pos + 1;
#line 477 "Utility/Device.vala"
							_tmp153_ = pos;
#line 477 "Utility/Device.vala"
							_tmp154_ = g_match_info_fetch (_tmp152_, _tmp153_);
#line 477 "Utility/Device.vala"
							_tmp155_ = _tmp154_;
#line 477 "Utility/Device.vala"
							_tmp156_ = string_strip (_tmp155_);
#line 477 "Utility/Device.vala"
							_g_free0 (_tmp151_->partuuid);
#line 477 "Utility/Device.vala"
							_tmp151_->partuuid = _tmp156_;
#line 477 "Utility/Device.vala"
							_g_free0 (_tmp155_);
#line 479 "Utility/Device.vala"
							_tmp157_ = pi;
#line 479 "Utility/Device.vala"
							_tmp158_ = match;
#line 479 "Utility/Device.vala"
							pos = pos + 1;
#line 479 "Utility/Device.vala"
							_tmp159_ = pos;
#line 479 "Utility/Device.vala"
							_tmp160_ = g_match_info_fetch (_tmp158_, _tmp159_);
#line 479 "Utility/Device.vala"
							_tmp161_ = _tmp160_;
#line 479 "Utility/Device.vala"
							_tmp162_ = string_strip (_tmp161_);
#line 479 "Utility/Device.vala"
							_g_free0 (_tmp157_->pkname);
#line 479 "Utility/Device.vala"
							_tmp157_->pkname = _tmp162_;
#line 479 "Utility/Device.vala"
							_g_free0 (_tmp161_);
#line 480 "Utility/Device.vala"
							_tmp163_ = pi;
#line 480 "Utility/Device.vala"
							_tmp164_ = match;
#line 480 "Utility/Device.vala"
							pos = pos + 1;
#line 480 "Utility/Device.vala"
							_tmp165_ = pos;
#line 480 "Utility/Device.vala"
							_tmp166_ = g_match_info_fetch (_tmp164_, _tmp165_);
#line 480 "Utility/Device.vala"
							_tmp167_ = _tmp166_;
#line 480 "Utility/Device.vala"
							_tmp168_ = string_strip (_tmp167_);
#line 480 "Utility/Device.vala"
							_g_free0 (_tmp163_->vendor);
#line 480 "Utility/Device.vala"
							_tmp163_->vendor = _tmp168_;
#line 480 "Utility/Device.vala"
							_g_free0 (_tmp167_);
#line 481 "Utility/Device.vala"
							_tmp169_ = pi;
#line 481 "Utility/Device.vala"
							_tmp170_ = match;
#line 481 "Utility/Device.vala"
							pos = pos + 1;
#line 481 "Utility/Device.vala"
							_tmp171_ = pos;
#line 481 "Utility/Device.vala"
							_tmp172_ = g_match_info_fetch (_tmp170_, _tmp171_);
#line 481 "Utility/Device.vala"
							_tmp173_ = _tmp172_;
#line 481 "Utility/Device.vala"
							_tmp174_ = string_strip (_tmp173_);
#line 481 "Utility/Device.vala"
							_g_free0 (_tmp169_->serial);
#line 481 "Utility/Device.vala"
							_tmp169_->serial = _tmp174_;
#line 481 "Utility/Device.vala"
							_g_free0 (_tmp173_);
#line 482 "Utility/Device.vala"
							_tmp175_ = pi;
#line 482 "Utility/Device.vala"
							_tmp176_ = match;
#line 482 "Utility/Device.vala"
							pos = pos + 1;
#line 482 "Utility/Device.vala"
							_tmp177_ = pos;
#line 482 "Utility/Device.vala"
							_tmp178_ = g_match_info_fetch (_tmp176_, _tmp177_);
#line 482 "Utility/Device.vala"
							_tmp179_ = _tmp178_;
#line 482 "Utility/Device.vala"
							_tmp180_ = string_strip (_tmp179_);
#line 482 "Utility/Device.vala"
							_g_free0 (_tmp175_->revision);
#line 482 "Utility/Device.vala"
							_tmp175_->revision = _tmp180_;
#line 482 "Utility/Device.vala"
							_g_free0 (_tmp179_);
#line 3104 "Device.c"
						}
#line 485 "Utility/Device.vala"
						_tmp181_ = pi;
#line 485 "Utility/Device.vala"
						index = index + 1;
#line 485 "Utility/Device.vala"
						_tmp182_ = index;
#line 485 "Utility/Device.vala"
						_tmp181_->order = _tmp182_;
#line 486 "Utility/Device.vala"
						_tmp183_ = pi;
#line 486 "Utility/Device.vala"
						_tmp184_ = pi;
#line 486 "Utility/Device.vala"
						_tmp185_ = _tmp184_->kname;
#line 486 "Utility/Device.vala"
						_tmp186_ = g_strdup_printf ("/dev/%s", _tmp185_);
#line 486 "Utility/Device.vala"
						_g_free0 (_tmp183_->device);
#line 486 "Utility/Device.vala"
						_tmp183_->device = _tmp186_;
#line 488 "Utility/Device.vala"
						_tmp187_ = pi;
#line 488 "Utility/Device.vala"
						_tmp188_ = _tmp187_->uuid;
#line 488 "Utility/Device.vala"
						_tmp189_ = strlen (_tmp188_);
#line 488 "Utility/Device.vala"
						_tmp190_ = _tmp189_;
#line 488 "Utility/Device.vala"
						if (_tmp190_ > 0) {
#line 3136 "Device.c"
							Device* _tmp191_;
							Device* _tmp192_;
							const gchar* _tmp193_;
							gchar* _tmp194_;
#line 489 "Utility/Device.vala"
							_tmp191_ = pi;
#line 489 "Utility/Device.vala"
							_tmp192_ = pi;
#line 489 "Utility/Device.vala"
							_tmp193_ = _tmp192_->uuid;
#line 489 "Utility/Device.vala"
							_tmp194_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp193_);
#line 489 "Utility/Device.vala"
							_g_free0 (_tmp191_->device_by_uuid);
#line 489 "Utility/Device.vala"
							_tmp191_->device_by_uuid = _tmp194_;
#line 3153 "Device.c"
						}
#line 492 "Utility/Device.vala"
						_tmp195_ = pi;
#line 492 "Utility/Device.vala"
						_tmp196_ = _tmp195_->label;
#line 492 "Utility/Device.vala"
						_tmp197_ = strlen (_tmp196_);
#line 492 "Utility/Device.vala"
						_tmp198_ = _tmp197_;
#line 492 "Utility/Device.vala"
						if (_tmp198_ > 0) {
#line 3165 "Device.c"
							Device* _tmp199_;
							Device* _tmp200_;
							const gchar* _tmp201_;
							gchar* _tmp202_;
#line 493 "Utility/Device.vala"
							_tmp199_ = pi;
#line 493 "Utility/Device.vala"
							_tmp200_ = pi;
#line 493 "Utility/Device.vala"
							_tmp201_ = _tmp200_->label;
#line 493 "Utility/Device.vala"
							_tmp202_ = g_strdup_printf ("/dev/disk/by-label/%s", _tmp201_);
#line 493 "Utility/Device.vala"
							_g_free0 (_tmp199_->device_by_label);
#line 493 "Utility/Device.vala"
							_tmp199_->device_by_label = _tmp202_;
#line 3182 "Device.c"
						}
#line 496 "Utility/Device.vala"
						_tmp203_ = pi;
#line 496 "Utility/Device.vala"
						_tmp204_ = _tmp203_->partuuid;
#line 496 "Utility/Device.vala"
						_tmp205_ = strlen (_tmp204_);
#line 496 "Utility/Device.vala"
						_tmp206_ = _tmp205_;
#line 496 "Utility/Device.vala"
						if (_tmp206_ > 0) {
#line 3194 "Device.c"
							Device* _tmp207_;
							Device* _tmp208_;
							const gchar* _tmp209_;
							gchar* _tmp210_;
#line 497 "Utility/Device.vala"
							_tmp207_ = pi;
#line 497 "Utility/Device.vala"
							_tmp208_ = pi;
#line 497 "Utility/Device.vala"
							_tmp209_ = _tmp208_->partuuid;
#line 497 "Utility/Device.vala"
							_tmp210_ = g_strdup_printf ("/dev/disk/by-partuuid/%s", _tmp209_);
#line 497 "Utility/Device.vala"
							_g_free0 (_tmp207_->device_by_partuuid);
#line 497 "Utility/Device.vala"
							_tmp207_->device_by_partuuid = _tmp210_;
#line 3211 "Device.c"
						}
#line 500 "Utility/Device.vala"
						_tmp211_ = pi;
#line 500 "Utility/Device.vala"
						_tmp212_ = _tmp211_->partlabel;
#line 500 "Utility/Device.vala"
						_tmp213_ = strlen (_tmp212_);
#line 500 "Utility/Device.vala"
						_tmp214_ = _tmp213_;
#line 500 "Utility/Device.vala"
						if (_tmp214_ > 0) {
#line 3223 "Device.c"
							Device* _tmp215_;
							Device* _tmp216_;
							const gchar* _tmp217_;
							gchar* _tmp218_;
#line 501 "Utility/Device.vala"
							_tmp215_ = pi;
#line 501 "Utility/Device.vala"
							_tmp216_ = pi;
#line 501 "Utility/Device.vala"
							_tmp217_ = _tmp216_->partlabel;
#line 501 "Utility/Device.vala"
							_tmp218_ = g_strdup_printf ("/dev/disk/by-partlabel/%s", _tmp217_);
#line 501 "Utility/Device.vala"
							_g_free0 (_tmp215_->device_by_partlabel);
#line 501 "Utility/Device.vala"
							_tmp215_->device_by_partlabel = _tmp218_;
#line 3240 "Device.c"
						}
#line 509 "Utility/Device.vala"
						_tmp219_ = list;
#line 509 "Utility/Device.vala"
						_tmp220_ = pi;
#line 509 "Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp219_, _tmp220_);
#line 437 "Utility/Device.vala"
						_g_free0 (txt);
#line 437 "Utility/Device.vala"
						_g_free0 (mp);
#line 437 "Utility/Device.vala"
						_g_object_unref0 (pi);
#line 3254 "Device.c"
					} else {
						const gchar* _tmp221_;
						gchar* _tmp222_;
						gchar* _tmp223_;
#line 513 "Utility/Device.vala"
						_tmp221_ = line;
#line 513 "Utility/Device.vala"
						_tmp222_ = g_strdup_printf ("no-match: %s", _tmp221_);
#line 513 "Utility/Device.vala"
						_tmp223_ = _tmp222_;
#line 513 "Utility/Device.vala"
						tee_jee_logging_log_debug (_tmp223_);
#line 513 "Utility/Device.vala"
						_g_free0 (_tmp223_);
#line 3269 "Device.c"
					}
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp224_;
					const gchar* _tmp225_;
#line 429 "Utility/Device.vala"
					e = _inner_error0_;
#line 429 "Utility/Device.vala"
					_inner_error0_ = NULL;
#line 517 "Utility/Device.vala"
					_tmp224_ = e;
#line 517 "Utility/Device.vala"
					_tmp225_ = _tmp224_->message;
#line 517 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp225_, FALSE, FALSE);
#line 429 "Utility/Device.vala"
					_g_error_free0 (e);
#line 3290 "Device.c"
				}
				__finally0:
#line 429 "Utility/Device.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 429 "Utility/Device.vala"
					_g_free0 (line);
#line 429 "Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 429 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 429 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 429 "Utility/Device.vala"
					_g_free0 (cmd);
#line 429 "Utility/Device.vala"
					_g_free0 (std_err);
#line 429 "Utility/Device.vala"
					_g_free0 (std_out);
#line 429 "Utility/Device.vala"
					_g_object_unref0 (list);
#line 429 "Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 429 "Utility/Device.vala"
					g_clear_error (&_inner_error0_);
#line 429 "Utility/Device.vala"
					return NULL;
#line 3317 "Device.c"
				}
#line 426 "Utility/Device.vala"
				_g_free0 (line);
#line 3321 "Device.c"
			}
		}
#line 426 "Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3326 "Device.c"
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp226_;
		gint _dev_size = 0;
		GeeArrayList* _tmp227_;
		gint _tmp228_;
		gint _tmp229_;
		gint _dev_index = 0;
#line 528 "Utility/Device.vala"
		_tmp226_ = list;
#line 528 "Utility/Device.vala"
		_dev_list = _tmp226_;
#line 528 "Utility/Device.vala"
		_tmp227_ = _dev_list;
#line 528 "Utility/Device.vala"
		_tmp228_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp227_);
#line 528 "Utility/Device.vala"
		_tmp229_ = _tmp228_;
#line 528 "Utility/Device.vala"
		_dev_size = _tmp229_;
#line 528 "Utility/Device.vala"
		_dev_index = -1;
#line 528 "Utility/Device.vala"
		while (TRUE) {
#line 3352 "Device.c"
			gint _tmp230_;
			gint _tmp231_;
			Device* dev = NULL;
			GeeArrayList* _tmp232_;
			gpointer _tmp233_;
			gchar* dev_by_uuid = NULL;
			Device* _tmp234_;
			const gchar* _tmp235_;
			gchar* _tmp236_;
			const gchar* _tmp237_;
#line 528 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 528 "Utility/Device.vala"
			_tmp230_ = _dev_index;
#line 528 "Utility/Device.vala"
			_tmp231_ = _dev_size;
#line 528 "Utility/Device.vala"
			if (!(_tmp230_ < _tmp231_)) {
#line 528 "Utility/Device.vala"
				break;
#line 3373 "Device.c"
			}
#line 528 "Utility/Device.vala"
			_tmp232_ = _dev_list;
#line 528 "Utility/Device.vala"
			_tmp233_ = gee_abstract_list_get ((GeeAbstractList*) _tmp232_, _dev_index);
#line 528 "Utility/Device.vala"
			dev = (Device*) _tmp233_;
#line 529 "Utility/Device.vala"
			_tmp234_ = dev;
#line 529 "Utility/Device.vala"
			_tmp235_ = _tmp234_->uuid;
#line 529 "Utility/Device.vala"
			_tmp236_ = tee_jee_file_system_path_combine ("/dev/disk/by-uuid/", _tmp235_);
#line 529 "Utility/Device.vala"
			dev_by_uuid = _tmp236_;
#line 530 "Utility/Device.vala"
			_tmp237_ = dev_by_uuid;
#line 530 "Utility/Device.vala"
			if (tee_jee_file_system_file_exists (_tmp237_)) {
#line 3393 "Device.c"
				Device* _tmp238_;
				GeeArrayList* _tmp239_;
				const gchar* _tmp240_;
#line 531 "Utility/Device.vala"
				_tmp238_ = dev;
#line 531 "Utility/Device.vala"
				_tmp239_ = _tmp238_->symlinks;
#line 531 "Utility/Device.vala"
				_tmp240_ = dev_by_uuid;
#line 531 "Utility/Device.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp239_, _tmp240_);
#line 3405 "Device.c"
			}
#line 528 "Utility/Device.vala"
			_g_free0 (dev_by_uuid);
#line 528 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 3411 "Device.c"
		}
	}
	{
		GFile* f_dev_mapper = NULL;
		GFile* _tmp241_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp242_;
		gchar* _tmp243_;
		gchar* _tmp244_;
		GFileEnumerator* _tmp245_;
		GFileEnumerator* _tmp246_;
		GFileInfo* info = NULL;
#line 539 "Utility/Device.vala"
		_tmp241_ = g_file_new_for_path ("/dev/mapper");
#line 539 "Utility/Device.vala"
		f_dev_mapper = _tmp241_;
#line 541 "Utility/Device.vala"
		_tmp242_ = f_dev_mapper;
#line 541 "Utility/Device.vala"
		_tmp243_ = g_strdup_printf ("%s,%s", G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 541 "Utility/Device.vala"
		_tmp244_ = _tmp243_;
#line 541 "Utility/Device.vala"
		_tmp245_ = g_file_enumerate_children (_tmp242_, _tmp244_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 541 "Utility/Device.vala"
		_tmp246_ = _tmp245_;
#line 541 "Utility/Device.vala"
		_g_free0 (_tmp244_);
#line 541 "Utility/Device.vala"
		enumerator = _tmp246_;
#line 541 "Utility/Device.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 541 "Utility/Device.vala"
			_g_object_unref0 (f_dev_mapper);
#line 3446 "Device.c"
			goto __catch1_g_error;
		}
#line 547 "Utility/Device.vala"
		while (TRUE) {
#line 3451 "Device.c"
			GFileInfo* _tmp247_ = NULL;
			GFileEnumerator* _tmp248_;
			GFileInfo* _tmp249_;
			GFileInfo* _tmp250_;
			GFileInfo* _tmp251_;
			GFileInfo* _tmp252_;
			const gchar* _tmp253_;
			GFile* f_mapped = NULL;
			GFile* _tmp254_;
			GFileInfo* _tmp255_;
			const gchar* _tmp256_;
			GFile* _tmp257_;
			gchar* mapped_file = NULL;
			GFile* _tmp258_;
			gchar* _tmp259_;
			gchar* mapped_device = NULL;
			GFileInfo* _tmp260_;
			const gchar* _tmp261_;
			gchar* _tmp262_;
			const gchar* _tmp263_;
			gchar* _tmp264_;
#line 547 "Utility/Device.vala"
			_tmp248_ = enumerator;
#line 547 "Utility/Device.vala"
			_tmp249_ = g_file_enumerator_next_file (_tmp248_, NULL, &_inner_error0_);
#line 547 "Utility/Device.vala"
			_tmp247_ = _tmp249_;
#line 547 "Utility/Device.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 547 "Utility/Device.vala"
				_g_object_unref0 (info);
#line 547 "Utility/Device.vala"
				_g_object_unref0 (enumerator);
#line 547 "Utility/Device.vala"
				_g_object_unref0 (f_dev_mapper);
#line 3487 "Device.c"
				goto __catch1_g_error;
			}
#line 547 "Utility/Device.vala"
			_tmp250_ = _tmp247_;
#line 547 "Utility/Device.vala"
			_tmp247_ = NULL;
#line 547 "Utility/Device.vala"
			_g_object_unref0 (info);
#line 547 "Utility/Device.vala"
			info = _tmp250_;
#line 547 "Utility/Device.vala"
			_tmp251_ = info;
#line 547 "Utility/Device.vala"
			if (!(_tmp251_ != NULL)) {
#line 547 "Utility/Device.vala"
				_g_object_unref0 (_tmp247_);
#line 547 "Utility/Device.vala"
				break;
#line 3506 "Device.c"
			}
#line 549 "Utility/Device.vala"
			_tmp252_ = info;
#line 549 "Utility/Device.vala"
			_tmp253_ = g_file_info_get_name (_tmp252_);
#line 549 "Utility/Device.vala"
			if (g_strcmp0 (_tmp253_, "control") == 0) {
#line 549 "Utility/Device.vala"
				_g_object_unref0 (_tmp247_);
#line 549 "Utility/Device.vala"
				continue;
#line 3518 "Device.c"
			}
#line 551 "Utility/Device.vala"
			_tmp254_ = f_dev_mapper;
#line 551 "Utility/Device.vala"
			_tmp255_ = info;
#line 551 "Utility/Device.vala"
			_tmp256_ = g_file_info_get_name (_tmp255_);
#line 551 "Utility/Device.vala"
			_tmp257_ = g_file_resolve_relative_path (_tmp254_, _tmp256_);
#line 551 "Utility/Device.vala"
			f_mapped = _tmp257_;
#line 553 "Utility/Device.vala"
			_tmp258_ = f_mapped;
#line 553 "Utility/Device.vala"
			_tmp259_ = g_file_get_path (_tmp258_);
#line 553 "Utility/Device.vala"
			mapped_file = _tmp259_;
#line 554 "Utility/Device.vala"
			_tmp260_ = info;
#line 554 "Utility/Device.vala"
			_tmp261_ = g_file_info_get_symlink_target (_tmp260_);
#line 554 "Utility/Device.vala"
			_tmp262_ = g_strdup (_tmp261_);
#line 554 "Utility/Device.vala"
			mapped_device = _tmp262_;
#line 555 "Utility/Device.vala"
			_tmp263_ = mapped_device;
#line 555 "Utility/Device.vala"
			_tmp264_ = string_replace (_tmp263_, "..", "/dev");
#line 555 "Utility/Device.vala"
			_g_free0 (mapped_device);
#line 555 "Utility/Device.vala"
			mapped_device = _tmp264_;
#line 3552 "Device.c"
			{
				GeeArrayList* _dev_list = NULL;
				GeeArrayList* _tmp265_;
				gint _dev_size = 0;
				GeeArrayList* _tmp266_;
				gint _tmp267_;
				gint _tmp268_;
				gint _dev_index = 0;
#line 561 "Utility/Device.vala"
				_tmp265_ = list;
#line 561 "Utility/Device.vala"
				_dev_list = _tmp265_;
#line 561 "Utility/Device.vala"
				_tmp266_ = _dev_list;
#line 561 "Utility/Device.vala"
				_tmp267_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp266_);
#line 561 "Utility/Device.vala"
				_tmp268_ = _tmp267_;
#line 561 "Utility/Device.vala"
				_dev_size = _tmp268_;
#line 561 "Utility/Device.vala"
				_dev_index = -1;
#line 561 "Utility/Device.vala"
				while (TRUE) {
#line 3577 "Device.c"
					gint _tmp269_;
					gint _tmp270_;
					Device* dev = NULL;
					GeeArrayList* _tmp271_;
					gpointer _tmp272_;
					Device* _tmp273_;
					const gchar* _tmp274_;
					const gchar* _tmp275_;
#line 561 "Utility/Device.vala"
					_dev_index = _dev_index + 1;
#line 561 "Utility/Device.vala"
					_tmp269_ = _dev_index;
#line 561 "Utility/Device.vala"
					_tmp270_ = _dev_size;
#line 561 "Utility/Device.vala"
					if (!(_tmp269_ < _tmp270_)) {
#line 561 "Utility/Device.vala"
						break;
#line 3596 "Device.c"
					}
#line 561 "Utility/Device.vala"
					_tmp271_ = _dev_list;
#line 561 "Utility/Device.vala"
					_tmp272_ = gee_abstract_list_get ((GeeAbstractList*) _tmp271_, _dev_index);
#line 561 "Utility/Device.vala"
					dev = (Device*) _tmp272_;
#line 562 "Utility/Device.vala"
					_tmp273_ = dev;
#line 562 "Utility/Device.vala"
					_tmp274_ = _tmp273_->device;
#line 562 "Utility/Device.vala"
					_tmp275_ = mapped_device;
#line 562 "Utility/Device.vala"
					if (g_strcmp0 (_tmp274_, _tmp275_) == 0) {
#line 3612 "Device.c"
						Device* _tmp276_;
						const gchar* _tmp277_;
						gchar* _tmp278_;
						Device* _tmp279_;
						GeeArrayList* _tmp280_;
						const gchar* _tmp281_;
#line 563 "Utility/Device.vala"
						_tmp276_ = dev;
#line 563 "Utility/Device.vala"
						_tmp277_ = mapped_file;
#line 563 "Utility/Device.vala"
						_tmp278_ = string_replace (_tmp277_, "/dev/mapper/", "");
#line 563 "Utility/Device.vala"
						_g_free0 (_tmp276_->mapped_name);
#line 563 "Utility/Device.vala"
						_tmp276_->mapped_name = _tmp278_;
#line 564 "Utility/Device.vala"
						_tmp279_ = dev;
#line 564 "Utility/Device.vala"
						_tmp280_ = _tmp279_->symlinks;
#line 564 "Utility/Device.vala"
						_tmp281_ = mapped_file;
#line 564 "Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp280_, _tmp281_);
#line 566 "Utility/Device.vala"
						_g_object_unref0 (dev);
#line 566 "Utility/Device.vala"
						break;
#line 3641 "Device.c"
					}
#line 561 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 3645 "Device.c"
				}
			}
#line 547 "Utility/Device.vala"
			_g_free0 (mapped_device);
#line 547 "Utility/Device.vala"
			_g_free0 (mapped_file);
#line 547 "Utility/Device.vala"
			_g_object_unref0 (f_mapped);
#line 547 "Utility/Device.vala"
			_g_object_unref0 (_tmp247_);
#line 3656 "Device.c"
		}
#line 537 "Utility/Device.vala"
		_g_object_unref0 (info);
#line 537 "Utility/Device.vala"
		_g_object_unref0 (enumerator);
#line 537 "Utility/Device.vala"
		_g_object_unref0 (f_dev_mapper);
#line 3664 "Device.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp282_;
		const gchar* _tmp283_;
#line 537 "Utility/Device.vala"
		e = _inner_error0_;
#line 537 "Utility/Device.vala"
		_inner_error0_ = NULL;
#line 572 "Utility/Device.vala"
		_tmp282_ = e;
#line 572 "Utility/Device.vala"
		_tmp283_ = _tmp282_->message;
#line 572 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp283_, FALSE, FALSE);
#line 537 "Utility/Device.vala"
		_g_error_free0 (e);
#line 3684 "Device.c"
	}
	__finally1:
#line 537 "Utility/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 537 "Utility/Device.vala"
		_g_match_info_unref0 (match);
#line 537 "Utility/Device.vala"
		_g_regex_unref0 (rex);
#line 537 "Utility/Device.vala"
		_g_free0 (cmd);
#line 537 "Utility/Device.vala"
		_g_free0 (std_err);
#line 537 "Utility/Device.vala"
		_g_free0 (std_out);
#line 537 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 537 "Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 537 "Utility/Device.vala"
		g_clear_error (&_inner_error0_);
#line 537 "Utility/Device.vala"
		return NULL;
#line 3707 "Device.c"
	}
#line 575 "Utility/Device.vala"
	_tmp284_ = list;
#line 575 "Utility/Device.vala"
	_tmp285_ = _g_object_ref0 (_tmp284_);
#line 575 "Utility/Device.vala"
	_g_object_unref0 (device_device_list);
#line 575 "Utility/Device.vala"
	device_device_list = _tmp285_;
#line 3717 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp286_;
		gint _part_size = 0;
		GeeArrayList* _tmp287_;
		gint _tmp288_;
		gint _tmp289_;
		gint _part_index = 0;
#line 577 "Utility/Device.vala"
		_tmp286_ = list;
#line 577 "Utility/Device.vala"
		_part_list = _tmp286_;
#line 577 "Utility/Device.vala"
		_tmp287_ = _part_list;
#line 577 "Utility/Device.vala"
		_tmp288_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp287_);
#line 577 "Utility/Device.vala"
		_tmp289_ = _tmp288_;
#line 577 "Utility/Device.vala"
		_part_size = _tmp289_;
#line 577 "Utility/Device.vala"
		_part_index = -1;
#line 577 "Utility/Device.vala"
		while (TRUE) {
#line 3742 "Device.c"
			gint _tmp290_;
			gint _tmp291_;
			Device* part = NULL;
			GeeArrayList* _tmp292_;
			gpointer _tmp293_;
			GeeArrayList* _tmp294_;
			Device* _tmp295_;
			GeeArrayList* _tmp296_;
			Device* _tmp297_;
#line 577 "Utility/Device.vala"
			_part_index = _part_index + 1;
#line 577 "Utility/Device.vala"
			_tmp290_ = _part_index;
#line 577 "Utility/Device.vala"
			_tmp291_ = _part_size;
#line 577 "Utility/Device.vala"
			if (!(_tmp290_ < _tmp291_)) {
#line 577 "Utility/Device.vala"
				break;
#line 3762 "Device.c"
			}
#line 577 "Utility/Device.vala"
			_tmp292_ = _part_list;
#line 577 "Utility/Device.vala"
			_tmp293_ = gee_abstract_list_get ((GeeAbstractList*) _tmp292_, _part_index);
#line 577 "Utility/Device.vala"
			part = (Device*) _tmp293_;
#line 578 "Utility/Device.vala"
			_tmp294_ = list;
#line 578 "Utility/Device.vala"
			_tmp295_ = part;
#line 578 "Utility/Device.vala"
			device_find_child_devices (_tmp294_, _tmp295_);
#line 579 "Utility/Device.vala"
			_tmp296_ = list;
#line 579 "Utility/Device.vala"
			_tmp297_ = part;
#line 579 "Utility/Device.vala"
			device_find_toplevel_parent (_tmp296_, _tmp297_);
#line 577 "Utility/Device.vala"
			_g_object_unref0 (part);
#line 3784 "Device.c"
		}
	}
	{
		gint i = 0;
		GeeArrayList* _tmp298_;
		gint _tmp299_;
		gint _tmp300_;
#line 585 "Utility/Device.vala"
		_tmp298_ = list;
#line 585 "Utility/Device.vala"
		_tmp299_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp298_);
#line 585 "Utility/Device.vala"
		_tmp300_ = _tmp299_;
#line 585 "Utility/Device.vala"
		i = _tmp300_ - 1;
#line 3800 "Device.c"
		{
			gboolean _tmp301_ = FALSE;
#line 585 "Utility/Device.vala"
			_tmp301_ = TRUE;
#line 585 "Utility/Device.vala"
			while (TRUE) {
#line 3807 "Device.c"
				GeeArrayList* _tmp303_;
				gpointer _tmp304_;
				Device* _tmp305_;
				const gchar* _tmp306_;
				gboolean _tmp307_;
#line 585 "Utility/Device.vala"
				if (!_tmp301_) {
#line 3815 "Device.c"
					gint _tmp302_;
#line 585 "Utility/Device.vala"
					i = i - 1;
#line 585 "Utility/Device.vala"
					_tmp302_ = i;
#line 3821 "Device.c"
				}
#line 585 "Utility/Device.vala"
				_tmp301_ = FALSE;
#line 585 "Utility/Device.vala"
				if (!(i >= 0)) {
#line 585 "Utility/Device.vala"
					break;
#line 3829 "Device.c"
				}
#line 586 "Utility/Device.vala"
				_tmp303_ = list;
#line 586 "Utility/Device.vala"
				_tmp304_ = gee_abstract_list_get ((GeeAbstractList*) _tmp303_, i);
#line 586 "Utility/Device.vala"
				_tmp305_ = (Device*) _tmp304_;
#line 586 "Utility/Device.vala"
				_tmp306_ = _tmp305_->type;
#line 586 "Utility/Device.vala"
				_tmp307_ = g_strcmp0 (_tmp306_, "raid5") == 0;
#line 586 "Utility/Device.vala"
				_g_object_unref0 (_tmp305_);
#line 586 "Utility/Device.vala"
				if (_tmp307_) {
#line 3845 "Device.c"
					GeeArrayList* _tmp326_;
					gpointer _tmp327_;
					Device* _tmp328_;
					gchar* _tmp329_;
					{
						gint j = 0;
#line 590 "Utility/Device.vala"
						j = i - 1;
#line 3854 "Device.c"
						{
							gboolean _tmp308_ = FALSE;
#line 590 "Utility/Device.vala"
							_tmp308_ = TRUE;
#line 590 "Utility/Device.vala"
							while (TRUE) {
#line 3861 "Device.c"
								GeeArrayList* _tmp310_;
								gpointer _tmp311_;
								Device* _tmp312_;
								const gchar* _tmp313_;
								GeeArrayList* _tmp314_;
								gpointer _tmp315_;
								Device* _tmp316_;
								const gchar* _tmp317_;
								gboolean _tmp318_;
#line 590 "Utility/Device.vala"
								if (!_tmp308_) {
#line 3873 "Device.c"
									gint _tmp309_;
#line 590 "Utility/Device.vala"
									j = j - 1;
#line 590 "Utility/Device.vala"
									_tmp309_ = j;
#line 3879 "Device.c"
								}
#line 590 "Utility/Device.vala"
								_tmp308_ = FALSE;
#line 590 "Utility/Device.vala"
								if (!(j >= 0)) {
#line 590 "Utility/Device.vala"
									break;
#line 3887 "Device.c"
								}
#line 591 "Utility/Device.vala"
								_tmp310_ = list;
#line 591 "Utility/Device.vala"
								_tmp311_ = gee_abstract_list_get ((GeeAbstractList*) _tmp310_, j);
#line 591 "Utility/Device.vala"
								_tmp312_ = (Device*) _tmp311_;
#line 591 "Utility/Device.vala"
								_tmp313_ = _tmp312_->kname;
#line 591 "Utility/Device.vala"
								_tmp314_ = list;
#line 591 "Utility/Device.vala"
								_tmp315_ = gee_abstract_list_get ((GeeAbstractList*) _tmp314_, i);
#line 591 "Utility/Device.vala"
								_tmp316_ = (Device*) _tmp315_;
#line 591 "Utility/Device.vala"
								_tmp317_ = _tmp316_->pkname;
#line 591 "Utility/Device.vala"
								_tmp318_ = g_strcmp0 (_tmp313_, _tmp317_) == 0;
#line 591 "Utility/Device.vala"
								_g_object_unref0 (_tmp316_);
#line 591 "Utility/Device.vala"
								_g_object_unref0 (_tmp312_);
#line 591 "Utility/Device.vala"
								if (_tmp318_) {
#line 3913 "Device.c"
									GeeArrayList* _tmp319_;
									gpointer _tmp320_;
									Device* _tmp321_;
									GeeArrayList* _tmp322_;
									gpointer _tmp323_;
									Device* _tmp324_;
									gint _tmp325_;
#line 592 "Utility/Device.vala"
									_tmp319_ = list;
#line 592 "Utility/Device.vala"
									_tmp320_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp319_, j);
#line 592 "Utility/Device.vala"
									_tmp321_ = (Device*) _tmp320_;
#line 592 "Utility/Device.vala"
									_g_object_unref0 (_tmp321_);
#line 593 "Utility/Device.vala"
									_tmp322_ = list;
#line 593 "Utility/Device.vala"
									_tmp323_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp322_, j - 1);
#line 593 "Utility/Device.vala"
									_tmp324_ = (Device*) _tmp323_;
#line 593 "Utility/Device.vala"
									_g_object_unref0 (_tmp324_);
#line 594 "Utility/Device.vala"
									i = i - 1;
#line 594 "Utility/Device.vala"
									_tmp325_ = i;
#line 595 "Utility/Device.vala"
									break;
#line 3943 "Device.c"
								}
							}
						}
					}
#line 600 "Utility/Device.vala"
					_tmp326_ = list;
#line 600 "Utility/Device.vala"
					_tmp327_ = gee_abstract_list_get ((GeeAbstractList*) _tmp326_, i);
#line 600 "Utility/Device.vala"
					_tmp328_ = (Device*) _tmp327_;
#line 600 "Utility/Device.vala"
					_tmp329_ = g_strdup ("");
#line 600 "Utility/Device.vala"
					_g_free0 (_tmp328_->pkname);
#line 600 "Utility/Device.vala"
					_tmp328_->pkname = _tmp329_;
#line 600 "Utility/Device.vala"
					_g_object_unref0 (_tmp328_);
#line 3962 "Device.c"
					{
						gint j = 0;
						GeeArrayList* _tmp330_;
						gint _tmp331_;
						gint _tmp332_;
#line 604 "Utility/Device.vala"
						_tmp330_ = list;
#line 604 "Utility/Device.vala"
						_tmp331_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp330_);
#line 604 "Utility/Device.vala"
						_tmp332_ = _tmp331_;
#line 604 "Utility/Device.vala"
						j = _tmp332_ - 1;
#line 3976 "Device.c"
						{
							gboolean _tmp333_ = FALSE;
#line 604 "Utility/Device.vala"
							_tmp333_ = TRUE;
#line 604 "Utility/Device.vala"
							while (TRUE) {
#line 3983 "Device.c"
								GeeArrayList* _tmp335_;
								gpointer _tmp336_;
								Device* _tmp337_;
								const gchar* _tmp338_;
								GeeArrayList* _tmp339_;
								gpointer _tmp340_;
								Device* _tmp341_;
								const gchar* _tmp342_;
								gboolean _tmp343_;
#line 604 "Utility/Device.vala"
								if (!_tmp333_) {
#line 3995 "Device.c"
									gint _tmp334_;
#line 604 "Utility/Device.vala"
									j = j - 1;
#line 604 "Utility/Device.vala"
									_tmp334_ = j;
#line 4001 "Device.c"
								}
#line 604 "Utility/Device.vala"
								_tmp333_ = FALSE;
#line 604 "Utility/Device.vala"
								if (!(j > i)) {
#line 604 "Utility/Device.vala"
									break;
#line 4009 "Device.c"
								}
#line 605 "Utility/Device.vala"
								_tmp335_ = list;
#line 605 "Utility/Device.vala"
								_tmp336_ = gee_abstract_list_get ((GeeAbstractList*) _tmp335_, j);
#line 605 "Utility/Device.vala"
								_tmp337_ = (Device*) _tmp336_;
#line 605 "Utility/Device.vala"
								_tmp338_ = _tmp337_->pkname;
#line 605 "Utility/Device.vala"
								_tmp339_ = list;
#line 605 "Utility/Device.vala"
								_tmp340_ = gee_abstract_list_get ((GeeAbstractList*) _tmp339_, i);
#line 605 "Utility/Device.vala"
								_tmp341_ = (Device*) _tmp340_;
#line 605 "Utility/Device.vala"
								_tmp342_ = _tmp341_->kname;
#line 605 "Utility/Device.vala"
								_tmp343_ = g_strcmp0 (_tmp338_, _tmp342_) == 0;
#line 605 "Utility/Device.vala"
								_g_object_unref0 (_tmp341_);
#line 605 "Utility/Device.vala"
								_g_object_unref0 (_tmp337_);
#line 605 "Utility/Device.vala"
								if (_tmp343_) {
#line 4035 "Device.c"
									{
										gint k = 0;
#line 606 "Utility/Device.vala"
										k = j - 1;
#line 4040 "Device.c"
										{
											gboolean _tmp344_ = FALSE;
#line 606 "Utility/Device.vala"
											_tmp344_ = TRUE;
#line 606 "Utility/Device.vala"
											while (TRUE) {
#line 4047 "Device.c"
												GeeArrayList* _tmp346_;
												gpointer _tmp347_;
												Device* _tmp348_;
												const gchar* _tmp349_;
												GeeArrayList* _tmp350_;
												gpointer _tmp351_;
												Device* _tmp352_;
												const gchar* _tmp353_;
												gboolean _tmp354_;
#line 606 "Utility/Device.vala"
												if (!_tmp344_) {
#line 4059 "Device.c"
													gint _tmp345_;
#line 606 "Utility/Device.vala"
													k = k - 1;
#line 606 "Utility/Device.vala"
													_tmp345_ = k;
#line 4065 "Device.c"
												}
#line 606 "Utility/Device.vala"
												_tmp344_ = FALSE;
#line 606 "Utility/Device.vala"
												if (!(k >= 0)) {
#line 606 "Utility/Device.vala"
													break;
#line 4073 "Device.c"
												}
#line 607 "Utility/Device.vala"
												_tmp346_ = list;
#line 607 "Utility/Device.vala"
												_tmp347_ = gee_abstract_list_get ((GeeAbstractList*) _tmp346_, k);
#line 607 "Utility/Device.vala"
												_tmp348_ = (Device*) _tmp347_;
#line 607 "Utility/Device.vala"
												_tmp349_ = _tmp348_->kname;
#line 607 "Utility/Device.vala"
												_tmp350_ = list;
#line 607 "Utility/Device.vala"
												_tmp351_ = gee_abstract_list_get ((GeeAbstractList*) _tmp350_, j);
#line 607 "Utility/Device.vala"
												_tmp352_ = (Device*) _tmp351_;
#line 607 "Utility/Device.vala"
												_tmp353_ = _tmp352_->kname;
#line 607 "Utility/Device.vala"
												_tmp354_ = g_strcmp0 (_tmp349_, _tmp353_) == 0;
#line 607 "Utility/Device.vala"
												_g_object_unref0 (_tmp352_);
#line 607 "Utility/Device.vala"
												_g_object_unref0 (_tmp348_);
#line 607 "Utility/Device.vala"
												if (_tmp354_) {
#line 4099 "Device.c"
													GeeArrayList* _tmp355_;
													gpointer _tmp356_;
													Device* _tmp357_;
													gint _tmp358_;
#line 608 "Utility/Device.vala"
													_tmp355_ = list;
#line 608 "Utility/Device.vala"
													_tmp356_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp355_, k);
#line 608 "Utility/Device.vala"
													_tmp357_ = (Device*) _tmp356_;
#line 608 "Utility/Device.vala"
													_g_object_unref0 (_tmp357_);
#line 609 "Utility/Device.vala"
													j = j - 1;
#line 609 "Utility/Device.vala"
													_tmp358_ = j;
#line 4116 "Device.c"
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
		GeeArrayList* _tmp359_;
		gint _tmp360_;
		gint _tmp361_;
#line 618 "Utility/Device.vala"
		_tmp359_ = list;
#line 618 "Utility/Device.vala"
		_tmp360_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp359_);
#line 618 "Utility/Device.vala"
		_tmp361_ = _tmp360_;
#line 618 "Utility/Device.vala"
		i = _tmp361_ - 1;
#line 4142 "Device.c"
		{
			gboolean _tmp362_ = FALSE;
#line 618 "Utility/Device.vala"
			_tmp362_ = TRUE;
#line 618 "Utility/Device.vala"
			while (TRUE) {
#line 4149 "Device.c"
				GeeArrayList* _tmp364_;
				gpointer _tmp365_;
				Device* _tmp366_;
				const gchar* _tmp367_;
				gboolean _tmp368_;
#line 618 "Utility/Device.vala"
				if (!_tmp362_) {
#line 4157 "Device.c"
					gint _tmp363_;
#line 618 "Utility/Device.vala"
					i = i - 1;
#line 618 "Utility/Device.vala"
					_tmp363_ = i;
#line 4163 "Device.c"
				}
#line 618 "Utility/Device.vala"
				_tmp362_ = FALSE;
#line 618 "Utility/Device.vala"
				if (!(i >= 0)) {
#line 618 "Utility/Device.vala"
					break;
#line 4171 "Device.c"
				}
#line 619 "Utility/Device.vala"
				_tmp364_ = list;
#line 619 "Utility/Device.vala"
				_tmp365_ = gee_abstract_list_get ((GeeAbstractList*) _tmp364_, i);
#line 619 "Utility/Device.vala"
				_tmp366_ = (Device*) _tmp365_;
#line 619 "Utility/Device.vala"
				_tmp367_ = _tmp366_->type;
#line 619 "Utility/Device.vala"
				_tmp368_ = g_strcmp0 (_tmp367_, "raid5") == 0;
#line 619 "Utility/Device.vala"
				_g_object_unref0 (_tmp366_);
#line 619 "Utility/Device.vala"
				if (_tmp368_) {
#line 4187 "Device.c"
					GeeArrayList* _tmp369_;
					gpointer _tmp370_;
					Device* _tmp371_;
					gchar* _tmp372_;
					GeeArrayList* _tmp373_;
					gpointer _tmp374_;
					Device* _tmp375_;
					GeeArrayList* _tmp376_;
					gpointer _tmp377_;
					Device* _tmp378_;
					const gchar* _tmp379_;
					gchar* _tmp380_;
#line 621 "Utility/Device.vala"
					_tmp369_ = list;
#line 621 "Utility/Device.vala"
					_tmp370_ = gee_abstract_list_get ((GeeAbstractList*) _tmp369_, i);
#line 621 "Utility/Device.vala"
					_tmp371_ = (Device*) _tmp370_;
#line 621 "Utility/Device.vala"
					_tmp372_ = g_strdup ("disk");
#line 621 "Utility/Device.vala"
					_g_free0 (_tmp371_->type);
#line 621 "Utility/Device.vala"
					_tmp371_->type = _tmp372_;
#line 621 "Utility/Device.vala"
					_g_object_unref0 (_tmp371_);
#line 622 "Utility/Device.vala"
					_tmp373_ = list;
#line 622 "Utility/Device.vala"
					_tmp374_ = gee_abstract_list_get ((GeeAbstractList*) _tmp373_, i);
#line 622 "Utility/Device.vala"
					_tmp375_ = (Device*) _tmp374_;
#line 622 "Utility/Device.vala"
					_tmp376_ = list;
#line 622 "Utility/Device.vala"
					_tmp377_ = gee_abstract_list_get ((GeeAbstractList*) _tmp376_, i);
#line 622 "Utility/Device.vala"
					_tmp378_ = (Device*) _tmp377_;
#line 622 "Utility/Device.vala"
					_tmp379_ = _tmp378_->name;
#line 622 "Utility/Device.vala"
					_tmp380_ = g_strdup (_tmp379_);
#line 622 "Utility/Device.vala"
					_g_free0 (_tmp375_->model);
#line 622 "Utility/Device.vala"
					_tmp375_->model = _tmp380_;
#line 622 "Utility/Device.vala"
					_g_object_unref0 (_tmp378_);
#line 622 "Utility/Device.vala"
					_g_object_unref0 (_tmp375_);
#line 4238 "Device.c"
					{
						gint j = 0;
						GeeArrayList* _tmp381_;
						gint _tmp382_;
						gint _tmp383_;
#line 625 "Utility/Device.vala"
						_tmp381_ = list;
#line 625 "Utility/Device.vala"
						_tmp382_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp381_);
#line 625 "Utility/Device.vala"
						_tmp383_ = _tmp382_;
#line 625 "Utility/Device.vala"
						j = _tmp383_ - 1;
#line 4252 "Device.c"
						{
							gboolean _tmp384_ = FALSE;
#line 625 "Utility/Device.vala"
							_tmp384_ = TRUE;
#line 625 "Utility/Device.vala"
							while (TRUE) {
#line 4259 "Device.c"
								gboolean _tmp386_ = FALSE;
								gboolean _tmp387_ = FALSE;
#line 625 "Utility/Device.vala"
								if (!_tmp384_) {
#line 4264 "Device.c"
									gint _tmp385_;
#line 625 "Utility/Device.vala"
									j = j - 1;
#line 625 "Utility/Device.vala"
									_tmp385_ = j;
#line 4270 "Device.c"
								}
#line 625 "Utility/Device.vala"
								_tmp384_ = FALSE;
#line 625 "Utility/Device.vala"
								if (!(j >= 0)) {
#line 625 "Utility/Device.vala"
									break;
#line 4278 "Device.c"
								}
#line 626 "Utility/Device.vala"
								if (i != j) {
#line 4282 "Device.c"
									GeeArrayList* _tmp388_;
									gpointer _tmp389_;
									Device* _tmp390_;
									const gchar* _tmp391_;
#line 626 "Utility/Device.vala"
									_tmp388_ = list;
#line 626 "Utility/Device.vala"
									_tmp389_ = gee_abstract_list_get ((GeeAbstractList*) _tmp388_, j);
#line 626 "Utility/Device.vala"
									_tmp390_ = (Device*) _tmp389_;
#line 626 "Utility/Device.vala"
									_tmp391_ = _tmp390_->type;
#line 626 "Utility/Device.vala"
									_tmp387_ = g_strcmp0 (_tmp391_, "raid5") == 0;
#line 626 "Utility/Device.vala"
									_g_object_unref0 (_tmp390_);
#line 4299 "Device.c"
								} else {
#line 626 "Utility/Device.vala"
									_tmp387_ = FALSE;
#line 4303 "Device.c"
								}
#line 626 "Utility/Device.vala"
								if (_tmp387_) {
#line 4307 "Device.c"
									GeeArrayList* _tmp392_;
									gpointer _tmp393_;
									Device* _tmp394_;
									const gchar* _tmp395_;
									GeeArrayList* _tmp396_;
									gpointer _tmp397_;
									Device* _tmp398_;
									const gchar* _tmp399_;
#line 626 "Utility/Device.vala"
									_tmp392_ = list;
#line 626 "Utility/Device.vala"
									_tmp393_ = gee_abstract_list_get ((GeeAbstractList*) _tmp392_, j);
#line 626 "Utility/Device.vala"
									_tmp394_ = (Device*) _tmp393_;
#line 626 "Utility/Device.vala"
									_tmp395_ = _tmp394_->kname;
#line 626 "Utility/Device.vala"
									_tmp396_ = list;
#line 626 "Utility/Device.vala"
									_tmp397_ = gee_abstract_list_get ((GeeAbstractList*) _tmp396_, i);
#line 626 "Utility/Device.vala"
									_tmp398_ = (Device*) _tmp397_;
#line 626 "Utility/Device.vala"
									_tmp399_ = _tmp398_->kname;
#line 626 "Utility/Device.vala"
									_tmp386_ = g_strcmp0 (_tmp395_, _tmp399_) == 0;
#line 626 "Utility/Device.vala"
									_g_object_unref0 (_tmp398_);
#line 626 "Utility/Device.vala"
									_g_object_unref0 (_tmp394_);
#line 4338 "Device.c"
								} else {
#line 626 "Utility/Device.vala"
									_tmp386_ = FALSE;
#line 4342 "Device.c"
								}
#line 626 "Utility/Device.vala"
								if (_tmp386_) {
#line 4346 "Device.c"
									GeeArrayList* _tmp400_;
									gpointer _tmp401_;
									Device* _tmp402_;
#line 627 "Utility/Device.vala"
									_tmp400_ = list;
#line 627 "Utility/Device.vala"
									_tmp401_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp400_, j);
#line 627 "Utility/Device.vala"
									_tmp402_ = (Device*) _tmp401_;
#line 627 "Utility/Device.vala"
									_g_object_unref0 (_tmp402_);
#line 628 "Utility/Device.vala"
									if (j < i) {
#line 4360 "Device.c"
										gint _tmp403_;
#line 629 "Utility/Device.vala"
										i = i - 1;
#line 629 "Utility/Device.vala"
										_tmp403_ = i;
#line 4366 "Device.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
		GeeArrayList* _tmp404_;
		gint _tmp405_;
		gint _tmp406_;
#line 638 "Utility/Device.vala"
		_tmp404_ = list;
#line 638 "Utility/Device.vala"
		_tmp405_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp404_);
#line 638 "Utility/Device.vala"
		_tmp406_ = _tmp405_;
#line 638 "Utility/Device.vala"
		i = _tmp406_ - 1;
#line 4389 "Device.c"
		{
			gboolean _tmp407_ = FALSE;
#line 638 "Utility/Device.vala"
			_tmp407_ = TRUE;
#line 638 "Utility/Device.vala"
			while (TRUE) {
#line 4396 "Device.c"
				GeeArrayList* _tmp409_;
				gpointer _tmp410_;
				Device* _tmp411_;
				const gchar* _tmp412_;
				gboolean _tmp413_;
#line 638 "Utility/Device.vala"
				if (!_tmp407_) {
#line 4404 "Device.c"
					gint _tmp408_;
#line 638 "Utility/Device.vala"
					i = i - 1;
#line 638 "Utility/Device.vala"
					_tmp408_ = i;
#line 4410 "Device.c"
				}
#line 638 "Utility/Device.vala"
				_tmp407_ = FALSE;
#line 638 "Utility/Device.vala"
				if (!(i >= 0)) {
#line 638 "Utility/Device.vala"
					break;
#line 4418 "Device.c"
				}
#line 639 "Utility/Device.vala"
				_tmp409_ = list;
#line 639 "Utility/Device.vala"
				_tmp410_ = gee_abstract_list_get ((GeeAbstractList*) _tmp409_, i);
#line 639 "Utility/Device.vala"
				_tmp411_ = (Device*) _tmp410_;
#line 639 "Utility/Device.vala"
				_tmp412_ = _tmp411_->type;
#line 639 "Utility/Device.vala"
				_tmp413_ = g_strcmp0 (_tmp412_, "dmraid") == 0;
#line 639 "Utility/Device.vala"
				_g_object_unref0 (_tmp411_);
#line 639 "Utility/Device.vala"
				if (_tmp413_) {
#line 4434 "Device.c"
					GeeArrayList* _tmp429_;
					gpointer _tmp430_;
					Device* _tmp431_;
					gchar* _tmp432_;
					{
						gint j = 0;
#line 643 "Utility/Device.vala"
						j = i - 1;
#line 4443 "Device.c"
						{
							gboolean _tmp414_ = FALSE;
#line 643 "Utility/Device.vala"
							_tmp414_ = TRUE;
#line 643 "Utility/Device.vala"
							while (TRUE) {
#line 4450 "Device.c"
								GeeArrayList* _tmp416_;
								gpointer _tmp417_;
								Device* _tmp418_;
								const gchar* _tmp419_;
								GeeArrayList* _tmp420_;
								gpointer _tmp421_;
								Device* _tmp422_;
								const gchar* _tmp423_;
								gboolean _tmp424_;
#line 643 "Utility/Device.vala"
								if (!_tmp414_) {
#line 4462 "Device.c"
									gint _tmp415_;
#line 643 "Utility/Device.vala"
									j = j - 1;
#line 643 "Utility/Device.vala"
									_tmp415_ = j;
#line 4468 "Device.c"
								}
#line 643 "Utility/Device.vala"
								_tmp414_ = FALSE;
#line 643 "Utility/Device.vala"
								if (!(j >= 0)) {
#line 643 "Utility/Device.vala"
									break;
#line 4476 "Device.c"
								}
#line 644 "Utility/Device.vala"
								_tmp416_ = list;
#line 644 "Utility/Device.vala"
								_tmp417_ = gee_abstract_list_get ((GeeAbstractList*) _tmp416_, j);
#line 644 "Utility/Device.vala"
								_tmp418_ = (Device*) _tmp417_;
#line 644 "Utility/Device.vala"
								_tmp419_ = _tmp418_->kname;
#line 644 "Utility/Device.vala"
								_tmp420_ = list;
#line 644 "Utility/Device.vala"
								_tmp421_ = gee_abstract_list_get ((GeeAbstractList*) _tmp420_, i);
#line 644 "Utility/Device.vala"
								_tmp422_ = (Device*) _tmp421_;
#line 644 "Utility/Device.vala"
								_tmp423_ = _tmp422_->pkname;
#line 644 "Utility/Device.vala"
								_tmp424_ = g_strcmp0 (_tmp419_, _tmp423_) == 0;
#line 644 "Utility/Device.vala"
								_g_object_unref0 (_tmp422_);
#line 644 "Utility/Device.vala"
								_g_object_unref0 (_tmp418_);
#line 644 "Utility/Device.vala"
								if (_tmp424_) {
#line 4502 "Device.c"
									GeeArrayList* _tmp425_;
									gpointer _tmp426_;
									Device* _tmp427_;
									gint _tmp428_;
#line 645 "Utility/Device.vala"
									_tmp425_ = list;
#line 645 "Utility/Device.vala"
									_tmp426_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp425_, j);
#line 645 "Utility/Device.vala"
									_tmp427_ = (Device*) _tmp426_;
#line 645 "Utility/Device.vala"
									_g_object_unref0 (_tmp427_);
#line 646 "Utility/Device.vala"
									i = i - 1;
#line 646 "Utility/Device.vala"
									_tmp428_ = i;
#line 647 "Utility/Device.vala"
									break;
#line 4521 "Device.c"
								}
							}
						}
					}
#line 652 "Utility/Device.vala"
					_tmp429_ = list;
#line 652 "Utility/Device.vala"
					_tmp430_ = gee_abstract_list_get ((GeeAbstractList*) _tmp429_, i);
#line 652 "Utility/Device.vala"
					_tmp431_ = (Device*) _tmp430_;
#line 652 "Utility/Device.vala"
					_tmp432_ = g_strdup ("");
#line 652 "Utility/Device.vala"
					_g_free0 (_tmp431_->pkname);
#line 652 "Utility/Device.vala"
					_tmp431_->pkname = _tmp432_;
#line 652 "Utility/Device.vala"
					_g_object_unref0 (_tmp431_);
#line 4540 "Device.c"
					{
						gint j = 0;
						GeeArrayList* _tmp433_;
						gint _tmp434_;
						gint _tmp435_;
#line 656 "Utility/Device.vala"
						_tmp433_ = list;
#line 656 "Utility/Device.vala"
						_tmp434_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp433_);
#line 656 "Utility/Device.vala"
						_tmp435_ = _tmp434_;
#line 656 "Utility/Device.vala"
						j = _tmp435_ - 1;
#line 4554 "Device.c"
						{
							gboolean _tmp436_ = FALSE;
#line 656 "Utility/Device.vala"
							_tmp436_ = TRUE;
#line 656 "Utility/Device.vala"
							while (TRUE) {
#line 4561 "Device.c"
								GeeArrayList* _tmp438_;
								gpointer _tmp439_;
								Device* _tmp440_;
								const gchar* _tmp441_;
								GeeArrayList* _tmp442_;
								gpointer _tmp443_;
								Device* _tmp444_;
								const gchar* _tmp445_;
								gboolean _tmp446_;
#line 656 "Utility/Device.vala"
								if (!_tmp436_) {
#line 4573 "Device.c"
									gint _tmp437_;
#line 656 "Utility/Device.vala"
									j = j - 1;
#line 656 "Utility/Device.vala"
									_tmp437_ = j;
#line 4579 "Device.c"
								}
#line 656 "Utility/Device.vala"
								_tmp436_ = FALSE;
#line 656 "Utility/Device.vala"
								if (!(j > i)) {
#line 656 "Utility/Device.vala"
									break;
#line 4587 "Device.c"
								}
#line 657 "Utility/Device.vala"
								_tmp438_ = list;
#line 657 "Utility/Device.vala"
								_tmp439_ = gee_abstract_list_get ((GeeAbstractList*) _tmp438_, j);
#line 657 "Utility/Device.vala"
								_tmp440_ = (Device*) _tmp439_;
#line 657 "Utility/Device.vala"
								_tmp441_ = _tmp440_->pkname;
#line 657 "Utility/Device.vala"
								_tmp442_ = list;
#line 657 "Utility/Device.vala"
								_tmp443_ = gee_abstract_list_get ((GeeAbstractList*) _tmp442_, i);
#line 657 "Utility/Device.vala"
								_tmp444_ = (Device*) _tmp443_;
#line 657 "Utility/Device.vala"
								_tmp445_ = _tmp444_->kname;
#line 657 "Utility/Device.vala"
								_tmp446_ = g_strcmp0 (_tmp441_, _tmp445_) == 0;
#line 657 "Utility/Device.vala"
								_g_object_unref0 (_tmp444_);
#line 657 "Utility/Device.vala"
								_g_object_unref0 (_tmp440_);
#line 657 "Utility/Device.vala"
								if (_tmp446_) {
#line 4613 "Device.c"
									{
										gint k = 0;
#line 658 "Utility/Device.vala"
										k = j - 1;
#line 4618 "Device.c"
										{
											gboolean _tmp447_ = FALSE;
#line 658 "Utility/Device.vala"
											_tmp447_ = TRUE;
#line 658 "Utility/Device.vala"
											while (TRUE) {
#line 4625 "Device.c"
												GeeArrayList* _tmp449_;
												gpointer _tmp450_;
												Device* _tmp451_;
												const gchar* _tmp452_;
												GeeArrayList* _tmp453_;
												gpointer _tmp454_;
												Device* _tmp455_;
												const gchar* _tmp456_;
												gboolean _tmp457_;
#line 658 "Utility/Device.vala"
												if (!_tmp447_) {
#line 4637 "Device.c"
													gint _tmp448_;
#line 658 "Utility/Device.vala"
													k = k - 1;
#line 658 "Utility/Device.vala"
													_tmp448_ = k;
#line 4643 "Device.c"
												}
#line 658 "Utility/Device.vala"
												_tmp447_ = FALSE;
#line 658 "Utility/Device.vala"
												if (!(k >= 0)) {
#line 658 "Utility/Device.vala"
													break;
#line 4651 "Device.c"
												}
#line 659 "Utility/Device.vala"
												_tmp449_ = list;
#line 659 "Utility/Device.vala"
												_tmp450_ = gee_abstract_list_get ((GeeAbstractList*) _tmp449_, k);
#line 659 "Utility/Device.vala"
												_tmp451_ = (Device*) _tmp450_;
#line 659 "Utility/Device.vala"
												_tmp452_ = _tmp451_->kname;
#line 659 "Utility/Device.vala"
												_tmp453_ = list;
#line 659 "Utility/Device.vala"
												_tmp454_ = gee_abstract_list_get ((GeeAbstractList*) _tmp453_, j);
#line 659 "Utility/Device.vala"
												_tmp455_ = (Device*) _tmp454_;
#line 659 "Utility/Device.vala"
												_tmp456_ = _tmp455_->kname;
#line 659 "Utility/Device.vala"
												_tmp457_ = g_strcmp0 (_tmp452_, _tmp456_) == 0;
#line 659 "Utility/Device.vala"
												_g_object_unref0 (_tmp455_);
#line 659 "Utility/Device.vala"
												_g_object_unref0 (_tmp451_);
#line 659 "Utility/Device.vala"
												if (_tmp457_) {
#line 4677 "Device.c"
													GeeArrayList* _tmp458_;
													gpointer _tmp459_;
													Device* _tmp460_;
													gint _tmp461_;
#line 660 "Utility/Device.vala"
													_tmp458_ = list;
#line 660 "Utility/Device.vala"
													_tmp459_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp458_, k);
#line 660 "Utility/Device.vala"
													_tmp460_ = (Device*) _tmp459_;
#line 660 "Utility/Device.vala"
													_g_object_unref0 (_tmp460_);
#line 661 "Utility/Device.vala"
													j = j - 1;
#line 661 "Utility/Device.vala"
													_tmp461_ = j;
#line 4694 "Device.c"
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
		GeeArrayList* _tmp462_;
		gint _tmp463_;
		gint _tmp464_;
#line 670 "Utility/Device.vala"
		_tmp462_ = list;
#line 670 "Utility/Device.vala"
		_tmp463_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp462_);
#line 670 "Utility/Device.vala"
		_tmp464_ = _tmp463_;
#line 670 "Utility/Device.vala"
		i = _tmp464_ - 1;
#line 4720 "Device.c"
		{
			gboolean _tmp465_ = FALSE;
#line 670 "Utility/Device.vala"
			_tmp465_ = TRUE;
#line 670 "Utility/Device.vala"
			while (TRUE) {
#line 4727 "Device.c"
				GeeArrayList* _tmp467_;
				gpointer _tmp468_;
				Device* _tmp469_;
				const gchar* _tmp470_;
				gboolean _tmp471_;
#line 670 "Utility/Device.vala"
				if (!_tmp465_) {
#line 4735 "Device.c"
					gint _tmp466_;
#line 670 "Utility/Device.vala"
					i = i - 1;
#line 670 "Utility/Device.vala"
					_tmp466_ = i;
#line 4741 "Device.c"
				}
#line 670 "Utility/Device.vala"
				_tmp465_ = FALSE;
#line 670 "Utility/Device.vala"
				if (!(i >= 0)) {
#line 670 "Utility/Device.vala"
					break;
#line 4749 "Device.c"
				}
#line 671 "Utility/Device.vala"
				_tmp467_ = list;
#line 671 "Utility/Device.vala"
				_tmp468_ = gee_abstract_list_get ((GeeAbstractList*) _tmp467_, i);
#line 671 "Utility/Device.vala"
				_tmp469_ = (Device*) _tmp468_;
#line 671 "Utility/Device.vala"
				_tmp470_ = _tmp469_->type;
#line 671 "Utility/Device.vala"
				_tmp471_ = g_strcmp0 (_tmp470_, "dmraid") == 0;
#line 671 "Utility/Device.vala"
				_g_object_unref0 (_tmp469_);
#line 671 "Utility/Device.vala"
				if (_tmp471_) {
#line 4765 "Device.c"
					GeeArrayList* _tmp472_;
					gpointer _tmp473_;
					Device* _tmp474_;
					gchar* _tmp475_;
					GeeArrayList* _tmp476_;
					gpointer _tmp477_;
					Device* _tmp478_;
					GeeArrayList* _tmp479_;
					gpointer _tmp480_;
					Device* _tmp481_;
					const gchar* _tmp482_;
					gchar* _tmp483_;
#line 673 "Utility/Device.vala"
					_tmp472_ = list;
#line 673 "Utility/Device.vala"
					_tmp473_ = gee_abstract_list_get ((GeeAbstractList*) _tmp472_, i);
#line 673 "Utility/Device.vala"
					_tmp474_ = (Device*) _tmp473_;
#line 673 "Utility/Device.vala"
					_tmp475_ = g_strdup ("disk");
#line 673 "Utility/Device.vala"
					_g_free0 (_tmp474_->type);
#line 673 "Utility/Device.vala"
					_tmp474_->type = _tmp475_;
#line 673 "Utility/Device.vala"
					_g_object_unref0 (_tmp474_);
#line 674 "Utility/Device.vala"
					_tmp476_ = list;
#line 674 "Utility/Device.vala"
					_tmp477_ = gee_abstract_list_get ((GeeAbstractList*) _tmp476_, i);
#line 674 "Utility/Device.vala"
					_tmp478_ = (Device*) _tmp477_;
#line 674 "Utility/Device.vala"
					_tmp479_ = list;
#line 674 "Utility/Device.vala"
					_tmp480_ = gee_abstract_list_get ((GeeAbstractList*) _tmp479_, i);
#line 674 "Utility/Device.vala"
					_tmp481_ = (Device*) _tmp480_;
#line 674 "Utility/Device.vala"
					_tmp482_ = _tmp481_->name;
#line 674 "Utility/Device.vala"
					_tmp483_ = g_strdup (_tmp482_);
#line 674 "Utility/Device.vala"
					_g_free0 (_tmp478_->model);
#line 674 "Utility/Device.vala"
					_tmp478_->model = _tmp483_;
#line 674 "Utility/Device.vala"
					_g_object_unref0 (_tmp481_);
#line 674 "Utility/Device.vala"
					_g_object_unref0 (_tmp478_);
#line 4816 "Device.c"
					{
						gint j = 0;
						GeeArrayList* _tmp484_;
						gint _tmp485_;
						gint _tmp486_;
#line 677 "Utility/Device.vala"
						_tmp484_ = list;
#line 677 "Utility/Device.vala"
						_tmp485_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp484_);
#line 677 "Utility/Device.vala"
						_tmp486_ = _tmp485_;
#line 677 "Utility/Device.vala"
						j = _tmp486_ - 1;
#line 4830 "Device.c"
						{
							gboolean _tmp487_ = FALSE;
#line 677 "Utility/Device.vala"
							_tmp487_ = TRUE;
#line 677 "Utility/Device.vala"
							while (TRUE) {
#line 4837 "Device.c"
								gboolean _tmp489_ = FALSE;
								gboolean _tmp490_ = FALSE;
#line 677 "Utility/Device.vala"
								if (!_tmp487_) {
#line 4842 "Device.c"
									gint _tmp488_;
#line 677 "Utility/Device.vala"
									j = j - 1;
#line 677 "Utility/Device.vala"
									_tmp488_ = j;
#line 4848 "Device.c"
								}
#line 677 "Utility/Device.vala"
								_tmp487_ = FALSE;
#line 677 "Utility/Device.vala"
								if (!(j >= 0)) {
#line 677 "Utility/Device.vala"
									break;
#line 4856 "Device.c"
								}
#line 678 "Utility/Device.vala"
								if (i != j) {
#line 4860 "Device.c"
									GeeArrayList* _tmp491_;
									gpointer _tmp492_;
									Device* _tmp493_;
									const gchar* _tmp494_;
#line 678 "Utility/Device.vala"
									_tmp491_ = list;
#line 678 "Utility/Device.vala"
									_tmp492_ = gee_abstract_list_get ((GeeAbstractList*) _tmp491_, j);
#line 678 "Utility/Device.vala"
									_tmp493_ = (Device*) _tmp492_;
#line 678 "Utility/Device.vala"
									_tmp494_ = _tmp493_->type;
#line 678 "Utility/Device.vala"
									_tmp490_ = g_strcmp0 (_tmp494_, "dmraid") == 0;
#line 678 "Utility/Device.vala"
									_g_object_unref0 (_tmp493_);
#line 4877 "Device.c"
								} else {
#line 678 "Utility/Device.vala"
									_tmp490_ = FALSE;
#line 4881 "Device.c"
								}
#line 678 "Utility/Device.vala"
								if (_tmp490_) {
#line 4885 "Device.c"
									GeeArrayList* _tmp495_;
									gpointer _tmp496_;
									Device* _tmp497_;
									const gchar* _tmp498_;
									GeeArrayList* _tmp499_;
									gpointer _tmp500_;
									Device* _tmp501_;
									const gchar* _tmp502_;
#line 678 "Utility/Device.vala"
									_tmp495_ = list;
#line 678 "Utility/Device.vala"
									_tmp496_ = gee_abstract_list_get ((GeeAbstractList*) _tmp495_, j);
#line 678 "Utility/Device.vala"
									_tmp497_ = (Device*) _tmp496_;
#line 678 "Utility/Device.vala"
									_tmp498_ = _tmp497_->kname;
#line 678 "Utility/Device.vala"
									_tmp499_ = list;
#line 678 "Utility/Device.vala"
									_tmp500_ = gee_abstract_list_get ((GeeAbstractList*) _tmp499_, i);
#line 678 "Utility/Device.vala"
									_tmp501_ = (Device*) _tmp500_;
#line 678 "Utility/Device.vala"
									_tmp502_ = _tmp501_->kname;
#line 678 "Utility/Device.vala"
									_tmp489_ = g_strcmp0 (_tmp498_, _tmp502_) == 0;
#line 678 "Utility/Device.vala"
									_g_object_unref0 (_tmp501_);
#line 678 "Utility/Device.vala"
									_g_object_unref0 (_tmp497_);
#line 4916 "Device.c"
								} else {
#line 678 "Utility/Device.vala"
									_tmp489_ = FALSE;
#line 4920 "Device.c"
								}
#line 678 "Utility/Device.vala"
								if (_tmp489_) {
#line 4924 "Device.c"
									GeeArrayList* _tmp503_;
									gpointer _tmp504_;
									Device* _tmp505_;
#line 679 "Utility/Device.vala"
									_tmp503_ = list;
#line 679 "Utility/Device.vala"
									_tmp504_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp503_, j);
#line 679 "Utility/Device.vala"
									_tmp505_ = (Device*) _tmp504_;
#line 679 "Utility/Device.vala"
									_g_object_unref0 (_tmp505_);
#line 680 "Utility/Device.vala"
									if (j < i) {
#line 4938 "Device.c"
										gint _tmp506_;
#line 681 "Utility/Device.vala"
										i = i - 1;
#line 681 "Utility/Device.vala"
										_tmp506_ = i;
#line 4944 "Device.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 690 "Utility/Device.vala"
	if (device_lsblk_is_ancient) {
#line 4956 "Device.c"
		GeeArrayList* _tmp507_;
#line 691 "Utility/Device.vala"
		_tmp507_ = list;
#line 691 "Utility/Device.vala"
		device_find_child_devices_using_dmsetup (_tmp507_);
#line 4962 "Device.c"
	}
#line 698 "Utility/Device.vala"
	result = list;
#line 698 "Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 698 "Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 698 "Utility/Device.vala"
	_g_free0 (cmd);
#line 698 "Utility/Device.vala"
	_g_free0 (std_err);
#line 698 "Utility/Device.vala"
	_g_free0 (std_out);
#line 698 "Utility/Device.vala"
	return result;
#line 4978 "Device.c"
}

GeeArrayList*
device_get_block_devices_using_blkid (const gchar* dev_name)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	gchar* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp6_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gint _tmp11_;
	const gchar* _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	GeeArrayList* _tmp104_;
	gint _tmp105_;
	gint _tmp106_;
	gchar* _tmp107_;
	gchar* _tmp108_;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result = NULL;
#line 702 "Utility/Device.vala"
	g_return_val_if_fail (dev_name != NULL, NULL);
#line 707 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 707 "Utility/Device.vala"
	list = _tmp0_;
#line 716 "Utility/Device.vala"
	_tmp2_ = strlen (dev_name);
#line 716 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 716 "Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 5022 "Device.c"
		gchar* _tmp4_;
#line 716 "Utility/Device.vala"
		_tmp4_ = g_strconcat (" ", dev_name, NULL);
#line 716 "Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 716 "Utility/Device.vala"
		_tmp1_ = _tmp4_;
#line 5030 "Device.c"
	} else {
		gchar* _tmp5_;
#line 716 "Utility/Device.vala"
		_tmp5_ = g_strdup ("");
#line 716 "Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 716 "Utility/Device.vala"
		_tmp1_ = _tmp5_;
#line 5039 "Device.c"
	}
#line 716 "Utility/Device.vala"
	_tmp6_ = g_strconcat ("/sbin/blkid", _tmp1_, NULL);
#line 716 "Utility/Device.vala"
	_g_free0 (cmd);
#line 716 "Utility/Device.vala"
	cmd = _tmp6_;
#line 718 "Utility/Device.vala"
	if (tee_jee_logging_LOG_DEBUG) {
#line 5049 "Device.c"
		const gchar* _tmp7_;
#line 719 "Utility/Device.vala"
		_tmp7_ = cmd;
#line 719 "Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp7_);
#line 5055 "Device.c"
	}
#line 722 "Utility/Device.vala"
	_tmp8_ = cmd;
#line 722 "Utility/Device.vala"
	_tmp11_ = tee_jee_process_helper_exec_script_sync (_tmp8_, &_tmp9_, &_tmp10_, FALSE, FALSE, TRUE, FALSE);
#line 722 "Utility/Device.vala"
	_g_free0 (std_out);
#line 722 "Utility/Device.vala"
	std_out = _tmp9_;
#line 722 "Utility/Device.vala"
	_g_free0 (std_err);
#line 722 "Utility/Device.vala"
	std_err = _tmp10_;
#line 722 "Utility/Device.vala"
	ret_val = _tmp11_;
#line 723 "Utility/Device.vala"
	if (ret_val != 0) {
#line 5073 "Device.c"
		gchar* msg = NULL;
		gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
		gint _tmp14_;
		gint _tmp15_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
#line 724 "Utility/Device.vala"
		_tmp12_ = g_strconcat ("blkid: ", _ ("Failed to get partition list"), NULL);
#line 724 "Utility/Device.vala"
		msg = _tmp12_;
#line 725 "Utility/Device.vala"
		_tmp14_ = strlen (dev_name);
#line 725 "Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 725 "Utility/Device.vala"
		if (_tmp15_ > 0) {
#line 5092 "Device.c"
			gchar* _tmp16_;
#line 725 "Utility/Device.vala"
			_tmp16_ = g_strconcat (": ", dev_name, NULL);
#line 725 "Utility/Device.vala"
			_g_free0 (_tmp13_);
#line 725 "Utility/Device.vala"
			_tmp13_ = _tmp16_;
#line 5100 "Device.c"
		} else {
			gchar* _tmp17_;
#line 725 "Utility/Device.vala"
			_tmp17_ = g_strdup ("");
#line 725 "Utility/Device.vala"
			_g_free0 (_tmp13_);
#line 725 "Utility/Device.vala"
			_tmp13_ = _tmp17_;
#line 5109 "Device.c"
		}
#line 725 "Utility/Device.vala"
		_tmp18_ = msg;
#line 725 "Utility/Device.vala"
		_tmp19_ = g_strconcat (_tmp18_, _tmp13_, NULL);
#line 725 "Utility/Device.vala"
		_g_free0 (msg);
#line 725 "Utility/Device.vala"
		msg = _tmp19_;
#line 726 "Utility/Device.vala"
		_tmp20_ = msg;
#line 726 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp20_, FALSE, FALSE);
#line 727 "Utility/Device.vala"
		result = list;
#line 727 "Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 727 "Utility/Device.vala"
		_g_free0 (msg);
#line 727 "Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 727 "Utility/Device.vala"
		_g_match_info_unref0 (match);
#line 727 "Utility/Device.vala"
		_g_regex_unref0 (rex);
#line 727 "Utility/Device.vala"
		_g_free0 (cmd);
#line 727 "Utility/Device.vala"
		_g_free0 (std_err);
#line 727 "Utility/Device.vala"
		_g_free0 (std_out);
#line 727 "Utility/Device.vala"
		return result;
#line 5143 "Device.c"
	}
#line 740 "Utility/Device.vala"
	_tmp21_ = std_out;
#line 740 "Utility/Device.vala"
	_tmp23_ = _tmp22_ = g_strsplit (_tmp21_, "\n", 0);
#line 5149 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 740 "Utility/Device.vala"
		line_collection = _tmp23_;
#line 740 "Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp22_);
#line 740 "Utility/Device.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 5161 "Device.c"
			gchar* _tmp24_;
			gchar* line = NULL;
#line 740 "Utility/Device.vala"
			_tmp24_ = g_strdup (line_collection[line_it]);
#line 740 "Utility/Device.vala"
			line = _tmp24_;
#line 5168 "Device.c"
			{
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gboolean _tmp30_;
				Device* pi = NULL;
				Device* _tmp31_;
				Device* _tmp32_;
				const gchar* _tmp33_;
				gchar** _tmp34_;
				gchar** _tmp35_;
				gchar** _tmp36_;
				gint _tmp36__length1;
				const gchar* _tmp37_;
				gchar* _tmp38_;
				Device* _tmp39_;
				const gchar* _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				Device* _tmp43_;
				const gchar* _tmp44_;
				gboolean _tmp45_ = FALSE;
				gboolean _tmp46_ = FALSE;
				gboolean _tmp47_ = FALSE;
				Device* _tmp48_;
				const gchar* _tmp49_;
				Device* _tmp98_;
				const gchar* _tmp99_;
				gint _tmp100_;
				gint _tmp101_;
#line 741 "Utility/Device.vala"
				_tmp25_ = line;
#line 741 "Utility/Device.vala"
				_tmp26_ = string_strip (_tmp25_);
#line 741 "Utility/Device.vala"
				_tmp27_ = _tmp26_;
#line 741 "Utility/Device.vala"
				_tmp28_ = strlen (_tmp27_);
#line 741 "Utility/Device.vala"
				_tmp29_ = _tmp28_;
#line 741 "Utility/Device.vala"
				_tmp30_ = _tmp29_ == 0;
#line 741 "Utility/Device.vala"
				_g_free0 (_tmp27_);
#line 741 "Utility/Device.vala"
				if (_tmp30_) {
#line 741 "Utility/Device.vala"
					_g_free0 (line);
#line 741 "Utility/Device.vala"
					continue;
#line 5221 "Device.c"
				}
#line 743 "Utility/Device.vala"
				_tmp31_ = device_new ();
#line 743 "Utility/Device.vala"
				pi = _tmp31_;
#line 745 "Utility/Device.vala"
				_tmp32_ = pi;
#line 745 "Utility/Device.vala"
				_tmp33_ = line;
#line 745 "Utility/Device.vala"
				_tmp35_ = _tmp34_ = g_strsplit (_tmp33_, ":", 0);
#line 745 "Utility/Device.vala"
				_tmp36_ = _tmp35_;
#line 745 "Utility/Device.vala"
				_tmp36__length1 = _vala_array_length (_tmp34_);
#line 745 "Utility/Device.vala"
				_tmp37_ = _tmp36_[0];
#line 745 "Utility/Device.vala"
				_tmp38_ = string_strip (_tmp37_);
#line 745 "Utility/Device.vala"
				_g_free0 (_tmp32_->device);
#line 745 "Utility/Device.vala"
				_tmp32_->device = _tmp38_;
#line 745 "Utility/Device.vala"
				_tmp36_ = (_vala_array_free (_tmp36_, _tmp36__length1, (GDestroyNotify) g_free), NULL);
#line 747 "Utility/Device.vala"
				_tmp39_ = pi;
#line 747 "Utility/Device.vala"
				_tmp40_ = _tmp39_->device;
#line 747 "Utility/Device.vala"
				_tmp41_ = strlen (_tmp40_);
#line 747 "Utility/Device.vala"
				_tmp42_ = _tmp41_;
#line 747 "Utility/Device.vala"
				if (_tmp42_ == 0) {
#line 747 "Utility/Device.vala"
					_g_object_unref0 (pi);
#line 747 "Utility/Device.vala"
					_g_free0 (line);
#line 747 "Utility/Device.vala"
					continue;
#line 5263 "Device.c"
				}
#line 751 "Utility/Device.vala"
				_tmp43_ = pi;
#line 751 "Utility/Device.vala"
				_tmp44_ = _tmp43_->device;
#line 751 "Utility/Device.vala"
				if (!g_str_has_prefix (_tmp44_, "/dev/")) {
#line 752 "Utility/Device.vala"
					_g_object_unref0 (pi);
#line 752 "Utility/Device.vala"
					_g_free0 (line);
#line 752 "Utility/Device.vala"
					continue;
#line 5277 "Device.c"
				}
#line 755 "Utility/Device.vala"
				_tmp48_ = pi;
#line 755 "Utility/Device.vala"
				_tmp49_ = _tmp48_->device;
#line 755 "Utility/Device.vala"
				if (g_str_has_prefix (_tmp49_, "/dev/sd")) {
#line 755 "Utility/Device.vala"
					_tmp47_ = TRUE;
#line 5287 "Device.c"
				} else {
					Device* _tmp50_;
					const gchar* _tmp51_;
#line 755 "Utility/Device.vala"
					_tmp50_ = pi;
#line 755 "Utility/Device.vala"
					_tmp51_ = _tmp50_->device;
#line 755 "Utility/Device.vala"
					_tmp47_ = g_str_has_prefix (_tmp51_, "/dev/hd");
#line 5297 "Device.c"
				}
#line 755 "Utility/Device.vala"
				if (_tmp47_) {
#line 755 "Utility/Device.vala"
					_tmp46_ = TRUE;
#line 5303 "Device.c"
				} else {
					Device* _tmp52_;
					const gchar* _tmp53_;
#line 755 "Utility/Device.vala"
					_tmp52_ = pi;
#line 755 "Utility/Device.vala"
					_tmp53_ = _tmp52_->device;
#line 755 "Utility/Device.vala"
					_tmp46_ = g_str_has_prefix (_tmp53_, "/dev/mapper/");
#line 5313 "Device.c"
				}
#line 755 "Utility/Device.vala"
				if (_tmp46_) {
#line 755 "Utility/Device.vala"
					_tmp45_ = TRUE;
#line 5319 "Device.c"
				} else {
					Device* _tmp54_;
					const gchar* _tmp55_;
#line 755 "Utility/Device.vala"
					_tmp54_ = pi;
#line 755 "Utility/Device.vala"
					_tmp55_ = _tmp54_->device;
#line 755 "Utility/Device.vala"
					_tmp45_ = g_str_has_prefix (_tmp55_, "/dev/dm");
#line 5329 "Device.c"
				}
#line 755 "Utility/Device.vala"
				if (_tmp45_) {
#line 5333 "Device.c"
				} else {
					Device* _tmp56_;
					const gchar* _tmp57_;
#line 758 "Utility/Device.vala"
					_tmp56_ = pi;
#line 758 "Utility/Device.vala"
					_tmp57_ = _tmp56_->device;
#line 758 "Utility/Device.vala"
					if (g_str_has_prefix (_tmp57_, "/dev/disk/by-uuid/")) {
#line 5343 "Device.c"
						Device* _tmp58_;
						Device* _tmp59_;
						const gchar* _tmp60_;
						gchar* _tmp61_;
#line 760 "Utility/Device.vala"
						_tmp58_ = pi;
#line 760 "Utility/Device.vala"
						_tmp59_ = pi;
#line 760 "Utility/Device.vala"
						_tmp60_ = _tmp59_->device;
#line 760 "Utility/Device.vala"
						_tmp61_ = string_replace (_tmp60_, "/dev/disk/by-uuid/", "");
#line 760 "Utility/Device.vala"
						_g_free0 (_tmp58_->uuid);
#line 760 "Utility/Device.vala"
						_tmp58_->uuid = _tmp61_;
#line 5360 "Device.c"
					} else {
#line 763 "Utility/Device.vala"
						_g_object_unref0 (pi);
#line 763 "Utility/Device.vala"
						_g_free0 (line);
#line 763 "Utility/Device.vala"
						continue;
#line 5368 "Device.c"
					}
				}
				{
					GRegex* _tmp62_ = NULL;
					GRegex* _tmp63_;
					GRegex* _tmp64_;
					GRegex* _tmp65_;
					const gchar* _tmp66_;
					GMatchInfo* _tmp67_ = NULL;
					gboolean _tmp68_;
					GRegex* _tmp72_ = NULL;
					GRegex* _tmp73_;
					GRegex* _tmp74_;
					GRegex* _tmp75_;
					const gchar* _tmp76_;
					GMatchInfo* _tmp77_ = NULL;
					gboolean _tmp78_;
					GRegex* _tmp84_ = NULL;
					GRegex* _tmp85_;
					GRegex* _tmp86_;
					GRegex* _tmp87_;
					const gchar* _tmp88_;
					GMatchInfo* _tmp89_ = NULL;
					gboolean _tmp90_;
#line 769 "Utility/Device.vala"
					_tmp63_ = g_regex_new ("LABEL=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error0_);
#line 769 "Utility/Device.vala"
					_tmp62_ = _tmp63_;
#line 769 "Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5399 "Device.c"
						goto __catch0_g_error;
					}
#line 769 "Utility/Device.vala"
					_tmp64_ = _tmp62_;
#line 769 "Utility/Device.vala"
					_tmp62_ = NULL;
#line 769 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 769 "Utility/Device.vala"
					rex = _tmp64_;
#line 770 "Utility/Device.vala"
					_tmp65_ = rex;
#line 770 "Utility/Device.vala"
					_tmp66_ = line;
#line 770 "Utility/Device.vala"
					_tmp68_ = g_regex_match (_tmp65_, _tmp66_, 0, &_tmp67_);
#line 770 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 770 "Utility/Device.vala"
					match = _tmp67_;
#line 770 "Utility/Device.vala"
					if (_tmp68_) {
#line 5422 "Device.c"
						Device* _tmp69_;
						GMatchInfo* _tmp70_;
						gchar* _tmp71_;
#line 771 "Utility/Device.vala"
						_tmp69_ = pi;
#line 771 "Utility/Device.vala"
						_tmp70_ = match;
#line 771 "Utility/Device.vala"
						_tmp71_ = g_match_info_fetch (_tmp70_, 1);
#line 771 "Utility/Device.vala"
						_g_free0 (_tmp69_->label);
#line 771 "Utility/Device.vala"
						_tmp69_->label = _tmp71_;
#line 5436 "Device.c"
					}
#line 774 "Utility/Device.vala"
					_tmp73_ = g_regex_new ("UUID=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error0_);
#line 774 "Utility/Device.vala"
					_tmp72_ = _tmp73_;
#line 774 "Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 774 "Utility/Device.vala"
						_g_regex_unref0 (_tmp62_);
#line 5446 "Device.c"
						goto __catch0_g_error;
					}
#line 774 "Utility/Device.vala"
					_tmp74_ = _tmp72_;
#line 774 "Utility/Device.vala"
					_tmp72_ = NULL;
#line 774 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 774 "Utility/Device.vala"
					rex = _tmp74_;
#line 775 "Utility/Device.vala"
					_tmp75_ = rex;
#line 775 "Utility/Device.vala"
					_tmp76_ = line;
#line 775 "Utility/Device.vala"
					_tmp78_ = g_regex_match (_tmp75_, _tmp76_, 0, &_tmp77_);
#line 775 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 775 "Utility/Device.vala"
					match = _tmp77_;
#line 775 "Utility/Device.vala"
					if (_tmp78_) {
#line 5469 "Device.c"
						Device* _tmp79_;
						GMatchInfo* _tmp80_;
						gchar* _tmp81_;
						gchar* _tmp82_;
						gchar* _tmp83_;
#line 776 "Utility/Device.vala"
						_tmp79_ = pi;
#line 776 "Utility/Device.vala"
						_tmp80_ = match;
#line 776 "Utility/Device.vala"
						_tmp81_ = g_match_info_fetch (_tmp80_, 1);
#line 776 "Utility/Device.vala"
						_tmp82_ = _tmp81_;
#line 776 "Utility/Device.vala"
						_tmp83_ = string_strip (_tmp82_);
#line 776 "Utility/Device.vala"
						_g_free0 (_tmp79_->uuid);
#line 776 "Utility/Device.vala"
						_tmp79_->uuid = _tmp83_;
#line 776 "Utility/Device.vala"
						_g_free0 (_tmp82_);
#line 5491 "Device.c"
					}
#line 779 "Utility/Device.vala"
					_tmp85_ = g_regex_new ("TYPE=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error0_);
#line 779 "Utility/Device.vala"
					_tmp84_ = _tmp85_;
#line 779 "Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 779 "Utility/Device.vala"
						_g_regex_unref0 (_tmp72_);
#line 779 "Utility/Device.vala"
						_g_regex_unref0 (_tmp62_);
#line 5503 "Device.c"
						goto __catch0_g_error;
					}
#line 779 "Utility/Device.vala"
					_tmp86_ = _tmp84_;
#line 779 "Utility/Device.vala"
					_tmp84_ = NULL;
#line 779 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 779 "Utility/Device.vala"
					rex = _tmp86_;
#line 780 "Utility/Device.vala"
					_tmp87_ = rex;
#line 780 "Utility/Device.vala"
					_tmp88_ = line;
#line 780 "Utility/Device.vala"
					_tmp90_ = g_regex_match (_tmp87_, _tmp88_, 0, &_tmp89_);
#line 780 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 780 "Utility/Device.vala"
					match = _tmp89_;
#line 780 "Utility/Device.vala"
					if (_tmp90_) {
#line 5526 "Device.c"
						Device* _tmp91_;
						GMatchInfo* _tmp92_;
						gchar* _tmp93_;
						gchar* _tmp94_;
						gchar* _tmp95_;
#line 781 "Utility/Device.vala"
						_tmp91_ = pi;
#line 781 "Utility/Device.vala"
						_tmp92_ = match;
#line 781 "Utility/Device.vala"
						_tmp93_ = g_match_info_fetch (_tmp92_, 1);
#line 781 "Utility/Device.vala"
						_tmp94_ = _tmp93_;
#line 781 "Utility/Device.vala"
						_tmp95_ = string_strip (_tmp94_);
#line 781 "Utility/Device.vala"
						_g_free0 (_tmp91_->fstype);
#line 781 "Utility/Device.vala"
						_tmp91_->fstype = _tmp95_;
#line 781 "Utility/Device.vala"
						_g_free0 (_tmp94_);
#line 5548 "Device.c"
					}
#line 768 "Utility/Device.vala"
					_g_regex_unref0 (_tmp84_);
#line 768 "Utility/Device.vala"
					_g_regex_unref0 (_tmp72_);
#line 768 "Utility/Device.vala"
					_g_regex_unref0 (_tmp62_);
#line 5556 "Device.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp96_;
					const gchar* _tmp97_;
#line 768 "Utility/Device.vala"
					e = _inner_error0_;
#line 768 "Utility/Device.vala"
					_inner_error0_ = NULL;
#line 785 "Utility/Device.vala"
					_tmp96_ = e;
#line 785 "Utility/Device.vala"
					_tmp97_ = _tmp96_->message;
#line 785 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp97_, FALSE, FALSE);
#line 768 "Utility/Device.vala"
					_g_error_free0 (e);
#line 5576 "Device.c"
				}
				__finally0:
#line 768 "Utility/Device.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 768 "Utility/Device.vala"
					_g_object_unref0 (pi);
#line 768 "Utility/Device.vala"
					_g_free0 (line);
#line 768 "Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 768 "Utility/Device.vala"
					_g_free0 (_tmp1_);
#line 768 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 768 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 768 "Utility/Device.vala"
					_g_free0 (cmd);
#line 768 "Utility/Device.vala"
					_g_free0 (std_err);
#line 768 "Utility/Device.vala"
					_g_free0 (std_out);
#line 768 "Utility/Device.vala"
					_g_object_unref0 (list);
#line 768 "Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 768 "Utility/Device.vala"
					g_clear_error (&_inner_error0_);
#line 768 "Utility/Device.vala"
					return NULL;
#line 5607 "Device.c"
				}
#line 790 "Utility/Device.vala"
				_tmp98_ = pi;
#line 790 "Utility/Device.vala"
				_tmp99_ = _tmp98_->uuid;
#line 790 "Utility/Device.vala"
				_tmp100_ = strlen (_tmp99_);
#line 790 "Utility/Device.vala"
				_tmp101_ = _tmp100_;
#line 790 "Utility/Device.vala"
				if (_tmp101_ > 0) {
#line 5619 "Device.c"
					GeeArrayList* _tmp102_;
					Device* _tmp103_;
#line 791 "Utility/Device.vala"
					_tmp102_ = list;
#line 791 "Utility/Device.vala"
					_tmp103_ = pi;
#line 791 "Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp102_, _tmp103_);
#line 5628 "Device.c"
				}
#line 740 "Utility/Device.vala"
				_g_object_unref0 (pi);
#line 740 "Utility/Device.vala"
				_g_free0 (line);
#line 5634 "Device.c"
			}
		}
#line 740 "Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 5639 "Device.c"
	}
#line 795 "Utility/Device.vala"
	_tmp104_ = list;
#line 795 "Utility/Device.vala"
	_tmp105_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp104_);
#line 795 "Utility/Device.vala"
	_tmp106_ = _tmp105_;
#line 795 "Utility/Device.vala"
	_tmp107_ = g_strdup_printf ("Device: get_block_devices_using_blkid(): %d", _tmp106_);
#line 795 "Utility/Device.vala"
	_tmp108_ = _tmp107_;
#line 795 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp108_);
#line 795 "Utility/Device.vala"
	_g_free0 (_tmp108_);
#line 797 "Utility/Device.vala"
	result = list;
#line 797 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 797 "Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 797 "Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 797 "Utility/Device.vala"
	_g_free0 (cmd);
#line 797 "Utility/Device.vala"
	_g_free0 (std_err);
#line 797 "Utility/Device.vala"
	_g_free0 (std_out);
#line 797 "Utility/Device.vala"
	return result;
#line 5671 "Device.c"
}

static guint64
uint64_parse (const gchar* str,
              guint _base)
{
	guint64 result = 0ULL;
#line 831 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 832 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, _base);
#line 832 "glib-2.0.vapi"
	return result;
#line 5685 "Device.c"
}

GeeArrayList*
device_get_disk_space_using_df (const gchar* dev_name_or_mount_point)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	const gchar* _tmp11_;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gint _tmp14_;
	gchar** lines = NULL;
	const gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint lines_length1;
	gint _lines_size_;
	gint line_num = 0;
	gchar** _tmp18_;
	gint _tmp18__length1;
	GeeArrayList* _tmp74_;
	gint _tmp75_;
	gint _tmp76_;
	gchar* _tmp77_;
	gchar* _tmp78_;
	GeeArrayList* result = NULL;
#line 800 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_mount_point != NULL, NULL);
#line 807 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 807 "Utility/Device.vala"
	list = _tmp0_;
#line 814 "Utility/Device.vala"
	_tmp1_ = g_strdup ("df -T -B1");
#line 814 "Utility/Device.vala"
	_g_free0 (cmd);
#line 814 "Utility/Device.vala"
	cmd = _tmp1_;
#line 816 "Utility/Device.vala"
	_tmp2_ = strlen (dev_name_or_mount_point);
#line 816 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 816 "Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 5737 "Device.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 817 "Utility/Device.vala"
		_tmp4_ = cmd;
#line 817 "Utility/Device.vala"
		_tmp5_ = tee_jee_file_system_escape_single_quote (dev_name_or_mount_point);
#line 817 "Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 817 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" '%s'", _tmp6_);
#line 817 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 817 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp4_, _tmp8_, NULL);
#line 817 "Utility/Device.vala"
		_g_free0 (cmd);
#line 817 "Utility/Device.vala"
		cmd = _tmp9_;
#line 817 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 817 "Utility/Device.vala"
		_g_free0 (_tmp6_);
#line 5764 "Device.c"
	}
#line 820 "Utility/Device.vala"
	if (tee_jee_logging_LOG_DEBUG) {
#line 5768 "Device.c"
		const gchar* _tmp10_;
#line 821 "Utility/Device.vala"
		_tmp10_ = cmd;
#line 821 "Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp10_);
#line 5774 "Device.c"
	}
#line 824 "Utility/Device.vala"
	_tmp11_ = cmd;
#line 824 "Utility/Device.vala"
	_tmp14_ = tee_jee_process_helper_exec_sync (_tmp11_, &_tmp12_, &_tmp13_);
#line 824 "Utility/Device.vala"
	_g_free0 (std_out);
#line 824 "Utility/Device.vala"
	std_out = _tmp12_;
#line 824 "Utility/Device.vala"
	_g_free0 (std_err);
#line 824 "Utility/Device.vala"
	std_err = _tmp13_;
#line 824 "Utility/Device.vala"
	ret_val = _tmp14_;
#line 839 "Utility/Device.vala"
	_tmp15_ = std_out;
#line 839 "Utility/Device.vala"
	_tmp17_ = _tmp16_ = g_strsplit (_tmp15_, "\n", 0);
#line 839 "Utility/Device.vala"
	lines = _tmp17_;
#line 839 "Utility/Device.vala"
	lines_length1 = _vala_array_length (_tmp16_);
#line 839 "Utility/Device.vala"
	_lines_size_ = lines_length1;
#line 841 "Utility/Device.vala"
	line_num = 0;
#line 842 "Utility/Device.vala"
	_tmp18_ = lines;
#line 842 "Utility/Device.vala"
	_tmp18__length1 = lines_length1;
#line 5806 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 842 "Utility/Device.vala"
		line_collection = _tmp18_;
#line 842 "Utility/Device.vala"
		line_collection_length1 = _tmp18__length1;
#line 842 "Utility/Device.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 5818 "Device.c"
			gchar* _tmp19_;
			gchar* line = NULL;
#line 842 "Utility/Device.vala"
			_tmp19_ = g_strdup (line_collection[line_it]);
#line 842 "Utility/Device.vala"
			line = _tmp19_;
#line 5825 "Device.c"
			{
				gint _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				gchar* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				gboolean _tmp26_;
				Device* pi = NULL;
				Device* _tmp27_;
				gint k = 0;
				const gchar* _tmp28_;
				gchar** _tmp29_;
				gchar** _tmp30_;
				Device* _tmp60_;
				Device* _tmp61_;
				const gchar* _tmp62_;
				gchar* _tmp63_;
				Device* _tmp64_;
				Device* _tmp65_;
				const gchar* _tmp66_;
				gchar* _tmp67_;
				Device* _tmp68_;
				const gchar* _tmp69_;
				gint _tmp70_;
				gint _tmp71_;
#line 844 "Utility/Device.vala"
				line_num = line_num + 1;
#line 844 "Utility/Device.vala"
				_tmp20_ = line_num;
#line 844 "Utility/Device.vala"
				if (_tmp20_ == 1) {
#line 844 "Utility/Device.vala"
					_g_free0 (line);
#line 844 "Utility/Device.vala"
					continue;
#line 5862 "Device.c"
				}
#line 845 "Utility/Device.vala"
				_tmp21_ = line;
#line 845 "Utility/Device.vala"
				_tmp22_ = string_strip (_tmp21_);
#line 845 "Utility/Device.vala"
				_tmp23_ = _tmp22_;
#line 845 "Utility/Device.vala"
				_tmp24_ = strlen (_tmp23_);
#line 845 "Utility/Device.vala"
				_tmp25_ = _tmp24_;
#line 845 "Utility/Device.vala"
				_tmp26_ = _tmp25_ == 0;
#line 845 "Utility/Device.vala"
				_g_free0 (_tmp23_);
#line 845 "Utility/Device.vala"
				if (_tmp26_) {
#line 845 "Utility/Device.vala"
					_g_free0 (line);
#line 845 "Utility/Device.vala"
					continue;
#line 5884 "Device.c"
				}
#line 847 "Utility/Device.vala"
				_tmp27_ = device_new ();
#line 847 "Utility/Device.vala"
				pi = _tmp27_;
#line 851 "Utility/Device.vala"
				k = 1;
#line 852 "Utility/Device.vala"
				_tmp28_ = line;
#line 852 "Utility/Device.vala"
				_tmp30_ = _tmp29_ = g_strsplit (_tmp28_, " ", 0);
#line 5896 "Device.c"
				{
					gchar** val_collection = NULL;
					gint val_collection_length1 = 0;
					gint _val_collection_size_ = 0;
					gint val_it = 0;
#line 852 "Utility/Device.vala"
					val_collection = _tmp30_;
#line 852 "Utility/Device.vala"
					val_collection_length1 = _vala_array_length (_tmp29_);
#line 852 "Utility/Device.vala"
					for (val_it = 0; val_it < val_collection_length1; val_it = val_it + 1) {
#line 5908 "Device.c"
						gchar* _tmp31_;
						gchar* val = NULL;
#line 852 "Utility/Device.vala"
						_tmp31_ = g_strdup (val_collection[val_it]);
#line 852 "Utility/Device.vala"
						val = _tmp31_;
#line 5915 "Device.c"
						{
							const gchar* _tmp32_;
							gchar* _tmp33_;
							gchar* _tmp34_;
							gint _tmp35_;
							gint _tmp36_;
							gboolean _tmp37_;
							gint _tmp38_;
#line 854 "Utility/Device.vala"
							_tmp32_ = val;
#line 854 "Utility/Device.vala"
							_tmp33_ = string_strip (_tmp32_);
#line 854 "Utility/Device.vala"
							_tmp34_ = _tmp33_;
#line 854 "Utility/Device.vala"
							_tmp35_ = strlen (_tmp34_);
#line 854 "Utility/Device.vala"
							_tmp36_ = _tmp35_;
#line 854 "Utility/Device.vala"
							_tmp37_ = _tmp36_ == 0;
#line 854 "Utility/Device.vala"
							_g_free0 (_tmp34_);
#line 854 "Utility/Device.vala"
							if (_tmp37_) {
#line 854 "Utility/Device.vala"
								_g_free0 (val);
#line 854 "Utility/Device.vala"
								continue;
#line 5944 "Device.c"
							}
#line 856 "Utility/Device.vala"
							_tmp38_ = k;
#line 856 "Utility/Device.vala"
							k = _tmp38_ + 1;
#line 856 "Utility/Device.vala"
							switch (_tmp38_) {
#line 856 "Utility/Device.vala"
								case 1:
#line 5954 "Device.c"
								{
									Device* _tmp39_;
									const gchar* _tmp40_;
									gchar* _tmp41_;
#line 858 "Utility/Device.vala"
									_tmp39_ = pi;
#line 858 "Utility/Device.vala"
									_tmp40_ = val;
#line 858 "Utility/Device.vala"
									_tmp41_ = string_strip (_tmp40_);
#line 858 "Utility/Device.vala"
									_g_free0 (_tmp39_->device);
#line 858 "Utility/Device.vala"
									_tmp39_->device = _tmp41_;
#line 859 "Utility/Device.vala"
									break;
#line 5971 "Device.c"
								}
#line 856 "Utility/Device.vala"
								case 2:
#line 5975 "Device.c"
								{
									Device* _tmp42_;
									const gchar* _tmp43_;
									gchar* _tmp44_;
#line 861 "Utility/Device.vala"
									_tmp42_ = pi;
#line 861 "Utility/Device.vala"
									_tmp43_ = val;
#line 861 "Utility/Device.vala"
									_tmp44_ = string_strip (_tmp43_);
#line 861 "Utility/Device.vala"
									_g_free0 (_tmp42_->fstype);
#line 861 "Utility/Device.vala"
									_tmp42_->fstype = _tmp44_;
#line 862 "Utility/Device.vala"
									break;
#line 5992 "Device.c"
								}
#line 856 "Utility/Device.vala"
								case 3:
#line 5996 "Device.c"
								{
									Device* _tmp45_;
									const gchar* _tmp46_;
									gchar* _tmp47_;
									gchar* _tmp48_;
#line 864 "Utility/Device.vala"
									_tmp45_ = pi;
#line 864 "Utility/Device.vala"
									_tmp46_ = val;
#line 864 "Utility/Device.vala"
									_tmp47_ = string_strip (_tmp46_);
#line 864 "Utility/Device.vala"
									_tmp48_ = _tmp47_;
#line 864 "Utility/Device.vala"
									_tmp45_->size_bytes = uint64_parse (_tmp48_, (guint) 0);
#line 864 "Utility/Device.vala"
									_g_free0 (_tmp48_);
#line 865 "Utility/Device.vala"
									break;
#line 6016 "Device.c"
								}
#line 856 "Utility/Device.vala"
								case 4:
#line 6020 "Device.c"
								{
									Device* _tmp49_;
									const gchar* _tmp50_;
									gchar* _tmp51_;
									gchar* _tmp52_;
#line 867 "Utility/Device.vala"
									_tmp49_ = pi;
#line 867 "Utility/Device.vala"
									_tmp50_ = val;
#line 867 "Utility/Device.vala"
									_tmp51_ = string_strip (_tmp50_);
#line 867 "Utility/Device.vala"
									_tmp52_ = _tmp51_;
#line 867 "Utility/Device.vala"
									_tmp49_->used_bytes = uint64_parse (_tmp52_, (guint) 0);
#line 867 "Utility/Device.vala"
									_g_free0 (_tmp52_);
#line 868 "Utility/Device.vala"
									break;
#line 6040 "Device.c"
								}
#line 856 "Utility/Device.vala"
								case 5:
#line 6044 "Device.c"
								{
									Device* _tmp53_;
									const gchar* _tmp54_;
									gchar* _tmp55_;
									gchar* _tmp56_;
#line 870 "Utility/Device.vala"
									_tmp53_ = pi;
#line 870 "Utility/Device.vala"
									_tmp54_ = val;
#line 870 "Utility/Device.vala"
									_tmp55_ = string_strip (_tmp54_);
#line 870 "Utility/Device.vala"
									_tmp56_ = _tmp55_;
#line 870 "Utility/Device.vala"
									_tmp53_->available_bytes = uint64_parse (_tmp56_, (guint) 0);
#line 870 "Utility/Device.vala"
									_g_free0 (_tmp56_);
#line 871 "Utility/Device.vala"
									break;
#line 6064 "Device.c"
								}
#line 856 "Utility/Device.vala"
								case 6:
#line 6068 "Device.c"
								{
									Device* _tmp57_;
									const gchar* _tmp58_;
									gchar* _tmp59_;
#line 873 "Utility/Device.vala"
									_tmp57_ = pi;
#line 873 "Utility/Device.vala"
									_tmp58_ = val;
#line 873 "Utility/Device.vala"
									_tmp59_ = string_strip (_tmp58_);
#line 873 "Utility/Device.vala"
									_g_free0 (_tmp57_->used_percent);
#line 873 "Utility/Device.vala"
									_tmp57_->used_percent = _tmp59_;
#line 874 "Utility/Device.vala"
									break;
#line 6085 "Device.c"
								}
#line 856 "Utility/Device.vala"
								case 7:
#line 6089 "Device.c"
								{
#line 880 "Utility/Device.vala"
									break;
#line 6093 "Device.c"
								}
								default:
#line 856 "Utility/Device.vala"
								break;
#line 6098 "Device.c"
							}
#line 852 "Utility/Device.vala"
							_g_free0 (val);
#line 6102 "Device.c"
						}
					}
#line 852 "Utility/Device.vala"
					val_collection = (_vala_array_free (val_collection, val_collection_length1, (GDestroyNotify) g_free), NULL);
#line 6107 "Device.c"
				}
#line 893 "Utility/Device.vala"
				_tmp60_ = pi;
#line 893 "Utility/Device.vala"
				_tmp61_ = pi;
#line 893 "Utility/Device.vala"
				_tmp62_ = _tmp61_->device;
#line 893 "Utility/Device.vala"
				_tmp63_ = device_resolve_device_name (_tmp62_);
#line 893 "Utility/Device.vala"
				_g_free0 (_tmp60_->device);
#line 893 "Utility/Device.vala"
				_tmp60_->device = _tmp63_;
#line 897 "Utility/Device.vala"
				_tmp64_ = pi;
#line 897 "Utility/Device.vala"
				_tmp65_ = pi;
#line 897 "Utility/Device.vala"
				_tmp66_ = _tmp65_->device;
#line 897 "Utility/Device.vala"
				_tmp67_ = device_get_device_uuid (_tmp66_);
#line 897 "Utility/Device.vala"
				_g_free0 (_tmp64_->uuid);
#line 897 "Utility/Device.vala"
				_tmp64_->uuid = _tmp67_;
#line 901 "Utility/Device.vala"
				_tmp68_ = pi;
#line 901 "Utility/Device.vala"
				_tmp69_ = _tmp68_->uuid;
#line 901 "Utility/Device.vala"
				_tmp70_ = strlen (_tmp69_);
#line 901 "Utility/Device.vala"
				_tmp71_ = _tmp70_;
#line 901 "Utility/Device.vala"
				if (_tmp71_ > 0) {
#line 6143 "Device.c"
					GeeArrayList* _tmp72_;
					Device* _tmp73_;
#line 902 "Utility/Device.vala"
					_tmp72_ = list;
#line 902 "Utility/Device.vala"
					_tmp73_ = pi;
#line 902 "Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp72_, _tmp73_);
#line 6152 "Device.c"
				}
#line 842 "Utility/Device.vala"
				_g_object_unref0 (pi);
#line 842 "Utility/Device.vala"
				_g_free0 (line);
#line 6158 "Device.c"
			}
		}
	}
#line 906 "Utility/Device.vala"
	_tmp74_ = list;
#line 906 "Utility/Device.vala"
	_tmp75_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp74_);
#line 906 "Utility/Device.vala"
	_tmp76_ = _tmp75_;
#line 906 "Utility/Device.vala"
	_tmp77_ = g_strdup_printf ("Device: get_disk_space_using_df(): %d", _tmp76_);
#line 906 "Utility/Device.vala"
	_tmp78_ = _tmp77_;
#line 906 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp78_);
#line 906 "Utility/Device.vala"
	_g_free0 (_tmp78_);
#line 908 "Utility/Device.vala"
	result = list;
#line 908 "Utility/Device.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 908 "Utility/Device.vala"
	_g_free0 (cmd);
#line 908 "Utility/Device.vala"
	_g_free0 (std_err);
#line 908 "Utility/Device.vala"
	_g_free0 (std_out);
#line 908 "Utility/Device.vala"
	return result;
#line 6188 "Device.c"
}

GeeArrayList*
device_get_mounted_filesystems_using_mtab (void)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* mtab_path = NULL;
	gchar* _tmp1_;
	gchar* mtab_lines = NULL;
	gchar* _tmp2_;
	GFile* f = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar** lines = NULL;
	const gchar* _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	gint lines_length1;
	gint _lines_size_;
	GeeArrayList* mount_list = NULL;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp100_;
	gint _tmp101_;
	gint _tmp102_;
	gchar* _tmp103_;
	gchar* _tmp104_;
	GeeArrayList* result = NULL;
#line 916 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 916 "Utility/Device.vala"
	list = _tmp0_;
#line 918 "Utility/Device.vala"
	_tmp1_ = g_strdup ("/etc/mtab");
#line 918 "Utility/Device.vala"
	mtab_path = _tmp1_;
#line 919 "Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 919 "Utility/Device.vala"
	mtab_lines = _tmp2_;
#line 925 "Utility/Device.vala"
	_tmp3_ = g_strdup ("/proc/mounts");
#line 925 "Utility/Device.vala"
	_g_free0 (mtab_path);
#line 925 "Utility/Device.vala"
	mtab_path = _tmp3_;
#line 926 "Utility/Device.vala"
	_tmp4_ = mtab_path;
#line 926 "Utility/Device.vala"
	_tmp5_ = g_file_new_for_path (_tmp4_);
#line 926 "Utility/Device.vala"
	_g_object_unref0 (f);
#line 926 "Utility/Device.vala"
	f = _tmp5_;
#line 927 "Utility/Device.vala"
	_tmp6_ = f;
#line 927 "Utility/Device.vala"
	if (!g_file_query_exists (_tmp6_, NULL)) {
#line 6251 "Device.c"
		gchar* _tmp7_;
		const gchar* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
#line 928 "Utility/Device.vala"
		_tmp7_ = g_strdup ("/proc/self/mounts");
#line 928 "Utility/Device.vala"
		_g_free0 (mtab_path);
#line 928 "Utility/Device.vala"
		mtab_path = _tmp7_;
#line 929 "Utility/Device.vala"
		_tmp8_ = mtab_path;
#line 929 "Utility/Device.vala"
		_tmp9_ = g_file_new_for_path (_tmp8_);
#line 929 "Utility/Device.vala"
		_g_object_unref0 (f);
#line 929 "Utility/Device.vala"
		f = _tmp9_;
#line 930 "Utility/Device.vala"
		_tmp10_ = f;
#line 930 "Utility/Device.vala"
		if (!g_file_query_exists (_tmp10_, NULL)) {
#line 6274 "Device.c"
			gchar* _tmp11_;
			const gchar* _tmp12_;
			GFile* _tmp13_;
			GFile* _tmp14_;
#line 931 "Utility/Device.vala"
			_tmp11_ = g_strdup ("/etc/mtab");
#line 931 "Utility/Device.vala"
			_g_free0 (mtab_path);
#line 931 "Utility/Device.vala"
			mtab_path = _tmp11_;
#line 932 "Utility/Device.vala"
			_tmp12_ = mtab_path;
#line 932 "Utility/Device.vala"
			_tmp13_ = g_file_new_for_path (_tmp12_);
#line 932 "Utility/Device.vala"
			_g_object_unref0 (f);
#line 932 "Utility/Device.vala"
			f = _tmp13_;
#line 933 "Utility/Device.vala"
			_tmp14_ = f;
#line 933 "Utility/Device.vala"
			if (!g_file_query_exists (_tmp14_, NULL)) {
#line 934 "Utility/Device.vala"
				result = list;
#line 934 "Utility/Device.vala"
				_g_object_unref0 (f);
#line 934 "Utility/Device.vala"
				_g_free0 (mtab_lines);
#line 934 "Utility/Device.vala"
				_g_free0 (mtab_path);
#line 934 "Utility/Device.vala"
				return result;
#line 6307 "Device.c"
			}
		}
	}
#line 947 "Utility/Device.vala"
	_tmp15_ = mtab_path;
#line 947 "Utility/Device.vala"
	_tmp16_ = tee_jee_file_system_file_read (_tmp15_);
#line 947 "Utility/Device.vala"
	_g_free0 (mtab_lines);
#line 947 "Utility/Device.vala"
	mtab_lines = _tmp16_;
#line 976 "Utility/Device.vala"
	_tmp17_ = mtab_lines;
#line 976 "Utility/Device.vala"
	_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, "\n", 0);
#line 976 "Utility/Device.vala"
	lines = _tmp19_;
#line 976 "Utility/Device.vala"
	lines_length1 = _vala_array_length (_tmp18_);
#line 976 "Utility/Device.vala"
	_lines_size_ = lines_length1;
#line 977 "Utility/Device.vala"
	_tmp20_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 977 "Utility/Device.vala"
	mount_list = _tmp20_;
#line 6333 "Device.c"
	{
		gint i = 0;
		gchar** _tmp21_;
		gint _tmp21__length1;
#line 979 "Utility/Device.vala"
		_tmp21_ = lines;
#line 979 "Utility/Device.vala"
		_tmp21__length1 = lines_length1;
#line 979 "Utility/Device.vala"
		i = _tmp21__length1 - 1;
#line 6344 "Device.c"
		{
			gboolean _tmp22_ = FALSE;
#line 979 "Utility/Device.vala"
			_tmp22_ = TRUE;
#line 979 "Utility/Device.vala"
			while (TRUE) {
#line 6351 "Device.c"
				gboolean ignoreEntry = FALSE;
				gchar* line = NULL;
				gchar** _tmp24_;
				gint _tmp24__length1;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				Device* pi = NULL;
				Device* _tmp30_;
				MountEntry* mp = NULL;
				Device* _tmp31_;
				MountEntry* _tmp32_;
				gint k = 0;
				const gchar* _tmp33_;
				gchar** _tmp34_;
				gchar** _tmp35_;
				Device* _tmp69_;
				Device* _tmp70_;
				const gchar* _tmp71_;
				gchar* _tmp72_;
				Device* _tmp73_;
				Device* _tmp74_;
				const gchar* _tmp75_;
				gchar* _tmp76_;
				Device* _tmp77_;
				const gchar* _tmp78_;
				gint _tmp79_;
				gint _tmp80_;
#line 979 "Utility/Device.vala"
				if (!_tmp22_) {
#line 6384 "Device.c"
					gint _tmp23_;
#line 979 "Utility/Device.vala"
					_tmp23_ = i;
#line 979 "Utility/Device.vala"
					i = _tmp23_ - 1;
#line 6390 "Device.c"
				}
#line 979 "Utility/Device.vala"
				_tmp22_ = FALSE;
#line 979 "Utility/Device.vala"
				if (!(i >= 0)) {
#line 979 "Utility/Device.vala"
					break;
#line 6398 "Device.c"
				}
#line 981 "Utility/Device.vala"
				ignoreEntry = FALSE;
#line 983 "Utility/Device.vala"
				_tmp24_ = lines;
#line 983 "Utility/Device.vala"
				_tmp24__length1 = lines_length1;
#line 983 "Utility/Device.vala"
				_tmp25_ = _tmp24_[i];
#line 983 "Utility/Device.vala"
				_tmp26_ = string_strip (_tmp25_);
#line 983 "Utility/Device.vala"
				line = _tmp26_;
#line 984 "Utility/Device.vala"
				_tmp27_ = line;
#line 984 "Utility/Device.vala"
				_tmp28_ = strlen (_tmp27_);
#line 984 "Utility/Device.vala"
				_tmp29_ = _tmp28_;
#line 984 "Utility/Device.vala"
				if (_tmp29_ == 0) {
#line 984 "Utility/Device.vala"
					_g_free0 (line);
#line 984 "Utility/Device.vala"
					continue;
#line 6424 "Device.c"
				}
#line 986 "Utility/Device.vala"
				_tmp30_ = device_new ();
#line 986 "Utility/Device.vala"
				pi = _tmp30_;
#line 988 "Utility/Device.vala"
				_tmp31_ = pi;
#line 988 "Utility/Device.vala"
				_tmp32_ = mount_entry_new (_tmp31_, "", "");
#line 988 "Utility/Device.vala"
				mp = _tmp32_;
#line 992 "Utility/Device.vala"
				k = 1;
#line 993 "Utility/Device.vala"
				_tmp33_ = line;
#line 993 "Utility/Device.vala"
				_tmp35_ = _tmp34_ = g_strsplit (_tmp33_, " ", 0);
#line 6442 "Device.c"
				{
					gchar** val_collection = NULL;
					gint val_collection_length1 = 0;
					gint _val_collection_size_ = 0;
					gint val_it = 0;
#line 993 "Utility/Device.vala"
					val_collection = _tmp35_;
#line 993 "Utility/Device.vala"
					val_collection_length1 = _vala_array_length (_tmp34_);
#line 993 "Utility/Device.vala"
					for (val_it = 0; val_it < val_collection_length1; val_it = val_it + 1) {
#line 6454 "Device.c"
						gchar* _tmp36_;
						gchar* val = NULL;
#line 993 "Utility/Device.vala"
						_tmp36_ = g_strdup (val_collection[val_it]);
#line 993 "Utility/Device.vala"
						val = _tmp36_;
#line 6461 "Device.c"
						{
							const gchar* _tmp37_;
							gchar* _tmp38_;
							gchar* _tmp39_;
							gint _tmp40_;
							gint _tmp41_;
							gboolean _tmp42_;
							gint _tmp43_;
#line 994 "Utility/Device.vala"
							_tmp37_ = val;
#line 994 "Utility/Device.vala"
							_tmp38_ = string_strip (_tmp37_);
#line 994 "Utility/Device.vala"
							_tmp39_ = _tmp38_;
#line 994 "Utility/Device.vala"
							_tmp40_ = strlen (_tmp39_);
#line 994 "Utility/Device.vala"
							_tmp41_ = _tmp40_;
#line 994 "Utility/Device.vala"
							_tmp42_ = _tmp41_ == 0;
#line 994 "Utility/Device.vala"
							_g_free0 (_tmp39_);
#line 994 "Utility/Device.vala"
							if (_tmp42_) {
#line 994 "Utility/Device.vala"
								_g_free0 (val);
#line 994 "Utility/Device.vala"
								continue;
#line 6490 "Device.c"
							}
#line 995 "Utility/Device.vala"
							if (ignoreEntry) {
#line 995 "Utility/Device.vala"
								_g_free0 (val);
#line 995 "Utility/Device.vala"
								break;
#line 6498 "Device.c"
							}
#line 996 "Utility/Device.vala"
							_tmp43_ = k;
#line 996 "Utility/Device.vala"
							k = _tmp43_ + 1;
#line 996 "Utility/Device.vala"
							switch (_tmp43_) {
#line 996 "Utility/Device.vala"
								case 1:
#line 6508 "Device.c"
								{
									Device* _tmp44_;
									const gchar* _tmp45_;
									gchar* _tmp46_;
#line 998 "Utility/Device.vala"
									_tmp44_ = pi;
#line 998 "Utility/Device.vala"
									_tmp45_ = val;
#line 998 "Utility/Device.vala"
									_tmp46_ = string_strip (_tmp45_);
#line 998 "Utility/Device.vala"
									_g_free0 (_tmp44_->device);
#line 998 "Utility/Device.vala"
									_tmp44_->device = _tmp46_;
#line 999 "Utility/Device.vala"
									break;
#line 6525 "Device.c"
								}
#line 996 "Utility/Device.vala"
								case 2:
#line 6529 "Device.c"
								{
									MountEntry* _tmp47_;
									const gchar* _tmp48_;
									gchar* _tmp49_;
									gchar* _tmp50_;
									gchar* _tmp51_;
									MountEntry* _tmp52_;
									const gchar* _tmp53_;
									GeeArrayList* _tmp54_;
									MountEntry* _tmp55_;
									const gchar* _tmp56_;
#line 1001 "Utility/Device.vala"
									_tmp47_ = mp;
#line 1001 "Utility/Device.vala"
									_tmp48_ = val;
#line 1001 "Utility/Device.vala"
									_tmp49_ = string_strip (_tmp48_);
#line 1001 "Utility/Device.vala"
									_tmp50_ = _tmp49_;
#line 1001 "Utility/Device.vala"
									_tmp51_ = string_replace (_tmp50_, "\\040", " ");
#line 1001 "Utility/Device.vala"
									_g_free0 (_tmp47_->mount_point);
#line 1001 "Utility/Device.vala"
									_tmp47_->mount_point = _tmp51_;
#line 1001 "Utility/Device.vala"
									_g_free0 (_tmp50_);
#line 1004 "Utility/Device.vala"
									_tmp52_ = mp;
#line 1004 "Utility/Device.vala"
									_tmp53_ = _tmp52_->mount_point;
#line 1004 "Utility/Device.vala"
									if (string_contains (_tmp53_, "/docker")) {
#line 1005 "Utility/Device.vala"
										ignoreEntry = TRUE;
#line 1006 "Utility/Device.vala"
										break;
#line 6567 "Device.c"
									}
#line 1009 "Utility/Device.vala"
									_tmp54_ = mount_list;
#line 1009 "Utility/Device.vala"
									_tmp55_ = mp;
#line 1009 "Utility/Device.vala"
									_tmp56_ = _tmp55_->mount_point;
#line 1009 "Utility/Device.vala"
									if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp54_, _tmp56_)) {
#line 6577 "Device.c"
										GeeArrayList* _tmp57_;
										MountEntry* _tmp58_;
										const gchar* _tmp59_;
										Device* _tmp60_;
										GeeArrayList* _tmp61_;
										MountEntry* _tmp62_;
#line 1010 "Utility/Device.vala"
										_tmp57_ = mount_list;
#line 1010 "Utility/Device.vala"
										_tmp58_ = mp;
#line 1010 "Utility/Device.vala"
										_tmp59_ = _tmp58_->mount_point;
#line 1010 "Utility/Device.vala"
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp57_, _tmp59_);
#line 1011 "Utility/Device.vala"
										_tmp60_ = pi;
#line 1011 "Utility/Device.vala"
										_tmp61_ = _tmp60_->mount_points;
#line 1011 "Utility/Device.vala"
										_tmp62_ = mp;
#line 1011 "Utility/Device.vala"
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp61_, _tmp62_);
#line 6600 "Device.c"
									}
#line 1013 "Utility/Device.vala"
									break;
#line 6604 "Device.c"
								}
#line 996 "Utility/Device.vala"
								case 3:
#line 6608 "Device.c"
								{
									Device* _tmp63_;
									const gchar* _tmp64_;
									gchar* _tmp65_;
#line 1015 "Utility/Device.vala"
									_tmp63_ = pi;
#line 1015 "Utility/Device.vala"
									_tmp64_ = val;
#line 1015 "Utility/Device.vala"
									_tmp65_ = string_strip (_tmp64_);
#line 1015 "Utility/Device.vala"
									_g_free0 (_tmp63_->fstype);
#line 1015 "Utility/Device.vala"
									_tmp63_->fstype = _tmp65_;
#line 1016 "Utility/Device.vala"
									break;
#line 6625 "Device.c"
								}
#line 996 "Utility/Device.vala"
								case 4:
#line 6629 "Device.c"
								{
									MountEntry* _tmp66_;
									const gchar* _tmp67_;
									gchar* _tmp68_;
#line 1018 "Utility/Device.vala"
									_tmp66_ = mp;
#line 1018 "Utility/Device.vala"
									_tmp67_ = val;
#line 1018 "Utility/Device.vala"
									_tmp68_ = string_strip (_tmp67_);
#line 1018 "Utility/Device.vala"
									_g_free0 (_tmp66_->mount_options);
#line 1018 "Utility/Device.vala"
									_tmp66_->mount_options = _tmp68_;
#line 1019 "Utility/Device.vala"
									break;
#line 6646 "Device.c"
								}
								default:
								{
#line 1022 "Utility/Device.vala"
									break;
#line 6652 "Device.c"
								}
							}
#line 993 "Utility/Device.vala"
							_g_free0 (val);
#line 6657 "Device.c"
						}
					}
#line 993 "Utility/Device.vala"
					val_collection = (_vala_array_free (val_collection, val_collection_length1, (GDestroyNotify) g_free), NULL);
#line 6662 "Device.c"
				}
#line 1026 "Utility/Device.vala"
				if (ignoreEntry) {
#line 1026 "Utility/Device.vala"
					_g_object_unref0 (mp);
#line 1026 "Utility/Device.vala"
					_g_object_unref0 (pi);
#line 1026 "Utility/Device.vala"
					_g_free0 (line);
#line 1026 "Utility/Device.vala"
					continue;
#line 6674 "Device.c"
				}
#line 1030 "Utility/Device.vala"
				_tmp69_ = pi;
#line 1030 "Utility/Device.vala"
				_tmp70_ = pi;
#line 1030 "Utility/Device.vala"
				_tmp71_ = _tmp70_->device;
#line 1030 "Utility/Device.vala"
				_tmp72_ = device_resolve_device_name (_tmp71_);
#line 1030 "Utility/Device.vala"
				_g_free0 (_tmp69_->device);
#line 1030 "Utility/Device.vala"
				_tmp69_->device = _tmp72_;
#line 1034 "Utility/Device.vala"
				_tmp73_ = pi;
#line 1034 "Utility/Device.vala"
				_tmp74_ = pi;
#line 1034 "Utility/Device.vala"
				_tmp75_ = _tmp74_->device;
#line 1034 "Utility/Device.vala"
				_tmp76_ = device_get_device_uuid (_tmp75_);
#line 1034 "Utility/Device.vala"
				_g_free0 (_tmp73_->uuid);
#line 1034 "Utility/Device.vala"
				_tmp73_->uuid = _tmp76_;
#line 1038 "Utility/Device.vala"
				_tmp77_ = pi;
#line 1038 "Utility/Device.vala"
				_tmp78_ = _tmp77_->uuid;
#line 1038 "Utility/Device.vala"
				_tmp79_ = strlen (_tmp78_);
#line 1038 "Utility/Device.vala"
				_tmp80_ = _tmp79_;
#line 1038 "Utility/Device.vala"
				if (_tmp80_ > 0) {
#line 6710 "Device.c"
					Device* dev = NULL;
					GeeArrayList* _tmp81_;
					Device* _tmp82_;
					const gchar* _tmp83_;
					Device* _tmp84_;
					Device* _tmp85_;
#line 1039 "Utility/Device.vala"
					_tmp81_ = list;
#line 1039 "Utility/Device.vala"
					_tmp82_ = pi;
#line 1039 "Utility/Device.vala"
					_tmp83_ = _tmp82_->uuid;
#line 1039 "Utility/Device.vala"
					_tmp84_ = device_find_device_in_list (_tmp81_, _tmp83_);
#line 1039 "Utility/Device.vala"
					dev = _tmp84_;
#line 1040 "Utility/Device.vala"
					_tmp85_ = dev;
#line 1040 "Utility/Device.vala"
					if (_tmp85_ == NULL) {
#line 6731 "Device.c"
						GeeArrayList* _tmp86_;
						Device* _tmp87_;
#line 1041 "Utility/Device.vala"
						_tmp86_ = list;
#line 1041 "Utility/Device.vala"
						_tmp87_ = pi;
#line 1041 "Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp86_, _tmp87_);
#line 6740 "Device.c"
					} else {
						{
							GeeArrayList* _item_list = NULL;
							Device* _tmp88_;
							GeeArrayList* _tmp89_;
							gint _item_size = 0;
							GeeArrayList* _tmp90_;
							gint _tmp91_;
							gint _tmp92_;
							gint _item_index = 0;
#line 1045 "Utility/Device.vala"
							_tmp88_ = pi;
#line 1045 "Utility/Device.vala"
							_tmp89_ = _tmp88_->mount_points;
#line 1045 "Utility/Device.vala"
							_item_list = _tmp89_;
#line 1045 "Utility/Device.vala"
							_tmp90_ = _item_list;
#line 1045 "Utility/Device.vala"
							_tmp91_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp90_);
#line 1045 "Utility/Device.vala"
							_tmp92_ = _tmp91_;
#line 1045 "Utility/Device.vala"
							_item_size = _tmp92_;
#line 1045 "Utility/Device.vala"
							_item_index = -1;
#line 1045 "Utility/Device.vala"
							while (TRUE) {
#line 6769 "Device.c"
								gint _tmp93_;
								gint _tmp94_;
								MountEntry* item = NULL;
								GeeArrayList* _tmp95_;
								gpointer _tmp96_;
								Device* _tmp97_;
								GeeArrayList* _tmp98_;
								MountEntry* _tmp99_;
#line 1045 "Utility/Device.vala"
								_item_index = _item_index + 1;
#line 1045 "Utility/Device.vala"
								_tmp93_ = _item_index;
#line 1045 "Utility/Device.vala"
								_tmp94_ = _item_size;
#line 1045 "Utility/Device.vala"
								if (!(_tmp93_ < _tmp94_)) {
#line 1045 "Utility/Device.vala"
									break;
#line 6788 "Device.c"
								}
#line 1045 "Utility/Device.vala"
								_tmp95_ = _item_list;
#line 1045 "Utility/Device.vala"
								_tmp96_ = gee_abstract_list_get ((GeeAbstractList*) _tmp95_, _item_index);
#line 1045 "Utility/Device.vala"
								item = (MountEntry*) _tmp96_;
#line 1046 "Utility/Device.vala"
								_tmp97_ = dev;
#line 1046 "Utility/Device.vala"
								_tmp98_ = _tmp97_->mount_points;
#line 1046 "Utility/Device.vala"
								_tmp99_ = item;
#line 1046 "Utility/Device.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp98_, _tmp99_);
#line 1045 "Utility/Device.vala"
								_g_object_unref0 (item);
#line 6806 "Device.c"
							}
						}
					}
#line 1038 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 6812 "Device.c"
				}
#line 979 "Utility/Device.vala"
				_g_object_unref0 (mp);
#line 979 "Utility/Device.vala"
				_g_object_unref0 (pi);
#line 979 "Utility/Device.vala"
				_g_free0 (line);
#line 6820 "Device.c"
			}
		}
	}
#line 1052 "Utility/Device.vala"
	_tmp100_ = list;
#line 1052 "Utility/Device.vala"
	_tmp101_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp100_);
#line 1052 "Utility/Device.vala"
	_tmp102_ = _tmp101_;
#line 1052 "Utility/Device.vala"
	_tmp103_ = g_strdup_printf ("Device: get_mounted_filesystems_using_mtab(): %d", _tmp102_);
#line 1052 "Utility/Device.vala"
	_tmp104_ = _tmp103_;
#line 1052 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp104_);
#line 1052 "Utility/Device.vala"
	_g_free0 (_tmp104_);
#line 1054 "Utility/Device.vala"
	result = list;
#line 1054 "Utility/Device.vala"
	_g_object_unref0 (mount_list);
#line 1054 "Utility/Device.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 1054 "Utility/Device.vala"
	_g_object_unref0 (f);
#line 1054 "Utility/Device.vala"
	_g_free0 (mtab_lines);
#line 1054 "Utility/Device.vala"
	_g_free0 (mtab_path);
#line 1054 "Utility/Device.vala"
	return result;
#line 6852 "Device.c"
}

Device*
device_get_device_by_uuid (const gchar* uuid)
{
	GeeArrayList* _tmp0_;
	Device* _tmp1_;
	Device* result = NULL;
#line 1059 "Utility/Device.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 1061 "Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1061 "Utility/Device.vala"
	_tmp1_ = device_find_device_in_list (_tmp0_, uuid);
#line 1061 "Utility/Device.vala"
	result = _tmp1_;
#line 1061 "Utility/Device.vala"
	return result;
#line 6871 "Device.c"
}

Device*
device_get_device_by_name (const gchar* file_name)
{
	GeeArrayList* _tmp0_;
	Device* _tmp1_;
	Device* result = NULL;
#line 1064 "Utility/Device.vala"
	g_return_val_if_fail (file_name != NULL, NULL);
#line 1066 "Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1066 "Utility/Device.vala"
	_tmp1_ = device_find_device_in_list (_tmp0_, file_name);
#line 1066 "Utility/Device.vala"
	result = _tmp1_;
#line 1066 "Utility/Device.vala"
	return result;
#line 6890 "Device.c"
}

Device*
device_get_device_by_path (const gchar* path_to_check)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	Device* result = NULL;
#line 1069 "Utility/Device.vala"
	g_return_val_if_fail (path_to_check != NULL, NULL);
#line 1071 "Utility/Device.vala"
	_tmp0_ = device_get_disk_space_using_df (path_to_check);
#line 1071 "Utility/Device.vala"
	list = _tmp0_;
#line 1073 "Utility/Device.vala"
	_tmp1_ = list;
#line 1073 "Utility/Device.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1073 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1073 "Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 6916 "Device.c"
		GeeArrayList* _tmp4_;
		gpointer _tmp5_;
#line 1074 "Utility/Device.vala"
		_tmp4_ = list;
#line 1074 "Utility/Device.vala"
		_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, 0);
#line 1074 "Utility/Device.vala"
		result = (Device*) _tmp5_;
#line 1074 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1074 "Utility/Device.vala"
		return result;
#line 6929 "Device.c"
	}
#line 1077 "Utility/Device.vala"
	result = NULL;
#line 1077 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1077 "Utility/Device.vala"
	return result;
#line 6937 "Device.c"
}

gchar*
device_get_device_uuid (const gchar* device)
{
	GeeArrayList* _tmp0_;
	gchar* _tmp15_;
	gchar* result = NULL;
#line 1080 "Utility/Device.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 1082 "Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1082 "Utility/Device.vala"
	if (_tmp0_ == NULL) {
#line 6952 "Device.c"
		GeeArrayList* _tmp1_;
#line 1083 "Utility/Device.vala"
		_tmp1_ = device_get_block_devices_using_lsblk ("");
#line 1083 "Utility/Device.vala"
		_g_object_unref0 (device_device_list);
#line 1083 "Utility/Device.vala"
		device_device_list = _tmp1_;
#line 6960 "Device.c"
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp2_;
		gint _dev_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _dev_index = 0;
#line 1085 "Utility/Device.vala"
		_tmp2_ = device_device_list;
#line 1085 "Utility/Device.vala"
		_dev_list = _tmp2_;
#line 1085 "Utility/Device.vala"
		_tmp3_ = _dev_list;
#line 1085 "Utility/Device.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 1085 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1085 "Utility/Device.vala"
		_dev_size = _tmp5_;
#line 1085 "Utility/Device.vala"
		_dev_index = -1;
#line 1085 "Utility/Device.vala"
		while (TRUE) {
#line 6986 "Device.c"
			gint _tmp6_;
			gint _tmp7_;
			Device* dev = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			Device* _tmp10_;
			const gchar* _tmp11_;
#line 1085 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1085 "Utility/Device.vala"
			_tmp6_ = _dev_index;
#line 1085 "Utility/Device.vala"
			_tmp7_ = _dev_size;
#line 1085 "Utility/Device.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 1085 "Utility/Device.vala"
				break;
#line 7004 "Device.c"
			}
#line 1085 "Utility/Device.vala"
			_tmp8_ = _dev_list;
#line 1085 "Utility/Device.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _dev_index);
#line 1085 "Utility/Device.vala"
			dev = (Device*) _tmp9_;
#line 1086 "Utility/Device.vala"
			_tmp10_ = dev;
#line 1086 "Utility/Device.vala"
			_tmp11_ = _tmp10_->device;
#line 1086 "Utility/Device.vala"
			if (g_strcmp0 (_tmp11_, device) == 0) {
#line 7018 "Device.c"
				Device* _tmp12_;
				const gchar* _tmp13_;
				gchar* _tmp14_;
#line 1087 "Utility/Device.vala"
				_tmp12_ = dev;
#line 1087 "Utility/Device.vala"
				_tmp13_ = _tmp12_->uuid;
#line 1087 "Utility/Device.vala"
				_tmp14_ = g_strdup (_tmp13_);
#line 1087 "Utility/Device.vala"
				result = _tmp14_;
#line 1087 "Utility/Device.vala"
				_g_object_unref0 (dev);
#line 1087 "Utility/Device.vala"
				return result;
#line 7034 "Device.c"
			}
#line 1085 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 7038 "Device.c"
		}
	}
#line 1091 "Utility/Device.vala"
	_tmp15_ = g_strdup ("");
#line 1091 "Utility/Device.vala"
	result = _tmp15_;
#line 1091 "Utility/Device.vala"
	return result;
#line 7047 "Device.c"
}

GeeArrayList*
device_get_device_mount_points (const gchar* dev_name_or_uuid)
{
	gchar* device = NULL;
	gchar* _tmp0_;
	gchar* uuid = NULL;
	gchar* _tmp1_;
	GeeArrayList* list_mtab = NULL;
	GeeArrayList* _tmp9_;
	Device* dev = NULL;
	GeeArrayList* _tmp10_;
	const gchar* _tmp11_;
	Device* _tmp12_;
	Device* _tmp13_;
	GeeArrayList* result = NULL;
#line 1094 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, NULL);
#line 1095 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1095 "Utility/Device.vala"
	device = _tmp0_;
#line 1096 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1096 "Utility/Device.vala"
	uuid = _tmp1_;
#line 1098 "Utility/Device.vala"
	if (g_str_has_prefix (dev_name_or_uuid, "/dev")) {
#line 7077 "Device.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 1099 "Utility/Device.vala"
		_tmp2_ = g_strdup (dev_name_or_uuid);
#line 1099 "Utility/Device.vala"
		_g_free0 (device);
#line 1099 "Utility/Device.vala"
		device = _tmp2_;
#line 1100 "Utility/Device.vala"
		_tmp3_ = device_get_device_uuid (dev_name_or_uuid);
#line 1100 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1100 "Utility/Device.vala"
		uuid = _tmp3_;
#line 7092 "Device.c"
	} else {
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 1103 "Utility/Device.vala"
		_tmp4_ = g_strdup (dev_name_or_uuid);
#line 1103 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1103 "Utility/Device.vala"
		uuid = _tmp4_;
#line 1104 "Utility/Device.vala"
		_tmp5_ = uuid;
#line 1104 "Utility/Device.vala"
		_tmp6_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp5_);
#line 1104 "Utility/Device.vala"
		_g_free0 (device);
#line 1104 "Utility/Device.vala"
		device = _tmp6_;
#line 1105 "Utility/Device.vala"
		_tmp7_ = device;
#line 1105 "Utility/Device.vala"
		_tmp8_ = device_resolve_device_name (_tmp7_);
#line 1105 "Utility/Device.vala"
		_g_free0 (device);
#line 1105 "Utility/Device.vala"
		device = _tmp8_;
#line 7121 "Device.c"
	}
#line 1108 "Utility/Device.vala"
	_tmp9_ = device_get_mounted_filesystems_using_mtab ();
#line 1108 "Utility/Device.vala"
	list_mtab = _tmp9_;
#line 1110 "Utility/Device.vala"
	_tmp10_ = list_mtab;
#line 1110 "Utility/Device.vala"
	_tmp11_ = uuid;
#line 1110 "Utility/Device.vala"
	_tmp12_ = device_find_device_in_list (_tmp10_, _tmp11_);
#line 1110 "Utility/Device.vala"
	dev = _tmp12_;
#line 1112 "Utility/Device.vala"
	_tmp13_ = dev;
#line 1112 "Utility/Device.vala"
	if (_tmp13_ != NULL) {
#line 7139 "Device.c"
		Device* _tmp14_;
		GeeArrayList* _tmp15_;
		GeeArrayList* _tmp16_;
#line 1113 "Utility/Device.vala"
		_tmp14_ = dev;
#line 1113 "Utility/Device.vala"
		_tmp15_ = _tmp14_->mount_points;
#line 1113 "Utility/Device.vala"
		_tmp16_ = _g_object_ref0 (_tmp15_);
#line 1113 "Utility/Device.vala"
		result = _tmp16_;
#line 1113 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1113 "Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 1113 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1113 "Utility/Device.vala"
		_g_free0 (device);
#line 1113 "Utility/Device.vala"
		return result;
#line 7161 "Device.c"
	} else {
		GeeArrayList* _tmp17_;
#line 1116 "Utility/Device.vala"
		_tmp17_ = gee_array_list_new (TYPE_MOUNT_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1116 "Utility/Device.vala"
		result = _tmp17_;
#line 1116 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1116 "Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 1116 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1116 "Utility/Device.vala"
		_g_free0 (device);
#line 1116 "Utility/Device.vala"
		return result;
#line 7178 "Device.c"
	}
}

gboolean
device_device_is_mounted (const gchar* dev_name_or_uuid)
{
	GeeArrayList* mps = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean result = FALSE;
#line 1120 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1122 "Utility/Device.vala"
	_tmp0_ = device_get_device_mount_points (dev_name_or_uuid);
#line 1122 "Utility/Device.vala"
	mps = _tmp0_;
#line 1123 "Utility/Device.vala"
	_tmp1_ = mps;
#line 1123 "Utility/Device.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1123 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1123 "Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 1124 "Utility/Device.vala"
		result = TRUE;
#line 1124 "Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1124 "Utility/Device.vala"
		return result;
#line 7211 "Device.c"
	}
#line 1127 "Utility/Device.vala"
	result = FALSE;
#line 1127 "Utility/Device.vala"
	_g_object_unref0 (mps);
#line 1127 "Utility/Device.vala"
	return result;
#line 7219 "Device.c"
}

gboolean
device_mount_point_in_use (const gchar* mount_point)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gboolean result = FALSE;
#line 1130 "Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1131 "Utility/Device.vala"
	_tmp0_ = device_get_mounted_filesystems_using_mtab ();
#line 1131 "Utility/Device.vala"
	list = _tmp0_;
#line 7234 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		gint _dev_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _dev_index = 0;
#line 1132 "Utility/Device.vala"
		_tmp1_ = list;
#line 1132 "Utility/Device.vala"
		_dev_list = _tmp1_;
#line 1132 "Utility/Device.vala"
		_tmp2_ = _dev_list;
#line 1132 "Utility/Device.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 1132 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 1132 "Utility/Device.vala"
		_dev_size = _tmp4_;
#line 1132 "Utility/Device.vala"
		_dev_index = -1;
#line 1132 "Utility/Device.vala"
		while (TRUE) {
#line 7259 "Device.c"
			gint _tmp5_;
			gint _tmp6_;
			Device* dev = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
#line 1132 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1132 "Utility/Device.vala"
			_tmp5_ = _dev_index;
#line 1132 "Utility/Device.vala"
			_tmp6_ = _dev_size;
#line 1132 "Utility/Device.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 1132 "Utility/Device.vala"
				break;
#line 7275 "Device.c"
			}
#line 1132 "Utility/Device.vala"
			_tmp7_ = _dev_list;
#line 1132 "Utility/Device.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _dev_index);
#line 1132 "Utility/Device.vala"
			dev = (Device*) _tmp8_;
#line 7283 "Device.c"
			{
				GeeArrayList* _mp_list = NULL;
				Device* _tmp9_;
				GeeArrayList* _tmp10_;
				gint _mp_size = 0;
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _mp_index = 0;
#line 1133 "Utility/Device.vala"
				_tmp9_ = dev;
#line 1133 "Utility/Device.vala"
				_tmp10_ = _tmp9_->mount_points;
#line 1133 "Utility/Device.vala"
				_mp_list = _tmp10_;
#line 1133 "Utility/Device.vala"
				_tmp11_ = _mp_list;
#line 1133 "Utility/Device.vala"
				_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 1133 "Utility/Device.vala"
				_tmp13_ = _tmp12_;
#line 1133 "Utility/Device.vala"
				_mp_size = _tmp13_;
#line 1133 "Utility/Device.vala"
				_mp_index = -1;
#line 1133 "Utility/Device.vala"
				while (TRUE) {
#line 7311 "Device.c"
					gint _tmp14_;
					gint _tmp15_;
					MountEntry* mp = NULL;
					GeeArrayList* _tmp16_;
					gpointer _tmp17_;
					MountEntry* _tmp18_;
					const gchar* _tmp19_;
#line 1133 "Utility/Device.vala"
					_mp_index = _mp_index + 1;
#line 1133 "Utility/Device.vala"
					_tmp14_ = _mp_index;
#line 1133 "Utility/Device.vala"
					_tmp15_ = _mp_size;
#line 1133 "Utility/Device.vala"
					if (!(_tmp14_ < _tmp15_)) {
#line 1133 "Utility/Device.vala"
						break;
#line 7329 "Device.c"
					}
#line 1133 "Utility/Device.vala"
					_tmp16_ = _mp_list;
#line 1133 "Utility/Device.vala"
					_tmp17_ = gee_abstract_list_get ((GeeAbstractList*) _tmp16_, _mp_index);
#line 1133 "Utility/Device.vala"
					mp = (MountEntry*) _tmp17_;
#line 1134 "Utility/Device.vala"
					_tmp18_ = mp;
#line 1134 "Utility/Device.vala"
					_tmp19_ = _tmp18_->mount_point;
#line 1134 "Utility/Device.vala"
					if (g_str_has_prefix (_tmp19_, mount_point)) {
#line 1136 "Utility/Device.vala"
						result = TRUE;
#line 1136 "Utility/Device.vala"
						_g_object_unref0 (mp);
#line 1136 "Utility/Device.vala"
						_g_object_unref0 (dev);
#line 1136 "Utility/Device.vala"
						_g_object_unref0 (list);
#line 1136 "Utility/Device.vala"
						return result;
#line 7353 "Device.c"
					}
#line 1133 "Utility/Device.vala"
					_g_object_unref0 (mp);
#line 7357 "Device.c"
				}
			}
#line 1132 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 7362 "Device.c"
		}
	}
#line 1140 "Utility/Device.vala"
	result = FALSE;
#line 1140 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1140 "Utility/Device.vala"
	return result;
#line 7371 "Device.c"
}

gchar*
device_resolve_device_name (const gchar* dev_alias)
{
	Device* dev = NULL;
	GeeArrayList* _tmp0_;
	Device* _tmp1_;
	Device* _tmp2_;
	gchar* result = NULL;
#line 1143 "Utility/Device.vala"
	g_return_val_if_fail (dev_alias != NULL, NULL);
#line 1145 "Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1145 "Utility/Device.vala"
	_tmp1_ = device_find_device_in_list (_tmp0_, dev_alias);
#line 1145 "Utility/Device.vala"
	dev = _tmp1_;
#line 1147 "Utility/Device.vala"
	_tmp2_ = dev;
#line 1147 "Utility/Device.vala"
	if (_tmp2_ != NULL) {
#line 7394 "Device.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 1148 "Utility/Device.vala"
		_tmp3_ = dev;
#line 1148 "Utility/Device.vala"
		_tmp4_ = _tmp3_->device;
#line 1148 "Utility/Device.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 1148 "Utility/Device.vala"
		result = _tmp5_;
#line 1148 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1148 "Utility/Device.vala"
		return result;
#line 7410 "Device.c"
	} else {
		gchar* _tmp6_;
#line 1151 "Utility/Device.vala"
		_tmp6_ = g_strdup (dev_alias);
#line 1151 "Utility/Device.vala"
		result = _tmp6_;
#line 1151 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1151 "Utility/Device.vala"
		return result;
#line 7421 "Device.c"
	}
}

Device*
device_find_device_in_list (GeeArrayList* list,
                            const gchar* _dev_alias)
{
	gchar* dev_alias = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	Device* result = NULL;
#line 1155 "Utility/Device.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 1155 "Utility/Device.vala"
	g_return_val_if_fail (_dev_alias != NULL, NULL);
#line 1157 "Utility/Device.vala"
	_tmp0_ = g_strdup (_dev_alias);
#line 1157 "Utility/Device.vala"
	dev_alias = _tmp0_;
#line 1159 "Utility/Device.vala"
	_tmp1_ = dev_alias;
#line 1159 "Utility/Device.vala"
	_tmp2_ = g_utf8_strdown (_tmp1_, (gssize) -1);
#line 1159 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1159 "Utility/Device.vala"
	_tmp4_ = g_str_has_prefix (_tmp3_, "uuid=");
#line 1159 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1159 "Utility/Device.vala"
	if (_tmp4_) {
#line 7456 "Device.c"
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 1161 "Utility/Device.vala"
		_tmp5_ = dev_alias;
#line 1161 "Utility/Device.vala"
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "=", 2);
#line 1161 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1161 "Utility/Device.vala"
		_tmp8__length1 = _vala_array_length (_tmp6_);
#line 1161 "Utility/Device.vala"
		_tmp9_ = _tmp8_[1];
#line 1161 "Utility/Device.vala"
		_tmp10_ = string_strip (_tmp9_);
#line 1161 "Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1161 "Utility/Device.vala"
		_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
#line 1161 "Utility/Device.vala"
		_g_free0 (dev_alias);
#line 1161 "Utility/Device.vala"
		dev_alias = _tmp12_;
#line 1161 "Utility/Device.vala"
		_g_free0 (_tmp11_);
#line 1161 "Utility/Device.vala"
		_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 7490 "Device.c"
	} else {
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
#line 1163 "Utility/Device.vala"
		_tmp14_ = dev_alias;
#line 1163 "Utility/Device.vala"
		if (tee_jee_file_system_file_exists (_tmp14_)) {
#line 7498 "Device.c"
			const gchar* _tmp15_;
#line 1163 "Utility/Device.vala"
			_tmp15_ = dev_alias;
#line 1163 "Utility/Device.vala"
			_tmp13_ = tee_jee_file_system_file_is_symlink (_tmp15_);
#line 7504 "Device.c"
		} else {
#line 1163 "Utility/Device.vala"
			_tmp13_ = FALSE;
#line 7508 "Device.c"
		}
#line 1163 "Utility/Device.vala"
		if (_tmp13_) {
#line 7512 "Device.c"
			gchar* link_path = NULL;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 1165 "Utility/Device.vala"
			_tmp16_ = dev_alias;
#line 1165 "Utility/Device.vala"
			_tmp17_ = tee_jee_file_system_file_get_symlink_target (_tmp16_);
#line 1165 "Utility/Device.vala"
			link_path = _tmp17_;
#line 1167 "Utility/Device.vala"
			_tmp18_ = link_path;
#line 1167 "Utility/Device.vala"
			_tmp19_ = string_replace (_tmp18_, "../../../", "/dev/");
#line 1167 "Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1167 "Utility/Device.vala"
			_tmp21_ = string_replace (_tmp20_, "../../", "/dev/");
#line 1167 "Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 1167 "Utility/Device.vala"
			_tmp23_ = string_replace (_tmp22_, "../", "/dev/");
#line 1167 "Utility/Device.vala"
			_g_free0 (dev_alias);
#line 1167 "Utility/Device.vala"
			dev_alias = _tmp23_;
#line 1167 "Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 1167 "Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 1163 "Utility/Device.vala"
			_g_free0 (link_path);
#line 7550 "Device.c"
		}
	}
	{
		GeeArrayList* _dev_list = NULL;
		gint _dev_size = 0;
		GeeArrayList* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		gint _dev_index = 0;
#line 1170 "Utility/Device.vala"
		_dev_list = list;
#line 1170 "Utility/Device.vala"
		_tmp24_ = _dev_list;
#line 1170 "Utility/Device.vala"
		_tmp25_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp24_);
#line 1170 "Utility/Device.vala"
		_tmp26_ = _tmp25_;
#line 1170 "Utility/Device.vala"
		_dev_size = _tmp26_;
#line 1170 "Utility/Device.vala"
		_dev_index = -1;
#line 1170 "Utility/Device.vala"
		while (TRUE) {
#line 7574 "Device.c"
			gint _tmp27_;
			gint _tmp28_;
			Device* dev = NULL;
			GeeArrayList* _tmp29_;
			gpointer _tmp30_;
			Device* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
#line 1170 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1170 "Utility/Device.vala"
			_tmp27_ = _dev_index;
#line 1170 "Utility/Device.vala"
			_tmp28_ = _dev_size;
#line 1170 "Utility/Device.vala"
			if (!(_tmp27_ < _tmp28_)) {
#line 1170 "Utility/Device.vala"
				break;
#line 7593 "Device.c"
			}
#line 1170 "Utility/Device.vala"
			_tmp29_ = _dev_list;
#line 1170 "Utility/Device.vala"
			_tmp30_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, _dev_index);
#line 1170 "Utility/Device.vala"
			dev = (Device*) _tmp30_;
#line 1172 "Utility/Device.vala"
			_tmp31_ = dev;
#line 1172 "Utility/Device.vala"
			_tmp32_ = _tmp31_->device;
#line 1172 "Utility/Device.vala"
			_tmp33_ = dev_alias;
#line 1172 "Utility/Device.vala"
			if (g_strcmp0 (_tmp32_, _tmp33_) == 0) {
#line 1173 "Utility/Device.vala"
				result = dev;
#line 1173 "Utility/Device.vala"
				_g_free0 (dev_alias);
#line 1173 "Utility/Device.vala"
				return result;
#line 7615 "Device.c"
			} else {
				Device* _tmp34_;
				const gchar* _tmp35_;
				const gchar* _tmp36_;
#line 1175 "Utility/Device.vala"
				_tmp34_ = dev;
#line 1175 "Utility/Device.vala"
				_tmp35_ = _tmp34_->uuid;
#line 1175 "Utility/Device.vala"
				_tmp36_ = dev_alias;
#line 1175 "Utility/Device.vala"
				if (g_strcmp0 (_tmp35_, _tmp36_) == 0) {
#line 1176 "Utility/Device.vala"
					result = dev;
#line 1176 "Utility/Device.vala"
					_g_free0 (dev_alias);
#line 1176 "Utility/Device.vala"
					return result;
#line 7634 "Device.c"
				} else {
					Device* _tmp37_;
					const gchar* _tmp38_;
					const gchar* _tmp39_;
#line 1178 "Utility/Device.vala"
					_tmp37_ = dev;
#line 1178 "Utility/Device.vala"
					_tmp38_ = _tmp37_->label;
#line 1178 "Utility/Device.vala"
					_tmp39_ = dev_alias;
#line 1178 "Utility/Device.vala"
					if (g_strcmp0 (_tmp38_, _tmp39_) == 0) {
#line 1179 "Utility/Device.vala"
						result = dev;
#line 1179 "Utility/Device.vala"
						_g_free0 (dev_alias);
#line 1179 "Utility/Device.vala"
						return result;
#line 7653 "Device.c"
					} else {
						Device* _tmp40_;
						const gchar* _tmp41_;
						const gchar* _tmp42_;
#line 1181 "Utility/Device.vala"
						_tmp40_ = dev;
#line 1181 "Utility/Device.vala"
						_tmp41_ = _tmp40_->partuuid;
#line 1181 "Utility/Device.vala"
						_tmp42_ = dev_alias;
#line 1181 "Utility/Device.vala"
						if (g_strcmp0 (_tmp41_, _tmp42_) == 0) {
#line 1182 "Utility/Device.vala"
							result = dev;
#line 1182 "Utility/Device.vala"
							_g_free0 (dev_alias);
#line 1182 "Utility/Device.vala"
							return result;
#line 7672 "Device.c"
						} else {
							Device* _tmp43_;
							const gchar* _tmp44_;
							const gchar* _tmp45_;
#line 1184 "Utility/Device.vala"
							_tmp43_ = dev;
#line 1184 "Utility/Device.vala"
							_tmp44_ = _tmp43_->partlabel;
#line 1184 "Utility/Device.vala"
							_tmp45_ = dev_alias;
#line 1184 "Utility/Device.vala"
							if (g_strcmp0 (_tmp44_, _tmp45_) == 0) {
#line 1185 "Utility/Device.vala"
								result = dev;
#line 1185 "Utility/Device.vala"
								_g_free0 (dev_alias);
#line 1185 "Utility/Device.vala"
								return result;
#line 7691 "Device.c"
							} else {
								Device* _tmp46_;
								const gchar* _tmp47_;
								const gchar* _tmp48_;
#line 1187 "Utility/Device.vala"
								_tmp46_ = dev;
#line 1187 "Utility/Device.vala"
								_tmp47_ = _tmp46_->device_by_uuid;
#line 1187 "Utility/Device.vala"
								_tmp48_ = dev_alias;
#line 1187 "Utility/Device.vala"
								if (g_strcmp0 (_tmp47_, _tmp48_) == 0) {
#line 1188 "Utility/Device.vala"
									result = dev;
#line 1188 "Utility/Device.vala"
									_g_free0 (dev_alias);
#line 1188 "Utility/Device.vala"
									return result;
#line 7710 "Device.c"
								} else {
									Device* _tmp49_;
									const gchar* _tmp50_;
									const gchar* _tmp51_;
#line 1190 "Utility/Device.vala"
									_tmp49_ = dev;
#line 1190 "Utility/Device.vala"
									_tmp50_ = _tmp49_->device_by_label;
#line 1190 "Utility/Device.vala"
									_tmp51_ = dev_alias;
#line 1190 "Utility/Device.vala"
									if (g_strcmp0 (_tmp50_, _tmp51_) == 0) {
#line 1191 "Utility/Device.vala"
										result = dev;
#line 1191 "Utility/Device.vala"
										_g_free0 (dev_alias);
#line 1191 "Utility/Device.vala"
										return result;
#line 7729 "Device.c"
									} else {
										Device* _tmp52_;
										const gchar* _tmp53_;
										const gchar* _tmp54_;
#line 1193 "Utility/Device.vala"
										_tmp52_ = dev;
#line 1193 "Utility/Device.vala"
										_tmp53_ = _tmp52_->device_by_partuuid;
#line 1193 "Utility/Device.vala"
										_tmp54_ = dev_alias;
#line 1193 "Utility/Device.vala"
										if (g_strcmp0 (_tmp53_, _tmp54_) == 0) {
#line 1194 "Utility/Device.vala"
											result = dev;
#line 1194 "Utility/Device.vala"
											_g_free0 (dev_alias);
#line 1194 "Utility/Device.vala"
											return result;
#line 7748 "Device.c"
										} else {
											Device* _tmp55_;
											const gchar* _tmp56_;
											const gchar* _tmp57_;
#line 1196 "Utility/Device.vala"
											_tmp55_ = dev;
#line 1196 "Utility/Device.vala"
											_tmp56_ = _tmp55_->device_by_partlabel;
#line 1196 "Utility/Device.vala"
											_tmp57_ = dev_alias;
#line 1196 "Utility/Device.vala"
											if (g_strcmp0 (_tmp56_, _tmp57_) == 0) {
#line 1197 "Utility/Device.vala"
												result = dev;
#line 1197 "Utility/Device.vala"
												_g_free0 (dev_alias);
#line 1197 "Utility/Device.vala"
												return result;
#line 7767 "Device.c"
											} else {
												Device* _tmp58_;
												const gchar* _tmp59_;
												const gchar* _tmp60_;
#line 1199 "Utility/Device.vala"
												_tmp58_ = dev;
#line 1199 "Utility/Device.vala"
												_tmp59_ = _tmp58_->device_mapper;
#line 1199 "Utility/Device.vala"
												_tmp60_ = dev_alias;
#line 1199 "Utility/Device.vala"
												if (g_strcmp0 (_tmp59_, _tmp60_) == 0) {
#line 1200 "Utility/Device.vala"
													result = dev;
#line 1200 "Utility/Device.vala"
													_g_free0 (dev_alias);
#line 1200 "Utility/Device.vala"
													return result;
#line 7786 "Device.c"
												} else {
													Device* _tmp61_;
													const gchar* _tmp62_;
													const gchar* _tmp63_;
#line 1202 "Utility/Device.vala"
													_tmp61_ = dev;
#line 1202 "Utility/Device.vala"
													_tmp62_ = _tmp61_->mapped_name;
#line 1202 "Utility/Device.vala"
													_tmp63_ = dev_alias;
#line 1202 "Utility/Device.vala"
													if (g_strcmp0 (_tmp62_, _tmp63_) == 0) {
#line 1203 "Utility/Device.vala"
														result = dev;
#line 1203 "Utility/Device.vala"
														_g_free0 (dev_alias);
#line 1203 "Utility/Device.vala"
														return result;
#line 7805 "Device.c"
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
#line 1170 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 7819 "Device.c"
		}
	}
#line 1207 "Utility/Device.vala"
	result = NULL;
#line 1207 "Utility/Device.vala"
	_g_free0 (dev_alias);
#line 1207 "Utility/Device.vala"
	return result;
#line 7828 "Device.c"
}

void
device_copy_fields_from (Device* self,
                         Device* dev2)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	GeeArrayList* _tmp18_;
	GeeArrayList* _tmp19_;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp21_;
	Device* _tmp22_;
	Device* _tmp23_;
	GeeArrayList* _tmp24_;
	GeeArrayList* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
#line 1210 "Utility/Device.vala"
	g_return_if_fail (self != NULL);
#line 1210 "Utility/Device.vala"
	g_return_if_fail (dev2 != NULL);
#line 1212 "Utility/Device.vala"
	_tmp0_ = dev2->device;
#line 1212 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1212 "Utility/Device.vala"
	_g_free0 (self->device);
#line 1212 "Utility/Device.vala"
	self->device = _tmp1_;
#line 1213 "Utility/Device.vala"
	_tmp2_ = dev2->name;
#line 1213 "Utility/Device.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 1213 "Utility/Device.vala"
	_g_free0 (self->name);
#line 1213 "Utility/Device.vala"
	self->name = _tmp3_;
#line 1214 "Utility/Device.vala"
	_tmp4_ = dev2->kname;
#line 1214 "Utility/Device.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 1214 "Utility/Device.vala"
	_g_free0 (self->kname);
#line 1214 "Utility/Device.vala"
	self->kname = _tmp5_;
#line 1215 "Utility/Device.vala"
	_tmp6_ = dev2->pkname;
#line 1215 "Utility/Device.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 1215 "Utility/Device.vala"
	_g_free0 (self->pkname);
#line 1215 "Utility/Device.vala"
	self->pkname = _tmp7_;
#line 1216 "Utility/Device.vala"
	_tmp8_ = dev2->label;
#line 1216 "Utility/Device.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 1216 "Utility/Device.vala"
	_g_free0 (self->label);
#line 1216 "Utility/Device.vala"
	self->label = _tmp9_;
#line 1217 "Utility/Device.vala"
	_tmp10_ = dev2->uuid;
#line 1217 "Utility/Device.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 1217 "Utility/Device.vala"
	_g_free0 (self->uuid);
#line 1217 "Utility/Device.vala"
	self->uuid = _tmp11_;
#line 1218 "Utility/Device.vala"
	_tmp12_ = dev2->mapped_name;
#line 1218 "Utility/Device.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 1218 "Utility/Device.vala"
	_g_free0 (self->mapped_name);
#line 1218 "Utility/Device.vala"
	self->mapped_name = _tmp13_;
#line 1220 "Utility/Device.vala"
	_tmp14_ = dev2->type;
#line 1220 "Utility/Device.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 1220 "Utility/Device.vala"
	_g_free0 (self->type);
#line 1220 "Utility/Device.vala"
	self->type = _tmp15_;
#line 1221 "Utility/Device.vala"
	_tmp16_ = dev2->fstype;
#line 1221 "Utility/Device.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 1221 "Utility/Device.vala"
	_g_free0 (self->fstype);
#line 1221 "Utility/Device.vala"
	self->fstype = _tmp17_;
#line 1223 "Utility/Device.vala"
	self->size_bytes = dev2->size_bytes;
#line 1224 "Utility/Device.vala"
	self->used_bytes = dev2->used_bytes;
#line 1225 "Utility/Device.vala"
	self->available_bytes = dev2->available_bytes;
#line 1227 "Utility/Device.vala"
	_tmp18_ = dev2->mount_points;
#line 1227 "Utility/Device.vala"
	_tmp19_ = _g_object_ref0 (_tmp18_);
#line 1227 "Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 1227 "Utility/Device.vala"
	self->mount_points = _tmp19_;
#line 1228 "Utility/Device.vala"
	_tmp20_ = dev2->symlinks;
#line 1228 "Utility/Device.vala"
	_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1228 "Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 1228 "Utility/Device.vala"
	self->symlinks = _tmp21_;
#line 1229 "Utility/Device.vala"
	_tmp22_ = dev2->parent;
#line 1229 "Utility/Device.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 1229 "Utility/Device.vala"
	_g_object_unref0 (self->parent);
#line 1229 "Utility/Device.vala"
	self->parent = _tmp23_;
#line 1230 "Utility/Device.vala"
	_tmp24_ = dev2->children;
#line 1230 "Utility/Device.vala"
	_tmp25_ = _g_object_ref0 (_tmp24_);
#line 1230 "Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 1230 "Utility/Device.vala"
	self->children = _tmp25_;
#line 1232 "Utility/Device.vala"
	_tmp26_ = dev2->vendor;
#line 1232 "Utility/Device.vala"
	_tmp27_ = g_strdup (_tmp26_);
#line 1232 "Utility/Device.vala"
	_g_free0 (self->vendor);
#line 1232 "Utility/Device.vala"
	self->vendor = _tmp27_;
#line 1233 "Utility/Device.vala"
	_tmp28_ = dev2->model;
#line 1233 "Utility/Device.vala"
	_tmp29_ = g_strdup (_tmp28_);
#line 1233 "Utility/Device.vala"
	_g_free0 (self->model);
#line 1233 "Utility/Device.vala"
	self->model = _tmp29_;
#line 1234 "Utility/Device.vala"
	_tmp30_ = dev2->serial;
#line 1234 "Utility/Device.vala"
	_tmp31_ = g_strdup (_tmp30_);
#line 1234 "Utility/Device.vala"
	_g_free0 (self->serial);
#line 1234 "Utility/Device.vala"
	self->serial = _tmp31_;
#line 1235 "Utility/Device.vala"
	_tmp32_ = dev2->revision;
#line 1235 "Utility/Device.vala"
	_tmp33_ = g_strdup (_tmp32_);
#line 1235 "Utility/Device.vala"
	_g_free0 (self->revision);
#line 1235 "Utility/Device.vala"
	self->revision = _tmp33_;
#line 1237 "Utility/Device.vala"
	self->removable = dev2->removable;
#line 1238 "Utility/Device.vala"
	self->read_only = dev2->read_only;
#line 8019 "Device.c"
}

Device*
device_query_changes (Device* self)
{
	Device* dev_new = NULL;
	Device* result = NULL;
#line 1241 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1243 "Utility/Device.vala"
	dev_new = NULL;
#line 8031 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp0_;
		gint _dev_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _dev_index = 0;
#line 1245 "Utility/Device.vala"
		_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 1245 "Utility/Device.vala"
		_dev_list = _tmp0_;
#line 1245 "Utility/Device.vala"
		_tmp1_ = _dev_list;
#line 1245 "Utility/Device.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1245 "Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 1245 "Utility/Device.vala"
		_dev_size = _tmp3_;
#line 1245 "Utility/Device.vala"
		_dev_index = -1;
#line 1245 "Utility/Device.vala"
		while (TRUE) {
#line 8056 "Device.c"
			gint _tmp4_;
			gint _tmp5_;
			Device* dev = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
			const gchar* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
#line 1245 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1245 "Utility/Device.vala"
			_tmp4_ = _dev_index;
#line 1245 "Utility/Device.vala"
			_tmp5_ = _dev_size;
#line 1245 "Utility/Device.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 1245 "Utility/Device.vala"
				break;
#line 8075 "Device.c"
			}
#line 1245 "Utility/Device.vala"
			_tmp6_ = _dev_list;
#line 1245 "Utility/Device.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _dev_index);
#line 1245 "Utility/Device.vala"
			dev = (Device*) _tmp7_;
#line 1246 "Utility/Device.vala"
			_tmp8_ = self->uuid;
#line 1246 "Utility/Device.vala"
			_tmp9_ = strlen (_tmp8_);
#line 1246 "Utility/Device.vala"
			_tmp10_ = _tmp9_;
#line 1246 "Utility/Device.vala"
			if (_tmp10_ > 0) {
#line 8091 "Device.c"
				Device* _tmp11_;
				const gchar* _tmp12_;
				const gchar* _tmp13_;
#line 1247 "Utility/Device.vala"
				_tmp11_ = dev;
#line 1247 "Utility/Device.vala"
				_tmp12_ = _tmp11_->uuid;
#line 1247 "Utility/Device.vala"
				_tmp13_ = self->uuid;
#line 1247 "Utility/Device.vala"
				if (g_strcmp0 (_tmp12_, _tmp13_) == 0) {
#line 8103 "Device.c"
					Device* _tmp14_;
					Device* _tmp15_;
#line 1248 "Utility/Device.vala"
					_tmp14_ = dev;
#line 1248 "Utility/Device.vala"
					_tmp15_ = _g_object_ref0 (_tmp14_);
#line 1248 "Utility/Device.vala"
					_g_object_unref0 (dev_new);
#line 1248 "Utility/Device.vala"
					dev_new = _tmp15_;
#line 1249 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1249 "Utility/Device.vala"
					break;
#line 8118 "Device.c"
				}
			} else {
				Device* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
#line 1253 "Utility/Device.vala"
				_tmp16_ = dev;
#line 1253 "Utility/Device.vala"
				_tmp17_ = _tmp16_->device;
#line 1253 "Utility/Device.vala"
				_tmp18_ = self->device;
#line 1253 "Utility/Device.vala"
				if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
#line 8132 "Device.c"
					Device* _tmp19_;
					Device* _tmp20_;
#line 1254 "Utility/Device.vala"
					_tmp19_ = dev;
#line 1254 "Utility/Device.vala"
					_tmp20_ = _g_object_ref0 (_tmp19_);
#line 1254 "Utility/Device.vala"
					_g_object_unref0 (dev_new);
#line 1254 "Utility/Device.vala"
					dev_new = _tmp20_;
#line 1255 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1255 "Utility/Device.vala"
					break;
#line 8147 "Device.c"
				}
			}
#line 1245 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 8152 "Device.c"
		}
#line 1245 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 8156 "Device.c"
	}
#line 1260 "Utility/Device.vala"
	result = dev_new;
#line 1260 "Utility/Device.vala"
	return result;
#line 8162 "Device.c"
}

void
device_query_disk_space (Device* self)
{
	GeeArrayList* list_df = NULL;
	const gchar* _tmp0_;
	GeeArrayList* _tmp1_;
	Device* dev_df = NULL;
	GeeArrayList* _tmp2_;
	const gchar* _tmp3_;
	Device* _tmp4_;
	Device* _tmp5_;
#line 1263 "Utility/Device.vala"
	g_return_if_fail (self != NULL);
#line 1267 "Utility/Device.vala"
	_tmp0_ = self->device;
#line 1267 "Utility/Device.vala"
	_tmp1_ = device_get_disk_space_using_df (_tmp0_);
#line 1267 "Utility/Device.vala"
	list_df = _tmp1_;
#line 1269 "Utility/Device.vala"
	_tmp2_ = list_df;
#line 1269 "Utility/Device.vala"
	_tmp3_ = self->uuid;
#line 1269 "Utility/Device.vala"
	_tmp4_ = device_find_device_in_list (_tmp2_, _tmp3_);
#line 1269 "Utility/Device.vala"
	dev_df = _tmp4_;
#line 1271 "Utility/Device.vala"
	_tmp5_ = dev_df;
#line 1271 "Utility/Device.vala"
	if (_tmp5_ != NULL) {
#line 8196 "Device.c"
		Device* _tmp6_;
		Device* _tmp7_;
		Device* _tmp8_;
		Device* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 1273 "Utility/Device.vala"
		_tmp6_ = dev_df;
#line 1273 "Utility/Device.vala"
		self->size_bytes = _tmp6_->size_bytes;
#line 1274 "Utility/Device.vala"
		_tmp7_ = dev_df;
#line 1274 "Utility/Device.vala"
		self->used_bytes = _tmp7_->used_bytes;
#line 1275 "Utility/Device.vala"
		_tmp8_ = dev_df;
#line 1275 "Utility/Device.vala"
		self->available_bytes = _tmp8_->available_bytes;
#line 1276 "Utility/Device.vala"
		_tmp9_ = dev_df;
#line 1276 "Utility/Device.vala"
		_tmp10_ = _tmp9_->used_percent;
#line 1276 "Utility/Device.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 1276 "Utility/Device.vala"
		_g_free0 (self->used_percent);
#line 1276 "Utility/Device.vala"
		self->used_percent = _tmp11_;
#line 8225 "Device.c"
	}
#line 1263 "Utility/Device.vala"
	_g_object_unref0 (dev_df);
#line 1263 "Utility/Device.vala"
	_g_object_unref0 (list_df);
#line 8231 "Device.c"
}

gboolean
device_automount_udisks (const gchar* dev_name_or_uuid,
                         GtkWindow* parent_window)
{
	gint _tmp0_;
	gint _tmp1_;
	gchar* cmd = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gint status = 0;
	const gchar* _tmp4_;
	gboolean result = FALSE;
#line 1282 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1284 "Utility/Device.vala"
	_tmp0_ = strlen (dev_name_or_uuid);
#line 1284 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1284 "Utility/Device.vala"
	if (_tmp1_ == 0) {
#line 1285 "Utility/Device.vala"
		tee_jee_logging_log_error (_ ("Device name is empty!"), FALSE, FALSE);
#line 1286 "Utility/Device.vala"
		result = FALSE;
#line 1286 "Utility/Device.vala"
		return result;
#line 8260 "Device.c"
	}
#line 1289 "Utility/Device.vala"
	_tmp2_ = g_strdup_printf ("udisksctl mount -b '%s'", dev_name_or_uuid);
#line 1289 "Utility/Device.vala"
	cmd = _tmp2_;
#line 1290 "Utility/Device.vala"
	_tmp3_ = cmd;
#line 1290 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 1291 "Utility/Device.vala"
	_tmp4_ = cmd;
#line 1291 "Utility/Device.vala"
	status = system (_tmp4_);
#line 1293 "Utility/Device.vala"
	if (status != 0) {
#line 1294 "Utility/Device.vala"
		if (parent_window != NULL) {
#line 8278 "Device.c"
			gchar* msg = NULL;
			gchar* _tmp5_;
			const gchar* _tmp6_;
#line 1295 "Utility/Device.vala"
			_tmp5_ = g_strdup_printf ("Failed to mount: %s", dev_name_or_uuid);
#line 1295 "Utility/Device.vala"
			msg = _tmp5_;
#line 1296 "Utility/Device.vala"
			_tmp6_ = msg;
#line 1296 "Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp6_, parent_window, TRUE);
#line 1294 "Utility/Device.vala"
			_g_free0 (msg);
#line 8292 "Device.c"
		}
	}
#line 1300 "Utility/Device.vala"
	result = status == 0;
#line 1300 "Utility/Device.vala"
	_g_free0 (cmd);
#line 1300 "Utility/Device.vala"
	return result;
#line 8301 "Device.c"
}

gboolean
device_automount_udisks_iso (const gchar* iso_file_path,
                             gchar* * loop_device,
                             GtkWindow* parent_window)
{
	gchar* _vala_loop_device = NULL;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint exit_code = 0;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gint _tmp11_;
	gboolean result = FALSE;
#line 1303 "Utility/Device.vala"
	g_return_val_if_fail (iso_file_path != NULL, FALSE);
#line 1305 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1305 "Utility/Device.vala"
	_g_free0 (_vala_loop_device);
#line 1305 "Utility/Device.vala"
	_vala_loop_device = _tmp0_;
#line 1307 "Utility/Device.vala"
	if (!tee_jee_file_system_file_exists (iso_file_path)) {
#line 8335 "Device.c"
		gchar* msg = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 1308 "Utility/Device.vala"
		_tmp1_ = g_strdup_printf ("%s: %s", _ ("Could not find file"), iso_file_path);
#line 1308 "Utility/Device.vala"
		msg = _tmp1_;
#line 1309 "Utility/Device.vala"
		_tmp2_ = msg;
#line 1309 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp2_, FALSE, FALSE);
#line 1310 "Utility/Device.vala"
		result = FALSE;
#line 1310 "Utility/Device.vala"
		_g_free0 (msg);
#line 1310 "Utility/Device.vala"
		if (loop_device) {
#line 1310 "Utility/Device.vala"
			*loop_device = _vala_loop_device;
#line 8355 "Device.c"
		} else {
#line 1310 "Utility/Device.vala"
			_g_free0 (_vala_loop_device);
#line 8359 "Device.c"
		}
#line 1310 "Utility/Device.vala"
		return result;
#line 8363 "Device.c"
	}
#line 1313 "Utility/Device.vala"
	_tmp3_ = tee_jee_file_system_escape_single_quote (iso_file_path);
#line 1313 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1313 "Utility/Device.vala"
	_tmp5_ = g_strdup_printf ("udisksctl loop-setup -r -f '%s'", _tmp4_);
#line 1313 "Utility/Device.vala"
	_tmp6_ = _tmp5_;
#line 1313 "Utility/Device.vala"
	_g_free0 (_tmp4_);
#line 1313 "Utility/Device.vala"
	cmd = _tmp6_;
#line 1316 "Utility/Device.vala"
	_tmp7_ = cmd;
#line 1316 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp7_);
#line 1318 "Utility/Device.vala"
	_tmp8_ = cmd;
#line 1318 "Utility/Device.vala"
	_tmp11_ = tee_jee_process_helper_exec_sync (_tmp8_, &_tmp9_, &_tmp10_);
#line 1318 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1318 "Utility/Device.vala"
	std_out = _tmp9_;
#line 1318 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1318 "Utility/Device.vala"
	std_err = _tmp10_;
#line 1318 "Utility/Device.vala"
	exit_code = _tmp11_;
#line 1320 "Utility/Device.vala"
	if (exit_code == 0) {
#line 8397 "Device.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar** _tmp17_;
		gchar** _tmp18_;
		gchar** _tmp19_;
		gint _tmp19__length1;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		GeeArrayList* list = NULL;
		GeeArrayList* _tmp27_;
#line 1321 "Utility/Device.vala"
		_tmp12_ = std_out;
#line 1321 "Utility/Device.vala"
		_tmp13_ = g_strdup_printf ("%s", _tmp12_);
#line 1321 "Utility/Device.vala"
		_tmp14_ = _tmp13_;
#line 1321 "Utility/Device.vala"
		tee_jee_logging_log_msg (_tmp14_, FALSE);
#line 1321 "Utility/Device.vala"
		_g_free0 (_tmp14_);
#line 1324 "Utility/Device.vala"
		_tmp15_ = std_out;
#line 1324 "Utility/Device.vala"
		if (!string_contains (_tmp15_, " as ")) {
#line 1325 "Utility/Device.vala"
			tee_jee_logging_log_error ("Could not determine loop device", FALSE, FALSE);
#line 1326 "Utility/Device.vala"
			result = FALSE;
#line 1326 "Utility/Device.vala"
			_g_free0 (std_err);
#line 1326 "Utility/Device.vala"
			_g_free0 (std_out);
#line 1326 "Utility/Device.vala"
			_g_free0 (cmd);
#line 1326 "Utility/Device.vala"
			if (loop_device) {
#line 1326 "Utility/Device.vala"
				*loop_device = _vala_loop_device;
#line 8444 "Device.c"
			} else {
#line 1326 "Utility/Device.vala"
				_g_free0 (_vala_loop_device);
#line 8448 "Device.c"
			}
#line 1326 "Utility/Device.vala"
			return result;
#line 8452 "Device.c"
		}
#line 1329 "Utility/Device.vala"
		_tmp16_ = std_out;
#line 1329 "Utility/Device.vala"
		_tmp18_ = _tmp17_ = g_strsplit (_tmp16_, " as ", 0);
#line 1329 "Utility/Device.vala"
		_tmp19_ = _tmp18_;
#line 1329 "Utility/Device.vala"
		_tmp19__length1 = _vala_array_length (_tmp17_);
#line 1329 "Utility/Device.vala"
		_tmp20_ = _tmp19_[1];
#line 1329 "Utility/Device.vala"
		_tmp21_ = string_replace (_tmp20_, ".", "");
#line 1329 "Utility/Device.vala"
		_tmp22_ = _tmp21_;
#line 1329 "Utility/Device.vala"
		_tmp23_ = string_strip (_tmp22_);
#line 1329 "Utility/Device.vala"
		_g_free0 (_vala_loop_device);
#line 1329 "Utility/Device.vala"
		_vala_loop_device = _tmp23_;
#line 1329 "Utility/Device.vala"
		_g_free0 (_tmp22_);
#line 1329 "Utility/Device.vala"
		_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 1330 "Utility/Device.vala"
		_tmp24_ = _vala_loop_device;
#line 1330 "Utility/Device.vala"
		_tmp25_ = g_strdup_printf ("loop_device: %s", _tmp24_);
#line 1330 "Utility/Device.vala"
		_tmp26_ = _tmp25_;
#line 1330 "Utility/Device.vala"
		tee_jee_logging_log_msg (_tmp26_, FALSE);
#line 1330 "Utility/Device.vala"
		_g_free0 (_tmp26_);
#line 1332 "Utility/Device.vala"
		_tmp27_ = device_get_block_devices_using_lsblk ("");
#line 1332 "Utility/Device.vala"
		list = _tmp27_;
#line 8492 "Device.c"
		{
			GeeArrayList* _dev_list = NULL;
			GeeArrayList* _tmp28_;
			gint _dev_size = 0;
			GeeArrayList* _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
			gint _dev_index = 0;
#line 1333 "Utility/Device.vala"
			_tmp28_ = list;
#line 1333 "Utility/Device.vala"
			_dev_list = _tmp28_;
#line 1333 "Utility/Device.vala"
			_tmp29_ = _dev_list;
#line 1333 "Utility/Device.vala"
			_tmp30_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp29_);
#line 1333 "Utility/Device.vala"
			_tmp31_ = _tmp30_;
#line 1333 "Utility/Device.vala"
			_dev_size = _tmp31_;
#line 1333 "Utility/Device.vala"
			_dev_index = -1;
#line 1333 "Utility/Device.vala"
			while (TRUE) {
#line 8517 "Device.c"
				gint _tmp32_;
				gint _tmp33_;
				Device* dev = NULL;
				GeeArrayList* _tmp34_;
				gpointer _tmp35_;
				gboolean _tmp36_ = FALSE;
				Device* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
				gboolean _tmp42_;
#line 1333 "Utility/Device.vala"
				_dev_index = _dev_index + 1;
#line 1333 "Utility/Device.vala"
				_tmp32_ = _dev_index;
#line 1333 "Utility/Device.vala"
				_tmp33_ = _dev_size;
#line 1333 "Utility/Device.vala"
				if (!(_tmp32_ < _tmp33_)) {
#line 1333 "Utility/Device.vala"
					break;
#line 8540 "Device.c"
				}
#line 1333 "Utility/Device.vala"
				_tmp34_ = _dev_list;
#line 1333 "Utility/Device.vala"
				_tmp35_ = gee_abstract_list_get ((GeeAbstractList*) _tmp34_, _dev_index);
#line 1333 "Utility/Device.vala"
				dev = (Device*) _tmp35_;
#line 1334 "Utility/Device.vala"
				_tmp37_ = dev;
#line 1334 "Utility/Device.vala"
				_tmp38_ = _tmp37_->pkname;
#line 1334 "Utility/Device.vala"
				_tmp39_ = _vala_loop_device;
#line 1334 "Utility/Device.vala"
				_tmp40_ = string_replace (_tmp39_, "/dev/", "");
#line 1334 "Utility/Device.vala"
				_tmp41_ = _tmp40_;
#line 1334 "Utility/Device.vala"
				_tmp42_ = g_strcmp0 (_tmp38_, _tmp41_) == 0;
#line 1334 "Utility/Device.vala"
				_g_free0 (_tmp41_);
#line 1334 "Utility/Device.vala"
				if (_tmp42_) {
#line 8564 "Device.c"
					Device* _tmp43_;
					const gchar* _tmp44_;
#line 1334 "Utility/Device.vala"
					_tmp43_ = dev;
#line 1334 "Utility/Device.vala"
					_tmp44_ = _tmp43_->fstype;
#line 1334 "Utility/Device.vala"
					_tmp36_ = g_strcmp0 (_tmp44_, "iso9660") == 0;
#line 8573 "Device.c"
				} else {
#line 1334 "Utility/Device.vala"
					_tmp36_ = FALSE;
#line 8577 "Device.c"
				}
#line 1334 "Utility/Device.vala"
				if (_tmp36_) {
#line 8581 "Device.c"
					Device* _tmp45_;
					const gchar* _tmp46_;
					gchar* _tmp47_;
					Device* _tmp48_;
					const gchar* _tmp49_;
#line 1335 "Utility/Device.vala"
					_tmp45_ = dev;
#line 1335 "Utility/Device.vala"
					_tmp46_ = _tmp45_->device;
#line 1335 "Utility/Device.vala"
					_tmp47_ = g_strdup (_tmp46_);
#line 1335 "Utility/Device.vala"
					_g_free0 (_vala_loop_device);
#line 1335 "Utility/Device.vala"
					_vala_loop_device = _tmp47_;
#line 1336 "Utility/Device.vala"
					_tmp48_ = dev;
#line 1336 "Utility/Device.vala"
					_tmp49_ = _tmp48_->device;
#line 1336 "Utility/Device.vala"
					result = device_automount_udisks (_tmp49_, parent_window);
#line 1336 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1336 "Utility/Device.vala"
					_g_object_unref0 (list);
#line 1336 "Utility/Device.vala"
					_g_free0 (std_err);
#line 1336 "Utility/Device.vala"
					_g_free0 (std_out);
#line 1336 "Utility/Device.vala"
					_g_free0 (cmd);
#line 1336 "Utility/Device.vala"
					if (loop_device) {
#line 1336 "Utility/Device.vala"
						*loop_device = _vala_loop_device;
#line 8617 "Device.c"
					} else {
#line 1336 "Utility/Device.vala"
						_g_free0 (_vala_loop_device);
#line 8621 "Device.c"
					}
#line 1336 "Utility/Device.vala"
					return result;
#line 8625 "Device.c"
				}
#line 1333 "Utility/Device.vala"
				_g_object_unref0 (dev);
#line 8629 "Device.c"
			}
		}
#line 1320 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 8634 "Device.c"
	}
#line 1341 "Utility/Device.vala"
	result = FALSE;
#line 1341 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1341 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1341 "Utility/Device.vala"
	_g_free0 (cmd);
#line 1341 "Utility/Device.vala"
	if (loop_device) {
#line 1341 "Utility/Device.vala"
		*loop_device = _vala_loop_device;
#line 8648 "Device.c"
	} else {
#line 1341 "Utility/Device.vala"
		_g_free0 (_vala_loop_device);
#line 8652 "Device.c"
	}
#line 1341 "Utility/Device.vala"
	return result;
#line 8656 "Device.c"
}

gboolean
device_unmount_udisks (const gchar* dev_name_or_uuid,
                       GtkWindow* parent_window)
{
	gint _tmp0_;
	gint _tmp1_;
	gchar* cmd = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gint status = 0;
	const gchar* _tmp4_;
	gboolean result = FALSE;
#line 1344 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1346 "Utility/Device.vala"
	_tmp0_ = strlen (dev_name_or_uuid);
#line 1346 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1346 "Utility/Device.vala"
	if (_tmp1_ == 0) {
#line 1347 "Utility/Device.vala"
		tee_jee_logging_log_error (_ ("Device name is empty!"), FALSE, FALSE);
#line 1348 "Utility/Device.vala"
		result = FALSE;
#line 1348 "Utility/Device.vala"
		return result;
#line 8685 "Device.c"
	}
#line 1351 "Utility/Device.vala"
	_tmp2_ = g_strdup_printf ("udisksctl unmount -b '%s'", dev_name_or_uuid);
#line 1351 "Utility/Device.vala"
	cmd = _tmp2_;
#line 1352 "Utility/Device.vala"
	_tmp3_ = cmd;
#line 1352 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 1353 "Utility/Device.vala"
	_tmp4_ = cmd;
#line 1353 "Utility/Device.vala"
	status = system (_tmp4_);
#line 1355 "Utility/Device.vala"
	if (status != 0) {
#line 1356 "Utility/Device.vala"
		if (parent_window != NULL) {
#line 8703 "Device.c"
			gchar* msg = NULL;
			gchar* _tmp5_;
			const gchar* _tmp6_;
#line 1357 "Utility/Device.vala"
			_tmp5_ = g_strdup_printf ("Failed to unmount: %s", dev_name_or_uuid);
#line 1357 "Utility/Device.vala"
			msg = _tmp5_;
#line 1358 "Utility/Device.vala"
			_tmp6_ = msg;
#line 1358 "Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp6_, parent_window, TRUE);
#line 1356 "Utility/Device.vala"
			_g_free0 (msg);
#line 8717 "Device.c"
		}
	}
#line 1362 "Utility/Device.vala"
	result = status == 0;
#line 1362 "Utility/Device.vala"
	_g_free0 (cmd);
#line 1362 "Utility/Device.vala"
	return result;
#line 8726 "Device.c"
}

Device*
device_luks_unlock (Device* luks_device,
                    const gchar* mapped_name,
                    const gchar* passphrase,
                    GtkWindow* parent_window,
                    gchar* * message,
                    gchar* * details)
{
	gchar* _vala_message = NULL;
	gchar* _vala_details = NULL;
	Device* unlocked_device = NULL;
	gchar* std_out = NULL;
	gchar* _tmp0_;
	gchar* std_err = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp7_;
	gchar* luks_pass = NULL;
	gchar* _tmp25_;
	gchar* luks_name = NULL;
	gchar* _tmp26_;
	gboolean _tmp27_ = FALSE;
	const gchar* _tmp28_;
	GeeArrayList* _tmp96_;
	gboolean is_error = FALSE;
	Device* _tmp110_;
	Device* result = NULL;
#line 1365 "Utility/Device.vala"
	g_return_val_if_fail (luks_device != NULL, NULL);
#line 1365 "Utility/Device.vala"
	g_return_val_if_fail (mapped_name != NULL, NULL);
#line 1365 "Utility/Device.vala"
	g_return_val_if_fail (passphrase != NULL, NULL);
#line 1375 "Utility/Device.vala"
	unlocked_device = NULL;
#line 1376 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1376 "Utility/Device.vala"
	std_out = _tmp0_;
#line 1376 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1376 "Utility/Device.vala"
	std_err = _tmp1_;
#line 1379 "Utility/Device.vala"
	_tmp3_ = luks_device->fstype;
#line 1379 "Utility/Device.vala"
	if (!string_contains (_tmp3_, "luks")) {
#line 8778 "Device.c"
		const gchar* _tmp4_;
#line 1379 "Utility/Device.vala"
		_tmp4_ = luks_device->fstype;
#line 1379 "Utility/Device.vala"
		_tmp2_ = !string_contains (_tmp4_, "crypt");
#line 8784 "Device.c"
	} else {
#line 1379 "Utility/Device.vala"
		_tmp2_ = FALSE;
#line 8788 "Device.c"
	}
#line 1379 "Utility/Device.vala"
	if (_tmp2_) {
#line 8792 "Device.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1380 "Utility/Device.vala"
		_tmp5_ = g_strdup (_ ("This device is not encrypted"));
#line 1380 "Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1380 "Utility/Device.vala"
		_vala_message = _tmp5_;
#line 1381 "Utility/Device.vala"
		_tmp6_ = g_strdup (_ ("Failed to unlock device"));
#line 1381 "Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1381 "Utility/Device.vala"
		_vala_details = _tmp6_;
#line 1382 "Utility/Device.vala"
		result = NULL;
#line 1382 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1382 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1382 "Utility/Device.vala"
		_g_object_unref0 (unlocked_device);
#line 1382 "Utility/Device.vala"
		if (message) {
#line 1382 "Utility/Device.vala"
			*message = _vala_message;
#line 8819 "Device.c"
		} else {
#line 1382 "Utility/Device.vala"
			_g_free0 (_vala_message);
#line 8823 "Device.c"
		}
#line 1382 "Utility/Device.vala"
		if (details) {
#line 1382 "Utility/Device.vala"
			*details = _vala_details;
#line 8829 "Device.c"
		} else {
#line 1382 "Utility/Device.vala"
			_g_free0 (_vala_details);
#line 8833 "Device.c"
		}
#line 1382 "Utility/Device.vala"
		return result;
#line 8837 "Device.c"
	}
#line 1386 "Utility/Device.vala"
	_tmp7_ = device_get_block_devices_using_lsblk ("");
#line 1386 "Utility/Device.vala"
	list = _tmp7_;
#line 8843 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp8_;
		gint _part_size = 0;
		GeeArrayList* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _part_index = 0;
#line 1387 "Utility/Device.vala"
		_tmp8_ = list;
#line 1387 "Utility/Device.vala"
		_part_list = _tmp8_;
#line 1387 "Utility/Device.vala"
		_tmp9_ = _part_list;
#line 1387 "Utility/Device.vala"
		_tmp10_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp9_);
#line 1387 "Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1387 "Utility/Device.vala"
		_part_size = _tmp11_;
#line 1387 "Utility/Device.vala"
		_part_index = -1;
#line 1387 "Utility/Device.vala"
		while (TRUE) {
#line 8868 "Device.c"
			gint _tmp12_;
			gint _tmp13_;
			Device* part = NULL;
			GeeArrayList* _tmp14_;
			gpointer _tmp15_;
			Device* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
#line 1387 "Utility/Device.vala"
			_part_index = _part_index + 1;
#line 1387 "Utility/Device.vala"
			_tmp12_ = _part_index;
#line 1387 "Utility/Device.vala"
			_tmp13_ = _part_size;
#line 1387 "Utility/Device.vala"
			if (!(_tmp12_ < _tmp13_)) {
#line 1387 "Utility/Device.vala"
				break;
#line 8887 "Device.c"
			}
#line 1387 "Utility/Device.vala"
			_tmp14_ = _part_list;
#line 1387 "Utility/Device.vala"
			_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _part_index);
#line 1387 "Utility/Device.vala"
			part = (Device*) _tmp15_;
#line 1388 "Utility/Device.vala"
			_tmp16_ = part;
#line 1388 "Utility/Device.vala"
			_tmp17_ = _tmp16_->pkname;
#line 1388 "Utility/Device.vala"
			_tmp18_ = luks_device->kname;
#line 1388 "Utility/Device.vala"
			if (g_strcmp0 (_tmp17_, _tmp18_) == 0) {
#line 8903 "Device.c"
				Device* _tmp19_;
				Device* _tmp20_;
				gchar* _tmp21_;
				Device* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
#line 1389 "Utility/Device.vala"
				_tmp19_ = part;
#line 1389 "Utility/Device.vala"
				_tmp20_ = _g_object_ref0 (_tmp19_);
#line 1389 "Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1389 "Utility/Device.vala"
				unlocked_device = _tmp20_;
#line 1390 "Utility/Device.vala"
				_tmp21_ = g_strdup (_ ("Device is unlocked"));
#line 1390 "Utility/Device.vala"
				_g_free0 (_vala_message);
#line 1390 "Utility/Device.vala"
				_vala_message = _tmp21_;
#line 1391 "Utility/Device.vala"
				_tmp22_ = part;
#line 1391 "Utility/Device.vala"
				_tmp23_ = _tmp22_->mapped_name;
#line 1391 "Utility/Device.vala"
				_tmp24_ = g_strdup_printf (_ ("Unlocked device is mapped to '%s'"), _tmp23_);
#line 1391 "Utility/Device.vala"
				_g_free0 (_vala_details);
#line 1391 "Utility/Device.vala"
				_vala_details = _tmp24_;
#line 1392 "Utility/Device.vala"
				result = part;
#line 1392 "Utility/Device.vala"
				_g_object_unref0 (list);
#line 1392 "Utility/Device.vala"
				_g_free0 (std_err);
#line 1392 "Utility/Device.vala"
				_g_free0 (std_out);
#line 1392 "Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1392 "Utility/Device.vala"
				if (message) {
#line 1392 "Utility/Device.vala"
					*message = _vala_message;
#line 8948 "Device.c"
				} else {
#line 1392 "Utility/Device.vala"
					_g_free0 (_vala_message);
#line 8952 "Device.c"
				}
#line 1392 "Utility/Device.vala"
				if (details) {
#line 1392 "Utility/Device.vala"
					*details = _vala_details;
#line 8958 "Device.c"
				} else {
#line 1392 "Utility/Device.vala"
					_g_free0 (_vala_details);
#line 8962 "Device.c"
				}
#line 1392 "Utility/Device.vala"
				return result;
#line 8966 "Device.c"
			}
#line 1387 "Utility/Device.vala"
			_g_object_unref0 (part);
#line 8970 "Device.c"
		}
	}
#line 1396 "Utility/Device.vala"
	_tmp25_ = g_strdup (passphrase);
#line 1396 "Utility/Device.vala"
	luks_pass = _tmp25_;
#line 1397 "Utility/Device.vala"
	_tmp26_ = g_strdup (mapped_name);
#line 1397 "Utility/Device.vala"
	luks_name = _tmp26_;
#line 1399 "Utility/Device.vala"
	_tmp28_ = luks_name;
#line 1399 "Utility/Device.vala"
	if (_tmp28_ == NULL) {
#line 1399 "Utility/Device.vala"
		_tmp27_ = TRUE;
#line 8987 "Device.c"
	} else {
		const gchar* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
#line 1399 "Utility/Device.vala"
		_tmp29_ = luks_name;
#line 1399 "Utility/Device.vala"
		_tmp30_ = strlen (_tmp29_);
#line 1399 "Utility/Device.vala"
		_tmp31_ = _tmp30_;
#line 1399 "Utility/Device.vala"
		_tmp27_ = _tmp31_ == 0;
#line 9000 "Device.c"
	}
#line 1399 "Utility/Device.vala"
	if (_tmp27_) {
#line 9004 "Device.c"
		const gchar* _tmp32_;
		gchar* _tmp33_;
#line 1400 "Utility/Device.vala"
		_tmp32_ = luks_device->kname;
#line 1400 "Utility/Device.vala"
		_tmp33_ = g_strdup_printf ("%s_crypt", _tmp32_);
#line 1400 "Utility/Device.vala"
		_g_free0 (luks_name);
#line 1400 "Utility/Device.vala"
		luks_name = _tmp33_;
#line 9015 "Device.c"
	}
#line 1403 "Utility/Device.vala"
	if (parent_window == NULL) {
#line 9019 "Device.c"
		gboolean _tmp34_ = FALSE;
		const gchar* _tmp35_;
#line 1407 "Utility/Device.vala"
		_tmp35_ = luks_pass;
#line 1407 "Utility/Device.vala"
		if (_tmp35_ == NULL) {
#line 1407 "Utility/Device.vala"
			_tmp34_ = TRUE;
#line 9028 "Device.c"
		} else {
			const gchar* _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
#line 1407 "Utility/Device.vala"
			_tmp36_ = luks_pass;
#line 1407 "Utility/Device.vala"
			_tmp37_ = strlen (_tmp36_);
#line 1407 "Utility/Device.vala"
			_tmp38_ = _tmp37_;
#line 1407 "Utility/Device.vala"
			_tmp34_ = _tmp38_ == 0;
#line 9041 "Device.c"
		}
#line 1407 "Utility/Device.vala"
		if (_tmp34_) {
#line 9045 "Device.c"
			TimeoutCounter* counter = NULL;
			TimeoutCounter* _tmp39_;
			TimeoutCounter* _tmp40_;
			gchar* cmd = NULL;
			const gchar* _tmp41_;
			const gchar* _tmp42_;
			gchar* _tmp43_;
			const gchar* _tmp44_;
			const gchar* _tmp45_;
			TimeoutCounter* _tmp46_;
#line 1411 "Utility/Device.vala"
			_tmp39_ = timeout_counter_new ();
#line 1411 "Utility/Device.vala"
			counter = _tmp39_;
#line 1412 "Utility/Device.vala"
			_tmp40_ = counter;
#line 1412 "Utility/Device.vala"
			timeout_counter_kill_process_on_timeout (_tmp40_, "cryptsetup", 20, TRUE);
#line 1413 "Utility/Device.vala"
			_tmp41_ = luks_device->device;
#line 1413 "Utility/Device.vala"
			_tmp42_ = luks_name;
#line 1413 "Utility/Device.vala"
			_tmp43_ = g_strdup_printf ("cryptsetup luksOpen '%s' '%s'", _tmp41_, _tmp42_);
#line 1413 "Utility/Device.vala"
			cmd = _tmp43_;
#line 1415 "Utility/Device.vala"
			_tmp44_ = cmd;
#line 1415 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp44_);
#line 1416 "Utility/Device.vala"
			_tmp45_ = cmd;
#line 1416 "Utility/Device.vala"
			system (_tmp45_);
#line 1417 "Utility/Device.vala"
			_tmp46_ = counter;
#line 1417 "Utility/Device.vala"
			timeout_counter_stop (_tmp46_);
#line 1418 "Utility/Device.vala"
			tee_jee_logging_log_msg ("", FALSE);
#line 1407 "Utility/Device.vala"
			_g_free0 (cmd);
#line 1407 "Utility/Device.vala"
			_g_object_unref0 (counter);
#line 9090 "Device.c"
		} else {
			gchar* cmd = NULL;
			const gchar* _tmp47_;
			const gchar* _tmp48_;
			const gchar* _tmp49_;
			gchar* _tmp50_;
			const gchar* _tmp51_;
			const gchar* _tmp52_;
			gchar* _tmp53_;
			gchar* _tmp54_;
			gint status = 0;
			const gchar* _tmp55_;
			gchar* _tmp56_ = NULL;
			gchar* _tmp57_ = NULL;
			gint _tmp58_;
#line 1425 "Utility/Device.vala"
			_tmp47_ = luks_pass;
#line 1425 "Utility/Device.vala"
			_tmp48_ = luks_device->device;
#line 1425 "Utility/Device.vala"
			_tmp49_ = luks_name;
#line 1425 "Utility/Device.vala"
			_tmp50_ = g_strdup_printf ("echo -n -e '%s' | cryptsetup luksOpen --key-file - '%s' '%s'\n", _tmp47_, _tmp48_, _tmp49_);
#line 1425 "Utility/Device.vala"
			cmd = _tmp50_;
#line 1428 "Utility/Device.vala"
			_tmp51_ = cmd;
#line 1428 "Utility/Device.vala"
			_tmp52_ = luks_pass;
#line 1428 "Utility/Device.vala"
			_tmp53_ = string_replace (_tmp51_, _tmp52_, "**PASSWORD**");
#line 1428 "Utility/Device.vala"
			_tmp54_ = _tmp53_;
#line 1428 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp54_);
#line 1428 "Utility/Device.vala"
			_g_free0 (_tmp54_);
#line 1430 "Utility/Device.vala"
			_tmp55_ = cmd;
#line 1430 "Utility/Device.vala"
			_tmp58_ = tee_jee_process_helper_exec_script_sync (_tmp55_, &_tmp56_, &_tmp57_, FALSE, TRUE, TRUE, FALSE);
#line 1430 "Utility/Device.vala"
			_g_free0 (std_out);
#line 1430 "Utility/Device.vala"
			std_out = _tmp56_;
#line 1430 "Utility/Device.vala"
			_g_free0 (std_err);
#line 1430 "Utility/Device.vala"
			std_err = _tmp57_;
#line 1430 "Utility/Device.vala"
			status = _tmp58_;
#line 1432 "Utility/Device.vala"
			switch (status) {
#line 1432 "Utility/Device.vala"
				case 512:
#line 9146 "Device.c"
				{
					gchar* _tmp59_;
					gchar* _tmp60_;
					const gchar* _tmp61_;
					const gchar* _tmp62_;
#line 1434 "Utility/Device.vala"
					_tmp59_ = g_strdup (_ ("Wrong password"));
#line 1434 "Utility/Device.vala"
					_g_free0 (_vala_message);
#line 1434 "Utility/Device.vala"
					_vala_message = _tmp59_;
#line 1435 "Utility/Device.vala"
					_tmp60_ = g_strdup (_ ("Failed to unlock device"));
#line 1435 "Utility/Device.vala"
					_g_free0 (_vala_details);
#line 1435 "Utility/Device.vala"
					_vala_details = _tmp60_;
#line 1436 "Utility/Device.vala"
					_tmp61_ = _vala_message;
#line 1436 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp61_, FALSE, FALSE);
#line 1437 "Utility/Device.vala"
					_tmp62_ = _vala_details;
#line 1437 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp62_, FALSE, FALSE);
#line 1438 "Utility/Device.vala"
					break;
#line 9174 "Device.c"
				}
				default:
#line 1432 "Utility/Device.vala"
				break;
#line 9179 "Device.c"
			}
#line 1407 "Utility/Device.vala"
			_g_free0 (cmd);
#line 9183 "Device.c"
		}
	} else {
		gboolean _tmp63_ = FALSE;
		const gchar* _tmp64_;
		gboolean _tmp75_ = FALSE;
		const gchar* _tmp76_;
#line 1447 "Utility/Device.vala"
		_tmp64_ = luks_pass;
#line 1447 "Utility/Device.vala"
		if (_tmp64_ == NULL) {
#line 1447 "Utility/Device.vala"
			_tmp63_ = TRUE;
#line 9196 "Device.c"
		} else {
			const gchar* _tmp65_;
			gint _tmp66_;
			gint _tmp67_;
#line 1447 "Utility/Device.vala"
			_tmp65_ = luks_pass;
#line 1447 "Utility/Device.vala"
			_tmp66_ = strlen (_tmp65_);
#line 1447 "Utility/Device.vala"
			_tmp67_ = _tmp66_;
#line 1447 "Utility/Device.vala"
			_tmp63_ = _tmp67_ == 0;
#line 9209 "Device.c"
		}
#line 1447 "Utility/Device.vala"
		if (_tmp63_) {
#line 9213 "Device.c"
			const gchar* _tmp68_;
			gchar* _tmp69_;
			gchar* _tmp70_;
			gchar* _tmp71_;
			const gchar* _tmp72_;
#line 1451 "Utility/Device.vala"
			tee_jee_logging_log_debug ("Prompting user for passphrase..");
#line 1453 "Utility/Device.vala"
			_tmp68_ = luks_device->name;
#line 1453 "Utility/Device.vala"
			_tmp69_ = g_strdup_printf (_ ("Enter passphrase to unlock '%s'"), _tmp68_);
#line 1453 "Utility/Device.vala"
			_tmp70_ = _tmp69_;
#line 1453 "Utility/Device.vala"
			_tmp71_ = tee_jee_gtk_helper_gtk_inputbox (_ ("Encrypted Device"), _tmp70_, parent_window, TRUE);
#line 1453 "Utility/Device.vala"
			_g_free0 (luks_pass);
#line 1453 "Utility/Device.vala"
			luks_pass = _tmp71_;
#line 1453 "Utility/Device.vala"
			_g_free0 (_tmp70_);
#line 1458 "Utility/Device.vala"
			_tmp72_ = luks_pass;
#line 1458 "Utility/Device.vala"
			if (_tmp72_ == NULL) {
#line 9239 "Device.c"
				gchar* _tmp73_;
				gchar* _tmp74_;
#line 1460 "Utility/Device.vala"
				_tmp73_ = g_strdup (_ ("Failed to unlock device"));
#line 1460 "Utility/Device.vala"
				_g_free0 (_vala_message);
#line 1460 "Utility/Device.vala"
				_vala_message = _tmp73_;
#line 1461 "Utility/Device.vala"
				_tmp74_ = g_strdup (_ ("User cancelled the password prompt"));
#line 1461 "Utility/Device.vala"
				_g_free0 (_vala_details);
#line 1461 "Utility/Device.vala"
				_vala_details = _tmp74_;
#line 1462 "Utility/Device.vala"
				tee_jee_logging_log_debug ("User cancelled the password prompt");
#line 1463 "Utility/Device.vala"
				result = NULL;
#line 1463 "Utility/Device.vala"
				_g_free0 (luks_name);
#line 1463 "Utility/Device.vala"
				_g_free0 (luks_pass);
#line 1463 "Utility/Device.vala"
				_g_object_unref0 (list);
#line 1463 "Utility/Device.vala"
				_g_free0 (std_err);
#line 1463 "Utility/Device.vala"
				_g_free0 (std_out);
#line 1463 "Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1463 "Utility/Device.vala"
				if (message) {
#line 1463 "Utility/Device.vala"
					*message = _vala_message;
#line 9274 "Device.c"
				} else {
#line 1463 "Utility/Device.vala"
					_g_free0 (_vala_message);
#line 9278 "Device.c"
				}
#line 1463 "Utility/Device.vala"
				if (details) {
#line 1463 "Utility/Device.vala"
					*details = _vala_details;
#line 9284 "Device.c"
				} else {
#line 1463 "Utility/Device.vala"
					_g_free0 (_vala_details);
#line 9288 "Device.c"
				}
#line 1463 "Utility/Device.vala"
				return result;
#line 9292 "Device.c"
			}
		}
#line 1467 "Utility/Device.vala"
		_tmp76_ = luks_pass;
#line 1467 "Utility/Device.vala"
		if (_tmp76_ != NULL) {
#line 9299 "Device.c"
			const gchar* _tmp77_;
			gint _tmp78_;
			gint _tmp79_;
#line 1467 "Utility/Device.vala"
			_tmp77_ = luks_pass;
#line 1467 "Utility/Device.vala"
			_tmp78_ = strlen (_tmp77_);
#line 1467 "Utility/Device.vala"
			_tmp79_ = _tmp78_;
#line 1467 "Utility/Device.vala"
			_tmp75_ = _tmp79_ > 0;
#line 9311 "Device.c"
		} else {
#line 1467 "Utility/Device.vala"
			_tmp75_ = FALSE;
#line 9315 "Device.c"
		}
#line 1467 "Utility/Device.vala"
		if (_tmp75_) {
#line 9319 "Device.c"
			gchar* cmd = NULL;
			const gchar* _tmp80_;
			const gchar* _tmp81_;
			const gchar* _tmp82_;
			gchar* _tmp83_;
			const gchar* _tmp84_;
			const gchar* _tmp85_;
			gchar* _tmp86_;
			gchar* _tmp87_;
			gint status = 0;
			const gchar* _tmp88_;
			gchar* _tmp89_ = NULL;
			gchar* _tmp90_ = NULL;
			gint _tmp91_;
#line 1471 "Utility/Device.vala"
			_tmp80_ = luks_pass;
#line 1471 "Utility/Device.vala"
			_tmp81_ = luks_device->device;
#line 1471 "Utility/Device.vala"
			_tmp82_ = luks_name;
#line 1471 "Utility/Device.vala"
			_tmp83_ = g_strdup_printf ("echo -n -e '%s' | cryptsetup luksOpen --key-file - '%s' '%s'\n", _tmp80_, _tmp81_, _tmp82_);
#line 1471 "Utility/Device.vala"
			cmd = _tmp83_;
#line 1474 "Utility/Device.vala"
			_tmp84_ = cmd;
#line 1474 "Utility/Device.vala"
			_tmp85_ = luks_pass;
#line 1474 "Utility/Device.vala"
			_tmp86_ = string_replace (_tmp84_, _tmp85_, "**PASSWORD**");
#line 1474 "Utility/Device.vala"
			_tmp87_ = _tmp86_;
#line 1474 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp87_);
#line 1474 "Utility/Device.vala"
			_g_free0 (_tmp87_);
#line 1476 "Utility/Device.vala"
			_tmp88_ = cmd;
#line 1476 "Utility/Device.vala"
			_tmp91_ = tee_jee_process_helper_exec_script_sync (_tmp88_, &_tmp89_, &_tmp90_, FALSE, TRUE, TRUE, FALSE);
#line 1476 "Utility/Device.vala"
			_g_free0 (std_out);
#line 1476 "Utility/Device.vala"
			std_out = _tmp89_;
#line 1476 "Utility/Device.vala"
			_g_free0 (std_err);
#line 1476 "Utility/Device.vala"
			std_err = _tmp90_;
#line 1476 "Utility/Device.vala"
			status = _tmp91_;
#line 1478 "Utility/Device.vala"
			switch (status) {
#line 1478 "Utility/Device.vala"
				case 512:
#line 9374 "Device.c"
				{
					gchar* _tmp92_;
					gchar* _tmp93_;
					const gchar* _tmp94_;
					const gchar* _tmp95_;
#line 1480 "Utility/Device.vala"
					_tmp92_ = g_strdup (_ ("Wrong password"));
#line 1480 "Utility/Device.vala"
					_g_free0 (_vala_message);
#line 1480 "Utility/Device.vala"
					_vala_message = _tmp92_;
#line 1481 "Utility/Device.vala"
					_tmp93_ = g_strdup (_ ("Failed to unlock device"));
#line 1481 "Utility/Device.vala"
					_g_free0 (_vala_details);
#line 1481 "Utility/Device.vala"
					_vala_details = _tmp93_;
#line 1482 "Utility/Device.vala"
					_tmp94_ = _vala_message;
#line 1482 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp94_, FALSE, FALSE);
#line 1483 "Utility/Device.vala"
					_tmp95_ = _vala_details;
#line 1483 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp95_, FALSE, FALSE);
#line 1484 "Utility/Device.vala"
					break;
#line 9402 "Device.c"
				}
				default:
#line 1478 "Utility/Device.vala"
				break;
#line 9407 "Device.c"
			}
#line 1467 "Utility/Device.vala"
			_g_free0 (cmd);
#line 9411 "Device.c"
		}
	}
#line 1491 "Utility/Device.vala"
	_tmp96_ = device_get_block_devices_using_lsblk ("");
#line 1491 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1491 "Utility/Device.vala"
	list = _tmp96_;
#line 9420 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp97_;
		gint _part_size = 0;
		GeeArrayList* _tmp98_;
		gint _tmp99_;
		gint _tmp100_;
		gint _part_index = 0;
#line 1492 "Utility/Device.vala"
		_tmp97_ = list;
#line 1492 "Utility/Device.vala"
		_part_list = _tmp97_;
#line 1492 "Utility/Device.vala"
		_tmp98_ = _part_list;
#line 1492 "Utility/Device.vala"
		_tmp99_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp98_);
#line 1492 "Utility/Device.vala"
		_tmp100_ = _tmp99_;
#line 1492 "Utility/Device.vala"
		_part_size = _tmp100_;
#line 1492 "Utility/Device.vala"
		_part_index = -1;
#line 1492 "Utility/Device.vala"
		while (TRUE) {
#line 9445 "Device.c"
			gint _tmp101_;
			gint _tmp102_;
			Device* part = NULL;
			GeeArrayList* _tmp103_;
			gpointer _tmp104_;
			Device* _tmp105_;
			const gchar* _tmp106_;
			const gchar* _tmp107_;
#line 1492 "Utility/Device.vala"
			_part_index = _part_index + 1;
#line 1492 "Utility/Device.vala"
			_tmp101_ = _part_index;
#line 1492 "Utility/Device.vala"
			_tmp102_ = _part_size;
#line 1492 "Utility/Device.vala"
			if (!(_tmp101_ < _tmp102_)) {
#line 1492 "Utility/Device.vala"
				break;
#line 9464 "Device.c"
			}
#line 1492 "Utility/Device.vala"
			_tmp103_ = _part_list;
#line 1492 "Utility/Device.vala"
			_tmp104_ = gee_abstract_list_get ((GeeAbstractList*) _tmp103_, _part_index);
#line 1492 "Utility/Device.vala"
			part = (Device*) _tmp104_;
#line 1493 "Utility/Device.vala"
			_tmp105_ = part;
#line 1493 "Utility/Device.vala"
			_tmp106_ = _tmp105_->pkname;
#line 1493 "Utility/Device.vala"
			_tmp107_ = luks_device->kname;
#line 1493 "Utility/Device.vala"
			if (g_strcmp0 (_tmp106_, _tmp107_) == 0) {
#line 9480 "Device.c"
				Device* _tmp108_;
				Device* _tmp109_;
#line 1494 "Utility/Device.vala"
				_tmp108_ = part;
#line 1494 "Utility/Device.vala"
				_tmp109_ = _g_object_ref0 (_tmp108_);
#line 1494 "Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1494 "Utility/Device.vala"
				unlocked_device = _tmp109_;
#line 1495 "Utility/Device.vala"
				_g_object_unref0 (part);
#line 1495 "Utility/Device.vala"
				break;
#line 9495 "Device.c"
			}
#line 1492 "Utility/Device.vala"
			_g_object_unref0 (part);
#line 9499 "Device.c"
		}
	}
#line 1499 "Utility/Device.vala"
	is_error = FALSE;
#line 1500 "Utility/Device.vala"
	_tmp110_ = unlocked_device;
#line 1500 "Utility/Device.vala"
	if (_tmp110_ == NULL) {
#line 9508 "Device.c"
		const gchar* _tmp111_;
		gchar* _tmp112_;
		gchar* _tmp113_;
		gchar* _tmp114_;
		const gchar* _tmp115_;
		gchar* _tmp116_;
#line 1501 "Utility/Device.vala"
		_tmp111_ = luks_device->device;
#line 1501 "Utility/Device.vala"
		_tmp112_ = g_strdup_printf (" '%s'", _tmp111_);
#line 1501 "Utility/Device.vala"
		_tmp113_ = _tmp112_;
#line 1501 "Utility/Device.vala"
		_tmp114_ = g_strconcat (_ ("Failed to unlock device"), _tmp113_, NULL);
#line 1501 "Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1501 "Utility/Device.vala"
		_vala_message = _tmp114_;
#line 1501 "Utility/Device.vala"
		_g_free0 (_tmp113_);
#line 1502 "Utility/Device.vala"
		_tmp115_ = std_err;
#line 1502 "Utility/Device.vala"
		_tmp116_ = g_strdup (_tmp115_);
#line 1502 "Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1502 "Utility/Device.vala"
		_vala_details = _tmp116_;
#line 1503 "Utility/Device.vala"
		is_error = TRUE;
#line 9539 "Device.c"
	} else {
		gchar* _tmp117_;
		Device* _tmp118_;
		const gchar* _tmp119_;
		gchar* _tmp120_;
#line 1506 "Utility/Device.vala"
		_tmp117_ = g_strdup (_ ("Unlocked successfully"));
#line 1506 "Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1506 "Utility/Device.vala"
		_vala_message = _tmp117_;
#line 1507 "Utility/Device.vala"
		_tmp118_ = unlocked_device;
#line 1507 "Utility/Device.vala"
		_tmp119_ = _tmp118_->mapped_name;
#line 1507 "Utility/Device.vala"
		_tmp120_ = g_strdup_printf (_ ("Unlocked device is mapped to '%s'"), _tmp119_);
#line 1507 "Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1507 "Utility/Device.vala"
		_vala_details = _tmp120_;
#line 9561 "Device.c"
	}
#line 1510 "Utility/Device.vala"
	if (parent_window != NULL) {
#line 9565 "Device.c"
		const gchar* _tmp121_;
		const gchar* _tmp122_;
#line 1511 "Utility/Device.vala"
		_tmp121_ = _vala_message;
#line 1511 "Utility/Device.vala"
		_tmp122_ = _vala_details;
#line 1511 "Utility/Device.vala"
		tee_jee_gtk_helper_gtk_messagebox (_tmp121_, _tmp122_, parent_window, is_error);
#line 9574 "Device.c"
	}
#line 1514 "Utility/Device.vala"
	result = unlocked_device;
#line 1514 "Utility/Device.vala"
	_g_free0 (luks_name);
#line 1514 "Utility/Device.vala"
	_g_free0 (luks_pass);
#line 1514 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1514 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1514 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1514 "Utility/Device.vala"
	if (message) {
#line 1514 "Utility/Device.vala"
		*message = _vala_message;
#line 9592 "Device.c"
	} else {
#line 1514 "Utility/Device.vala"
		_g_free0 (_vala_message);
#line 9596 "Device.c"
	}
#line 1514 "Utility/Device.vala"
	if (details) {
#line 1514 "Utility/Device.vala"
		*details = _vala_details;
#line 9602 "Device.c"
	} else {
#line 1514 "Utility/Device.vala"
		_g_free0 (_vala_details);
#line 9606 "Device.c"
	}
#line 1514 "Utility/Device.vala"
	return result;
#line 9610 "Device.c"
}

gboolean
device_luks_lock (const gchar* kname,
                  GtkWindow* parent_window)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean result = FALSE;
#line 1517 "Utility/Device.vala"
	g_return_val_if_fail (kname != NULL, FALSE);
#line 1518 "Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("cryptsetup luksClose %s", kname);
#line 1518 "Utility/Device.vala"
	cmd = _tmp0_;
#line 1520 "Utility/Device.vala"
	_tmp1_ = cmd;
#line 1520 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 1523 "Utility/Device.vala"
	_tmp2_ = cmd;
#line 1523 "Utility/Device.vala"
	_tmp5_ = tee_jee_process_helper_exec_script_sync (_tmp2_, &_tmp3_, &_tmp4_, FALSE, TRUE, TRUE, FALSE);
#line 1523 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1523 "Utility/Device.vala"
	std_out = _tmp3_;
#line 1523 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1523 "Utility/Device.vala"
	std_err = _tmp4_;
#line 1523 "Utility/Device.vala"
	status = _tmp5_;
#line 1524 "Utility/Device.vala"
	_tmp6_ = std_out;
#line 1524 "Utility/Device.vala"
	tee_jee_logging_log_msg (_tmp6_, FALSE);
#line 1525 "Utility/Device.vala"
	_tmp7_ = std_err;
#line 1525 "Utility/Device.vala"
	tee_jee_logging_log_msg (_tmp7_, FALSE);
#line 1527 "Utility/Device.vala"
	if (status != 0) {
#line 1528 "Utility/Device.vala"
		if (parent_window != NULL) {
#line 9666 "Device.c"
			gchar* msg = NULL;
			gchar* _tmp8_;
			const gchar* _tmp9_;
#line 1529 "Utility/Device.vala"
			_tmp8_ = g_strdup_printf ("Failed to lock device: %s", kname);
#line 1529 "Utility/Device.vala"
			msg = _tmp8_;
#line 1530 "Utility/Device.vala"
			_tmp9_ = msg;
#line 1530 "Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp9_, parent_window, TRUE);
#line 1528 "Utility/Device.vala"
			_g_free0 (msg);
#line 9680 "Device.c"
		}
	}
#line 1534 "Utility/Device.vala"
	result = status == 0;
#line 1534 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1534 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1534 "Utility/Device.vala"
	_g_free0 (cmd);
#line 1534 "Utility/Device.vala"
	return result;
#line 9693 "Device.c"
}

gboolean
device_mount (const gchar* dev_name_or_uuid,
              const gchar* mount_point,
              const gchar* mount_options,
              gboolean silent)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gchar* device = NULL;
	gchar* _tmp1_;
	gchar* uuid = NULL;
	gchar* _tmp2_;
	GeeArrayList* mps = NULL;
	GeeArrayList* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gint _tmp52_;
	gint _tmp53_;
	const gchar* _tmp58_;
	gchar* _tmp59_ = NULL;
	gchar* _tmp60_ = NULL;
	gint _tmp61_;
	gboolean result = FALSE;
#line 1548 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1548 "Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1548 "Utility/Device.vala"
	g_return_val_if_fail (mount_options != NULL, FALSE);
#line 1556 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1556 "Utility/Device.vala"
	cmd = _tmp0_;
#line 1561 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1561 "Utility/Device.vala"
	device = _tmp1_;
#line 1562 "Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 1562 "Utility/Device.vala"
	uuid = _tmp2_;
#line 1566 "Utility/Device.vala"
	if (g_str_has_prefix (dev_name_or_uuid, "/dev")) {
#line 9743 "Device.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 1567 "Utility/Device.vala"
		_tmp3_ = g_strdup (dev_name_or_uuid);
#line 1567 "Utility/Device.vala"
		_g_free0 (device);
#line 1567 "Utility/Device.vala"
		device = _tmp3_;
#line 1568 "Utility/Device.vala"
		_tmp4_ = device_get_device_uuid (dev_name_or_uuid);
#line 1568 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1568 "Utility/Device.vala"
		uuid = _tmp4_;
#line 9758 "Device.c"
	} else {
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 1571 "Utility/Device.vala"
		_tmp5_ = g_strdup (dev_name_or_uuid);
#line 1571 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1571 "Utility/Device.vala"
		uuid = _tmp5_;
#line 1572 "Utility/Device.vala"
		_tmp6_ = uuid;
#line 1572 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp6_);
#line 1572 "Utility/Device.vala"
		_g_free0 (device);
#line 1572 "Utility/Device.vala"
		device = _tmp7_;
#line 1573 "Utility/Device.vala"
		_tmp8_ = device;
#line 1573 "Utility/Device.vala"
		_tmp9_ = device_resolve_device_name (_tmp8_);
#line 1573 "Utility/Device.vala"
		_g_free0 (device);
#line 1573 "Utility/Device.vala"
		device = _tmp9_;
#line 9787 "Device.c"
	}
#line 1578 "Utility/Device.vala"
	_tmp10_ = device_get_device_mount_points (dev_name_or_uuid);
#line 1578 "Utility/Device.vala"
	mps = _tmp10_;
#line 1580 "Utility/Device.vala"
	tee_jee_logging_log_debug ("------------------");
#line 1581 "Utility/Device.vala"
	_tmp11_ = device;
#line 1581 "Utility/Device.vala"
	_tmp12_ = g_strdup_printf ("arg=%s, device=%s", dev_name_or_uuid, _tmp11_);
#line 1581 "Utility/Device.vala"
	_tmp13_ = _tmp12_;
#line 1581 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp13_);
#line 1581 "Utility/Device.vala"
	_g_free0 (_tmp13_);
#line 9805 "Device.c"
	{
		GeeArrayList* _mp_list = NULL;
		GeeArrayList* _tmp14_;
		gint _mp_size = 0;
		GeeArrayList* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		gint _mp_index = 0;
#line 1582 "Utility/Device.vala"
		_tmp14_ = mps;
#line 1582 "Utility/Device.vala"
		_mp_list = _tmp14_;
#line 1582 "Utility/Device.vala"
		_tmp15_ = _mp_list;
#line 1582 "Utility/Device.vala"
		_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 1582 "Utility/Device.vala"
		_tmp17_ = _tmp16_;
#line 1582 "Utility/Device.vala"
		_mp_size = _tmp17_;
#line 1582 "Utility/Device.vala"
		_mp_index = -1;
#line 1582 "Utility/Device.vala"
		while (TRUE) {
#line 9830 "Device.c"
			gint _tmp18_;
			gint _tmp19_;
			MountEntry* mp = NULL;
			GeeArrayList* _tmp20_;
			gpointer _tmp21_;
			MountEntry* _tmp22_;
			const gchar* _tmp23_;
#line 1582 "Utility/Device.vala"
			_mp_index = _mp_index + 1;
#line 1582 "Utility/Device.vala"
			_tmp18_ = _mp_index;
#line 1582 "Utility/Device.vala"
			_tmp19_ = _mp_size;
#line 1582 "Utility/Device.vala"
			if (!(_tmp18_ < _tmp19_)) {
#line 1582 "Utility/Device.vala"
				break;
#line 9848 "Device.c"
			}
#line 1582 "Utility/Device.vala"
			_tmp20_ = _mp_list;
#line 1582 "Utility/Device.vala"
			_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _mp_index);
#line 1582 "Utility/Device.vala"
			mp = (MountEntry*) _tmp21_;
#line 1583 "Utility/Device.vala"
			_tmp22_ = mp;
#line 1583 "Utility/Device.vala"
			_tmp23_ = _tmp22_->mount_point;
#line 1583 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp23_);
#line 1582 "Utility/Device.vala"
			_g_object_unref0 (mp);
#line 9864 "Device.c"
		}
	}
#line 1585 "Utility/Device.vala"
	tee_jee_logging_log_debug ("------------------");
#line 9869 "Device.c"
	{
		GeeArrayList* _mp_list = NULL;
		GeeArrayList* _tmp24_;
		gint _mp_size = 0;
		GeeArrayList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _mp_index = 0;
#line 1587 "Utility/Device.vala"
		_tmp24_ = mps;
#line 1587 "Utility/Device.vala"
		_mp_list = _tmp24_;
#line 1587 "Utility/Device.vala"
		_tmp25_ = _mp_list;
#line 1587 "Utility/Device.vala"
		_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
#line 1587 "Utility/Device.vala"
		_tmp27_ = _tmp26_;
#line 1587 "Utility/Device.vala"
		_mp_size = _tmp27_;
#line 1587 "Utility/Device.vala"
		_mp_index = -1;
#line 1587 "Utility/Device.vala"
		while (TRUE) {
#line 9894 "Device.c"
			gint _tmp28_;
			gint _tmp29_;
			MountEntry* mp = NULL;
			GeeArrayList* _tmp30_;
			gpointer _tmp31_;
			gboolean _tmp32_ = FALSE;
			MountEntry* _tmp33_;
			const gchar* _tmp34_;
#line 1587 "Utility/Device.vala"
			_mp_index = _mp_index + 1;
#line 1587 "Utility/Device.vala"
			_tmp28_ = _mp_index;
#line 1587 "Utility/Device.vala"
			_tmp29_ = _mp_size;
#line 1587 "Utility/Device.vala"
			if (!(_tmp28_ < _tmp29_)) {
#line 1587 "Utility/Device.vala"
				break;
#line 9913 "Device.c"
			}
#line 1587 "Utility/Device.vala"
			_tmp30_ = _mp_list;
#line 1587 "Utility/Device.vala"
			_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _mp_index);
#line 1587 "Utility/Device.vala"
			mp = (MountEntry*) _tmp31_;
#line 1588 "Utility/Device.vala"
			_tmp33_ = mp;
#line 1588 "Utility/Device.vala"
			_tmp34_ = _tmp33_->mount_point;
#line 1588 "Utility/Device.vala"
			if (g_strcmp0 (_tmp34_, mount_point) == 0) {
#line 9927 "Device.c"
				MountEntry* _tmp35_;
				const gchar* _tmp36_;
#line 1588 "Utility/Device.vala"
				_tmp35_ = mp;
#line 1588 "Utility/Device.vala"
				_tmp36_ = _tmp35_->mount_options;
#line 1588 "Utility/Device.vala"
				_tmp32_ = string_contains (_tmp36_, mount_options);
#line 9936 "Device.c"
			} else {
#line 1588 "Utility/Device.vala"
				_tmp32_ = FALSE;
#line 9940 "Device.c"
			}
#line 1588 "Utility/Device.vala"
			if (_tmp32_) {
#line 1589 "Utility/Device.vala"
				if (!silent) {
#line 9946 "Device.c"
					gchar* msg = NULL;
					const gchar* _tmp37_;
					gchar* _tmp38_;
					MountEntry* _tmp39_;
					const gchar* _tmp40_;
					gint _tmp41_;
					gint _tmp42_;
					const gchar* _tmp49_;
					gchar* _tmp50_;
					gchar* _tmp51_;
#line 1590 "Utility/Device.vala"
					_tmp37_ = device;
#line 1590 "Utility/Device.vala"
					_tmp38_ = g_strdup_printf ("%s is mounted at: %s", _tmp37_, mount_point);
#line 1590 "Utility/Device.vala"
					msg = _tmp38_;
#line 1591 "Utility/Device.vala"
					_tmp39_ = mp;
#line 1591 "Utility/Device.vala"
					_tmp40_ = _tmp39_->mount_options;
#line 1591 "Utility/Device.vala"
					_tmp41_ = strlen (_tmp40_);
#line 1591 "Utility/Device.vala"
					_tmp42_ = _tmp41_;
#line 1591 "Utility/Device.vala"
					if (_tmp42_ > 0) {
#line 9973 "Device.c"
						const gchar* _tmp43_;
						MountEntry* _tmp44_;
						const gchar* _tmp45_;
						gchar* _tmp46_;
						gchar* _tmp47_;
						gchar* _tmp48_;
#line 1592 "Utility/Device.vala"
						_tmp43_ = msg;
#line 1592 "Utility/Device.vala"
						_tmp44_ = mp;
#line 1592 "Utility/Device.vala"
						_tmp45_ = _tmp44_->mount_options;
#line 1592 "Utility/Device.vala"
						_tmp46_ = g_strdup_printf (", options: %s", _tmp45_);
#line 1592 "Utility/Device.vala"
						_tmp47_ = _tmp46_;
#line 1592 "Utility/Device.vala"
						_tmp48_ = g_strconcat (_tmp43_, _tmp47_, NULL);
#line 1592 "Utility/Device.vala"
						_g_free0 (msg);
#line 1592 "Utility/Device.vala"
						msg = _tmp48_;
#line 1592 "Utility/Device.vala"
						_g_free0 (_tmp47_);
#line 9998 "Device.c"
					}
#line 1594 "Utility/Device.vala"
					_tmp49_ = msg;
#line 1594 "Utility/Device.vala"
					_tmp50_ = g_strdup_printf ("\n%s\n", _tmp49_);
#line 1594 "Utility/Device.vala"
					_tmp51_ = _tmp50_;
#line 1594 "Utility/Device.vala"
					tee_jee_logging_log_msg (_tmp51_, FALSE);
#line 1594 "Utility/Device.vala"
					_g_free0 (_tmp51_);
#line 1589 "Utility/Device.vala"
					_g_free0 (msg);
#line 10012 "Device.c"
				}
#line 1596 "Utility/Device.vala"
				result = TRUE;
#line 1596 "Utility/Device.vala"
				_g_object_unref0 (mp);
#line 1596 "Utility/Device.vala"
				_g_object_unref0 (mps);
#line 1596 "Utility/Device.vala"
				_g_free0 (uuid);
#line 1596 "Utility/Device.vala"
				_g_free0 (device);
#line 1596 "Utility/Device.vala"
				_g_free0 (std_err);
#line 1596 "Utility/Device.vala"
				_g_free0 (std_out);
#line 1596 "Utility/Device.vala"
				_g_free0 (cmd);
#line 1596 "Utility/Device.vala"
				return result;
#line 10032 "Device.c"
			}
#line 1587 "Utility/Device.vala"
			_g_object_unref0 (mp);
#line 10036 "Device.c"
		}
	}
#line 1600 "Utility/Device.vala"
	tee_jee_file_system_dir_create (mount_point, FALSE);
#line 1604 "Utility/Device.vala"
	device_unmount (mount_point);
#line 1608 "Utility/Device.vala"
	_tmp52_ = strlen (mount_options);
#line 1608 "Utility/Device.vala"
	_tmp53_ = _tmp52_;
#line 1608 "Utility/Device.vala"
	if (_tmp53_ > 0) {
#line 10049 "Device.c"
		const gchar* _tmp54_;
		gchar* _tmp55_;
#line 1609 "Utility/Device.vala"
		_tmp54_ = device;
#line 1609 "Utility/Device.vala"
		_tmp55_ = g_strdup_printf ("mount -o %s \"%s\" \"%s\"", mount_options, _tmp54_, mount_point);
#line 1609 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1609 "Utility/Device.vala"
		cmd = _tmp55_;
#line 10060 "Device.c"
	} else {
		const gchar* _tmp56_;
		gchar* _tmp57_;
#line 1612 "Utility/Device.vala"
		_tmp56_ = device;
#line 1612 "Utility/Device.vala"
		_tmp57_ = g_strdup_printf ("mount \"%s\" \"%s\"", _tmp56_, mount_point);
#line 1612 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1612 "Utility/Device.vala"
		cmd = _tmp57_;
#line 10072 "Device.c"
	}
#line 1615 "Utility/Device.vala"
	_tmp58_ = cmd;
#line 1615 "Utility/Device.vala"
	_tmp61_ = tee_jee_process_helper_exec_sync (_tmp58_, &_tmp59_, &_tmp60_);
#line 1615 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1615 "Utility/Device.vala"
	std_out = _tmp59_;
#line 1615 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1615 "Utility/Device.vala"
	std_err = _tmp60_;
#line 1615 "Utility/Device.vala"
	ret_val = _tmp61_;
#line 1617 "Utility/Device.vala"
	if (ret_val != 0) {
#line 10090 "Device.c"
		const gchar* _tmp62_;
		gchar* _tmp63_;
		gchar* _tmp64_;
		const gchar* _tmp65_;
#line 1618 "Utility/Device.vala"
		_tmp62_ = device;
#line 1618 "Utility/Device.vala"
		_tmp63_ = g_strdup_printf ("Failed to mount device '%s' at mount point '%s'", _tmp62_, mount_point);
#line 1618 "Utility/Device.vala"
		_tmp64_ = _tmp63_;
#line 1618 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp64_, FALSE, FALSE);
#line 1618 "Utility/Device.vala"
		_g_free0 (_tmp64_);
#line 1619 "Utility/Device.vala"
		_tmp65_ = std_err;
#line 1619 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp65_, FALSE, FALSE);
#line 1620 "Utility/Device.vala"
		result = FALSE;
#line 1620 "Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1620 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1620 "Utility/Device.vala"
		_g_free0 (device);
#line 1620 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1620 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1620 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1620 "Utility/Device.vala"
		return result;
#line 10125 "Device.c"
	} else {
#line 1623 "Utility/Device.vala"
		if (!silent) {
#line 10129 "Device.c"
			Device* dev = NULL;
			const gchar* _tmp66_;
			Device* _tmp67_;
			gchar* _tmp68_ = NULL;
			Device* _tmp69_;
			gchar* _tmp75_ = NULL;
			gint _tmp76_;
			gint _tmp77_;
			gchar* _tmp80_;
			gchar* _tmp81_;
#line 1624 "Utility/Device.vala"
			_tmp66_ = device;
#line 1624 "Utility/Device.vala"
			_tmp67_ = device_get_device_by_name (_tmp66_);
#line 1624 "Utility/Device.vala"
			dev = _tmp67_;
#line 1626 "Utility/Device.vala"
			_tmp69_ = dev;
#line 1626 "Utility/Device.vala"
			if (_tmp69_ == NULL) {
#line 10150 "Device.c"
				const gchar* _tmp70_;
				gchar* _tmp71_;
#line 1626 "Utility/Device.vala"
				_tmp70_ = device;
#line 1626 "Utility/Device.vala"
				_tmp71_ = g_strdup (_tmp70_);
#line 1626 "Utility/Device.vala"
				_g_free0 (_tmp68_);
#line 1626 "Utility/Device.vala"
				_tmp68_ = _tmp71_;
#line 10161 "Device.c"
			} else {
				Device* _tmp72_;
				gchar* _tmp73_;
				gchar* _tmp74_;
#line 1626 "Utility/Device.vala"
				_tmp72_ = dev;
#line 1626 "Utility/Device.vala"
				_tmp73_ = device_get_device_name_with_parent (_tmp72_);
#line 1626 "Utility/Device.vala"
				_tmp74_ = _tmp73_;
#line 1626 "Utility/Device.vala"
				_g_free0 (_tmp68_);
#line 1626 "Utility/Device.vala"
				_tmp68_ = _tmp74_;
#line 10176 "Device.c"
			}
#line 1627 "Utility/Device.vala"
			_tmp76_ = strlen (mount_options);
#line 1627 "Utility/Device.vala"
			_tmp77_ = _tmp76_;
#line 1627 "Utility/Device.vala"
			if (_tmp77_ > 0) {
#line 10184 "Device.c"
				gchar* _tmp78_;
#line 1627 "Utility/Device.vala"
				_tmp78_ = g_strdup_printf (" (%s)", mount_options);
#line 1627 "Utility/Device.vala"
				_g_free0 (_tmp75_);
#line 1627 "Utility/Device.vala"
				_tmp75_ = _tmp78_;
#line 10192 "Device.c"
			} else {
				gchar* _tmp79_;
#line 1627 "Utility/Device.vala"
				_tmp79_ = g_strdup ("");
#line 1627 "Utility/Device.vala"
				_g_free0 (_tmp75_);
#line 1627 "Utility/Device.vala"
				_tmp75_ = _tmp79_;
#line 10201 "Device.c"
			}
#line 1625 "Utility/Device.vala"
			_tmp80_ = g_strdup_printf ("Mounted '%s'%s at '%s'", _tmp68_, _tmp75_, mount_point);
#line 1625 "Utility/Device.vala"
			_tmp81_ = _tmp80_;
#line 1625 "Utility/Device.vala"
			tee_jee_logging_log_msg (_tmp81_, FALSE);
#line 1625 "Utility/Device.vala"
			_g_free0 (_tmp81_);
#line 1623 "Utility/Device.vala"
			_g_free0 (_tmp75_);
#line 1623 "Utility/Device.vala"
			_g_free0 (_tmp68_);
#line 1623 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 10217 "Device.c"
		}
#line 1630 "Utility/Device.vala"
		result = TRUE;
#line 1630 "Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1630 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1630 "Utility/Device.vala"
		_g_free0 (device);
#line 1630 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1630 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1630 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1630 "Utility/Device.vala"
		return result;
#line 10235 "Device.c"
	}
}

gchar*
device_automount (const gchar* dev_name_or_uuid,
                  const gchar* mount_options,
                  const gchar* mount_prefix)
{
	gchar* device = NULL;
	gchar* _tmp0_;
	gchar* uuid = NULL;
	gchar* _tmp1_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp9_;
	Device* dev = NULL;
	GeeArrayList* _tmp10_;
	const gchar* _tmp11_;
	Device* _tmp12_;
	Device* _tmp13_;
	gchar* mount_point = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1645 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, NULL);
#line 1645 "Utility/Device.vala"
	g_return_val_if_fail (mount_options != NULL, NULL);
#line 1645 "Utility/Device.vala"
	g_return_val_if_fail (mount_prefix != NULL, NULL);
#line 1652 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1652 "Utility/Device.vala"
	device = _tmp0_;
#line 1653 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1653 "Utility/Device.vala"
	uuid = _tmp1_;
#line 1657 "Utility/Device.vala"
	if (g_str_has_prefix (dev_name_or_uuid, "/dev")) {
#line 10278 "Device.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 1658 "Utility/Device.vala"
		_tmp2_ = g_strdup (dev_name_or_uuid);
#line 1658 "Utility/Device.vala"
		_g_free0 (device);
#line 1658 "Utility/Device.vala"
		device = _tmp2_;
#line 1659 "Utility/Device.vala"
		_tmp3_ = device_get_device_uuid (dev_name_or_uuid);
#line 1659 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1659 "Utility/Device.vala"
		uuid = _tmp3_;
#line 10293 "Device.c"
	} else {
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 1662 "Utility/Device.vala"
		_tmp4_ = g_strdup (dev_name_or_uuid);
#line 1662 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1662 "Utility/Device.vala"
		uuid = _tmp4_;
#line 1663 "Utility/Device.vala"
		_tmp5_ = uuid;
#line 1663 "Utility/Device.vala"
		_tmp6_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp5_);
#line 1663 "Utility/Device.vala"
		_g_free0 (device);
#line 1663 "Utility/Device.vala"
		device = _tmp6_;
#line 1664 "Utility/Device.vala"
		_tmp7_ = device;
#line 1664 "Utility/Device.vala"
		_tmp8_ = device_resolve_device_name (_tmp7_);
#line 1664 "Utility/Device.vala"
		_g_free0 (device);
#line 1664 "Utility/Device.vala"
		device = _tmp8_;
#line 10322 "Device.c"
	}
#line 1669 "Utility/Device.vala"
	_tmp9_ = device_get_block_devices_using_lsblk ("");
#line 1669 "Utility/Device.vala"
	list = _tmp9_;
#line 1670 "Utility/Device.vala"
	_tmp10_ = list;
#line 1670 "Utility/Device.vala"
	_tmp11_ = uuid;
#line 1670 "Utility/Device.vala"
	_tmp12_ = device_find_device_in_list (_tmp10_, _tmp11_);
#line 1670 "Utility/Device.vala"
	dev = _tmp12_;
#line 1671 "Utility/Device.vala"
	_tmp13_ = dev;
#line 1671 "Utility/Device.vala"
	if (_tmp13_ != NULL) {
#line 10340 "Device.c"
		Device* _tmp14_;
		GeeArrayList* _tmp15_;
		gpointer _tmp16_;
		MountEntry* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 1672 "Utility/Device.vala"
		_tmp14_ = dev;
#line 1672 "Utility/Device.vala"
		_tmp15_ = _tmp14_->mount_points;
#line 1672 "Utility/Device.vala"
		_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, 0);
#line 1672 "Utility/Device.vala"
		_tmp17_ = (MountEntry*) _tmp16_;
#line 1672 "Utility/Device.vala"
		_tmp18_ = _tmp17_->mount_point;
#line 1672 "Utility/Device.vala"
		_tmp19_ = g_strdup (_tmp18_);
#line 1672 "Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1672 "Utility/Device.vala"
		_g_object_unref0 (_tmp17_);
#line 1672 "Utility/Device.vala"
		result = _tmp20_;
#line 1672 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1672 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1672 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1672 "Utility/Device.vala"
		_g_free0 (device);
#line 1672 "Utility/Device.vala"
		return result;
#line 10376 "Device.c"
	}
#line 1677 "Utility/Device.vala"
	_tmp21_ = uuid;
#line 1677 "Utility/Device.vala"
	_tmp22_ = g_strdup_printf ("%s/%s", mount_prefix, _tmp21_);
#line 1677 "Utility/Device.vala"
	mount_point = _tmp22_;
#line 10384 "Device.c"
	{
		GFile* file = NULL;
		const gchar* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
#line 1680 "Utility/Device.vala"
		_tmp23_ = mount_point;
#line 1680 "Utility/Device.vala"
		_tmp24_ = g_file_new_for_path (_tmp23_);
#line 1680 "Utility/Device.vala"
		file = _tmp24_;
#line 1681 "Utility/Device.vala"
		_tmp25_ = file;
#line 1681 "Utility/Device.vala"
		if (!g_file_query_exists (_tmp25_, NULL)) {
#line 10400 "Device.c"
			GFile* _tmp26_;
#line 1682 "Utility/Device.vala"
			_tmp26_ = file;
#line 1682 "Utility/Device.vala"
			g_file_make_directory_with_parents (_tmp26_, NULL, &_inner_error0_);
#line 1682 "Utility/Device.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1682 "Utility/Device.vala"
				_g_object_unref0 (file);
#line 10410 "Device.c"
				goto __catch0_g_error;
			}
		}
#line 1679 "Utility/Device.vala"
		_g_object_unref0 (file);
#line 10416 "Device.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
#line 1679 "Utility/Device.vala"
		e = _inner_error0_;
#line 1679 "Utility/Device.vala"
		_inner_error0_ = NULL;
#line 1686 "Utility/Device.vala"
		_tmp27_ = e;
#line 1686 "Utility/Device.vala"
		_tmp28_ = _tmp27_->message;
#line 1686 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp28_, FALSE, FALSE);
#line 1687 "Utility/Device.vala"
		_tmp29_ = g_strdup ("");
#line 1687 "Utility/Device.vala"
		result = _tmp29_;
#line 1687 "Utility/Device.vala"
		_g_error_free0 (e);
#line 1687 "Utility/Device.vala"
		_g_free0 (mount_point);
#line 1687 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1687 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1687 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1687 "Utility/Device.vala"
		_g_free0 (device);
#line 1687 "Utility/Device.vala"
		return result;
#line 10453 "Device.c"
	}
	__finally0:
#line 1679 "Utility/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1679 "Utility/Device.vala"
		_g_free0 (mount_point);
#line 1679 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1679 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1679 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1679 "Utility/Device.vala"
		_g_free0 (device);
#line 1679 "Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1679 "Utility/Device.vala"
		g_clear_error (&_inner_error0_);
#line 1679 "Utility/Device.vala"
		return NULL;
#line 10474 "Device.c"
	}
#line 1692 "Utility/Device.vala"
	_tmp30_ = uuid;
#line 1692 "Utility/Device.vala"
	_tmp31_ = mount_point;
#line 1692 "Utility/Device.vala"
	if (device_mount (_tmp30_, _tmp31_, mount_options, FALSE)) {
#line 1693 "Utility/Device.vala"
		result = mount_point;
#line 1693 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1693 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1693 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1693 "Utility/Device.vala"
		_g_free0 (device);
#line 1693 "Utility/Device.vala"
		return result;
#line 10494 "Device.c"
	} else {
		gchar* _tmp32_;
#line 1696 "Utility/Device.vala"
		_tmp32_ = g_strdup ("");
#line 1696 "Utility/Device.vala"
		result = _tmp32_;
#line 1696 "Utility/Device.vala"
		_g_free0 (mount_point);
#line 1696 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1696 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1696 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1696 "Utility/Device.vala"
		_g_free0 (device);
#line 1696 "Utility/Device.vala"
		return result;
#line 10513 "Device.c"
	}
}

gboolean
device_unmount (const gchar* mount_point)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 1700 "Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1705 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1705 "Utility/Device.vala"
	cmd = _tmp0_;
#line 1711 "Utility/Device.vala"
	if (!device_mount_point_in_use (mount_point)) {
#line 1712 "Utility/Device.vala"
		result = TRUE;
#line 1712 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1712 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1712 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1712 "Utility/Device.vala"
		return result;
#line 10545 "Device.c"
	}
	{
		gchar* cmd_unmount = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		const gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gint _tmp14_;
#line 1719 "Utility/Device.vala"
		_tmp1_ = g_strdup_printf ("cat /proc/mounts | awk '{print $2}' | grep '%s' | sort -r | xargs umou" \
"nt", mount_point);
#line 1719 "Utility/Device.vala"
		cmd_unmount = _tmp1_;
#line 1721 "Utility/Device.vala"
		_tmp2_ = g_strdup_printf (": '%s'", mount_point);
#line 1721 "Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 1721 "Utility/Device.vala"
		_tmp4_ = g_strconcat (_ ("Unmounting from"), _tmp3_, NULL);
#line 1721 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1721 "Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp5_);
#line 1721 "Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1721 "Utility/Device.vala"
		_g_free0 (_tmp3_);
#line 1724 "Utility/Device.vala"
		_tmp6_ = g_strdup ("sync");
#line 1724 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1724 "Utility/Device.vala"
		cmd = _tmp6_;
#line 1725 "Utility/Device.vala"
		_tmp7_ = cmd;
#line 1725 "Utility/Device.vala"
		g_spawn_command_line_sync (_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_, &_inner_error0_);
#line 1725 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1725 "Utility/Device.vala"
		std_out = _tmp8_;
#line 1725 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1725 "Utility/Device.vala"
		std_err = _tmp9_;
#line 1725 "Utility/Device.vala"
		ret_val = _tmp10_;
#line 1725 "Utility/Device.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1725 "Utility/Device.vala"
			_g_free0 (cmd_unmount);
#line 10605 "Device.c"
			goto __catch0_g_error;
		}
#line 1729 "Utility/Device.vala"
		_tmp11_ = cmd_unmount;
#line 1729 "Utility/Device.vala"
		_tmp14_ = tee_jee_process_helper_exec_script_sync (_tmp11_, &_tmp12_, &_tmp13_, FALSE, FALSE, TRUE, FALSE);
#line 1729 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1729 "Utility/Device.vala"
		std_out = _tmp12_;
#line 1729 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1729 "Utility/Device.vala"
		std_err = _tmp13_;
#line 1729 "Utility/Device.vala"
		ret_val = _tmp14_;
#line 1731 "Utility/Device.vala"
		if (ret_val != 0) {
#line 10624 "Device.c"
			const gchar* _tmp15_;
#line 1732 "Utility/Device.vala"
			tee_jee_logging_log_error (_ ("Failed to unmount"), FALSE, FALSE);
#line 1733 "Utility/Device.vala"
			_tmp15_ = std_err;
#line 1733 "Utility/Device.vala"
			tee_jee_logging_log_error (_tmp15_, FALSE, FALSE);
#line 10632 "Device.c"
		}
#line 1717 "Utility/Device.vala"
		_g_free0 (cmd_unmount);
#line 10636 "Device.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 1717 "Utility/Device.vala"
		e = _inner_error0_;
#line 1717 "Utility/Device.vala"
		_inner_error0_ = NULL;
#line 1737 "Utility/Device.vala"
		_tmp16_ = e;
#line 1737 "Utility/Device.vala"
		_tmp17_ = _tmp16_->message;
#line 1737 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 1738 "Utility/Device.vala"
		result = FALSE;
#line 1738 "Utility/Device.vala"
		_g_error_free0 (e);
#line 1738 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1738 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1738 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1738 "Utility/Device.vala"
		return result;
#line 10666 "Device.c"
	}
	__finally0:
#line 1717 "Utility/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10671 "Device.c"
		gboolean _tmp18_ = FALSE;
#line 1717 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1717 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1717 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1717 "Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1717 "Utility/Device.vala"
		g_clear_error (&_inner_error0_);
#line 1717 "Utility/Device.vala"
		return _tmp18_;
#line 10685 "Device.c"
	}
#line 1742 "Utility/Device.vala"
	if (!device_mount_point_in_use (mount_point)) {
#line 1743 "Utility/Device.vala"
		result = TRUE;
#line 1743 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1743 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1743 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1743 "Utility/Device.vala"
		return result;
#line 10699 "Device.c"
	} else {
#line 1746 "Utility/Device.vala"
		result = FALSE;
#line 1746 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1746 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1746 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1746 "Utility/Device.vala"
		return result;
#line 10711 "Device.c"
	}
}

gchar*
device_description (Device* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result = NULL;
#line 1802 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1803 "Utility/Device.vala"
	_tmp0_ = device_description_formatted (self);
#line 1803 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1803 "Utility/Device.vala"
	_tmp2_ = string_replace (_tmp1_, "<b>", "");
#line 1803 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1803 "Utility/Device.vala"
	_tmp4_ = string_replace (_tmp3_, "</b>", "");
#line 1803 "Utility/Device.vala"
	_tmp5_ = _tmp4_;
#line 1803 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1803 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 1803 "Utility/Device.vala"
	result = _tmp5_;
#line 1803 "Utility/Device.vala"
	return result;
#line 10747 "Device.c"
}

gchar*
device_description_formatted (Device* self)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp66_;
	gchar* _tmp67_;
	gchar* result = NULL;
#line 1806 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1807 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1807 "Utility/Device.vala"
	s = _tmp0_;
#line 1809 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 1809 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 10769 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		const gchar* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
#line 1810 "Utility/Device.vala"
		_tmp2_ = s;
#line 1810 "Utility/Device.vala"
		_tmp3_ = self->kname;
#line 1810 "Utility/Device.vala"
		_tmp4_ = g_strconcat ("<b>", _tmp3_, NULL);
#line 1810 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1810 "Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp5_, "</b> ~", NULL);
#line 1810 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1810 "Utility/Device.vala"
		_tmp8_ = g_strconcat (_tmp2_, _tmp7_, NULL);
#line 1810 "Utility/Device.vala"
		_g_free0 (s);
#line 1810 "Utility/Device.vala"
		s = _tmp8_;
#line 1810 "Utility/Device.vala"
		_g_free0 (_tmp7_);
#line 1810 "Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1811 "Utility/Device.vala"
		_tmp9_ = self->vendor;
#line 1811 "Utility/Device.vala"
		_tmp10_ = strlen (_tmp9_);
#line 1811 "Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1811 "Utility/Device.vala"
		if (_tmp11_ > 0) {
#line 10813 "Device.c"
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 1812 "Utility/Device.vala"
			_tmp12_ = s;
#line 1812 "Utility/Device.vala"
			_tmp13_ = self->vendor;
#line 1812 "Utility/Device.vala"
			_tmp14_ = g_strconcat (" ", _tmp13_, NULL);
#line 1812 "Utility/Device.vala"
			_tmp15_ = _tmp14_;
#line 1812 "Utility/Device.vala"
			_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 1812 "Utility/Device.vala"
			_g_free0 (s);
#line 1812 "Utility/Device.vala"
			s = _tmp16_;
#line 1812 "Utility/Device.vala"
			_g_free0 (_tmp15_);
#line 10835 "Device.c"
		}
#line 1814 "Utility/Device.vala"
		_tmp17_ = self->model;
#line 1814 "Utility/Device.vala"
		_tmp18_ = strlen (_tmp17_);
#line 1814 "Utility/Device.vala"
		_tmp19_ = _tmp18_;
#line 1814 "Utility/Device.vala"
		if (_tmp19_ > 0) {
#line 10845 "Device.c"
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 1815 "Utility/Device.vala"
			_tmp20_ = s;
#line 1815 "Utility/Device.vala"
			_tmp21_ = self->model;
#line 1815 "Utility/Device.vala"
			_tmp22_ = g_strconcat (" ", _tmp21_, NULL);
#line 1815 "Utility/Device.vala"
			_tmp23_ = _tmp22_;
#line 1815 "Utility/Device.vala"
			_tmp24_ = g_strconcat (_tmp20_, _tmp23_, NULL);
#line 1815 "Utility/Device.vala"
			_g_free0 (s);
#line 1815 "Utility/Device.vala"
			s = _tmp24_;
#line 1815 "Utility/Device.vala"
			_g_free0 (_tmp23_);
#line 10867 "Device.c"
		}
#line 1817 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 10871 "Device.c"
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
#line 1818 "Utility/Device.vala"
			_tmp25_ = s;
#line 1818 "Utility/Device.vala"
			_tmp26_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1818 "Utility/Device.vala"
			_tmp27_ = _tmp26_;
#line 1818 "Utility/Device.vala"
			_tmp28_ = g_strdup_printf (" (%s)", _tmp27_);
#line 1818 "Utility/Device.vala"
			_tmp29_ = _tmp28_;
#line 1818 "Utility/Device.vala"
			_tmp30_ = g_strconcat (_tmp25_, _tmp29_, NULL);
#line 1818 "Utility/Device.vala"
			_g_free0 (s);
#line 1818 "Utility/Device.vala"
			s = _tmp30_;
#line 1818 "Utility/Device.vala"
			_g_free0 (_tmp29_);
#line 1818 "Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 10898 "Device.c"
		}
	} else {
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_ = NULL;
		const gchar* _tmp41_;
		gint _tmp42_;
		gint _tmp43_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_ = NULL;
		const gchar* _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		const gchar* _tmp58_;
		gchar* _tmp59_;
#line 1822 "Utility/Device.vala"
		_tmp31_ = s;
#line 1822 "Utility/Device.vala"
		_tmp32_ = device_get_short_name_with_parent (self);
#line 1822 "Utility/Device.vala"
		_tmp33_ = _tmp32_;
#line 1822 "Utility/Device.vala"
		_tmp34_ = _tmp33_;
#line 1822 "Utility/Device.vala"
		_tmp35_ = g_strconcat ("<b>", _tmp34_, NULL);
#line 1822 "Utility/Device.vala"
		_tmp36_ = _tmp35_;
#line 1822 "Utility/Device.vala"
		_tmp37_ = g_strconcat (_tmp36_, "</b>", NULL);
#line 1822 "Utility/Device.vala"
		_tmp38_ = _tmp37_;
#line 1822 "Utility/Device.vala"
		_tmp39_ = g_strconcat (_tmp31_, _tmp38_, NULL);
#line 1822 "Utility/Device.vala"
		_g_free0 (s);
#line 1822 "Utility/Device.vala"
		s = _tmp39_;
#line 1822 "Utility/Device.vala"
		_g_free0 (_tmp38_);
#line 1822 "Utility/Device.vala"
		_g_free0 (_tmp36_);
#line 1822 "Utility/Device.vala"
		_g_free0 (_tmp34_);
#line 1823 "Utility/Device.vala"
		_tmp41_ = self->label;
#line 1823 "Utility/Device.vala"
		_tmp42_ = strlen (_tmp41_);
#line 1823 "Utility/Device.vala"
		_tmp43_ = _tmp42_;
#line 1823 "Utility/Device.vala"
		if (_tmp43_ > 0) {
#line 10958 "Device.c"
			const gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
#line 1823 "Utility/Device.vala"
			_tmp44_ = self->label;
#line 1823 "Utility/Device.vala"
			_tmp45_ = g_strconcat (" (", _tmp44_, NULL);
#line 1823 "Utility/Device.vala"
			_tmp46_ = _tmp45_;
#line 1823 "Utility/Device.vala"
			_tmp47_ = g_strconcat (_tmp46_, ")", NULL);
#line 1823 "Utility/Device.vala"
			_g_free0 (_tmp40_);
#line 1823 "Utility/Device.vala"
			_tmp40_ = _tmp47_;
#line 1823 "Utility/Device.vala"
			_g_free0 (_tmp46_);
#line 10977 "Device.c"
		} else {
			gchar* _tmp48_;
#line 1823 "Utility/Device.vala"
			_tmp48_ = g_strdup ("");
#line 1823 "Utility/Device.vala"
			_g_free0 (_tmp40_);
#line 1823 "Utility/Device.vala"
			_tmp40_ = _tmp48_;
#line 10986 "Device.c"
		}
#line 1823 "Utility/Device.vala"
		_tmp49_ = s;
#line 1823 "Utility/Device.vala"
		_tmp50_ = g_strconcat (_tmp49_, _tmp40_, NULL);
#line 1823 "Utility/Device.vala"
		_g_free0 (s);
#line 1823 "Utility/Device.vala"
		s = _tmp50_;
#line 1824 "Utility/Device.vala"
		_tmp52_ = self->fstype;
#line 1824 "Utility/Device.vala"
		_tmp53_ = strlen (_tmp52_);
#line 1824 "Utility/Device.vala"
		_tmp54_ = _tmp53_;
#line 1824 "Utility/Device.vala"
		if (_tmp54_ > 0) {
#line 11004 "Device.c"
			const gchar* _tmp55_;
			gchar* _tmp56_;
#line 1824 "Utility/Device.vala"
			_tmp55_ = self->fstype;
#line 1824 "Utility/Device.vala"
			_tmp56_ = g_strconcat (" ~ ", _tmp55_, NULL);
#line 1824 "Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 1824 "Utility/Device.vala"
			_tmp51_ = _tmp56_;
#line 11015 "Device.c"
		} else {
			gchar* _tmp57_;
#line 1824 "Utility/Device.vala"
			_tmp57_ = g_strdup ("");
#line 1824 "Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 1824 "Utility/Device.vala"
			_tmp51_ = _tmp57_;
#line 11024 "Device.c"
		}
#line 1824 "Utility/Device.vala"
		_tmp58_ = s;
#line 1824 "Utility/Device.vala"
		_tmp59_ = g_strconcat (_tmp58_, _tmp51_, NULL);
#line 1824 "Utility/Device.vala"
		_g_free0 (s);
#line 1824 "Utility/Device.vala"
		s = _tmp59_;
#line 1825 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 11036 "Device.c"
			const gchar* _tmp60_;
			gchar* _tmp61_;
			gchar* _tmp62_;
			gchar* _tmp63_;
			gchar* _tmp64_;
			gchar* _tmp65_;
#line 1826 "Utility/Device.vala"
			_tmp60_ = s;
#line 1826 "Utility/Device.vala"
			_tmp61_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1826 "Utility/Device.vala"
			_tmp62_ = _tmp61_;
#line 1826 "Utility/Device.vala"
			_tmp63_ = g_strdup_printf (" (%s)", _tmp62_);
#line 1826 "Utility/Device.vala"
			_tmp64_ = _tmp63_;
#line 1826 "Utility/Device.vala"
			_tmp65_ = g_strconcat (_tmp60_, _tmp64_, NULL);
#line 1826 "Utility/Device.vala"
			_g_free0 (s);
#line 1826 "Utility/Device.vala"
			s = _tmp65_;
#line 1826 "Utility/Device.vala"
			_g_free0 (_tmp64_);
#line 1826 "Utility/Device.vala"
			_g_free0 (_tmp62_);
#line 11063 "Device.c"
		}
#line 1809 "Utility/Device.vala"
		_g_free0 (_tmp51_);
#line 1809 "Utility/Device.vala"
		_g_free0 (_tmp40_);
#line 11069 "Device.c"
	}
#line 1830 "Utility/Device.vala"
	_tmp66_ = s;
#line 1830 "Utility/Device.vala"
	_tmp67_ = string_strip (_tmp66_);
#line 1830 "Utility/Device.vala"
	result = _tmp67_;
#line 1830 "Utility/Device.vala"
	_g_free0 (s);
#line 1830 "Utility/Device.vala"
	return result;
#line 11081 "Device.c"
}

gchar*
device_description_simple (Device* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result = NULL;
#line 1833 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1834 "Utility/Device.vala"
	_tmp0_ = device_description_simple_formatted (self);
#line 1834 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1834 "Utility/Device.vala"
	_tmp2_ = string_replace (_tmp1_, "<b>", "");
#line 1834 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1834 "Utility/Device.vala"
	_tmp4_ = string_replace (_tmp3_, "</b>", "");
#line 1834 "Utility/Device.vala"
	_tmp5_ = _tmp4_;
#line 1834 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1834 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 1834 "Utility/Device.vala"
	result = _tmp5_;
#line 1834 "Utility/Device.vala"
	return result;
#line 11116 "Device.c"
}

gchar*
device_description_simple_formatted (Device* self)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp71_;
	gchar* _tmp72_;
	gchar* result = NULL;
#line 1837 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1839 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1839 "Utility/Device.vala"
	s = _tmp0_;
#line 1841 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 1841 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 11138 "Device.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 1842 "Utility/Device.vala"
		_tmp2_ = self->vendor;
#line 1842 "Utility/Device.vala"
		_tmp3_ = strlen (_tmp2_);
#line 1842 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 1842 "Utility/Device.vala"
		if (_tmp4_ > 0) {
#line 11153 "Device.c"
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 1843 "Utility/Device.vala"
			_tmp5_ = s;
#line 1843 "Utility/Device.vala"
			_tmp6_ = self->vendor;
#line 1843 "Utility/Device.vala"
			_tmp7_ = g_strconcat (" ", _tmp6_, NULL);
#line 1843 "Utility/Device.vala"
			_tmp8_ = _tmp7_;
#line 1843 "Utility/Device.vala"
			_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1843 "Utility/Device.vala"
			_g_free0 (s);
#line 1843 "Utility/Device.vala"
			s = _tmp9_;
#line 1843 "Utility/Device.vala"
			_g_free0 (_tmp8_);
#line 11175 "Device.c"
		}
#line 1845 "Utility/Device.vala"
		_tmp10_ = self->model;
#line 1845 "Utility/Device.vala"
		_tmp11_ = strlen (_tmp10_);
#line 1845 "Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1845 "Utility/Device.vala"
		if (_tmp12_ > 0) {
#line 11185 "Device.c"
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 1846 "Utility/Device.vala"
			_tmp13_ = s;
#line 1846 "Utility/Device.vala"
			_tmp14_ = self->model;
#line 1846 "Utility/Device.vala"
			_tmp15_ = g_strconcat (" ", _tmp14_, NULL);
#line 1846 "Utility/Device.vala"
			_tmp16_ = _tmp15_;
#line 1846 "Utility/Device.vala"
			_tmp17_ = g_strconcat (_tmp13_, _tmp16_, NULL);
#line 1846 "Utility/Device.vala"
			_g_free0 (s);
#line 1846 "Utility/Device.vala"
			s = _tmp17_;
#line 1846 "Utility/Device.vala"
			_g_free0 (_tmp16_);
#line 11207 "Device.c"
		}
#line 1848 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 11211 "Device.c"
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
			gboolean _tmp23_;
#line 1849 "Utility/Device.vala"
			_tmp18_ = s;
#line 1849 "Utility/Device.vala"
			_tmp19_ = string_strip (_tmp18_);
#line 1849 "Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1849 "Utility/Device.vala"
			_tmp21_ = strlen (_tmp20_);
#line 1849 "Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 1849 "Utility/Device.vala"
			_tmp23_ = _tmp22_ == 0;
#line 1849 "Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 1849 "Utility/Device.vala"
			if (_tmp23_) {
#line 11234 "Device.c"
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
#line 1850 "Utility/Device.vala"
				_tmp24_ = s;
#line 1850 "Utility/Device.vala"
				_tmp25_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1850 "Utility/Device.vala"
				_tmp26_ = _tmp25_;
#line 1850 "Utility/Device.vala"
				_tmp27_ = g_strdup_printf ("%s Device", _tmp26_);
#line 1850 "Utility/Device.vala"
				_tmp28_ = _tmp27_;
#line 1850 "Utility/Device.vala"
				_tmp29_ = g_strconcat (_tmp24_, _tmp28_, NULL);
#line 1850 "Utility/Device.vala"
				_g_free0 (s);
#line 1850 "Utility/Device.vala"
				s = _tmp29_;
#line 1850 "Utility/Device.vala"
				_g_free0 (_tmp28_);
#line 1850 "Utility/Device.vala"
				_g_free0 (_tmp26_);
#line 11261 "Device.c"
			} else {
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
#line 1853 "Utility/Device.vala"
				_tmp30_ = s;
#line 1853 "Utility/Device.vala"
				_tmp31_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1853 "Utility/Device.vala"
				_tmp32_ = _tmp31_;
#line 1853 "Utility/Device.vala"
				_tmp33_ = g_strdup_printf (" (%s)", _tmp32_);
#line 1853 "Utility/Device.vala"
				_tmp34_ = _tmp33_;
#line 1853 "Utility/Device.vala"
				_tmp35_ = g_strconcat (_tmp30_, _tmp34_, NULL);
#line 1853 "Utility/Device.vala"
				_g_free0 (s);
#line 1853 "Utility/Device.vala"
				s = _tmp35_;
#line 1853 "Utility/Device.vala"
				_g_free0 (_tmp34_);
#line 1853 "Utility/Device.vala"
				_g_free0 (_tmp32_);
#line 11289 "Device.c"
			}
		}
	} else {
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_ = NULL;
		const gchar* _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_ = NULL;
		const gchar* _tmp57_;
		gint _tmp58_;
		gint _tmp59_;
		const gchar* _tmp63_;
		gchar* _tmp64_;
#line 1858 "Utility/Device.vala"
		_tmp36_ = s;
#line 1858 "Utility/Device.vala"
		_tmp37_ = device_get_short_name_with_parent (self);
#line 1858 "Utility/Device.vala"
		_tmp38_ = _tmp37_;
#line 1858 "Utility/Device.vala"
		_tmp39_ = _tmp38_;
#line 1858 "Utility/Device.vala"
		_tmp40_ = g_strconcat ("<b>", _tmp39_, NULL);
#line 1858 "Utility/Device.vala"
		_tmp41_ = _tmp40_;
#line 1858 "Utility/Device.vala"
		_tmp42_ = g_strconcat (_tmp41_, "</b>", NULL);
#line 1858 "Utility/Device.vala"
		_tmp43_ = _tmp42_;
#line 1858 "Utility/Device.vala"
		_tmp44_ = g_strconcat (_tmp36_, _tmp43_, NULL);
#line 1858 "Utility/Device.vala"
		_g_free0 (s);
#line 1858 "Utility/Device.vala"
		s = _tmp44_;
#line 1858 "Utility/Device.vala"
		_g_free0 (_tmp43_);
#line 1858 "Utility/Device.vala"
		_g_free0 (_tmp41_);
#line 1858 "Utility/Device.vala"
		_g_free0 (_tmp39_);
#line 1859 "Utility/Device.vala"
		_tmp46_ = self->label;
#line 1859 "Utility/Device.vala"
		_tmp47_ = strlen (_tmp46_);
#line 1859 "Utility/Device.vala"
		_tmp48_ = _tmp47_;
#line 1859 "Utility/Device.vala"
		if (_tmp48_ > 0) {
#line 11350 "Device.c"
			const gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
#line 1859 "Utility/Device.vala"
			_tmp49_ = self->label;
#line 1859 "Utility/Device.vala"
			_tmp50_ = g_strconcat (" (", _tmp49_, NULL);
#line 1859 "Utility/Device.vala"
			_tmp51_ = _tmp50_;
#line 1859 "Utility/Device.vala"
			_tmp52_ = g_strconcat (_tmp51_, ")", NULL);
#line 1859 "Utility/Device.vala"
			_g_free0 (_tmp45_);
#line 1859 "Utility/Device.vala"
			_tmp45_ = _tmp52_;
#line 1859 "Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 11369 "Device.c"
		} else {
			gchar* _tmp53_;
#line 1859 "Utility/Device.vala"
			_tmp53_ = g_strdup ("");
#line 1859 "Utility/Device.vala"
			_g_free0 (_tmp45_);
#line 1859 "Utility/Device.vala"
			_tmp45_ = _tmp53_;
#line 11378 "Device.c"
		}
#line 1859 "Utility/Device.vala"
		_tmp54_ = s;
#line 1859 "Utility/Device.vala"
		_tmp55_ = g_strconcat (_tmp54_, _tmp45_, NULL);
#line 1859 "Utility/Device.vala"
		_g_free0 (s);
#line 1859 "Utility/Device.vala"
		s = _tmp55_;
#line 1860 "Utility/Device.vala"
		_tmp57_ = self->fstype;
#line 1860 "Utility/Device.vala"
		_tmp58_ = strlen (_tmp57_);
#line 1860 "Utility/Device.vala"
		_tmp59_ = _tmp58_;
#line 1860 "Utility/Device.vala"
		if (_tmp59_ > 0) {
#line 11396 "Device.c"
			const gchar* _tmp60_;
			gchar* _tmp61_;
#line 1860 "Utility/Device.vala"
			_tmp60_ = self->fstype;
#line 1860 "Utility/Device.vala"
			_tmp61_ = g_strconcat (" ~ ", _tmp60_, NULL);
#line 1860 "Utility/Device.vala"
			_g_free0 (_tmp56_);
#line 1860 "Utility/Device.vala"
			_tmp56_ = _tmp61_;
#line 11407 "Device.c"
		} else {
			gchar* _tmp62_;
#line 1860 "Utility/Device.vala"
			_tmp62_ = g_strdup ("");
#line 1860 "Utility/Device.vala"
			_g_free0 (_tmp56_);
#line 1860 "Utility/Device.vala"
			_tmp56_ = _tmp62_;
#line 11416 "Device.c"
		}
#line 1860 "Utility/Device.vala"
		_tmp63_ = s;
#line 1860 "Utility/Device.vala"
		_tmp64_ = g_strconcat (_tmp63_, _tmp56_, NULL);
#line 1860 "Utility/Device.vala"
		_g_free0 (s);
#line 1860 "Utility/Device.vala"
		s = _tmp64_;
#line 1861 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 11428 "Device.c"
			const gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
			gchar* _tmp69_;
			gchar* _tmp70_;
#line 1862 "Utility/Device.vala"
			_tmp65_ = s;
#line 1862 "Utility/Device.vala"
			_tmp66_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1862 "Utility/Device.vala"
			_tmp67_ = _tmp66_;
#line 1862 "Utility/Device.vala"
			_tmp68_ = g_strdup_printf (" (%s)", _tmp67_);
#line 1862 "Utility/Device.vala"
			_tmp69_ = _tmp68_;
#line 1862 "Utility/Device.vala"
			_tmp70_ = g_strconcat (_tmp65_, _tmp69_, NULL);
#line 1862 "Utility/Device.vala"
			_g_free0 (s);
#line 1862 "Utility/Device.vala"
			s = _tmp70_;
#line 1862 "Utility/Device.vala"
			_g_free0 (_tmp69_);
#line 1862 "Utility/Device.vala"
			_g_free0 (_tmp67_);
#line 11455 "Device.c"
		}
#line 1841 "Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1841 "Utility/Device.vala"
		_g_free0 (_tmp45_);
#line 11461 "Device.c"
	}
#line 1866 "Utility/Device.vala"
	_tmp71_ = s;
#line 1866 "Utility/Device.vala"
	_tmp72_ = string_strip (_tmp71_);
#line 1866 "Utility/Device.vala"
	result = _tmp72_;
#line 1866 "Utility/Device.vala"
	_g_free0 (s);
#line 1866 "Utility/Device.vala"
	return result;
#line 11473 "Device.c"
}

gchar*
device_description_full_free (Device* self)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* result = NULL;
#line 1869 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1870 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1870 "Utility/Device.vala"
	s = _tmp0_;
#line 1872 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 1872 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 11493 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 1873 "Utility/Device.vala"
		_tmp2_ = s;
#line 1873 "Utility/Device.vala"
		_tmp3_ = self->model;
#line 1873 "Utility/Device.vala"
		_tmp4_ = self->vendor;
#line 1873 "Utility/Device.vala"
		_tmp5_ = g_strdup_printf ("%s %s", _tmp3_, _tmp4_);
#line 1873 "Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 1873 "Utility/Device.vala"
		_tmp7_ = string_strip (_tmp6_);
#line 1873 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1873 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp2_, _tmp8_, NULL);
#line 1873 "Utility/Device.vala"
		_g_free0 (s);
#line 1873 "Utility/Device.vala"
		s = _tmp9_;
#line 1873 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 1873 "Utility/Device.vala"
		_g_free0 (_tmp6_);
#line 1874 "Utility/Device.vala"
		_tmp10_ = s;
#line 1874 "Utility/Device.vala"
		_tmp11_ = strlen (_tmp10_);
#line 1874 "Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1874 "Utility/Device.vala"
		if (_tmp12_ == 0) {
#line 11537 "Device.c"
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 1875 "Utility/Device.vala"
			_tmp13_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1875 "Utility/Device.vala"
			_tmp14_ = _tmp13_;
#line 1875 "Utility/Device.vala"
			_tmp15_ = g_strdup_printf ("%s Disk", _tmp14_);
#line 1875 "Utility/Device.vala"
			_g_free0 (s);
#line 1875 "Utility/Device.vala"
			s = _tmp15_;
#line 1875 "Utility/Device.vala"
			_g_free0 (_tmp14_);
#line 11553 "Device.c"
		} else {
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 1878 "Utility/Device.vala"
			_tmp16_ = s;
#line 1878 "Utility/Device.vala"
			_tmp17_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1878 "Utility/Device.vala"
			_tmp18_ = _tmp17_;
#line 1878 "Utility/Device.vala"
			_tmp19_ = g_strdup_printf (" (%s Disk)", _tmp18_);
#line 1878 "Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1878 "Utility/Device.vala"
			_tmp21_ = g_strconcat (_tmp16_, _tmp20_, NULL);
#line 1878 "Utility/Device.vala"
			_g_free0 (s);
#line 1878 "Utility/Device.vala"
			s = _tmp21_;
#line 1878 "Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 1878 "Utility/Device.vala"
			_g_free0 (_tmp18_);
#line 11581 "Device.c"
		}
	} else {
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		const gchar* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		guint64 _tmp41_;
		guint64 _tmp42_;
#line 1882 "Utility/Device.vala"
		_tmp22_ = s;
#line 1882 "Utility/Device.vala"
		_tmp23_ = self->kname;
#line 1882 "Utility/Device.vala"
		_tmp24_ = g_strconcat (_tmp22_, _tmp23_, NULL);
#line 1882 "Utility/Device.vala"
		_g_free0 (s);
#line 1882 "Utility/Device.vala"
		s = _tmp24_;
#line 1883 "Utility/Device.vala"
		_tmp25_ = self->label;
#line 1883 "Utility/Device.vala"
		_tmp26_ = strlen (_tmp25_);
#line 1883 "Utility/Device.vala"
		_tmp27_ = _tmp26_;
#line 1883 "Utility/Device.vala"
		if (_tmp27_ > 0) {
#line 11613 "Device.c"
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
#line 1884 "Utility/Device.vala"
			_tmp28_ = s;
#line 1884 "Utility/Device.vala"
			_tmp29_ = self->label;
#line 1884 "Utility/Device.vala"
			_tmp30_ = g_strdup_printf (" (%s)", _tmp29_);
#line 1884 "Utility/Device.vala"
			_tmp31_ = _tmp30_;
#line 1884 "Utility/Device.vala"
			_tmp32_ = g_strconcat (_tmp28_, _tmp31_, NULL);
#line 1884 "Utility/Device.vala"
			_g_free0 (s);
#line 1884 "Utility/Device.vala"
			s = _tmp32_;
#line 1884 "Utility/Device.vala"
			_g_free0 (_tmp31_);
#line 11635 "Device.c"
		}
#line 1886 "Utility/Device.vala"
		_tmp33_ = self->fstype;
#line 1886 "Utility/Device.vala"
		_tmp34_ = strlen (_tmp33_);
#line 1886 "Utility/Device.vala"
		_tmp35_ = _tmp34_;
#line 1886 "Utility/Device.vala"
		if (_tmp35_ > 0) {
#line 11645 "Device.c"
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
#line 1887 "Utility/Device.vala"
			_tmp36_ = s;
#line 1887 "Utility/Device.vala"
			_tmp37_ = self->fstype;
#line 1887 "Utility/Device.vala"
			_tmp38_ = g_strdup_printf (" ~ %s", _tmp37_);
#line 1887 "Utility/Device.vala"
			_tmp39_ = _tmp38_;
#line 1887 "Utility/Device.vala"
			_tmp40_ = g_strconcat (_tmp36_, _tmp39_, NULL);
#line 1887 "Utility/Device.vala"
			_g_free0 (s);
#line 1887 "Utility/Device.vala"
			s = _tmp40_;
#line 1887 "Utility/Device.vala"
			_g_free0 (_tmp39_);
#line 11667 "Device.c"
		}
#line 1889 "Utility/Device.vala"
		_tmp41_ = device_get_free_bytes (self);
#line 1889 "Utility/Device.vala"
		_tmp42_ = _tmp41_;
#line 1889 "Utility/Device.vala"
		if (_tmp42_ > ((guint64) 0)) {
#line 11675 "Device.c"
			const gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
#line 1890 "Utility/Device.vala"
			_tmp43_ = s;
#line 1890 "Utility/Device.vala"
			_tmp44_ = device_description_free (self);
#line 1890 "Utility/Device.vala"
			_tmp45_ = _tmp44_;
#line 1890 "Utility/Device.vala"
			_tmp46_ = g_strdup_printf (" ~ %s", _tmp45_);
#line 1890 "Utility/Device.vala"
			_tmp47_ = _tmp46_;
#line 1890 "Utility/Device.vala"
			_tmp48_ = g_strconcat (_tmp43_, _tmp47_, NULL);
#line 1890 "Utility/Device.vala"
			_g_free0 (s);
#line 1890 "Utility/Device.vala"
			s = _tmp48_;
#line 1890 "Utility/Device.vala"
			_g_free0 (_tmp47_);
#line 1890 "Utility/Device.vala"
			_g_free0 (_tmp45_);
#line 11702 "Device.c"
		}
	}
#line 1894 "Utility/Device.vala"
	result = s;
#line 1894 "Utility/Device.vala"
	return result;
#line 11709 "Device.c"
}

gchar*
device_description_full (Device* self)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	const gchar* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_ = NULL;
	const gchar* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_ = NULL;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gboolean _tmp39_;
	const gchar* _tmp59_;
	gchar* _tmp60_;
	gchar* result = NULL;
#line 1897 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1898 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1898 "Utility/Device.vala"
	s = _tmp0_;
#line 1899 "Utility/Device.vala"
	_tmp1_ = s;
#line 1899 "Utility/Device.vala"
	_tmp2_ = self->device;
#line 1899 "Utility/Device.vala"
	_tmp3_ = g_strconcat (_tmp1_, _tmp2_, NULL);
#line 1899 "Utility/Device.vala"
	_g_free0 (s);
#line 1899 "Utility/Device.vala"
	s = _tmp3_;
#line 1900 "Utility/Device.vala"
	_tmp5_ = self->label;
#line 1900 "Utility/Device.vala"
	_tmp6_ = strlen (_tmp5_);
#line 1900 "Utility/Device.vala"
	_tmp7_ = _tmp6_;
#line 1900 "Utility/Device.vala"
	if (_tmp7_ > 0) {
#line 11772 "Device.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1900 "Utility/Device.vala"
		_tmp8_ = self->label;
#line 1900 "Utility/Device.vala"
		_tmp9_ = g_strconcat (" (", _tmp8_, NULL);
#line 1900 "Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1900 "Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp10_, ")", NULL);
#line 1900 "Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 1900 "Utility/Device.vala"
		_tmp4_ = _tmp11_;
#line 1900 "Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 11791 "Device.c"
	} else {
		gchar* _tmp12_;
#line 1900 "Utility/Device.vala"
		_tmp12_ = g_strdup ("");
#line 1900 "Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 1900 "Utility/Device.vala"
		_tmp4_ = _tmp12_;
#line 11800 "Device.c"
	}
#line 1900 "Utility/Device.vala"
	_tmp13_ = s;
#line 1900 "Utility/Device.vala"
	_tmp14_ = g_strconcat (_tmp13_, _tmp4_, NULL);
#line 1900 "Utility/Device.vala"
	_g_free0 (s);
#line 1900 "Utility/Device.vala"
	s = _tmp14_;
#line 1901 "Utility/Device.vala"
	_tmp16_ = self->uuid;
#line 1901 "Utility/Device.vala"
	_tmp17_ = strlen (_tmp16_);
#line 1901 "Utility/Device.vala"
	_tmp18_ = _tmp17_;
#line 1901 "Utility/Device.vala"
	if (_tmp18_ > 0) {
#line 11818 "Device.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 1901 "Utility/Device.vala"
		_tmp19_ = self->uuid;
#line 1901 "Utility/Device.vala"
		_tmp20_ = g_strconcat (" ~ ", _tmp19_, NULL);
#line 1901 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1901 "Utility/Device.vala"
		_tmp15_ = _tmp20_;
#line 11829 "Device.c"
	} else {
		gchar* _tmp21_;
#line 1901 "Utility/Device.vala"
		_tmp21_ = g_strdup ("");
#line 1901 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1901 "Utility/Device.vala"
		_tmp15_ = _tmp21_;
#line 11838 "Device.c"
	}
#line 1901 "Utility/Device.vala"
	_tmp22_ = s;
#line 1901 "Utility/Device.vala"
	_tmp23_ = g_strconcat (_tmp22_, _tmp15_, NULL);
#line 1901 "Utility/Device.vala"
	_g_free0 (s);
#line 1901 "Utility/Device.vala"
	s = _tmp23_;
#line 1902 "Utility/Device.vala"
	_tmp25_ = self->fstype;
#line 1902 "Utility/Device.vala"
	_tmp26_ = strlen (_tmp25_);
#line 1902 "Utility/Device.vala"
	_tmp27_ = _tmp26_;
#line 1902 "Utility/Device.vala"
	if (_tmp27_ > 0) {
#line 11856 "Device.c"
		const gchar* _tmp28_;
		gchar* _tmp29_;
#line 1902 "Utility/Device.vala"
		_tmp28_ = self->fstype;
#line 1902 "Utility/Device.vala"
		_tmp29_ = g_strconcat (" ~ ", _tmp28_, NULL);
#line 1902 "Utility/Device.vala"
		_g_free0 (_tmp24_);
#line 1902 "Utility/Device.vala"
		_tmp24_ = _tmp29_;
#line 11867 "Device.c"
	} else {
		gchar* _tmp30_;
#line 1902 "Utility/Device.vala"
		_tmp30_ = g_strdup ("");
#line 1902 "Utility/Device.vala"
		_g_free0 (_tmp24_);
#line 1902 "Utility/Device.vala"
		_tmp24_ = _tmp30_;
#line 11876 "Device.c"
	}
#line 1902 "Utility/Device.vala"
	_tmp31_ = s;
#line 1902 "Utility/Device.vala"
	_tmp32_ = g_strconcat (_tmp31_, _tmp24_, NULL);
#line 1902 "Utility/Device.vala"
	_g_free0 (s);
#line 1902 "Utility/Device.vala"
	s = _tmp32_;
#line 1903 "Utility/Device.vala"
	_tmp34_ = device_get_used (self);
#line 1903 "Utility/Device.vala"
	_tmp35_ = _tmp34_;
#line 1903 "Utility/Device.vala"
	_tmp36_ = _tmp35_;
#line 1903 "Utility/Device.vala"
	_tmp37_ = strlen (_tmp36_);
#line 1903 "Utility/Device.vala"
	_tmp38_ = _tmp37_;
#line 1903 "Utility/Device.vala"
	_tmp39_ = _tmp38_ > 0;
#line 1903 "Utility/Device.vala"
	_g_free0 (_tmp36_);
#line 1903 "Utility/Device.vala"
	if (_tmp39_) {
#line 11902 "Device.c"
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
#line 1903 "Utility/Device.vala"
		_tmp40_ = device_get_used (self);
#line 1903 "Utility/Device.vala"
		_tmp41_ = _tmp40_;
#line 1903 "Utility/Device.vala"
		_tmp42_ = _tmp41_;
#line 1903 "Utility/Device.vala"
		_tmp43_ = g_strconcat (" ~ ", _tmp42_, NULL);
#line 1903 "Utility/Device.vala"
		_tmp44_ = _tmp43_;
#line 1903 "Utility/Device.vala"
		_tmp45_ = g_strconcat (_tmp44_, " / ", NULL);
#line 1903 "Utility/Device.vala"
		_tmp46_ = _tmp45_;
#line 1903 "Utility/Device.vala"
		_tmp47_ = device_get_size (self);
#line 1903 "Utility/Device.vala"
		_tmp48_ = _tmp47_;
#line 1903 "Utility/Device.vala"
		_tmp49_ = _tmp48_;
#line 1903 "Utility/Device.vala"
		_tmp50_ = g_strconcat (_tmp46_, _tmp49_, NULL);
#line 1903 "Utility/Device.vala"
		_tmp51_ = _tmp50_;
#line 1903 "Utility/Device.vala"
		_tmp52_ = g_strconcat (_tmp51_, " GB used (", NULL);
#line 1903 "Utility/Device.vala"
		_tmp53_ = _tmp52_;
#line 1903 "Utility/Device.vala"
		_tmp54_ = self->used_percent;
#line 1903 "Utility/Device.vala"
		_tmp55_ = g_strconcat (_tmp53_, _tmp54_, NULL);
#line 1903 "Utility/Device.vala"
		_tmp56_ = _tmp55_;
#line 1903 "Utility/Device.vala"
		_tmp57_ = g_strconcat (_tmp56_, ")", NULL);
#line 1903 "Utility/Device.vala"
		_g_free0 (_tmp33_);
#line 1903 "Utility/Device.vala"
		_tmp33_ = _tmp57_;
#line 1903 "Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1903 "Utility/Device.vala"
		_g_free0 (_tmp53_);
#line 1903 "Utility/Device.vala"
		_g_free0 (_tmp51_);
#line 1903 "Utility/Device.vala"
		_g_free0 (_tmp49_);
#line 1903 "Utility/Device.vala"
		_g_free0 (_tmp46_);
#line 1903 "Utility/Device.vala"
		_g_free0 (_tmp44_);
#line 1903 "Utility/Device.vala"
		_g_free0 (_tmp42_);
#line 11975 "Device.c"
	} else {
		gchar* _tmp58_;
#line 1903 "Utility/Device.vala"
		_tmp58_ = g_strdup ("");
#line 1903 "Utility/Device.vala"
		_g_free0 (_tmp33_);
#line 1903 "Utility/Device.vala"
		_tmp33_ = _tmp58_;
#line 11984 "Device.c"
	}
#line 1903 "Utility/Device.vala"
	_tmp59_ = s;
#line 1903 "Utility/Device.vala"
	_tmp60_ = g_strconcat (_tmp59_, _tmp33_, NULL);
#line 1903 "Utility/Device.vala"
	_g_free0 (s);
#line 1903 "Utility/Device.vala"
	s = _tmp60_;
#line 1905 "Utility/Device.vala"
	result = s;
#line 1905 "Utility/Device.vala"
	_g_free0 (_tmp33_);
#line 1905 "Utility/Device.vala"
	_g_free0 (_tmp24_);
#line 1905 "Utility/Device.vala"
	_g_free0 (_tmp15_);
#line 1905 "Utility/Device.vala"
	_g_free0 (_tmp4_);
#line 1905 "Utility/Device.vala"
	return result;
#line 12006 "Device.c"
}

gchar*
device_description_usage (Device* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	gchar* result = NULL;
#line 1908 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1909 "Utility/Device.vala"
	_tmp0_ = device_get_used (self);
#line 1909 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1909 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 1909 "Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1909 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1909 "Utility/Device.vala"
	_tmp5_ = _tmp4_ > 0;
#line 1909 "Utility/Device.vala"
	_g_free0 (_tmp2_);
#line 1909 "Utility/Device.vala"
	if (_tmp5_) {
#line 12037 "Device.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 1910 "Utility/Device.vala"
		_tmp6_ = device_get_used (self);
#line 1910 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1910 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1910 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp8_, " / ", NULL);
#line 1910 "Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1910 "Utility/Device.vala"
		_tmp11_ = device_get_size (self);
#line 1910 "Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1910 "Utility/Device.vala"
		_tmp13_ = _tmp12_;
#line 1910 "Utility/Device.vala"
		_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
#line 1910 "Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1910 "Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp15_, " used (", NULL);
#line 1910 "Utility/Device.vala"
		_tmp17_ = _tmp16_;
#line 1910 "Utility/Device.vala"
		_tmp18_ = self->used_percent;
#line 1910 "Utility/Device.vala"
		_tmp19_ = g_strconcat (_tmp17_, _tmp18_, NULL);
#line 1910 "Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1910 "Utility/Device.vala"
		_tmp21_ = g_strconcat (_tmp20_, ")", NULL);
#line 1910 "Utility/Device.vala"
		_tmp22_ = _tmp21_;
#line 1910 "Utility/Device.vala"
		_g_free0 (_tmp20_);
#line 1910 "Utility/Device.vala"
		_g_free0 (_tmp17_);
#line 1910 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1910 "Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 1910 "Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 1910 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 1910 "Utility/Device.vala"
		result = _tmp22_;
#line 1910 "Utility/Device.vala"
		return result;
#line 12105 "Device.c"
	} else {
		gchar* _tmp23_;
#line 1913 "Utility/Device.vala"
		_tmp23_ = g_strdup ("");
#line 1913 "Utility/Device.vala"
		result = _tmp23_;
#line 1913 "Utility/Device.vala"
		return result;
#line 12114 "Device.c"
	}
}

gchar*
device_description_free (Device* self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
	gchar* result = NULL;
#line 1917 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1918 "Utility/Device.vala"
	_tmp0_ = device_get_used (self);
#line 1918 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1918 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 1918 "Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1918 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1918 "Utility/Device.vala"
	_tmp5_ = _tmp4_ > 0;
#line 1918 "Utility/Device.vala"
	_g_free0 (_tmp2_);
#line 1918 "Utility/Device.vala"
	if (_tmp5_) {
#line 12146 "Device.c"
		guint64 _tmp6_;
		guint64 _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 1919 "Utility/Device.vala"
		_tmp6_ = device_get_free_bytes (self);
#line 1919 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1919 "Utility/Device.vala"
		_tmp8_ = tee_jee_file_system_format_file_size (_tmp7_, FALSE, "g", FALSE, 1);
#line 1919 "Utility/Device.vala"
		_tmp9_ = _tmp8_;
#line 1919 "Utility/Device.vala"
		_tmp10_ = g_strconcat (_tmp9_, " / ", NULL);
#line 1919 "Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1919 "Utility/Device.vala"
		_tmp12_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "g", TRUE, 1);
#line 1919 "Utility/Device.vala"
		_tmp13_ = _tmp12_;
#line 1919 "Utility/Device.vala"
		_tmp14_ = g_strconcat (_tmp11_, _tmp13_, NULL);
#line 1919 "Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1919 "Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp15_, " free", NULL);
#line 1919 "Utility/Device.vala"
		_tmp17_ = _tmp16_;
#line 1919 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1919 "Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 1919 "Utility/Device.vala"
		_g_free0 (_tmp11_);
#line 1919 "Utility/Device.vala"
		_g_free0 (_tmp9_);
#line 1919 "Utility/Device.vala"
		result = _tmp17_;
#line 1919 "Utility/Device.vala"
		return result;
#line 12195 "Device.c"
	} else {
		gchar* _tmp18_;
#line 1923 "Utility/Device.vala"
		_tmp18_ = g_strdup ("");
#line 1923 "Utility/Device.vala"
		result = _tmp18_;
#line 1923 "Utility/Device.vala"
		return result;
#line 12204 "Device.c"
	}
}

gchar*
device_tooltip_text (Device* self)
{
	gchar* tt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp92_;
	gchar* _tmp93_;
	gchar* result = NULL;
#line 1927 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1928 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1928 "Utility/Device.vala"
	tt = _tmp0_;
#line 1930 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 1930 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 12227 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_ = NULL;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
#line 1931 "Utility/Device.vala"
		_tmp2_ = tt;
#line 1931 "Utility/Device.vala"
		_tmp3_ = self->device;
#line 1931 "Utility/Device.vala"
		_tmp4_ = g_strdup_printf ("%-15s: %s\n", _ ("Device"), _tmp3_);
#line 1931 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1931 "Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
#line 1931 "Utility/Device.vala"
		_g_free0 (tt);
#line 1931 "Utility/Device.vala"
		tt = _tmp6_;
#line 1931 "Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1932 "Utility/Device.vala"
		_tmp7_ = tt;
#line 1932 "Utility/Device.vala"
		_tmp8_ = self->vendor;
#line 1932 "Utility/Device.vala"
		_tmp9_ = g_strdup_printf ("%-15s: %s\n", _ ("Vendor"), _tmp8_);
#line 1932 "Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1932 "Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp7_, _tmp10_, NULL);
#line 1932 "Utility/Device.vala"
		_g_free0 (tt);
#line 1932 "Utility/Device.vala"
		tt = _tmp11_;
#line 1932 "Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 1933 "Utility/Device.vala"
		_tmp12_ = tt;
#line 1933 "Utility/Device.vala"
		_tmp13_ = self->model;
#line 1933 "Utility/Device.vala"
		_tmp14_ = g_strdup_printf ("%-15s: %s\n", _ ("Model"), _tmp13_);
#line 1933 "Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1933 "Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 1933 "Utility/Device.vala"
		_g_free0 (tt);
#line 1933 "Utility/Device.vala"
		tt = _tmp16_;
#line 1933 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1934 "Utility/Device.vala"
		_tmp17_ = tt;
#line 1934 "Utility/Device.vala"
		_tmp18_ = self->serial;
#line 1934 "Utility/Device.vala"
		_tmp19_ = g_strdup_printf ("%-15s: %s\n", _ ("Serial"), _tmp18_);
#line 1934 "Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1934 "Utility/Device.vala"
		_tmp21_ = g_strconcat (_tmp17_, _tmp20_, NULL);
#line 1934 "Utility/Device.vala"
		_g_free0 (tt);
#line 1934 "Utility/Device.vala"
		tt = _tmp21_;
#line 1934 "Utility/Device.vala"
		_g_free0 (_tmp20_);
#line 1935 "Utility/Device.vala"
		_tmp22_ = tt;
#line 1935 "Utility/Device.vala"
		_tmp23_ = self->revision;
#line 1935 "Utility/Device.vala"
		_tmp24_ = g_strdup_printf ("%-15s: %s\n", _ ("Revision"), _tmp23_);
#line 1935 "Utility/Device.vala"
		_tmp25_ = _tmp24_;
#line 1935 "Utility/Device.vala"
		_tmp26_ = g_strconcat (_tmp22_, _tmp25_, NULL);
#line 1935 "Utility/Device.vala"
		_g_free0 (tt);
#line 1935 "Utility/Device.vala"
		tt = _tmp26_;
#line 1935 "Utility/Device.vala"
		_g_free0 (_tmp25_);
#line 1938 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 12340 "Device.c"
			gchar* _tmp28_;
#line 1938 "Utility/Device.vala"
			_tmp28_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1938 "Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 1938 "Utility/Device.vala"
			_tmp27_ = _tmp28_;
#line 12348 "Device.c"
		} else {
			gchar* _tmp29_;
#line 1938 "Utility/Device.vala"
			_tmp29_ = g_strdup ("N/A");
#line 1938 "Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 1938 "Utility/Device.vala"
			_tmp27_ = _tmp29_;
#line 12357 "Device.c"
		}
#line 1937 "Utility/Device.vala"
		_tmp30_ = tt;
#line 1937 "Utility/Device.vala"
		_tmp31_ = g_strdup_printf ("%-15s: %s\n", _ ("Size"), _tmp27_);
#line 1937 "Utility/Device.vala"
		_tmp32_ = _tmp31_;
#line 1937 "Utility/Device.vala"
		_tmp33_ = g_strconcat (_tmp30_, _tmp32_, NULL);
#line 1937 "Utility/Device.vala"
		_g_free0 (tt);
#line 1937 "Utility/Device.vala"
		tt = _tmp33_;
#line 1937 "Utility/Device.vala"
		_g_free0 (_tmp32_);
#line 1930 "Utility/Device.vala"
		_g_free0 (_tmp27_);
#line 12375 "Device.c"
	} else {
		gchar* _tmp34_ = NULL;
		const gchar* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		const gchar* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		const gchar* _tmp58_;
		const gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		const gchar* _tmp63_;
		const gchar* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		const gchar* _tmp68_;
		const gchar* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_ = NULL;
		const gchar* _tmp76_;
		gchar* _tmp77_;
		gchar* _tmp78_;
		gchar* _tmp79_;
		gchar* _tmp80_ = NULL;
		const gchar* _tmp83_;
		gchar* _tmp84_;
		gchar* _tmp85_;
		gchar* _tmp86_;
		const gchar* _tmp87_;
		const gchar* _tmp88_;
		gchar* _tmp89_;
		gchar* _tmp90_;
		gchar* _tmp91_;
#line 1942 "Utility/Device.vala"
		_tmp35_ = self->mapped_name;
#line 1942 "Utility/Device.vala"
		_tmp36_ = strlen (_tmp35_);
#line 1942 "Utility/Device.vala"
		_tmp37_ = _tmp36_;
#line 1942 "Utility/Device.vala"
		if (_tmp37_ > 0) {
#line 12428 "Device.c"
			const gchar* _tmp38_;
			const gchar* _tmp39_;
			gchar* _tmp40_;
#line 1942 "Utility/Device.vala"
			_tmp38_ = self->device;
#line 1942 "Utility/Device.vala"
			_tmp39_ = self->mapped_name;
#line 1942 "Utility/Device.vala"
			_tmp40_ = g_strdup_printf ("%s → %s", _tmp38_, _tmp39_);
#line 1942 "Utility/Device.vala"
			_g_free0 (_tmp34_);
#line 1942 "Utility/Device.vala"
			_tmp34_ = _tmp40_;
#line 12442 "Device.c"
		} else {
			const gchar* _tmp41_;
			gchar* _tmp42_;
#line 1942 "Utility/Device.vala"
			_tmp41_ = self->device;
#line 1942 "Utility/Device.vala"
			_tmp42_ = g_strdup (_tmp41_);
#line 1942 "Utility/Device.vala"
			_g_free0 (_tmp34_);
#line 1942 "Utility/Device.vala"
			_tmp34_ = _tmp42_;
#line 12454 "Device.c"
		}
#line 1941 "Utility/Device.vala"
		_tmp43_ = tt;
#line 1941 "Utility/Device.vala"
		_tmp44_ = g_strdup_printf ("%-15s: %s\n", _ ("Device"), _tmp34_);
#line 1941 "Utility/Device.vala"
		_tmp45_ = _tmp44_;
#line 1941 "Utility/Device.vala"
		_tmp46_ = g_strconcat (_tmp43_, _tmp45_, NULL);
#line 1941 "Utility/Device.vala"
		_g_free0 (tt);
#line 1941 "Utility/Device.vala"
		tt = _tmp46_;
#line 1941 "Utility/Device.vala"
		_g_free0 (_tmp45_);
#line 1944 "Utility/Device.vala"
		if (device_has_parent (self)) {
#line 12472 "Device.c"
			const gchar* _tmp47_;
			Device* _tmp48_;
			const gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
#line 1945 "Utility/Device.vala"
			_tmp47_ = tt;
#line 1945 "Utility/Device.vala"
			_tmp48_ = self->parent;
#line 1945 "Utility/Device.vala"
			_tmp49_ = _tmp48_->device;
#line 1945 "Utility/Device.vala"
			_tmp50_ = g_strdup_printf ("%-15s: %s\n", _ ("Parent Device"), _tmp49_);
#line 1945 "Utility/Device.vala"
			_tmp51_ = _tmp50_;
#line 1945 "Utility/Device.vala"
			_tmp52_ = g_strconcat (_tmp47_, _tmp51_, NULL);
#line 1945 "Utility/Device.vala"
			_g_free0 (tt);
#line 1945 "Utility/Device.vala"
			tt = _tmp52_;
#line 1945 "Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 12497 "Device.c"
		}
#line 1947 "Utility/Device.vala"
		_tmp53_ = tt;
#line 1947 "Utility/Device.vala"
		_tmp54_ = self->uuid;
#line 1947 "Utility/Device.vala"
		_tmp55_ = g_strdup_printf ("%-15s: %s\n", _ ("UUID"), _tmp54_);
#line 1947 "Utility/Device.vala"
		_tmp56_ = _tmp55_;
#line 1947 "Utility/Device.vala"
		_tmp57_ = g_strconcat (_tmp53_, _tmp56_, NULL);
#line 1947 "Utility/Device.vala"
		_g_free0 (tt);
#line 1947 "Utility/Device.vala"
		tt = _tmp57_;
#line 1947 "Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1948 "Utility/Device.vala"
		_tmp58_ = tt;
#line 1948 "Utility/Device.vala"
		_tmp59_ = self->type;
#line 1948 "Utility/Device.vala"
		_tmp60_ = g_strdup_printf ("%-15s: %s\n", _ ("Type"), _tmp59_);
#line 1948 "Utility/Device.vala"
		_tmp61_ = _tmp60_;
#line 1948 "Utility/Device.vala"
		_tmp62_ = g_strconcat (_tmp58_, _tmp61_, NULL);
#line 1948 "Utility/Device.vala"
		_g_free0 (tt);
#line 1948 "Utility/Device.vala"
		tt = _tmp62_;
#line 1948 "Utility/Device.vala"
		_g_free0 (_tmp61_);
#line 1949 "Utility/Device.vala"
		_tmp63_ = tt;
#line 1949 "Utility/Device.vala"
		_tmp64_ = self->fstype;
#line 1949 "Utility/Device.vala"
		_tmp65_ = g_strdup_printf ("%-15s: %s\n", _ ("Filesystem"), _tmp64_);
#line 1949 "Utility/Device.vala"
		_tmp66_ = _tmp65_;
#line 1949 "Utility/Device.vala"
		_tmp67_ = g_strconcat (_tmp63_, _tmp66_, NULL);
#line 1949 "Utility/Device.vala"
		_g_free0 (tt);
#line 1949 "Utility/Device.vala"
		tt = _tmp67_;
#line 1949 "Utility/Device.vala"
		_g_free0 (_tmp66_);
#line 1950 "Utility/Device.vala"
		_tmp68_ = tt;
#line 1950 "Utility/Device.vala"
		_tmp69_ = self->label;
#line 1950 "Utility/Device.vala"
		_tmp70_ = g_strdup_printf ("%-15s: %s\n", _ ("Label"), _tmp69_);
#line 1950 "Utility/Device.vala"
		_tmp71_ = _tmp70_;
#line 1950 "Utility/Device.vala"
		_tmp72_ = g_strconcat (_tmp68_, _tmp71_, NULL);
#line 1950 "Utility/Device.vala"
		_g_free0 (tt);
#line 1950 "Utility/Device.vala"
		tt = _tmp72_;
#line 1950 "Utility/Device.vala"
		_g_free0 (_tmp71_);
#line 1953 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 12565 "Device.c"
			gchar* _tmp74_;
#line 1953 "Utility/Device.vala"
			_tmp74_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1953 "Utility/Device.vala"
			_g_free0 (_tmp73_);
#line 1953 "Utility/Device.vala"
			_tmp73_ = _tmp74_;
#line 12573 "Device.c"
		} else {
			gchar* _tmp75_;
#line 1953 "Utility/Device.vala"
			_tmp75_ = g_strdup ("N/A");
#line 1953 "Utility/Device.vala"
			_g_free0 (_tmp73_);
#line 1953 "Utility/Device.vala"
			_tmp73_ = _tmp75_;
#line 12582 "Device.c"
		}
#line 1952 "Utility/Device.vala"
		_tmp76_ = tt;
#line 1952 "Utility/Device.vala"
		_tmp77_ = g_strdup_printf ("%-15s: %s\n", _ ("Size"), _tmp73_);
#line 1952 "Utility/Device.vala"
		_tmp78_ = _tmp77_;
#line 1952 "Utility/Device.vala"
		_tmp79_ = g_strconcat (_tmp76_, _tmp78_, NULL);
#line 1952 "Utility/Device.vala"
		_g_free0 (tt);
#line 1952 "Utility/Device.vala"
		tt = _tmp79_;
#line 1952 "Utility/Device.vala"
		_g_free0 (_tmp78_);
#line 1956 "Utility/Device.vala"
		if (self->used_bytes > ((guint64) 0)) {
#line 12600 "Device.c"
			gchar* _tmp81_;
#line 1956 "Utility/Device.vala"
			_tmp81_ = tee_jee_file_system_format_file_size (self->used_bytes, FALSE, "", TRUE, 1);
#line 1956 "Utility/Device.vala"
			_g_free0 (_tmp80_);
#line 1956 "Utility/Device.vala"
			_tmp80_ = _tmp81_;
#line 12608 "Device.c"
		} else {
			gchar* _tmp82_;
#line 1956 "Utility/Device.vala"
			_tmp82_ = g_strdup ("N/A");
#line 1956 "Utility/Device.vala"
			_g_free0 (_tmp80_);
#line 1956 "Utility/Device.vala"
			_tmp80_ = _tmp82_;
#line 12617 "Device.c"
		}
#line 1955 "Utility/Device.vala"
		_tmp83_ = tt;
#line 1955 "Utility/Device.vala"
		_tmp84_ = g_strdup_printf ("%-15s: %s\n", _ ("Used"), _tmp80_);
#line 1955 "Utility/Device.vala"
		_tmp85_ = _tmp84_;
#line 1955 "Utility/Device.vala"
		_tmp86_ = g_strconcat (_tmp83_, _tmp85_, NULL);
#line 1955 "Utility/Device.vala"
		_g_free0 (tt);
#line 1955 "Utility/Device.vala"
		tt = _tmp86_;
#line 1955 "Utility/Device.vala"
		_g_free0 (_tmp85_);
#line 1958 "Utility/Device.vala"
		_tmp87_ = tt;
#line 1958 "Utility/Device.vala"
		_tmp88_ = self->dist_info;
#line 1958 "Utility/Device.vala"
		_tmp89_ = g_strdup_printf ("%-15s: %s\n", _ ("System"), _tmp88_);
#line 1958 "Utility/Device.vala"
		_tmp90_ = _tmp89_;
#line 1958 "Utility/Device.vala"
		_tmp91_ = g_strconcat (_tmp87_, _tmp90_, NULL);
#line 1958 "Utility/Device.vala"
		_g_free0 (tt);
#line 1958 "Utility/Device.vala"
		tt = _tmp91_;
#line 1958 "Utility/Device.vala"
		_g_free0 (_tmp90_);
#line 1930 "Utility/Device.vala"
		_g_free0 (_tmp80_);
#line 1930 "Utility/Device.vala"
		_g_free0 (_tmp73_);
#line 1930 "Utility/Device.vala"
		_g_free0 (_tmp34_);
#line 12655 "Device.c"
	}
#line 1961 "Utility/Device.vala"
	_tmp92_ = tt;
#line 1961 "Utility/Device.vala"
	_tmp93_ = g_strdup_printf ("<tt>%s</tt>", _tmp92_);
#line 1961 "Utility/Device.vala"
	result = _tmp93_;
#line 1961 "Utility/Device.vala"
	_g_free0 (tt);
#line 1961 "Utility/Device.vala"
	return result;
#line 12667 "Device.c"
}

static gchar*
device_display_name (Device* self,
                     gboolean short_name,
                     gboolean show_label,
                     gboolean show_parent,
                     gboolean show_alias)
{
	gchar* txt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp7_;
	gchar* result = NULL;
#line 1964 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1966 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1966 "Utility/Device.vala"
	txt = _tmp0_;
#line 1968 "Utility/Device.vala"
	if (short_name) {
#line 12689 "Device.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 1969 "Utility/Device.vala"
		_tmp1_ = txt;
#line 1969 "Utility/Device.vala"
		_tmp2_ = self->kname;
#line 1969 "Utility/Device.vala"
		_tmp3_ = g_strconcat (_tmp1_, _tmp2_, NULL);
#line 1969 "Utility/Device.vala"
		_g_free0 (txt);
#line 1969 "Utility/Device.vala"
		txt = _tmp3_;
#line 12703 "Device.c"
	} else {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 1972 "Utility/Device.vala"
		_tmp4_ = txt;
#line 1972 "Utility/Device.vala"
		_tmp5_ = self->device;
#line 1972 "Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp4_, _tmp5_, NULL);
#line 1972 "Utility/Device.vala"
		_g_free0 (txt);
#line 1972 "Utility/Device.vala"
		txt = _tmp6_;
#line 12718 "Device.c"
	}
#line 1975 "Utility/Device.vala"
	_tmp7_ = self->type;
#line 1975 "Utility/Device.vala"
	if (g_strcmp0 (_tmp7_, "disk") == 0) {
#line 12724 "Device.c"
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		const gchar* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 1976 "Utility/Device.vala"
		_tmp8_ = self->vendor;
#line 1976 "Utility/Device.vala"
		_tmp9_ = strlen (_tmp8_);
#line 1976 "Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1976 "Utility/Device.vala"
		if (_tmp10_ > 0) {
#line 12739 "Device.c"
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 1977 "Utility/Device.vala"
			_tmp11_ = txt;
#line 1977 "Utility/Device.vala"
			_tmp12_ = self->vendor;
#line 1977 "Utility/Device.vala"
			_tmp13_ = g_strconcat (" ", _tmp12_, NULL);
#line 1977 "Utility/Device.vala"
			_tmp14_ = _tmp13_;
#line 1977 "Utility/Device.vala"
			_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 1977 "Utility/Device.vala"
			_g_free0 (txt);
#line 1977 "Utility/Device.vala"
			txt = _tmp15_;
#line 1977 "Utility/Device.vala"
			_g_free0 (_tmp14_);
#line 12761 "Device.c"
		}
#line 1979 "Utility/Device.vala"
		_tmp16_ = self->model;
#line 1979 "Utility/Device.vala"
		_tmp17_ = strlen (_tmp16_);
#line 1979 "Utility/Device.vala"
		_tmp18_ = _tmp17_;
#line 1979 "Utility/Device.vala"
		if (_tmp18_ > 0) {
#line 12771 "Device.c"
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 1980 "Utility/Device.vala"
			_tmp19_ = txt;
#line 1980 "Utility/Device.vala"
			_tmp20_ = self->model;
#line 1980 "Utility/Device.vala"
			_tmp21_ = g_strconcat (" ", _tmp20_, NULL);
#line 1980 "Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 1980 "Utility/Device.vala"
			_tmp23_ = g_strconcat (_tmp19_, _tmp22_, NULL);
#line 1980 "Utility/Device.vala"
			_g_free0 (txt);
#line 1980 "Utility/Device.vala"
			txt = _tmp23_;
#line 1980 "Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 12793 "Device.c"
		}
#line 1982 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 12797 "Device.c"
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
			gboolean _tmp29_;
#line 1983 "Utility/Device.vala"
			_tmp24_ = txt;
#line 1983 "Utility/Device.vala"
			_tmp25_ = string_strip (_tmp24_);
#line 1983 "Utility/Device.vala"
			_tmp26_ = _tmp25_;
#line 1983 "Utility/Device.vala"
			_tmp27_ = strlen (_tmp26_);
#line 1983 "Utility/Device.vala"
			_tmp28_ = _tmp27_;
#line 1983 "Utility/Device.vala"
			_tmp29_ = _tmp28_ == 0;
#line 1983 "Utility/Device.vala"
			_g_free0 (_tmp26_);
#line 1983 "Utility/Device.vala"
			if (_tmp29_) {
#line 12820 "Device.c"
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
#line 1984 "Utility/Device.vala"
				_tmp30_ = txt;
#line 1984 "Utility/Device.vala"
				_tmp31_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1984 "Utility/Device.vala"
				_tmp32_ = _tmp31_;
#line 1984 "Utility/Device.vala"
				_tmp33_ = g_strdup_printf ("%s Device", _tmp32_);
#line 1984 "Utility/Device.vala"
				_tmp34_ = _tmp33_;
#line 1984 "Utility/Device.vala"
				_tmp35_ = g_strconcat (_tmp30_, _tmp34_, NULL);
#line 1984 "Utility/Device.vala"
				_g_free0 (txt);
#line 1984 "Utility/Device.vala"
				txt = _tmp35_;
#line 1984 "Utility/Device.vala"
				_g_free0 (_tmp34_);
#line 1984 "Utility/Device.vala"
				_g_free0 (_tmp32_);
#line 12847 "Device.c"
			} else {
				const gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
#line 1987 "Utility/Device.vala"
				_tmp36_ = txt;
#line 1987 "Utility/Device.vala"
				_tmp37_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1987 "Utility/Device.vala"
				_tmp38_ = _tmp37_;
#line 1987 "Utility/Device.vala"
				_tmp39_ = g_strdup_printf (" (%s)", _tmp38_);
#line 1987 "Utility/Device.vala"
				_tmp40_ = _tmp39_;
#line 1987 "Utility/Device.vala"
				_tmp41_ = g_strconcat (_tmp36_, _tmp40_, NULL);
#line 1987 "Utility/Device.vala"
				_g_free0 (txt);
#line 1987 "Utility/Device.vala"
				txt = _tmp41_;
#line 1987 "Utility/Device.vala"
				_g_free0 (_tmp40_);
#line 1987 "Utility/Device.vala"
				_g_free0 (_tmp38_);
#line 12875 "Device.c"
			}
		}
	} else {
		gboolean _tmp42_ = FALSE;
		gboolean _tmp51_ = FALSE;
		gboolean _tmp52_ = FALSE;
		gboolean _tmp60_ = FALSE;
#line 1992 "Utility/Device.vala"
		if (show_label) {
#line 12885 "Device.c"
			const gchar* _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
#line 1992 "Utility/Device.vala"
			_tmp43_ = self->label;
#line 1992 "Utility/Device.vala"
			_tmp44_ = strlen (_tmp43_);
#line 1992 "Utility/Device.vala"
			_tmp45_ = _tmp44_;
#line 1992 "Utility/Device.vala"
			_tmp42_ = _tmp45_ > 0;
#line 12897 "Device.c"
		} else {
#line 1992 "Utility/Device.vala"
			_tmp42_ = FALSE;
#line 12901 "Device.c"
		}
#line 1992 "Utility/Device.vala"
		if (_tmp42_) {
#line 12905 "Device.c"
			const gchar* _tmp46_;
			const gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
#line 1993 "Utility/Device.vala"
			_tmp46_ = txt;
#line 1993 "Utility/Device.vala"
			_tmp47_ = self->label;
#line 1993 "Utility/Device.vala"
			_tmp48_ = g_strdup_printf ("(%s)", _tmp47_);
#line 1993 "Utility/Device.vala"
			_tmp49_ = _tmp48_;
#line 1993 "Utility/Device.vala"
			_tmp50_ = g_strconcat (_tmp46_, _tmp49_, NULL);
#line 1993 "Utility/Device.vala"
			_g_free0 (txt);
#line 1993 "Utility/Device.vala"
			txt = _tmp50_;
#line 1993 "Utility/Device.vala"
			_g_free0 (_tmp49_);
#line 12927 "Device.c"
		}
#line 1995 "Utility/Device.vala"
		if (show_parent) {
#line 1995 "Utility/Device.vala"
			_tmp52_ = device_has_parent (self);
#line 12933 "Device.c"
		} else {
#line 1995 "Utility/Device.vala"
			_tmp52_ = FALSE;
#line 12937 "Device.c"
		}
#line 1995 "Utility/Device.vala"
		if (_tmp52_) {
#line 12941 "Device.c"
			Device* _tmp53_;
			const gchar* _tmp54_;
#line 1995 "Utility/Device.vala"
			_tmp53_ = self->parent;
#line 1995 "Utility/Device.vala"
			_tmp54_ = _tmp53_->type;
#line 1995 "Utility/Device.vala"
			_tmp51_ = g_strcmp0 (_tmp54_, "part") == 0;
#line 12950 "Device.c"
		} else {
#line 1995 "Utility/Device.vala"
			_tmp51_ = FALSE;
#line 12954 "Device.c"
		}
#line 1995 "Utility/Device.vala"
		if (_tmp51_) {
#line 12958 "Device.c"
			const gchar* _tmp55_;
			const gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
#line 1996 "Utility/Device.vala"
			_tmp55_ = txt;
#line 1996 "Utility/Device.vala"
			_tmp56_ = self->pkname;
#line 1996 "Utility/Device.vala"
			_tmp57_ = g_strdup_printf ("(%s)", _tmp56_);
#line 1996 "Utility/Device.vala"
			_tmp58_ = _tmp57_;
#line 1996 "Utility/Device.vala"
			_tmp59_ = g_strconcat (_tmp55_, _tmp58_, NULL);
#line 1996 "Utility/Device.vala"
			_g_free0 (txt);
#line 1996 "Utility/Device.vala"
			txt = _tmp59_;
#line 1996 "Utility/Device.vala"
			_g_free0 (_tmp58_);
#line 12980 "Device.c"
		}
#line 1998 "Utility/Device.vala"
		if (show_alias) {
#line 12984 "Device.c"
			const gchar* _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
#line 1998 "Utility/Device.vala"
			_tmp61_ = self->mapped_name;
#line 1998 "Utility/Device.vala"
			_tmp62_ = strlen (_tmp61_);
#line 1998 "Utility/Device.vala"
			_tmp63_ = _tmp62_;
#line 1998 "Utility/Device.vala"
			_tmp60_ = _tmp63_ > 0;
#line 12996 "Device.c"
		} else {
#line 1998 "Utility/Device.vala"
			_tmp60_ = FALSE;
#line 13000 "Device.c"
		}
#line 1998 "Utility/Device.vala"
		if (_tmp60_) {
#line 13004 "Device.c"
			const gchar* _tmp64_;
			const gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
#line 1999 "Utility/Device.vala"
			_tmp64_ = txt;
#line 1999 "Utility/Device.vala"
			_tmp65_ = self->mapped_name;
#line 1999 "Utility/Device.vala"
			_tmp66_ = g_strdup_printf ("(%s)", _tmp65_);
#line 1999 "Utility/Device.vala"
			_tmp67_ = _tmp66_;
#line 1999 "Utility/Device.vala"
			_tmp68_ = g_strconcat (_tmp64_, _tmp67_, NULL);
#line 1999 "Utility/Device.vala"
			_g_free0 (txt);
#line 1999 "Utility/Device.vala"
			txt = _tmp68_;
#line 1999 "Utility/Device.vala"
			_g_free0 (_tmp67_);
#line 13026 "Device.c"
		}
	}
#line 2003 "Utility/Device.vala"
	result = txt;
#line 2003 "Utility/Device.vala"
	return result;
#line 13033 "Device.c"
}

void
device_test_all (void)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	GeeArrayList* _tmp8_;
	GeeArrayList* _tmp9_;
#line 2009 "Utility/Device.vala"
	_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 2009 "Utility/Device.vala"
	list = _tmp0_;
#line 2010 "Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_block_devices_using_lsblk()", FALSE);
#line 2011 "Utility/Device.vala"
	_tmp1_ = list;
#line 2011 "Utility/Device.vala"
	device_print_device_list (_tmp1_);
#line 2013 "Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 2019 "Utility/Device.vala"
	_tmp2_ = device_get_mounted_filesystems_using_mtab ();
#line 2019 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 2019 "Utility/Device.vala"
	list = _tmp2_;
#line 2020 "Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_mounted_filesystems_using_mtab()", FALSE);
#line 2021 "Utility/Device.vala"
	_tmp3_ = list;
#line 2021 "Utility/Device.vala"
	device_print_device_mounts (_tmp3_);
#line 2023 "Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 2025 "Utility/Device.vala"
	_tmp4_ = device_get_disk_space_using_df ("");
#line 2025 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 2025 "Utility/Device.vala"
	list = _tmp4_;
#line 2026 "Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_disk_space_using_df()", FALSE);
#line 2027 "Utility/Device.vala"
	_tmp5_ = list;
#line 2027 "Utility/Device.vala"
	device_print_device_disk_space (_tmp5_);
#line 2029 "Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 2031 "Utility/Device.vala"
	_tmp6_ = device_get_filesystems (TRUE, TRUE);
#line 2031 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 2031 "Utility/Device.vala"
	list = _tmp6_;
#line 2032 "Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_filesystems()", FALSE);
#line 2033 "Utility/Device.vala"
	_tmp7_ = list;
#line 2033 "Utility/Device.vala"
	device_print_device_list (_tmp7_);
#line 2034 "Utility/Device.vala"
	_tmp8_ = list;
#line 2034 "Utility/Device.vala"
	device_print_device_mounts (_tmp8_);
#line 2035 "Utility/Device.vala"
	_tmp9_ = list;
#line 2035 "Utility/Device.vala"
	device_print_device_disk_space (_tmp9_);
#line 2037 "Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 2008 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 13114 "Device.c"
}

void
device_print_device_list (GeeArrayList* list)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 2040 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 2042 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 2044 "Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-12s ,%-5s ,%-5s ,%-36s ,%s", "device", "pkname", "kname", "uuid", "mapped_name");
#line 2044 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 2044 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 2044 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2051 "Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2051 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2051 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2051 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 13144 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		gint _dev_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _dev_index = 0;
#line 2053 "Utility/Device.vala"
		_dev_list = list;
#line 2053 "Utility/Device.vala"
		_tmp4_ = _dev_list;
#line 2053 "Utility/Device.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 2053 "Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 2053 "Utility/Device.vala"
		_dev_size = _tmp6_;
#line 2053 "Utility/Device.vala"
		_dev_index = -1;
#line 2053 "Utility/Device.vala"
		while (TRUE) {
#line 13166 "Device.c"
			gint _tmp7_;
			gint _tmp8_;
			Device* dev = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			Device* _tmp11_;
			const gchar* _tmp12_;
			Device* _tmp13_;
			const gchar* _tmp14_;
			Device* _tmp15_;
			const gchar* _tmp16_;
			Device* _tmp17_;
			const gchar* _tmp18_;
			Device* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
#line 2053 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 2053 "Utility/Device.vala"
			_tmp7_ = _dev_index;
#line 2053 "Utility/Device.vala"
			_tmp8_ = _dev_size;
#line 2053 "Utility/Device.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 2053 "Utility/Device.vala"
				break;
#line 13194 "Device.c"
			}
#line 2053 "Utility/Device.vala"
			_tmp9_ = _dev_list;
#line 2053 "Utility/Device.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _dev_index);
#line 2053 "Utility/Device.vala"
			dev = (Device*) _tmp10_;
#line 2054 "Utility/Device.vala"
			_tmp11_ = dev;
#line 2054 "Utility/Device.vala"
			_tmp12_ = _tmp11_->device;
#line 2054 "Utility/Device.vala"
			_tmp13_ = dev;
#line 2054 "Utility/Device.vala"
			_tmp14_ = _tmp13_->pkname;
#line 2054 "Utility/Device.vala"
			_tmp15_ = dev;
#line 2054 "Utility/Device.vala"
			_tmp16_ = _tmp15_->kname;
#line 2054 "Utility/Device.vala"
			_tmp17_ = dev;
#line 2054 "Utility/Device.vala"
			_tmp18_ = _tmp17_->uuid;
#line 2054 "Utility/Device.vala"
			_tmp19_ = dev;
#line 2054 "Utility/Device.vala"
			_tmp20_ = _tmp19_->mapped_name;
#line 2054 "Utility/Device.vala"
			_tmp21_ = g_strdup_printf ("%-12s ,%-5s ,%-5s ,%-36s ,%s", _tmp12_, _tmp14_, _tmp16_, _tmp18_, _tmp20_);
#line 2054 "Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 2054 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp22_);
#line 2054 "Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 2053 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 13232 "Device.c"
		}
	}
#line 2063 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 13237 "Device.c"
}

void
device_print_device_mounts (GeeArrayList* list)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 2116 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 2118 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 2120 "Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-15s %s", "device", "> mount_points (mount_options)");
#line 2120 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 2120 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 2120 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2126 "Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2126 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2126 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2126 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 13267 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		gint _dev_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _dev_index = 0;
#line 2128 "Utility/Device.vala"
		_dev_list = list;
#line 2128 "Utility/Device.vala"
		_tmp4_ = _dev_list;
#line 2128 "Utility/Device.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 2128 "Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 2128 "Utility/Device.vala"
		_dev_size = _tmp6_;
#line 2128 "Utility/Device.vala"
		_dev_index = -1;
#line 2128 "Utility/Device.vala"
		while (TRUE) {
#line 13289 "Device.c"
			gint _tmp7_;
			gint _tmp8_;
			Device* dev = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			gchar* mps = NULL;
			gchar* _tmp11_;
			Device* _tmp37_;
			const gchar* _tmp38_;
			const gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
#line 2128 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 2128 "Utility/Device.vala"
			_tmp7_ = _dev_index;
#line 2128 "Utility/Device.vala"
			_tmp8_ = _dev_size;
#line 2128 "Utility/Device.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 2128 "Utility/Device.vala"
				break;
#line 13312 "Device.c"
			}
#line 2128 "Utility/Device.vala"
			_tmp9_ = _dev_list;
#line 2128 "Utility/Device.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _dev_index);
#line 2128 "Utility/Device.vala"
			dev = (Device*) _tmp10_;
#line 2130 "Utility/Device.vala"
			_tmp11_ = g_strdup ("");
#line 2130 "Utility/Device.vala"
			mps = _tmp11_;
#line 13324 "Device.c"
			{
				GeeArrayList* _mp_list = NULL;
				Device* _tmp12_;
				GeeArrayList* _tmp13_;
				gint _mp_size = 0;
				GeeArrayList* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _mp_index = 0;
#line 2131 "Utility/Device.vala"
				_tmp12_ = dev;
#line 2131 "Utility/Device.vala"
				_tmp13_ = _tmp12_->mount_points;
#line 2131 "Utility/Device.vala"
				_mp_list = _tmp13_;
#line 2131 "Utility/Device.vala"
				_tmp14_ = _mp_list;
#line 2131 "Utility/Device.vala"
				_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 2131 "Utility/Device.vala"
				_tmp16_ = _tmp15_;
#line 2131 "Utility/Device.vala"
				_mp_size = _tmp16_;
#line 2131 "Utility/Device.vala"
				_mp_index = -1;
#line 2131 "Utility/Device.vala"
				while (TRUE) {
#line 13352 "Device.c"
					gint _tmp17_;
					gint _tmp18_;
					MountEntry* mp = NULL;
					GeeArrayList* _tmp19_;
					gpointer _tmp20_;
					const gchar* _tmp21_;
					MountEntry* _tmp22_;
					const gchar* _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
					MountEntry* _tmp27_;
					const gchar* _tmp28_;
					gint _tmp29_;
					gint _tmp30_;
#line 2131 "Utility/Device.vala"
					_mp_index = _mp_index + 1;
#line 2131 "Utility/Device.vala"
					_tmp17_ = _mp_index;
#line 2131 "Utility/Device.vala"
					_tmp18_ = _mp_size;
#line 2131 "Utility/Device.vala"
					if (!(_tmp17_ < _tmp18_)) {
#line 2131 "Utility/Device.vala"
						break;
#line 13378 "Device.c"
					}
#line 2131 "Utility/Device.vala"
					_tmp19_ = _mp_list;
#line 2131 "Utility/Device.vala"
					_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _mp_index);
#line 2131 "Utility/Device.vala"
					mp = (MountEntry*) _tmp20_;
#line 2132 "Utility/Device.vala"
					_tmp21_ = mps;
#line 2132 "Utility/Device.vala"
					_tmp22_ = mp;
#line 2132 "Utility/Device.vala"
					_tmp23_ = _tmp22_->mount_point;
#line 2132 "Utility/Device.vala"
					_tmp24_ = g_strdup_printf ("\n    %s -> ", _tmp23_);
#line 2132 "Utility/Device.vala"
					_tmp25_ = _tmp24_;
#line 2132 "Utility/Device.vala"
					_tmp26_ = g_strconcat (_tmp21_, _tmp25_, NULL);
#line 2132 "Utility/Device.vala"
					_g_free0 (mps);
#line 2132 "Utility/Device.vala"
					mps = _tmp26_;
#line 2132 "Utility/Device.vala"
					_g_free0 (_tmp25_);
#line 2133 "Utility/Device.vala"
					_tmp27_ = mp;
#line 2133 "Utility/Device.vala"
					_tmp28_ = _tmp27_->mount_options;
#line 2133 "Utility/Device.vala"
					_tmp29_ = strlen (_tmp28_);
#line 2133 "Utility/Device.vala"
					_tmp30_ = _tmp29_;
#line 2133 "Utility/Device.vala"
					if (_tmp30_ > 0) {
#line 13414 "Device.c"
						const gchar* _tmp31_;
						MountEntry* _tmp32_;
						const gchar* _tmp33_;
						gchar* _tmp34_;
						gchar* _tmp35_;
						gchar* _tmp36_;
#line 2134 "Utility/Device.vala"
						_tmp31_ = mps;
#line 2134 "Utility/Device.vala"
						_tmp32_ = mp;
#line 2134 "Utility/Device.vala"
						_tmp33_ = _tmp32_->mount_options;
#line 2134 "Utility/Device.vala"
						_tmp34_ = g_strdup_printf (" %s", _tmp33_);
#line 2134 "Utility/Device.vala"
						_tmp35_ = _tmp34_;
#line 2134 "Utility/Device.vala"
						_tmp36_ = g_strconcat (_tmp31_, _tmp35_, NULL);
#line 2134 "Utility/Device.vala"
						_g_free0 (mps);
#line 2134 "Utility/Device.vala"
						mps = _tmp36_;
#line 2134 "Utility/Device.vala"
						_g_free0 (_tmp35_);
#line 13439 "Device.c"
					}
#line 2131 "Utility/Device.vala"
					_g_object_unref0 (mp);
#line 13443 "Device.c"
				}
			}
#line 2138 "Utility/Device.vala"
			_tmp37_ = dev;
#line 2138 "Utility/Device.vala"
			_tmp38_ = _tmp37_->device;
#line 2138 "Utility/Device.vala"
			_tmp39_ = mps;
#line 2138 "Utility/Device.vala"
			_tmp40_ = g_strdup_printf ("%-15s %s", _tmp38_, _tmp39_);
#line 2138 "Utility/Device.vala"
			_tmp41_ = _tmp40_;
#line 2138 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp41_);
#line 2138 "Utility/Device.vala"
			_g_free0 (_tmp41_);
#line 2128 "Utility/Device.vala"
			_g_free0 (mps);
#line 2128 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 13464 "Device.c"
		}
	}
#line 2146 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 13469 "Device.c"
}

void
device_print_device_disk_space (GeeArrayList* list)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 2149 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 2150 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 2152 "Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-15s %-12s %15s %15s %15s %10s", "device", "fstype", "size", "used", "available", "used_percent");
#line 2152 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 2152 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 2152 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2161 "Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2161 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2161 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2161 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 13499 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		gint _dev_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _dev_index = 0;
#line 2163 "Utility/Device.vala"
		_dev_list = list;
#line 2163 "Utility/Device.vala"
		_tmp4_ = _dev_list;
#line 2163 "Utility/Device.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 2163 "Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 2163 "Utility/Device.vala"
		_dev_size = _tmp6_;
#line 2163 "Utility/Device.vala"
		_dev_index = -1;
#line 2163 "Utility/Device.vala"
		while (TRUE) {
#line 13521 "Device.c"
			gint _tmp7_;
			gint _tmp8_;
			Device* dev = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			Device* _tmp11_;
			const gchar* _tmp12_;
			Device* _tmp13_;
			const gchar* _tmp14_;
			Device* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			Device* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			Device* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			Device* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
#line 2163 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 2163 "Utility/Device.vala"
			_tmp7_ = _dev_index;
#line 2163 "Utility/Device.vala"
			_tmp8_ = _dev_size;
#line 2163 "Utility/Device.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 2163 "Utility/Device.vala"
				break;
#line 13554 "Device.c"
			}
#line 2163 "Utility/Device.vala"
			_tmp9_ = _dev_list;
#line 2163 "Utility/Device.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _dev_index);
#line 2163 "Utility/Device.vala"
			dev = (Device*) _tmp10_;
#line 2164 "Utility/Device.vala"
			_tmp11_ = dev;
#line 2164 "Utility/Device.vala"
			_tmp12_ = _tmp11_->device;
#line 2164 "Utility/Device.vala"
			_tmp13_ = dev;
#line 2164 "Utility/Device.vala"
			_tmp14_ = _tmp13_->fstype;
#line 2164 "Utility/Device.vala"
			_tmp15_ = dev;
#line 2164 "Utility/Device.vala"
			_tmp16_ = tee_jee_file_system_format_file_size (_tmp15_->size_bytes, TRUE, "", TRUE, 1);
#line 2164 "Utility/Device.vala"
			_tmp17_ = _tmp16_;
#line 2164 "Utility/Device.vala"
			_tmp18_ = dev;
#line 2164 "Utility/Device.vala"
			_tmp19_ = tee_jee_file_system_format_file_size (_tmp18_->used_bytes, TRUE, "", TRUE, 1);
#line 2164 "Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 2164 "Utility/Device.vala"
			_tmp21_ = dev;
#line 2164 "Utility/Device.vala"
			_tmp22_ = tee_jee_file_system_format_file_size (_tmp21_->available_bytes, TRUE, "", TRUE, 1);
#line 2164 "Utility/Device.vala"
			_tmp23_ = _tmp22_;
#line 2164 "Utility/Device.vala"
			_tmp24_ = dev;
#line 2164 "Utility/Device.vala"
			_tmp25_ = _tmp24_->used_percent;
#line 2164 "Utility/Device.vala"
			_tmp26_ = g_strdup_printf ("%-15s %-12s %15s %15s %15s %10s", _tmp12_, _tmp14_, _tmp17_, _tmp20_, _tmp23_, _tmp25_);
#line 2164 "Utility/Device.vala"
			_tmp27_ = _tmp26_;
#line 2164 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp27_);
#line 2164 "Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 2164 "Utility/Device.vala"
			_g_free0 (_tmp23_);
#line 2164 "Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 2164 "Utility/Device.vala"
			_g_free0 (_tmp17_);
#line 2163 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 13608 "Device.c"
		}
	}
#line 2174 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 13613 "Device.c"
}

guint64
device_get_free_bytes (Device* self)
{
	guint64 result;
	guint64 _tmp0_ = 0ULL;
#line 121 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 122 "Utility/Device.vala"
	if (self->used_bytes == ((guint64) 0)) {
#line 122 "Utility/Device.vala"
		_tmp0_ = (guint64) 0;
#line 13627 "Device.c"
	} else {
#line 122 "Utility/Device.vala"
		_tmp0_ = self->size_bytes - self->used_bytes;
#line 13631 "Device.c"
	}
#line 122 "Utility/Device.vala"
	result = _tmp0_;
#line 122 "Utility/Device.vala"
	return result;
#line 13637 "Device.c"
}

gchar*
device_get_size (Device* self)
{
	gchar* result;
#line 127 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "Utility/Device.vala"
	if (((gdouble) self->size_bytes) < device_GB) {
#line 13648 "Device.c"
		gchar* _tmp0_;
#line 129 "Utility/Device.vala"
		_tmp0_ = g_strdup_printf ("%.1f MB", self->size_bytes / device_MB);
#line 129 "Utility/Device.vala"
		result = _tmp0_;
#line 129 "Utility/Device.vala"
		return result;
#line 13656 "Device.c"
	} else {
#line 131 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 13660 "Device.c"
			gchar* _tmp1_;
#line 132 "Utility/Device.vala"
			_tmp1_ = g_strdup_printf ("%.1f GB", self->size_bytes / device_GB);
#line 132 "Utility/Device.vala"
			result = _tmp1_;
#line 132 "Utility/Device.vala"
			return result;
#line 13668 "Device.c"
		} else {
			gchar* _tmp2_;
#line 135 "Utility/Device.vala"
			_tmp2_ = g_strdup ("");
#line 135 "Utility/Device.vala"
			result = _tmp2_;
#line 135 "Utility/Device.vala"
			return result;
#line 13677 "Device.c"
		}
	}
}

gchar*
device_get_used (Device* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
#line 141 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "Utility/Device.vala"
	if (self->used_bytes == ((guint64) 0)) {
#line 13691 "Device.c"
		gchar* _tmp1_;
#line 142 "Utility/Device.vala"
		_tmp1_ = g_strdup ("");
#line 142 "Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 142 "Utility/Device.vala"
		_tmp0_ = _tmp1_;
#line 13699 "Device.c"
	} else {
		gchar* _tmp2_;
#line 142 "Utility/Device.vala"
		_tmp2_ = g_strdup_printf ("%.1f GB", self->used_bytes / device_GB);
#line 142 "Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 142 "Utility/Device.vala"
		_tmp0_ = _tmp2_;
#line 13708 "Device.c"
	}
#line 142 "Utility/Device.vala"
	result = _tmp0_;
#line 142 "Utility/Device.vala"
	return result;
#line 13714 "Device.c"
}

gchar*
device_get_free (Device* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	guint64 _tmp2_;
#line 147 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 148 "Utility/Device.vala"
	_tmp1_ = device_get_free_bytes (self);
#line 148 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 148 "Utility/Device.vala"
	if (_tmp2_ == ((guint64) 0)) {
#line 13732 "Device.c"
		gchar* _tmp3_;
#line 148 "Utility/Device.vala"
		_tmp3_ = g_strdup ("");
#line 148 "Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 148 "Utility/Device.vala"
		_tmp0_ = _tmp3_;
#line 13740 "Device.c"
	} else {
		guint64 _tmp4_;
		guint64 _tmp5_;
		gchar* _tmp6_;
#line 148 "Utility/Device.vala"
		_tmp4_ = device_get_free_bytes (self);
#line 148 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 148 "Utility/Device.vala"
		_tmp6_ = g_strdup_printf ("%.1f GB", _tmp5_ / device_GB);
#line 148 "Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 148 "Utility/Device.vala"
		_tmp0_ = _tmp6_;
#line 13755 "Device.c"
	}
#line 148 "Utility/Device.vala"
	result = _tmp0_;
#line 148 "Utility/Device.vala"
	return result;
#line 13761 "Device.c"
}

gboolean
device_get_is_mounted (Device* self)
{
	gboolean result;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 153 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "Utility/Device.vala"
	_tmp0_ = self->mount_points;
#line 154 "Utility/Device.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 154 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 154 "Utility/Device.vala"
	result = _tmp2_ > 0;
#line 154 "Utility/Device.vala"
	return result;
#line 13783 "Device.c"
}

gchar*
device_get_full_name_with_alias (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 1753 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1754 "Utility/Device.vala"
	_tmp0_ = self->device;
#line 1754 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1754 "Utility/Device.vala"
	text = _tmp1_;
#line 1755 "Utility/Device.vala"
	_tmp2_ = self->mapped_name;
#line 1755 "Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1755 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1755 "Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 13812 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1756 "Utility/Device.vala"
		_tmp5_ = text;
#line 1756 "Utility/Device.vala"
		_tmp6_ = self->mapped_name;
#line 1756 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1756 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1756 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1756 "Utility/Device.vala"
		_g_free0 (text);
#line 1756 "Utility/Device.vala"
		text = _tmp9_;
#line 1756 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 13834 "Device.c"
	}
#line 1758 "Utility/Device.vala"
	result = text;
#line 1758 "Utility/Device.vala"
	return result;
#line 13840 "Device.c"
}

gchar*
device_get_full_name_with_parent (Device* self)
{
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1763 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1764 "Utility/Device.vala"
	_tmp0_ = device_get_device_name_with_parent (self);
#line 1764 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1764 "Utility/Device.vala"
	result = _tmp1_;
#line 1764 "Utility/Device.vala"
	return result;
#line 13859 "Device.c"
}

gchar*
device_get_short_name_with_alias (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 1769 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1770 "Utility/Device.vala"
	_tmp0_ = self->kname;
#line 1770 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1770 "Utility/Device.vala"
	text = _tmp1_;
#line 1771 "Utility/Device.vala"
	_tmp2_ = self->mapped_name;
#line 1771 "Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1771 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1771 "Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 13888 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1772 "Utility/Device.vala"
		_tmp5_ = text;
#line 1772 "Utility/Device.vala"
		_tmp6_ = self->mapped_name;
#line 1772 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1772 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1772 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1772 "Utility/Device.vala"
		_g_free0 (text);
#line 1772 "Utility/Device.vala"
		text = _tmp9_;
#line 1772 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 13910 "Device.c"
	}
#line 1774 "Utility/Device.vala"
	result = text;
#line 1774 "Utility/Device.vala"
	return result;
#line 13916 "Device.c"
}

gchar*
device_get_short_name_with_parent (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1779 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1780 "Utility/Device.vala"
	_tmp0_ = self->kname;
#line 1780 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1780 "Utility/Device.vala"
	text = _tmp1_;
#line 1782 "Utility/Device.vala"
	if (device_has_parent (self)) {
#line 13937 "Device.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
#line 1782 "Utility/Device.vala"
		_tmp3_ = self->parent;
#line 1782 "Utility/Device.vala"
		_tmp4_ = _tmp3_->type;
#line 1782 "Utility/Device.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "part") == 0;
#line 13946 "Device.c"
	} else {
#line 1782 "Utility/Device.vala"
		_tmp2_ = FALSE;
#line 13950 "Device.c"
	}
#line 1782 "Utility/Device.vala"
	if (_tmp2_) {
#line 13954 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1783 "Utility/Device.vala"
		_tmp5_ = text;
#line 1783 "Utility/Device.vala"
		_tmp6_ = self->pkname;
#line 1783 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1783 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1783 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1783 "Utility/Device.vala"
		_g_free0 (text);
#line 1783 "Utility/Device.vala"
		text = _tmp9_;
#line 1783 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 13976 "Device.c"
	}
#line 1786 "Utility/Device.vala"
	result = text;
#line 1786 "Utility/Device.vala"
	return result;
#line 13982 "Device.c"
}

gchar*
device_get_device_name_with_parent (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1791 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1792 "Utility/Device.vala"
	_tmp0_ = self->device;
#line 1792 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1792 "Utility/Device.vala"
	text = _tmp1_;
#line 1794 "Utility/Device.vala"
	if (device_has_parent (self)) {
#line 14003 "Device.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
#line 1794 "Utility/Device.vala"
		_tmp3_ = self->parent;
#line 1794 "Utility/Device.vala"
		_tmp4_ = _tmp3_->type;
#line 1794 "Utility/Device.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "part") == 0;
#line 14012 "Device.c"
	} else {
#line 1794 "Utility/Device.vala"
		_tmp2_ = FALSE;
#line 14016 "Device.c"
	}
#line 1794 "Utility/Device.vala"
	if (_tmp2_) {
#line 14020 "Device.c"
		const gchar* _tmp5_;
		Device* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1795 "Utility/Device.vala"
		_tmp5_ = text;
#line 1795 "Utility/Device.vala"
		_tmp6_ = self->parent;
#line 1795 "Utility/Device.vala"
		_tmp7_ = _tmp6_->kname;
#line 1795 "Utility/Device.vala"
		_tmp8_ = g_strdup_printf (" (%s)", _tmp7_);
#line 1795 "Utility/Device.vala"
		_tmp9_ = _tmp8_;
#line 1795 "Utility/Device.vala"
		_tmp10_ = g_strconcat (_tmp5_, _tmp9_, NULL);
#line 1795 "Utility/Device.vala"
		_g_free0 (text);
#line 1795 "Utility/Device.vala"
		text = _tmp10_;
#line 1795 "Utility/Device.vala"
		_g_free0 (_tmp9_);
#line 14045 "Device.c"
	}
#line 1798 "Utility/Device.vala"
	result = text;
#line 1798 "Utility/Device.vala"
	return result;
#line 14051 "Device.c"
}

static void
device_class_init (DeviceClass * klass,
                   gpointer klass_data)
{
	gchar* _tmp0_;
#line 32 "Utility/Device.vala"
	device_parent_class = g_type_class_peek_parent (klass);
#line 32 "Utility/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_device_get_property;
#line 32 "Utility/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = device_finalize;
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FREE_BYTES_PROPERTY, device_properties[DEVICE_FREE_BYTES_PROPERTY] = g_param_spec_uint64 ("free-bytes", "free-bytes", "free-bytes", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SIZE_PROPERTY, device_properties[DEVICE_SIZE_PROPERTY] = g_param_spec_string ("size", "size", "size", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_USED_PROPERTY, device_properties[DEVICE_USED_PROPERTY] = g_param_spec_string ("used", "used", "used", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FREE_PROPERTY, device_properties[DEVICE_FREE_PROPERTY] = g_param_spec_string ("free", "free", "free", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_IS_MOUNTED_PROPERTY, device_properties[DEVICE_IS_MOUNTED_PROPERTY] = g_param_spec_boolean ("is-mounted", "is-mounted", "is-mounted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY, device_properties[DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY] = g_param_spec_string ("full-name-with-alias", "full-name-with-alias", "full-name-with-alias", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FULL_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_FULL_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("full-name-with-parent", "full-name-with-parent", "full-name-with-parent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY, device_properties[DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY] = g_param_spec_string ("short-name-with-alias", "short-name-with-alias", "short-name-with-alias", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("short-name-with-parent", "short-name-with-parent", "short-name-with-parent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("device-name-with-parent", "device-name-with-parent", "device-name-with-parent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 37 "Utility/Device.vala"
	device_MB = 1000 * device_KB;
#line 38 "Utility/Device.vala"
	device_GB = 1000 * device_MB;
#line 41 "Utility/Device.vala"
	device_MiB = 1024 * device_KiB;
#line 42 "Utility/Device.vala"
	device_GiB = 1024 * device_MiB;
#line 89 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 89 "Utility/Device.vala"
	device_lsblk_version = _tmp0_;
#line 14097 "Device.c"
}

static void
device_instance_init (Device * self,
                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
#line 44 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 44 "Utility/Device.vala"
	self->device = _tmp0_;
#line 45 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 45 "Utility/Device.vala"
	self->name = _tmp1_;
#line 46 "Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 46 "Utility/Device.vala"
	self->kname = _tmp2_;
#line 47 "Utility/Device.vala"
	_tmp3_ = g_strdup ("");
#line 47 "Utility/Device.vala"
	self->pkname = _tmp3_;
#line 48 "Utility/Device.vala"
	_tmp4_ = g_strdup ("");
#line 48 "Utility/Device.vala"
	self->pkname_toplevel = _tmp4_;
#line 49 "Utility/Device.vala"
	_tmp5_ = g_strdup ("");
#line 49 "Utility/Device.vala"
	self->mapped_name = _tmp5_;
#line 50 "Utility/Device.vala"
	_tmp6_ = g_strdup ("");
#line 50 "Utility/Device.vala"
	self->uuid = _tmp6_;
#line 51 "Utility/Device.vala"
	_tmp7_ = g_strdup ("");
#line 51 "Utility/Device.vala"
	self->label = _tmp7_;
#line 52 "Utility/Device.vala"
	_tmp8_ = g_strdup ("");
#line 52 "Utility/Device.vala"
	self->partuuid = _tmp8_;
#line 53 "Utility/Device.vala"
	_tmp9_ = g_strdup ("");
#line 53 "Utility/Device.vala"
	self->partlabel = _tmp9_;
#line 55 "Utility/Device.vala"
	self->major = -1;
#line 56 "Utility/Device.vala"
	self->minor = -1;
#line 58 "Utility/Device.vala"
	_tmp10_ = g_strdup ("");
#line 58 "Utility/Device.vala"
	self->device_mapper = _tmp10_;
#line 59 "Utility/Device.vala"
	_tmp11_ = g_strdup ("");
#line 59 "Utility/Device.vala"
	self->device_by_uuid = _tmp11_;
#line 60 "Utility/Device.vala"
	_tmp12_ = g_strdup ("");
#line 60 "Utility/Device.vala"
	self->device_by_label = _tmp12_;
#line 61 "Utility/Device.vala"
	_tmp13_ = g_strdup ("");
#line 61 "Utility/Device.vala"
	self->device_by_partuuid = _tmp13_;
#line 62 "Utility/Device.vala"
	_tmp14_ = g_strdup ("");
#line 62 "Utility/Device.vala"
	self->device_by_partlabel = _tmp14_;
#line 64 "Utility/Device.vala"
	_tmp15_ = g_strdup ("");
#line 64 "Utility/Device.vala"
	self->type = _tmp15_;
#line 65 "Utility/Device.vala"
	_tmp16_ = g_strdup ("");
#line 65 "Utility/Device.vala"
	self->fstype = _tmp16_;
#line 67 "Utility/Device.vala"
	self->order = -1;
#line 69 "Utility/Device.vala"
	_tmp17_ = g_strdup ("");
#line 69 "Utility/Device.vala"
	self->vendor = _tmp17_;
#line 70 "Utility/Device.vala"
	_tmp18_ = g_strdup ("");
#line 70 "Utility/Device.vala"
	self->model = _tmp18_;
#line 71 "Utility/Device.vala"
	_tmp19_ = g_strdup ("");
#line 71 "Utility/Device.vala"
	self->serial = _tmp19_;
#line 72 "Utility/Device.vala"
	_tmp20_ = g_strdup ("");
#line 72 "Utility/Device.vala"
	self->revision = _tmp20_;
#line 74 "Utility/Device.vala"
	self->removable = FALSE;
#line 75 "Utility/Device.vala"
	self->read_only = FALSE;
#line 77 "Utility/Device.vala"
	self->size_bytes = (guint64) 0;
#line 78 "Utility/Device.vala"
	self->used_bytes = (guint64) 0;
#line 79 "Utility/Device.vala"
	self->available_bytes = (guint64) 0;
#line 81 "Utility/Device.vala"
	_tmp21_ = g_strdup ("");
#line 81 "Utility/Device.vala"
	self->used_percent = _tmp21_;
#line 82 "Utility/Device.vala"
	_tmp22_ = g_strdup ("");
#line 82 "Utility/Device.vala"
	self->dist_info = _tmp22_;
#line 86 "Utility/Device.vala"
	self->parent = NULL;
#line 87 "Utility/Device.vala"
	self->children = NULL;
#line 14239 "Device.c"
}

static void
device_finalize (GObject * obj)
{
	Device * self;
#line 32 "Utility/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DEVICE, Device);
#line 44 "Utility/Device.vala"
	_g_free0 (self->device);
#line 45 "Utility/Device.vala"
	_g_free0 (self->name);
#line 46 "Utility/Device.vala"
	_g_free0 (self->kname);
#line 47 "Utility/Device.vala"
	_g_free0 (self->pkname);
#line 48 "Utility/Device.vala"
	_g_free0 (self->pkname_toplevel);
#line 49 "Utility/Device.vala"
	_g_free0 (self->mapped_name);
#line 50 "Utility/Device.vala"
	_g_free0 (self->uuid);
#line 51 "Utility/Device.vala"
	_g_free0 (self->label);
#line 52 "Utility/Device.vala"
	_g_free0 (self->partuuid);
#line 53 "Utility/Device.vala"
	_g_free0 (self->partlabel);
#line 58 "Utility/Device.vala"
	_g_free0 (self->device_mapper);
#line 59 "Utility/Device.vala"
	_g_free0 (self->device_by_uuid);
#line 60 "Utility/Device.vala"
	_g_free0 (self->device_by_label);
#line 61 "Utility/Device.vala"
	_g_free0 (self->device_by_partuuid);
#line 62 "Utility/Device.vala"
	_g_free0 (self->device_by_partlabel);
#line 64 "Utility/Device.vala"
	_g_free0 (self->type);
#line 65 "Utility/Device.vala"
	_g_free0 (self->fstype);
#line 69 "Utility/Device.vala"
	_g_free0 (self->vendor);
#line 70 "Utility/Device.vala"
	_g_free0 (self->model);
#line 71 "Utility/Device.vala"
	_g_free0 (self->serial);
#line 72 "Utility/Device.vala"
	_g_free0 (self->revision);
#line 81 "Utility/Device.vala"
	_g_free0 (self->used_percent);
#line 82 "Utility/Device.vala"
	_g_free0 (self->dist_info);
#line 83 "Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 84 "Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 86 "Utility/Device.vala"
	_g_object_unref0 (self->parent);
#line 87 "Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 32 "Utility/Device.vala"
	G_OBJECT_CLASS (device_parent_class)->finalize (obj);
#line 14304 "Device.c"
}

static GType
device_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Device), 0, (GInstanceInitFunc) device_instance_init, NULL };
	GType device_type_id;
	device_type_id = g_type_register_static (G_TYPE_OBJECT, "Device", &g_define_type_info, 0);
	return device_type_id;
}

GType
device_get_type (void)
{
	static volatile gsize device_type_id__volatile = 0;
	if (g_once_init_enter (&device_type_id__volatile)) {
		GType device_type_id;
		device_type_id = device_get_type_once ();
		g_once_init_leave (&device_type_id__volatile, device_type_id);
	}
	return device_type_id__volatile;
}

static void
_vala_device_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Device * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DEVICE, Device);
#line 32 "Utility/Device.vala"
	switch (property_id) {
#line 32 "Utility/Device.vala"
		case DEVICE_FREE_BYTES_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_set_uint64 (value, device_get_free_bytes (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_SIZE_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_size (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_USED_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_used (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_FREE_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_free (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_IS_MOUNTED_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_set_boolean (value, device_get_is_mounted (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_full_name_with_alias (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_FULL_NAME_WITH_PARENT_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_full_name_with_parent (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_short_name_with_alias (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_short_name_with_parent (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_device_name_with_parent (self));
#line 32 "Utility/Device.vala"
		break;
#line 14398 "Device.c"
		default:
#line 32 "Utility/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "Utility/Device.vala"
		break;
#line 14404 "Device.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

